#include "AFlib3_ASCii.bi"
#include "AFlib3_Miscellaneous.bi"

Dim BitDepth as integer = 24

Dim Full_or_Windowed as integer = 0 '<----- Pass '0' for Windowed Mode; or
                                    '            '1' for Fullscreen Mode.

'========================================================================== 
'/////// S T A R T   O F   M A I N   P O R T I O N 
'========================================================================== 

ScreenRes 424, 96 , , 0
Windowtitle "AFlib III -- Drawing Primitives Test"
Color 15, 1: ? "          Please select your color depth!!!          "
Locate 4: Color 15, 0
Locate , 17: Color 10: ? "[1] ";: Color 14: ? "- 15-bit color": ?
Locate , 17: Color 10: ? "[2] ";: Color 14: ? "- 16-bit color": ?
Locate , 17: Color 10: ? "[3] ";: Color 14: ? "- 24-bit color": ?
Locate , 17: Color 10: ? "[4] ";: Color 14: ? "- 32-bit color"

Do
  Select case Inkey$
    Case "1": BitDepth = 15: Exit Do
    Case "2": BitDepth = 16: Exit Do
    Case "3": BitDepth = 24: Exit Do
    Case "4": BitDepth = 32: Exit Do
  End Select
Loop
Cls

ScreenRes 424, 280, , , 0
Color 15, 1: ? "         Please select your graphics mode!!!         "
Locate 4: Color 15, 0
Locate , 27: Color 10: ? "[1] ";: Color 14: ? "- 320x200"
Locate , 27: ?
Locate , 27: Color 10: ? "[2] ";: Color 14: ? "- 320x240"
Locate , 27: ?
Locate , 27: Color 10: ? "[3] ";: Color 14: ? "- 400x300"
Locate , 27: ?
Locate , 27: Color 10: ? "[4] ";: Color 14: ? "- 512x384"
Locate , 27: ?
Locate , 27: Color 10: ? "[5] ";: Color 14: ? "- 640x400"
Locate , 27: ?
Locate , 27: Color 10: ? "[6] ";: Color 14: ? "- 640x480"
Locate , 27: ?
Locate , 27: Color 10: ? "[7] ";: Color 14: ? "- 720x480"
Locate , 27: ?
Locate , 27: Color 10: ? "[8] ";: Color 14: ? "- 720x576"
Locate , 27: ?
Locate , 27: Color 10: ? "[9] ";: Color 14: ? "- 800x600"
Locate , 27: ?
Locate , 27: Color 10: ? "[0] ";: Color 14: ? "- 1024x768"
Locate , 27: ?
Locate , 27: Color 10: ? "[A] ";: Color 14: ? "- 1152x864"
Locate , 27: ?
Locate , 27: Color 10: ? "[B] ";: Color 14: ? "- 1280x720"
Locate , 27: ?
Locate , 27: Color 10: ? "[C] ";: Color 14: ? "- 1280x1024"
Locate , 27: ?
Locate , 27: Color 10: ? "[D] ";: Color 14: ? "- 1600x1200"
Locate , 27: ?
Locate , 27: Color 10: ? "[E] ";: Color 14: ? "- 1920x1080"
Locate 6, 5: Color 15: ? BitDepth; "-bit color"
Locate 7, 10: Color 15: ? "is selected!"

Do
  Select case Inkey$
    Case "1": ScreenRes 320, 200, BitDepth, 2, Full_or_Windowed: Exit Do
    Case "2": ScreenRes 320, 240, BitDepth, 2, Full_or_Windowed: Exit Do
    Case "3": ScreenRes 400, 300, BitDepth, 2, Full_or_Windowed: Exit Do
    Case "4": ScreenRes 512, 384, BitDepth, 2, Full_or_Windowed: Exit Do
    Case "5": ScreenRes 640, 400, BitDepth, 2, Full_or_Windowed: Exit Do
    Case "6": ScreenRes 640, 480, BitDepth, 2, Full_or_Windowed: Exit Do
    Case "7": ScreenRes 720, 480, BitDepth, 2, Full_or_Windowed: Exit Do
    Case "8": ScreenRes 720, 576, BitDepth, 2, Full_or_Windowed: Exit Do
    Case "9": ScreenRes 800, 600, BitDepth, 2, Full_or_Windowed: Exit Do
    Case "0": ScreenRes 1024, 768, BitDepth, 2, Full_or_Windowed: Exit Do
    Case "A", "a": ScreenRes 1152, 864, BitDepth, 2, Full_or_Windowed: Exit Do
    Case "B", "b": ScreenRes 1280, 720, BitDepth, 2, Full_or_Windowed: Exit Do
    Case "C", "c": ScreenRes 1280, 1024, BitDepth, 2, Full_or_Windowed: Exit Do
    Case "D", "d": ScreenRes 1600, 1200, BitDepth, 2, Full_or_Windowed: Exit Do
    Case "E", "e": ScreenRes 1920, 1080, BitDepth, 2, Full_or_Windowed: Exit Do
  End Select
Loop
SetMouse , , 0

Dim as Integer Screen_h, Screen_v
SetMouse , , 0

Windowtitle "AFlib III -- ASCii Drawing Primitives Test"

Dim as Integer GFX_h, GFX_v, MGFX_h, MGFX_v
ScreenInfo GFX_h, GFX_v: ScreenInfo MGFX_h, MGFX_v
GFX_h /= 8: GFX_v /= 8


Dim as Integer t, stime, BlitsPerSecond, BlitsPerSecond_max(1 to 30), TimeLeft, Rcol, waiting

Color RGB(255, 255, 30), RGB(0, 0, 128): Locate 1, 1: ? "------- A F l i b   I I I -------"
Color RGB(255, 205, 155), 0: Locate 2, 5: ? "ASCii Drawing Primitives Test"

If GFX_h > 320 then
  Color RGB(255, 255, 255), 0: Locate 4, 1: ? "(c)2005-2016 Adigun Azikiwe Polack/Aura Flow."
else
  Color RGB(255, 255, 255), 0: Locate 4, 1: ? "(c)2005-2016 AAP/Aura Flow."
End if
Color RGB(255, 255, 255), 0: Locate 5, 1: ? "All Rights Reserved."

Locate 7, 1: ? "Now Starting...";
For waiting = 0 to 9
  ? ".";: Sleep 500
Next

AFlibIII_ASCii_ClearDisplay RGB(0, 0, 0)
AFlibIII_Initialize_ASCii


'----- Testing for "AFlibIII_ASCii_Pixel" ------------------------------------------

BlitsPerSecond = 0
TimeLeft = 5
Do
  AFlibIII_ASCii_Pixel Chr(Int(rnd(1) * 255) + 1), _
                       Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                       RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), _
                       Int(rnd(1) * 36) + 1
  BlitsPerSecond += 1
  t = (timer - stime) * 2
  If t > 2 then
    BlitsPerSecond_max(1) = BlitsPerSecond
    BlitsPerSecond = 0
    stime = timer
    TimeLeft -= 1
  End if
Loop until TimeLeft = 0

AFlibIII_ASCii_FilledBox_alpha Chr(32), 0, 0, GFX_h - 1, 1, RGB(0, 0, 0), RGB(0, 0, 0), 200, 4
AFlibIII_ASCii_Print "AFlibIII_ASCii_Pixel", 0, 0, RGB(255, 255, 255), RGB(255, 0, 255), 4
AFlibIII_ASCii_Print "Blits per Second: " + Ltrim$(str$(BlitsPerSecond_max(1))), 0, 1, RGB(255, 255, 30), RGB(255, 0, 255), 4
While inkey$ <> "": Wend
Sleep 4000
AFlibIII_ASCii_ClearDisplay RGB(0, 0, 0)

'----- Testing for "AFlibIII_ASCii_Pixel_alpha" ------------------------------------------

BlitsPerSecond = 0
TimeLeft = 5
Do
  AFlibIII_ASCii_Pixel_alpha Chr(Int(rnd(1) * 255) + 1), _
                             Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                             RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), _
                             Int(rnd(1) * 64) + 1, Int(rnd(1) * 36) + 1
  BlitsPerSecond += 1
  t = (timer - stime) * 2
  If t > 2 then
    BlitsPerSecond_max(2) = BlitsPerSecond
    BlitsPerSecond = 0
    stime = timer
    TimeLeft -= 1
  End if
Loop until TimeLeft = 0

AFlibIII_ASCii_FilledBox_alpha Chr(32), 0, 0, GFX_h - 1, 1, RGB(0, 0, 0), RGB(0, 0, 0), 200, 4
AFlibIII_ASCii_Print "AFlibIII_ASCii_Pixel_alpha", 0, 0, RGB(255, 255, 255), RGB(255, 0, 255), 4
AFlibIII_ASCii_Print "Blits per Second: " + Ltrim$(str$(BlitsPerSecond_max(2))), 0, 1, RGB(255, 255, 30), RGB(255, 0, 255), 4
While inkey$ <> "": Wend
Sleep 4000
AFlibIII_ASCii_ClearDisplay RGB(0, 0, 0)

'----- Testing for "AFlibIII_ASCii_Pixel_add" ------------------------------------------

BlitsPerSecond = 0
TimeLeft = 5
Do
  AFlibIII_ASCii_Pixel_add Chr(Int(rnd(1) * 255) + 1), _
                           Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                           RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), _
                           Int(rnd(1) * 64) + 1, Int(rnd(1) * 36) + 1
  BlitsPerSecond += 1
  t = (timer - stime) * 2
  If t > 2 then
    BlitsPerSecond_max(3) = BlitsPerSecond
    BlitsPerSecond = 0
    stime = timer
    TimeLeft -= 1
  End if
Loop until TimeLeft = 0

AFlibIII_ASCii_FilledBox_alpha Chr(32), 0, 0, GFX_h - 1, 1, RGB(0, 0, 0), RGB(0, 0, 0), 200, 4
AFlibIII_ASCii_Print "AFlibIII_ASCii_Pixel_add", 0, 0, RGB(255, 255, 255), RGB(255, 0, 255), 4
AFlibIII_ASCii_Print "Blits per Second: " + Ltrim$(str$(BlitsPerSecond_max(3))), 0, 1, RGB(255, 255, 30), RGB(255, 0, 255), 4
While inkey$ <> "": Wend
Sleep 4000
AFlibIII_ASCii_ClearDisplay RGB(0, 0, 0)

'----- Testing for "AFlibIII_ASCii_Line" ------------------------------------------

BlitsPerSecond = 0
TimeLeft = 5
Do
  AFlibIII_ASCii_Line Chr(Int(rnd(1) * 255) + 1), _
                      Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                      RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), _
                      Int(rnd(1) * 36) + 1
  BlitsPerSecond += 1
  t = (timer - stime) * 2
  If t > 2 then
    BlitsPerSecond_max(4) = BlitsPerSecond
    BlitsPerSecond = 0
    stime = timer
    TimeLeft -= 1
  End if
Loop until TimeLeft = 0

AFlibIII_ASCii_FilledBox_alpha Chr(32), 0, 0, GFX_h - 1, 1, RGB(0, 0, 0), RGB(0, 0, 0), 200, 4
AFlibIII_ASCii_Print "AFlibIII_ASCii_Line", 0, 0, RGB(255, 255, 255), RGB(255, 0, 255), 4
AFlibIII_ASCii_Print "Blits per Second: " + Ltrim$(str$(BlitsPerSecond_max(4))), 0, 1, RGB(255, 255, 30), RGB(255, 0, 255), 4
While inkey$ <> "": Wend
Sleep 4000
AFlibIII_ASCii_ClearDisplay RGB(0, 0, 0)

'----- Testing for "AFlibIII_ASCii_Line_alpha" ------------------------------------------

BlitsPerSecond = 0
TimeLeft = 5
Do
  AFlibIII_ASCii_Line_alpha Chr(Int(rnd(1) * 255) + 1), _
                            Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                            RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), _
                            Int(rnd(1) * 64) + 1, Int(rnd(1) * 36) + 1
  BlitsPerSecond += 1
  t = (timer - stime) * 2
  If t > 2 then
    BlitsPerSecond_max(5) = BlitsPerSecond
    BlitsPerSecond = 0
    stime = timer
    TimeLeft -= 1
  End if
Loop until TimeLeft = 0

AFlibIII_ASCii_FilledBox_alpha Chr(32), 0, 0, GFX_h - 1, 1, RGB(0, 0, 0), RGB(0, 0, 0), 200, 4
AFlibIII_ASCii_Print "AFlibIII_ASCii_Line_alpha", 0, 0, RGB(255, 255, 255), RGB(255, 0, 255), 4
AFlibIII_ASCii_Print "Blits per Second: " + Ltrim$(str$(BlitsPerSecond_max(5))), 0, 1, RGB(255, 255, 30), RGB(255, 0, 255), 4
While inkey$ <> "": Wend
Sleep 4000
AFlibIII_ASCii_ClearDisplay RGB(0, 0, 0)

'----- Testing for "AFlibIII_ASCii_Line_add" ------------------------------------------

BlitsPerSecond = 0
TimeLeft = 5
Do
  AFlibIII_ASCii_Line_add Chr(Int(rnd(1) * 255) + 1), _
                          Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                          RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), _
                          Int(rnd(1) * 64) + 1, Int(rnd(1) * 36) + 1
  BlitsPerSecond += 1
  t = (timer - stime) * 2
  If t > 2 then
    BlitsPerSecond_max(6) = BlitsPerSecond
    BlitsPerSecond = 0
    stime = timer
    TimeLeft -= 1
  End if
Loop until TimeLeft = 0

AFlibIII_ASCii_FilledBox_alpha Chr(32), 0, 0, GFX_h - 1, 1, RGB(0, 0, 0), RGB(0, 0, 0), 200, 4
AFlibIII_ASCii_Print "AFlibIII_ASCii_Line_add", 0, 0, RGB(255, 255, 255), RGB(255, 0, 255), 4
AFlibIII_ASCii_Print "Blits per Second: " + Ltrim$(str$(BlitsPerSecond_max(6))), 0, 1, RGB(255, 255, 30), RGB(255, 0, 255), 4
While inkey$ <> "": Wend
Sleep 4000
AFlibIII_ASCii_ClearDisplay RGB(0, 0, 0)

'----- Testing for "AFlibIII_ASCii_Box" ------------------------------------------

BlitsPerSecond = 0
TimeLeft = 5
Do
  AFlibIII_ASCii_Box Chr(Int(rnd(1) * 255) + 1), _
                     Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                     RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), _
                     Int(rnd(1) * 36) + 1
  BlitsPerSecond += 1
  t = (timer - stime) * 2
  If t > 2 then
    BlitsPerSecond_max(7) = BlitsPerSecond
    BlitsPerSecond = 0
    stime = timer
    TimeLeft -= 1
  End if
Loop until TimeLeft = 0

AFlibIII_ASCii_FilledBox_alpha Chr(32), 0, 0, GFX_h - 1, 1, RGB(0, 0, 0), RGB(0, 0, 0), 200, 4
AFlibIII_ASCii_Print "AFlibIII_ASCii_Box", 0, 0, RGB(255, 255, 255), RGB(255, 0, 255), 4
AFlibIII_ASCii_Print "Blits per Second: " + Ltrim$(str$(BlitsPerSecond_max(7))), 0, 1, RGB(255, 255, 30), RGB(255, 0, 255), 4
While inkey$ <> "": Wend
Sleep 4000
AFlibIII_ASCii_ClearDisplay RGB(0, 0, 0)

'----- Testing for "AFlibIII_ASCii_Box_alpha" ------------------------------------------

BlitsPerSecond = 0
TimeLeft = 5
Do
  AFlibIII_ASCii_Box_alpha Chr(Int(rnd(1) * 255) + 1), _
                           Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                           RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), _
                           Int(rnd(1) * 64) + 1, Int(rnd(1) * 36) + 1
  BlitsPerSecond += 1
  t = (timer - stime) * 2
  If t > 2 then
    BlitsPerSecond_max(8) = BlitsPerSecond
    BlitsPerSecond = 0
    stime = timer
    TimeLeft -= 1
  End if
Loop until TimeLeft = 0

AFlibIII_ASCii_FilledBox_alpha Chr(32), 0, 0, GFX_h - 1, 1, RGB(0, 0, 0), RGB(0, 0, 0), 200, 4
AFlibIII_ASCii_Print "AFlibIII_ASCii_Box_alpha", 0, 0, RGB(255, 255, 255), RGB(255, 0, 255), 4
AFlibIII_ASCii_Print "Blits per Second: " + Ltrim$(str$(BlitsPerSecond_max(8))), 0, 1, RGB(255, 255, 30), RGB(255, 0, 255), 4
While inkey$ <> "": Wend
Sleep 4000
AFlibIII_ASCii_ClearDisplay RGB(0, 0, 0)

'----- Testing for "AFlibIII_ASCii_Box_add" ------------------------------------------

BlitsPerSecond = 0
TimeLeft = 5
Do
  AFlibIII_ASCii_Box_add Chr(Int(rnd(1) * 255) + 1), _
                         Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                         RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), _
                         Int(rnd(1) * 64) + 1, Int(rnd(1) * 36) + 1
  BlitsPerSecond += 1
  t = (timer - stime) * 2
  If t > 2 then
    BlitsPerSecond_max(9) = BlitsPerSecond
    BlitsPerSecond = 0
    stime = timer
    TimeLeft -= 1
  End if
Loop until TimeLeft = 0

AFlibIII_ASCii_FilledBox_alpha Chr(32), 0, 0, GFX_h - 1, 1, RGB(0, 0, 0), RGB(0, 0, 0), 200, 4
AFlibIII_ASCii_Print "AFlibIII_ASCii_Box_add", 0, 0, RGB(255, 255, 255), RGB(255, 0, 255), 4
AFlibIII_ASCii_Print "Blits per Second: " + Ltrim$(str$(BlitsPerSecond_max(9))), 0, 1, RGB(255, 255, 30), RGB(255, 0, 255), 4
While inkey$ <> "": Wend
Sleep 4000
AFlibIII_ASCii_ClearDisplay RGB(0, 0, 0)

'----- Testing for "AFlibIII_ASCii_FilledBox" ------------------------------------------

BlitsPerSecond = 0
TimeLeft = 5
Do
  AFlibIII_ASCii_FilledBox Chr(Int(rnd(1) * 255) + 1), _
                           Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                           RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), _
                           Int(rnd(1) * 36) + 1
  BlitsPerSecond += 1
  t = (timer - stime) * 2
  If t > 2 then
    BlitsPerSecond_max(10) = BlitsPerSecond
    BlitsPerSecond = 0
    stime = timer
    TimeLeft -= 1
  End if
Loop until TimeLeft = 0

AFlibIII_ASCii_FilledBox_alpha Chr(32), 0, 0, GFX_h - 1, 1, RGB(0, 0, 0), RGB(0, 0, 0), 200, 4
AFlibIII_ASCii_Print "AFlibIII_ASCii_FilledBox", 0, 0, RGB(255, 255, 255), RGB(255, 0, 255), 4
AFlibIII_ASCii_Print "Blits per Second: " + Ltrim$(str$(BlitsPerSecond_max(10))), 0, 1, RGB(255, 255, 30), RGB(255, 0, 255), 4
While inkey$ <> "": Wend
Sleep 4000
AFlibIII_ASCii_ClearDisplay RGB(0, 0, 0)

'----- Testing for "AFlibIII_ASCii_FilledBox_alpha" ------------------------------------------

BlitsPerSecond = 0
TimeLeft = 5
Do
  AFlibIII_ASCii_FilledBox_alpha Chr(Int(rnd(1) * 255) + 1), _
                                 Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                                 RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), _
                                 Int(rnd(1) * 64) + 1, Int(rnd(1) * 36) + 1
  BlitsPerSecond += 1
  t = (timer - stime) * 2
  If t > 2 then
    BlitsPerSecond_max(11) = BlitsPerSecond
    BlitsPerSecond = 0
    stime = timer
    TimeLeft -= 1
  End if
Loop until TimeLeft = 0

AFlibIII_ASCii_FilledBox_alpha Chr(32), 0, 0, GFX_h - 1, 1, RGB(0, 0, 0), RGB(0, 0, 0), 200, 4
AFlibIII_ASCii_Print "AFlibIII_ASCii_FilledBox_alpha", 0, 0, RGB(255, 255, 255), RGB(255, 0, 255), 4
AFlibIII_ASCii_Print "Blits per Second: " + Ltrim$(str$(BlitsPerSecond_max(11))), 0, 1, RGB(255, 255, 30), RGB(255, 0, 255), 4
While inkey$ <> "": Wend
Sleep 4000
AFlibIII_ASCii_ClearDisplay RGB(0, 0, 0)

'----- Testing for "AFlibIII_ASCii_FilledBox_add" ------------------------------------------

BlitsPerSecond = 0
TimeLeft = 5
Do
  AFlibIII_ASCii_FilledBox_add Chr(Int(rnd(1) * 255) + 1), _
                               Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                               RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), _
                               Int(rnd(1) * 64) + 1, Int(rnd(1) * 36) + 1
  BlitsPerSecond += 1
  t = (timer - stime) * 2
  If t > 2 then
    BlitsPerSecond_max(12) = BlitsPerSecond
    BlitsPerSecond = 0
    stime = timer
    TimeLeft -= 1
  End if
Loop until TimeLeft = 0

AFlibIII_ASCii_FilledBox_alpha Chr(32), 0, 0, GFX_h - 1, 1, RGB(0, 0, 0), RGB(0, 0, 0), 200, 4
AFlibIII_ASCii_Print "AFlibIII_ASCii_FilledBox_add", 0, 0, RGB(255, 255, 255), RGB(255, 0, 255), 4
AFlibIII_ASCii_Print "Blits per Second: " + Ltrim$(str$(BlitsPerSecond_max(12))), 0, 1, RGB(255, 255, 30), RGB(255, 0, 255), 4
While inkey$ <> "": Wend
Sleep 4000
AFlibIII_ASCii_ClearDisplay RGB(0, 0, 0)

'----- Testing for "AFlibIII_ASCii_Circle" ------------------------------------------

BlitsPerSecond = 0
TimeLeft = 5
Do
  AFlibIII_ASCii_Circle Chr(Int(rnd(1) * 255) + 1), _
                        Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                        Int(rnd(1) * 59) + 1, Int(rnd(1) * 59) + 1, _
                        RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), _
                        Int(rnd(1) * 36) + 1
  BlitsPerSecond += 1
  t = (timer - stime) * 2
  If t > 2 then
    BlitsPerSecond_max(13) = BlitsPerSecond
    BlitsPerSecond = 0
    stime = timer
    TimeLeft -= 1
  End if
Loop until TimeLeft = 0

AFlibIII_ASCii_FilledBox_alpha Chr(32), 0, 0, GFX_h - 1, 1, RGB(0, 0, 0), RGB(0, 0, 0), 200, 4
AFlibIII_ASCii_Print "AFlibIII_ASCii_Circle", 0, 0, RGB(255, 255, 255), RGB(255, 0, 255), 4
AFlibIII_ASCii_Print "Blits per Second: " + Ltrim$(str$(BlitsPerSecond_max(13))), 0, 1, RGB(255, 255, 30), RGB(255, 0, 255), 4
While inkey$ <> "": Wend
Sleep 4000
AFlibIII_ASCii_ClearDisplay RGB(0, 0, 0)

'----- Testing for "AFlibIII_ASCii_Circle_alpha" ------------------------------------------

BlitsPerSecond = 0
TimeLeft = 5
Do
  AFlibIII_ASCii_Circle_alpha Chr(Int(rnd(1) * 255) + 1), _
                              Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                              Int(rnd(1) * 59) + 1, Int(rnd(1) * 59) + 1, _
                              RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), _
                              Int(rnd(1) * 64) + 1, Int(rnd(1) * 36) + 1
  BlitsPerSecond += 1
  t = (timer - stime) * 2
  If t > 2 then
    BlitsPerSecond_max(14) = BlitsPerSecond
    BlitsPerSecond = 0
    stime = timer
    TimeLeft -= 1
  End if
Loop until TimeLeft = 0

AFlibIII_ASCii_FilledBox_alpha Chr(32), 0, 0, GFX_h - 1, 1, RGB(0, 0, 0), RGB(0, 0, 0), 200, 4
AFlibIII_ASCii_Print "AFlibIII_ASCii_Circle_alpha", 0, 0, RGB(255, 255, 255), RGB(255, 0, 255), 4
AFlibIII_ASCii_Print "Blits per Second: " + Ltrim$(str$(BlitsPerSecond_max(14))), 0, 1, RGB(255, 255, 30), RGB(255, 0, 255), 4
While inkey$ <> "": Wend
Sleep 4000
AFlibIII_ASCii_ClearDisplay RGB(0, 0, 0)

'----- Testing for "AFlibIII_ASCii_Circle_add" ------------------------------------------

BlitsPerSecond = 0
TimeLeft = 5
Do
  AFlibIII_ASCii_Circle_add Chr(Int(rnd(1) * 255) + 1), _
                            Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                            Int(rnd(1) * 59) + 1, Int(rnd(1) * 59) + 1, _
                            RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), _
                            Int(rnd(1) * 64) + 1, Int(rnd(1) * 36) + 1
  BlitsPerSecond += 1
  t = (timer - stime) * 2
  If t > 2 then
    BlitsPerSecond_max(15) = BlitsPerSecond
    BlitsPerSecond = 0
    stime = timer
    TimeLeft -= 1
  End if
Loop until TimeLeft = 0

AFlibIII_ASCii_FilledBox_alpha Chr(32), 0, 0, GFX_h - 1, 1, RGB(0, 0, 0), RGB(0, 0, 0), 200, 4
AFlibIII_ASCii_Print "AFlibIII_ASCii_Circle_add", 0, 0, RGB(255, 255, 255), RGB(255, 0, 255), 4
AFlibIII_ASCii_Print "Blits per Second: " + Ltrim$(str$(BlitsPerSecond_max(15))), 0, 1, RGB(255, 255, 30), RGB(255, 0, 255), 4
While inkey$ <> "": Wend
Sleep 4000
AFlibIII_ASCii_ClearDisplay RGB(0, 0, 0)

'----- Testing for "AFlibIII_ASCii_FilledCircle" ------------------------------------------

BlitsPerSecond = 0
TimeLeft = 5
Do
  AFlibIII_ASCii_FilledCircle Chr(Int(rnd(1) * 255) + 1), _
                              Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                              Int(rnd(1) * 39) + 1, Int(rnd(1) * 39) + 1, _
                              RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), _
                              Int(rnd(1) * 36) + 1
  BlitsPerSecond += 1
  t = (timer - stime) * 2
  If t > 2 then
    BlitsPerSecond_max(16) = BlitsPerSecond
    BlitsPerSecond = 0
    stime = timer
    TimeLeft -= 1
  End if
Loop until TimeLeft = 0

AFlibIII_ASCii_FilledBox_alpha Chr(32), 0, 0, GFX_h - 1, 1, RGB(0, 0, 0), RGB(0, 0, 0), 200, 4
AFlibIII_ASCii_Print "AFlibIII_ASCii_FilledCircle", 0, 0, RGB(255, 255, 255), RGB(255, 0, 255), 4
AFlibIII_ASCii_Print "Blits per Second: " + Ltrim$(str$(BlitsPerSecond_max(16))), 0, 1, RGB(255, 255, 30), RGB(255, 0, 255), 4
While inkey$ <> "": Wend
Sleep 4000
AFlibIII_ASCii_ClearDisplay RGB(0, 0, 0)

'----- Testing for "AFlibIII_ASCii_FilledCircle_alpha" ------------------------------------------

BlitsPerSecond = 0
TimeLeft = 5
Do
  AFlibIII_ASCii_FilledCircle_alpha Chr(Int(rnd(1) * 255) + 1), _
                                    Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                                    Int(rnd(1) * 39) + 1, Int(rnd(1) * 39) + 1, _
                                    RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), _
                                    Int(rnd(1) * 64) + 1, Int(rnd(1) * 36) + 1
  BlitsPerSecond += 1
  t = (timer - stime) * 2
  If t > 2 then
    BlitsPerSecond_max(17) = BlitsPerSecond
    BlitsPerSecond = 0
    stime = timer
    TimeLeft -= 1
  End if
Loop until TimeLeft = 0

AFlibIII_ASCii_FilledBox_alpha Chr(32), 0, 0, GFX_h - 1, 1, RGB(0, 0, 0), RGB(0, 0, 0), 200, 4
AFlibIII_ASCii_Print "AFlibIII_ASCii_FilledCircle_alpha", 0, 0, RGB(255, 255, 255), RGB(255, 0, 255), 4
AFlibIII_ASCii_Print "Blits per Second: " + Ltrim$(str$(BlitsPerSecond_max(17))), 0, 1, RGB(255, 255, 30), RGB(255, 0, 255), 4
While inkey$ <> "": Wend
Sleep 4000
AFlibIII_ASCii_ClearDisplay RGB(0, 0, 0)

'----- Testing for "AFlibIII_ASCii_FilledCircle_add" ------------------------------------------

BlitsPerSecond = 0
TimeLeft = 5
Do
  AFlibIII_ASCii_FilledCircle_add Chr(Int(rnd(1) * 255) + 1), _
                                  Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                                  Int(rnd(1) * 39) + 1, Int(rnd(1) * 39) + 1, _
                                  RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), _
                                  Int(rnd(1) * 64) + 1, Int(rnd(1) * 36) + 1
  BlitsPerSecond += 1
  t = (timer - stime) * 2
  If t > 2 then
    BlitsPerSecond_max(18) = BlitsPerSecond
    BlitsPerSecond = 0
    stime = timer
    TimeLeft -= 1
  End if
Loop until TimeLeft = 0

AFlibIII_ASCii_FilledBox_alpha Chr(32), 0, 0, GFX_h - 1, 1, RGB(0, 0, 0), RGB(0, 0, 0), 200, 4
AFlibIII_ASCii_Print "AFlibIII_ASCii_FilledCircle_add", 0, 0, RGB(255, 255, 255), RGB(255, 0, 255), 4
AFlibIII_ASCii_Print "Blits per Second: " + Ltrim$(str$(BlitsPerSecond_max(18))), 0, 1, RGB(255, 255, 30), RGB(255, 0, 255), 4
While inkey$ <> "": Wend
Sleep 4000
AFlibIII_ASCii_ClearDisplay RGB(0, 0, 0)

'----- Testing for "AFlibIII_ASCii_Triangle" ------------------------------------------

BlitsPerSecond = 0
TimeLeft = 5
Do
  AFlibIII_ASCii_Triangle Chr(Int(rnd(1) * 255) + 1), _
                          Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                          Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                          Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                          RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), _
                          Int(rnd(1) * 36) + 1
  BlitsPerSecond += 1
  t = (timer - stime) * 2
  If t > 2 then
    BlitsPerSecond_max(19) = BlitsPerSecond
    BlitsPerSecond = 0
    stime = timer
    TimeLeft -= 1
  End if
Loop until TimeLeft = 0

AFlibIII_ASCii_FilledBox_alpha Chr(32), 0, 0, GFX_h - 1, 1, RGB(0, 0, 0), RGB(0, 0, 0), 200, 4
AFlibIII_ASCii_Print "AFlibIII_ASCii_Triangle", 0, 0, RGB(255, 255, 255), RGB(255, 0, 255), 4
AFlibIII_ASCii_Print "Blits per Second: " + Ltrim$(str$(BlitsPerSecond_max(19))), 0, 1, RGB(255, 255, 30), RGB(255, 0, 255), 4
While inkey$ <> "": Wend
Sleep 4000
AFlibIII_ASCii_ClearDisplay RGB(0, 0, 0)

'----- Testing for "AFlibIII_ASCii_Triangle_alpha" ------------------------------------------

BlitsPerSecond = 0
TimeLeft = 5
Do
  AFlibIII_ASCii_Triangle_alpha Chr(Int(rnd(1) * 255) + 1), _
                                Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                                Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                                Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                                RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), _
                                Int(rnd(1) * 64) + 1, Int(rnd(1) * 36) + 1
  BlitsPerSecond += 1
  t = (timer - stime) * 2
  If t > 2 then
    BlitsPerSecond_max(20) = BlitsPerSecond
    BlitsPerSecond = 0
    stime = timer
    TimeLeft -= 1
  End if
Loop until TimeLeft = 0

AFlibIII_ASCii_FilledBox_alpha Chr(32), 0, 0, GFX_h - 1, 1, RGB(0, 0, 0), RGB(0, 0, 0), 200, 4
AFlibIII_ASCii_Print "AFlibIII_ASCii_Triangle_alpha", 0, 0, RGB(255, 255, 255), RGB(255, 0, 255), 4
AFlibIII_ASCii_Print "Blits per Second: " + Ltrim$(str$(BlitsPerSecond_max(20))), 0, 1, RGB(255, 255, 30), RGB(255, 0, 255), 4
While inkey$ <> "": Wend
Sleep 4000
AFlibIII_ASCii_ClearDisplay RGB(0, 0, 0)

'----- Testing for "AFlibIII_ASCii_Triangle_add" ------------------------------------------

BlitsPerSecond = 0
TimeLeft = 5
Do
  AFlibIII_ASCii_Triangle_add Chr(Int(rnd(1) * 255) + 1), _
                              Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                              Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                              Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                              RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), _
                              Int(rnd(1) * 64) + 1, Int(rnd(1) * 36) + 1
  BlitsPerSecond += 1
  t = (timer - stime) * 2
  If t > 2 then
    BlitsPerSecond_max(21) = BlitsPerSecond
    BlitsPerSecond = 0
    stime = timer
    TimeLeft -= 1
  End if
Loop until TimeLeft = 0

AFlibIII_ASCii_FilledBox_alpha Chr(32), 0, 0, GFX_h - 1, 1, RGB(0, 0, 0), RGB(0, 0, 0), 200, 4
AFlibIII_ASCii_Print "AFlibIII_ASCii_Triangle_add", 0, 0, RGB(255, 255, 255), RGB(255, 0, 255), 4
AFlibIII_ASCii_Print "Blits per Second: " + Ltrim$(str$(BlitsPerSecond_max(21))), 0, 1, RGB(255, 255, 30), RGB(255, 0, 255), 4
While inkey$ <> "": Wend
Sleep 4000
AFlibIII_ASCii_ClearDisplay RGB(0, 0, 0)

'----- Testing for "AFlibIII_ASCii_FilledTriangle" ------------------------------------------

BlitsPerSecond = 0
TimeLeft = 5
Do
  AFlibIII_ASCii_FilledTriangle Chr(Int(rnd(1) * 255) + 1), _
                                Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                                Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                                Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                                RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), _
                                Int(rnd(1) * 36) + 1
  BlitsPerSecond += 1
  t = (timer - stime) * 2
  If t > 2 then
    BlitsPerSecond_max(22) = BlitsPerSecond
    BlitsPerSecond = 0
    stime = timer
    TimeLeft -= 1
  End if
Loop until TimeLeft = 0

AFlibIII_ASCii_FilledBox_alpha Chr(32), 0, 0, GFX_h - 1, 1, RGB(0, 0, 0), RGB(0, 0, 0), 200, 4
AFlibIII_ASCii_Print "AFlibIII_ASCii_FilledTriangle", 0, 0, RGB(255, 255, 255), RGB(255, 0, 255), 4
AFlibIII_ASCii_Print "Blits per Second: " + Ltrim$(str$(BlitsPerSecond_max(22))), 0, 1, RGB(255, 255, 30), RGB(255, 0, 255), 4
While inkey$ <> "": Wend
Sleep 4000
AFlibIII_ASCii_ClearDisplay RGB(0, 0, 0)

'----- Testing for "AFlibIII_ASCii_FilledTriangle_alpha" ------------------------------------------

BlitsPerSecond = 0
TimeLeft = 5
Do
  AFlibIII_ASCii_FilledTriangle_alpha Chr(Int(rnd(1) * 255) + 1), _
                                      Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                                      Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                                      Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                                      RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), _
                                      Int(rnd(1) * 64) + 1, Int(rnd(1) * 36) + 1
  BlitsPerSecond += 1
  t = (timer - stime) * 2
  If t > 2 then
    BlitsPerSecond_max(23) = BlitsPerSecond
    BlitsPerSecond = 0
    stime = timer
    TimeLeft -= 1
  End if
Loop until TimeLeft = 0

AFlibIII_ASCii_FilledBox_alpha Chr(32), 0, 0, GFX_h - 1, 1, RGB(0, 0, 0), RGB(0, 0, 0), 200, 4
AFlibIII_ASCii_Print "AFlibIII_ASCii_FilledTriangle_alpha", 0, 0, RGB(255, 255, 255), RGB(255, 0, 255), 4
AFlibIII_ASCii_Print "Blits per Second: " + Ltrim$(str$(BlitsPerSecond_max(23))), 0, 1, RGB(255, 255, 30), RGB(255, 0, 255), 4
While inkey$ <> "": Wend
Sleep 4000
AFlibIII_ASCii_ClearDisplay RGB(0, 0, 0)

'----- Testing for "AFlibIII_ASCii_FilledTriangle_add" ------------------------------------------

BlitsPerSecond = 0
TimeLeft = 5
Do
  AFlibIII_ASCii_FilledTriangle_add Chr(Int(rnd(1) * 255) + 1), _
                                    Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                                    Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                                    Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                                    RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), _
                                    Int(rnd(1) * 64) + 1, Int(rnd(1) * 36) + 1
  BlitsPerSecond += 1
  t = (timer - stime) * 2
  If t > 2 then
    BlitsPerSecond_max(24) = BlitsPerSecond
    BlitsPerSecond = 0
    stime = timer
    TimeLeft -= 1
  End if
Loop until TimeLeft = 0

AFlibIII_ASCii_FilledBox_alpha Chr(32), 0, 0, GFX_h - 1, 1, RGB(0, 0, 0), RGB(0, 0, 0), 200, 4
AFlibIII_ASCii_Print "AFlibIII_ASCii_FilledTriangle_add", 0, 0, RGB(255, 255, 255), RGB(255, 0, 255), 4
AFlibIII_ASCii_Print "Blits per Second: " + Ltrim$(str$(BlitsPerSecond_max(24))), 0, 1, RGB(255, 255, 30), RGB(255, 0, 255), 4
While inkey$ <> "": Wend
Sleep 4000
AFlibIII_ASCii_ClearDisplay RGB(0, 0, 0)

'----- Testing for "AFlibIII_ASCii_Globe" ------------------------------------------

BlitsPerSecond = 0
TimeLeft = 5
Do
  AFlibIII_ASCii_Globe Chr(Int(rnd(1) * 255) + 1), _
                       Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                       (Int(rnd(1) * 20) + 1) / 10, (Int(rnd(1) * 20) + 1) / 10, _
                       (Int(rnd(1) * 200) + 1) / 10, _
                       RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), RGB(int((rnd(1)*255 + 1) / 2), int((rnd(1)*255 + 1) / 2), int((rnd(1)*255 + 1) / 2)), _
                       RGB((int(rnd(1)*255 + 1) / 2), (int(rnd(1)*255 + 1) / 2), (int(rnd(1)*255 + 1) / 2)), _
                       Int(rnd(1) * 25) + 1, _
                       Int(rnd(1) * 36) + 1
  BlitsPerSecond += 1
  t = (timer - stime) * 2
  If t > 2 then
    BlitsPerSecond_max(25) = BlitsPerSecond
    BlitsPerSecond = 0
    stime = timer
    TimeLeft -= 1
  End if
Loop until TimeLeft = 0

AFlibIII_ASCii_FilledBox_alpha Chr(32), 0, 0, GFX_h - 1, 1, RGB(0, 0, 0), RGB(0, 0, 0), 200, 4
AFlibIII_ASCii_Print "AFlibIII_ASCii_Globe", 0, 0, RGB(255, 255, 255), RGB(255, 0, 255), 4
AFlibIII_ASCii_Print "Blits per Second: " + Ltrim$(str$(BlitsPerSecond_max(25))), 0, 1, RGB(255, 255, 30), RGB(255, 0, 255), 4
While inkey$ <> "": Wend
Sleep 4000
AFlibIII_ASCii_ClearDisplay RGB(0, 0, 0)

'----- Testing for "AFlibIII_ASCii_Globe_alpha" ------------------------------------------

BlitsPerSecond = 0
TimeLeft = 5
Do
  AFlibIII_ASCii_Globe_alpha Chr(Int(rnd(1) * 255) + 1), _
                             Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                             (Int(rnd(1) * 20) + 1) / 10, (Int(rnd(1) * 20) + 1) / 10, _
                             (Int(rnd(1) * 200) + 1) / 10, _
                             RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), RGB(int((rnd(1)*255 + 1) / 2), int((rnd(1)*255 + 1) / 2), int((rnd(1)*255 + 1) / 2)), _
                             RGB((int(rnd(1)*255 + 1) / 2), (int(rnd(1)*255 + 1) / 2), (int(rnd(1)*255 + 1) / 2)), _
                             Int(rnd(1) * 25) + 1, _
                             Int(rnd(1) * 255) + 1, Int(rnd(1) * 36) + 1
  BlitsPerSecond += 1
  t = (timer - stime) * 2
  If t > 2 then
    BlitsPerSecond_max(26) = BlitsPerSecond
    BlitsPerSecond = 0
    stime = timer
    TimeLeft -= 1
  End if
Loop until TimeLeft = 0

AFlibIII_ASCii_FilledBox_alpha Chr(32), 0, 0, GFX_h - 1, 1, RGB(0, 0, 0), RGB(0, 0, 0), 200, 4
AFlibIII_ASCii_Print "AFlibIII_ASCii_Globe_alpha", 0, 0, RGB(255, 255, 255), RGB(255, 0, 255), 4
AFlibIII_ASCii_Print "Blits per Second: " + Ltrim$(str$(BlitsPerSecond_max(26))), 0, 1, RGB(255, 255, 30), RGB(255, 0, 255), 4
While inkey$ <> "": Wend
Sleep 4000
AFlibIII_ASCii_ClearDisplay RGB(0, 0, 0)

'----- Testing for "AFlibIII_ASCii_Globe_add" ------------------------------------------

BlitsPerSecond = 0
TimeLeft = 5
Do
  AFlibIII_ASCii_Globe_add Chr(Int(rnd(1) * 255) + 1), _
                           Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                           (Int(rnd(1) * 20) + 1) / 10, (Int(rnd(1) * 20) + 1) / 10, _
                           (Int(rnd(1) * 200) + 1) / 10, _
                           RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), RGB(int((rnd(1)*255 + 1) / 2), int((rnd(1)*255 + 1) / 2), int((rnd(1)*255 + 1) / 2)), _
                           RGB((int(rnd(1)*255 + 1) / 2), (int(rnd(1)*255 + 1) / 2), (int(rnd(1)*255 + 1) / 2)), _
                           Int(rnd(1) * 25) + 1, _
                           Int(rnd(1) * 255) + 1, Int(rnd(1) * 36) + 1
  BlitsPerSecond += 1
  t = (timer - stime) * 2
  If t > 2 then
    BlitsPerSecond_max(27) = BlitsPerSecond
    BlitsPerSecond = 0
    stime = timer
    TimeLeft -= 1
  End if
Loop until TimeLeft = 0

AFlibIII_ASCii_FilledBox_alpha Chr(32), 0, 0, GFX_h - 1, 1, RGB(0, 0, 0), RGB(0, 0, 0), 200, 4
AFlibIII_ASCii_Print "AFlibIII_ASCii_Globe_add", 0, 0, RGB(255, 255, 255), RGB(255, 0, 255), 4
AFlibIII_ASCii_Print "Blits per Second: " + Ltrim$(str$(BlitsPerSecond_max(27))), 0, 1, RGB(255, 255, 30), RGB(255, 0, 255), 4
While inkey$ <> "": Wend
Sleep 4000
AFlibIII_ASCii_ClearDisplay RGB(0, 0, 0)

'----- Testing for "AFlibIII_ASCii_Lightning" ------------------------------------------

BlitsPerSecond = 0
TimeLeft = 5
Do
  AFlibIII_ASCii_Lightning Chr(Int(rnd(1) * 255) + 1), _
                           Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                           Int(rnd(1) * 40) + 1, _
                           RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), _
                           Int(rnd(1) * 36) + 1
  BlitsPerSecond += 1
  t = (timer - stime) * 2
  If t > 2 then
    BlitsPerSecond_max(28) = BlitsPerSecond
    BlitsPerSecond = 0
    stime = timer
    TimeLeft -= 1
  End if
Loop until TimeLeft = 0

AFlibIII_ASCii_FilledBox_alpha Chr(32), 0, 0, GFX_h - 1, 1, RGB(0, 0, 0), RGB(0, 0, 0), 200, 4
AFlibIII_ASCii_Print "AFlibIII_ASCii_Lightning", 0, 0, RGB(255, 255, 255), RGB(255, 0, 255), 4
AFlibIII_ASCii_Print "Blits per Second: " + Ltrim$(str$(BlitsPerSecond_max(28))), 0, 1, RGB(255, 255, 30), RGB(255, 0, 255), 4
While inkey$ <> "": Wend
Sleep 4000
AFlibIII_ASCii_ClearDisplay RGB(0, 0, 0)

'----- Testing for "AFlibIII_ASCii_Lightning_alpha" ------------------------------------------

BlitsPerSecond = 0
TimeLeft = 5
Do
  AFlibIII_ASCii_Lightning_alpha Chr(Int(rnd(1) * 255) + 1), _
                                 Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                                 Int(rnd(1) * 40) + 1, _
                                 RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), _
                                 Int(rnd(1) * 64) + 1, Int(rnd(1) * 36) + 1
  BlitsPerSecond += 1
  t = (timer - stime) * 2
  If t > 2 then
    BlitsPerSecond_max(29) = BlitsPerSecond
    BlitsPerSecond = 0
    stime = timer
    TimeLeft -= 1
  End if
Loop until TimeLeft = 0

AFlibIII_ASCii_FilledBox_alpha Chr(32), 0, 0, GFX_h - 1, 1, RGB(0, 0, 0), RGB(0, 0, 0), 200, 4
AFlibIII_ASCii_Print "AFlibIII_ASCii_Lightning_alpha", 0, 0, RGB(255, 255, 255), RGB(255, 0, 255), 4
AFlibIII_ASCii_Print "Blits per Second: " + Ltrim$(str$(BlitsPerSecond_max(29))), 0, 1, RGB(255, 255, 30), RGB(255, 0, 255), 4
While inkey$ <> "": Wend
Sleep 4000
AFlibIII_ASCii_ClearDisplay RGB(0, 0, 0)

'----- Testing for "AFlibIII_ASCii_Lightning_add" ------------------------------------------

BlitsPerSecond = 0
TimeLeft = 5
Do
  AFlibIII_ASCii_Lightning_add Chr(Int(rnd(1) * 255) + 1), _
                               Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), Int(rnd(1) * GFX_h), Int(rnd(1) * GFX_v), _
                               Int(rnd(1) * 40) + 1, _
                               RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), RGB(int(rnd(1)*255 + 1), int(rnd(1)*255 + 1), int(rnd(1)*255 + 1)), _
                               Int(rnd(1) * 64) + 1, Int(rnd(1) * 36) + 1
  BlitsPerSecond += 1
  t = (timer - stime) * 2
  If t > 2 then
    BlitsPerSecond_max(30) = BlitsPerSecond
    BlitsPerSecond = 0
    stime = timer
    TimeLeft -= 1
  End if
Loop until TimeLeft = 0

AFlibIII_ASCii_FilledBox_alpha Chr(32), 0, 0, GFX_h - 1, 1, RGB(0, 0, 0), RGB(0, 0, 0), 200, 4
AFlibIII_ASCii_Print "AFlibIII_ASCii_Lightning_add", 0, 0, RGB(255, 255, 255), RGB(255, 0, 255), 4
AFlibIII_ASCii_Print "Blits per Second: " + Ltrim$(str$(BlitsPerSecond_max(30))), 0, 1, RGB(255, 255, 30), RGB(255, 0, 255), 4
While inkey$ <> "": Wend
Sleep 4000
AFlibIII_ASCii_ClearDisplay RGB(0, 0, 0)







AFlibIII_DeInit_ASCii
ScreenRes 512, 360, , , 0

Windowtitle "AFlib III -- ASCii Drawing Primitives Test Results!"
Locate 1, 1
Color 15, 1: ? "------ ASCii Drawing Primitives Test Results (AFlib III): ------"
?
Color 10, 0: print "M o d e   S e l e c t e d :"
Color 15, 0: ? GFX_h; "x"; Ltrim(Str$(GFX_v)); " ASCii-graphics mode, "; Ltrim(Str$(BitDepth)); "-bit color"
Locate , 2: Color 15, 0: ? "(from a main ";: Color 14, 4: ? Ltrim(Str$(MGFX_h)) + "x" + Ltrim(Str$(MGFX_v)) + "x" + Ltrim(Str$(BitDepth));: Color 15,0: ? " graphics mode!)"
?: ?

Color 14, 0: print "AFlibIII_ASCii_Pixel -------------------";
Color 31, 0: ? BlitsPerSecond_max(1); " blits/second"

Color 14, 0: print "AFlibIII_ASCii_Pixel_alpha -------------";
Color 31, 0: ? BlitsPerSecond_max(2); " blits/second"

Color 14, 0: print "AFlibIII_ASCii_Pixel_add ---------------";
Color 31, 0: ? BlitsPerSecond_max(3); " blits/second"

Color 14, 0: print "AFlibIII_ASCii_Line --------------------";
Color 31, 0: ? BlitsPerSecond_max(4); " blits/second"

Color 14, 0: print "AFlibIII_ASCii_Line_alpha --------------";
Color 31, 0: ? BlitsPerSecond_max(5); " blits/second"

Color 14, 0: print "AFlibIII_ASCii_Line_add ----------------";
Color 31, 0: ? BlitsPerSecond_max(6); " blits/second"

Color 14, 0: print "AFlibIII_ASCii_Box ---------------------";
Color 31, 0: ? BlitsPerSecond_max(7); " blits/second"

Color 14, 0: print "AFlibIII_ASCii_Box_alpha ---------------";
Color 31, 0: ? BlitsPerSecond_max(8); " blits/second"

Color 14, 0: print "AFlibIII_ASCii_Box_add -----------------";
Color 31, 0: ? BlitsPerSecond_max(9); " blits/second"

Color 14, 0: print "AFlibIII_ASCii_FilledBox ---------------";
Color 31, 0: ? BlitsPerSecond_max(10); " blits/second"

Color 14, 0: print "AFlibIII_ASCii_FilledBox_alpha ---------";
Color 31, 0: ? BlitsPerSecond_max(11); " blits/second"

Color 14, 0: print "AFlibIII_ASCii_FilledBox_add -----------";
Color 31, 0: ? BlitsPerSecond_max(12); " blits/second"

Color 14, 0: print "AFlibIII_ASCii_Circle ------------------";
Color 31, 0: ? BlitsPerSecond_max(13); " blits/second"

Color 14, 0: print "AFlibIII_ASCii_Circle_alpha ------------";
Color 31, 0: ? BlitsPerSecond_max(14); " blits/second"

Color 14, 0: print "AFlibIII_ASCii_Circle_add --------------";
Color 31, 0: ? BlitsPerSecond_max(15); " blits/second"

Color 14, 0: print "AFlibIII_ASCii_FilledCircle ------------";
Color 31, 0: ? BlitsPerSecond_max(16); " blits/second"

Color 14, 0: print "AFlibIII_ASCii_FilledCircle_alpha ------";
Color 31, 0: ? BlitsPerSecond_max(17); " blits/second"

Color 14, 0: print "AFlibIII_ASCii_FilledCircle_add --------";
Color 31, 0: ? BlitsPerSecond_max(18); " blits/second"

Color 14, 0: print "AFlibIII_ASCii_Triangle ----------------";
Color 31, 0: ? BlitsPerSecond_max(19); " blits/second"

Color 14, 0: print "AFlibIII_ASCii_Triangle_alpha ----------";
Color 31, 0: ? BlitsPerSecond_max(20); " blits/second"

Color 14, 0: print "AFlibIII_ASCii_Triangle_add ------------";
Color 31, 0: ? BlitsPerSecond_max(21); " blits/second"

Color 14, 0: print "AFlibIII_ASCii_FilledTriangle ----------";
Color 31, 0: ? BlitsPerSecond_max(22); " blits/second"

Color 14, 0: print "AFlibIII_ASCii_FilledTriangle_alpha ----";
Color 31, 0: ? BlitsPerSecond_max(23); " blits/second"

Color 14, 0: print "AFlibIII_ASCii_FilledTriangle_add ------";
Color 31, 0: ? BlitsPerSecond_max(24); " blits/second"

Color 14, 0: print "AFlibIII_ASCii_Globe -------------------";
Color 31, 0: ? BlitsPerSecond_max(25); " blits/second"

Color 14, 0: print "AFlibIII_ASCii_Globe_alpha -------------";
Color 31, 0: ? BlitsPerSecond_max(26); " blits/second"

Color 14, 0: print "AFlibIII_ASCii_Globe_add ---------------";
Color 31, 0: ? BlitsPerSecond_max(27); " blits/second"

Color 14, 0: print "AFlibIII_ASCii_Lightning ---------------";
Color 31, 0: ? BlitsPerSecond_max(28); " blits/second"

Color 14, 0: print "AFlibIII_ASCii_Lightning_alpha ---------";
Color 31, 0: ? BlitsPerSecond_max(29); " blits/second"

Color 14, 0: print "AFlibIII_ASCii_Lightning_add -----------";
Color 31, 0: ? BlitsPerSecond_max(30); " blits/second"

?: ?: ?: ? "Press any key to end, please."

AFlibIII_ConsoleEdit_Open
AFlibIII_ConsoleEdit_Print "--- ASCii Drawing Primitives Test Results (AFlib III): ---"
AFlibIII_ConsoleEdit_Print ""
AFlibIII_ConsoleEdit_Print ""
AFlibIII_ConsoleEdit_Print "M o d e   S e l e c t e d :"
AFlibIII_ConsoleEdit_Print Ltrim(Str$(GFX_h)) + "x" + Ltrim(Str$(GFX_v)) + " ASCii-graphics mode, " + Ltrim(Str$(BitDepth)) + "-bit color"
AFlibIII_ConsoleEdit_Print "(from a main " + Ltrim(Str$(MGFX_h)) + "x" + Ltrim(Str$(MGFX_v)) + "x" + Ltrim(Str$(BitDepth)) + " graphics mode!)"
AFlibIII_ConsoleEdit_Print ""
AFlibIII_ConsoleEdit_Print "AFlibIII_ASCii_Pixel -------------------" + Ltrim(Str$(BlitsPerSecond_max(1))) + " blits/second"
AFlibIII_ConsoleEdit_Print "AFlibIII_ASCii_Pixel_alpha -------------" + Ltrim(Str$(BlitsPerSecond_max(2))) + " blits/second"
AFlibIII_ConsoleEdit_Print "AFlibIII_ASCii_Pixel_add ---------------" + Ltrim(Str$(BlitsPerSecond_max(3))) + " blits/second"
AFlibIII_ConsoleEdit_Print "AFlibIII_ASCii_Line --------------------" + Ltrim(Str$(BlitsPerSecond_max(4))) + " blits/second"
AFlibIII_ConsoleEdit_Print "AFlibIII_ASCii_Line_alpha --------------" + Ltrim(Str$(BlitsPerSecond_max(5))) + " blits/second"
AFlibIII_ConsoleEdit_Print "AFlibIII_ASCii_Line_add ----------------" + Ltrim(Str$(BlitsPerSecond_max(6))) + " blits/second"
AFlibIII_ConsoleEdit_Print "AFlibIII_ASCii_Box ---------------------" + Ltrim(Str$(BlitsPerSecond_max(7))) + " blits/second"
AFlibIII_ConsoleEdit_Print "AFlibIII_ASCii_Box_alpha ---------------" + Ltrim(Str$(BlitsPerSecond_max(8))) + " blits/second"
AFlibIII_ConsoleEdit_Print "AFlibIII_ASCii_Box_add -----------------" + Ltrim(Str$(BlitsPerSecond_max(9))) + " blits/second"
AFlibIII_ConsoleEdit_Print "AFlibIII_ASCii_FilledBox ---------------" + Ltrim(Str$(BlitsPerSecond_max(10))) + " blits/second"
AFlibIII_ConsoleEdit_Print "AFlibIII_ASCii_FilledBox_alpha ---------" + Ltrim(Str$(BlitsPerSecond_max(11))) + " blits/second"
AFlibIII_ConsoleEdit_Print "AFlibIII_ASCii_FilledBox_add -----------" + Ltrim(Str$(BlitsPerSecond_max(12))) + " blits/second"
AFlibIII_ConsoleEdit_Print "AFlibIII_ASCii_Circle ------------------" + Ltrim(Str$(BlitsPerSecond_max(13))) + " blits/second"
AFlibIII_ConsoleEdit_Print "AFlibIII_ASCii_Circle_alpha ------------" + Ltrim(Str$(BlitsPerSecond_max(14))) + " blits/second"
AFlibIII_ConsoleEdit_Print "AFlibIII_ASCii_Circle_add --------------" + Ltrim(Str$(BlitsPerSecond_max(15))) + " blits/second"
AFlibIII_ConsoleEdit_Print "AFlibIII_ASCii_FilledCircle ------------" + Ltrim(Str$(BlitsPerSecond_max(16))) + " blits/second"
AFlibIII_ConsoleEdit_Print "AFlibIII_ASCii_FilledCircle_alpha ------" + Ltrim(Str$(BlitsPerSecond_max(17))) + " blits/second"
AFlibIII_ConsoleEdit_Print "AFlibIII_ASCii_FilledCircle_add --------" + Ltrim(Str$(BlitsPerSecond_max(18))) + " blits/second"
AFlibIII_ConsoleEdit_Print "AFlibIII_ASCii_Triangle ----------------" + Ltrim(Str$(BlitsPerSecond_max(19))) + " blits/second"
AFlibIII_ConsoleEdit_Print "AFlibIII_ASCii_Triangle_alpha ----------" + Ltrim(Str$(BlitsPerSecond_max(20))) + " blits/second"
AFlibIII_ConsoleEdit_Print "AFlibIII_ASCii_Triangle_add ------------" + Ltrim(Str$(BlitsPerSecond_max(21))) + " blits/second"
AFlibIII_ConsoleEdit_Print "AFlibIII_ASCii_FilledTriangle ----------" + Ltrim(Str$(BlitsPerSecond_max(22))) + " blits/second"
AFlibIII_ConsoleEdit_Print "AFlibIII_ASCii_FilledTriangle_alpha ----" + Ltrim(Str$(BlitsPerSecond_max(23))) + " blits/second"
AFlibIII_ConsoleEdit_Print "AFlibIII_ASCii_FilledTriangle_add ------" + Ltrim(Str$(BlitsPerSecond_max(24))) + " blits/second"
AFlibIII_ConsoleEdit_Print "AFlibIII_ASCii_Globe -------------------" + Ltrim(Str$(BlitsPerSecond_max(25))) + " blits/second"
AFlibIII_ConsoleEdit_Print "AFlibIII_ASCii_Globe_alpha -------------" + Ltrim(Str$(BlitsPerSecond_max(26))) + " blits/second"
AFlibIII_ConsoleEdit_Print "AFlibIII_ASCii_Globe_add ---------------" + Ltrim(Str$(BlitsPerSecond_max(27))) + " blits/second"
AFlibIII_ConsoleEdit_Print "AFlibIII_ASCii_Lightning ---------------" + Ltrim(Str$(BlitsPerSecond_max(28))) + " blits/second"
AFlibIII_ConsoleEdit_Print "AFlibIII_ASCii_Lightning_alpha ---------" + Ltrim(Str$(BlitsPerSecond_max(29))) + " blits/second"
AFlibIII_ConsoleEdit_Print "AFlibIII_ASCii_Lightning_add -----------" + Ltrim(Str$(BlitsPerSecond_max(30))) + " blits/second"
AFlibIII_ConsoleEdit_Close

Sleep

AFlibIII_EndProgram








