'===============================================================
' A F l i b   I I I   G F X   T w e a k   E x a m p l e   # 3
'=============================================================== 
'
'In this third and final graphical tweak example of this
'stepped-up game library in FreeBASIC called AFlib III, better
'hang on tight because you will witness the very transformation
'of an ordinary full-screen graphics mode into something rather
'extraordinary: A CUSTOM TWEAKED GRAPHICS MODE, just like some
'of that you see in Mode-X if you can remember either DOS or
'QuickBASIC/QBasic!!!  ^-^
'
'Here, I will show you how to tweak a normal, regular
'full-screen graphics mode both vertically *and* horizontally
'simultaneously, all effortlessly and rather easily!!!  And the
'wonderous magic starts with just this either one of two
'commands:
'
'                ---- AFlibIII_LowRes2x ----
'                            or
'       ---- AFlibIII_Resize2X_auto (even FASTER!!) ----
'
'.....because this is where it all starts!!!  For example, take
'a 320x240 full-screen graphics mode.  Then, if you use this
'either of the two commands there, it will simply tweak the mode
'into a brand-new 160x120 mode, just like that!!!  :D !
'
'Please remember that while the first command "AFlibIII_LowRes2x"
'FULLY supports all 15-, 16-, 24-, and 32-bit modes only, the
'second command "AFlibIII_Resize2X_auto" runs a WHOLE LOT faster
'and better but only supports exclusively quite a handful of the
'more common fullscreen/windowed graphics modes with color depths
'of 15-, 16-, 24-, and 32-bit... including full-HD modes of 720p
'(1280x720) and 1080p (1920x1080), too!!!  Either way, be sure to
'never miss this great opportunity in your FreeBASIC programs!!!
' 
'Look, I do hope you enjoy this amazing little example, splendid
'ladies and gents!!  Peace!!!  (^_-)v !!
' 
' 
'                                        - Adigun Azikiwe Polack 
'                               One of the Founders of Aura Flow 
'                                       Developer of "AFlib III" 
'---------------------------------------------------------------


#include "AFlib3_Sprite.bi"
#include "AFlib3_Font.bi"
#include "AFlib3_Screen.bi"
#include "AFlib3_Resize2X.bi"
#include "AFlib3_Miscellaneous.bi"

Dim Full_or_Windowed as integer = 0 '<----- Pass '0' for Windowed Mode; or
                                    '            '1' for Fullscreen Mode.



Declare Sub ShadowPrint ( Byref text as String, _ 
                          Byval x as Integer, Byval y as Integer, _ 
                          Byval col as Integer, Byval sh_x as Integer, _ 
                          Byval sh_y as Integer, Byval sh_col as Integer, _ 
                          Byval chara_id as Integer ) 


'========================================================================== 
'/////// S T A R T   O F   M A I N   P O R T I O N 
'========================================================================== 

Dim BitDepth as Integer

ScreenRes 424, 96 , , 0
Windowtitle "AFlib III -- GFX Tweak #3"
Color 15, 1: ? "          Please select your color depth!!!          "
Locate 4: Color 15, 0
Locate , 17: Color 10: ? "[1] ";: Color 14: ? "- 15-bit color": ?
Locate , 17: Color 10: ? "[2] ";: Color 14: ? "- 16-bit color": ?
Locate , 17: Color 10: ? "[3] ";: Color 14: ? "- 24-bit color": ?
Locate , 17: Color 10: ? "[4] ";: Color 14: ? "- 32-bit color"

Do
  Select case Inkey$
    Case "1": BitDepth = 15: Exit Do
    Case "2": BitDepth = 16: Exit Do
    Case "3": BitDepth = 24: Exit Do
    Case "4": BitDepth = 32: Exit Do
  End Select
Loop
Cls

ScreenRes 424, 280, , , 0
Color 15, 1: ? "         Please select your graphics mode!!!         "
Locate 4: Color 15, 0
Locate , 27: Color 10: ? "[1] ";: Color 14: ? "- 320x200"
Locate , 27: ?
Locate , 27: Color 10: ? "[2] ";: Color 14: ? "- 320x240"
Locate , 27: ?
Locate , 27: Color 10: ? "[3] ";: Color 14: ? "- 400x300"
Locate , 27: ?
Locate , 27: Color 10: ? "[4] ";: Color 14: ? "- 512x384"
Locate , 27: ?
Locate , 27: Color 10: ? "[5] ";: Color 14: ? "- 640x400"
Locate , 27: ?
Locate , 27: Color 10: ? "[6] ";: Color 14: ? "- 640x480"
Locate , 27: ?
Locate , 27: Color 10: ? "[7] ";: Color 14: ? "- 720x480"
Locate , 27: ?
Locate , 27: Color 10: ? "[8] ";: Color 14: ? "- 720x576"
Locate , 27: ?
Locate , 27: Color 10: ? "[9] ";: Color 14: ? "- 800x600"
Locate , 27: ?
Locate , 27: Color 10: ? "[0] ";: Color 14: ? "- 1024x768"
Locate , 27: ?
Locate , 27: Color 10: ? "[A] ";: Color 14: ? "- 1152x864"
Locate , 27: ?
Locate , 27: Color 10: ? "[B] ";: Color 14: ? "- 1280x720"
Locate , 27: ?
Locate , 27: Color 10: ? "[C] ";: Color 14: ? "- 1280x1024"
Locate , 27: ?
Locate , 27: Color 10: ? "[D] ";: Color 14: ? "- 1600x1200"
Locate , 27: ?
Locate , 27: Color 10: ? "[E] ";: Color 14: ? "- 1920x1080"
Locate 6, 5: Color 15: ? BitDepth; "-bit color"
Locate 7, 10: Color 15: ? "is selected!"

Do
  Select case Inkey$
    Case "1": ScreenRes 320, 200, BitDepth, 2, Full_or_Windowed: Exit Do
    Case "2": ScreenRes 320, 240, BitDepth, 2, Full_or_Windowed: Exit Do
    Case "3": ScreenRes 400, 300, BitDepth, 2, Full_or_Windowed: Exit Do
    Case "4": ScreenRes 512, 384, BitDepth, 2, Full_or_Windowed: Exit Do
    Case "5": ScreenRes 640, 400, BitDepth, 2, Full_or_Windowed: Exit Do
    Case "6": ScreenRes 640, 480, BitDepth, 2, Full_or_Windowed: Exit Do
    Case "7": ScreenRes 720, 480, BitDepth, 2, Full_or_Windowed: Exit Do
    Case "8": ScreenRes 720, 576, BitDepth, 2, Full_or_Windowed: Exit Do
    Case "9": ScreenRes 800, 600, BitDepth, 2, Full_or_Windowed: Exit Do
    Case "0": ScreenRes 1024, 768, BitDepth, 2, Full_or_Windowed: Exit Do
    Case "A", "a": ScreenRes 1152, 864, BitDepth, 2, Full_or_Windowed: Exit Do
    Case "B", "b": ScreenRes 1280, 720, BitDepth, 2, Full_or_Windowed: Exit Do
    Case "C", "c": ScreenRes 1280, 1024, BitDepth, 2, Full_or_Windowed: Exit Do
    Case "D", "d": ScreenRes 1600, 1200, BitDepth, 2, Full_or_Windowed: Exit Do
    Case "E", "e": ScreenRes 1920, 1080, BitDepth, 2, Full_or_Windowed: Exit Do
  End Select
Loop
SetMouse , , 0

Dim as Integer Screen_h, Screen_v
SetMouse , , 0

Windowtitle "AFlib III -- GFX Tweak #3"
SetMouse , , 0

'---------------------------------------------------- 
ScreenSet 1, 0 
AFlibIII_PrepareCharTrans 0, 0
AFlibIII_DisplayAllChars 0, 0, 0, &hffffff, 0, 28
AFlibIII_OptimizeFontSet 0, 0, 1
ScreenSet 0, 0 
'----------------------------------------------------

Randomize Timer

Dim as integer e, Scr_horiz, Scr_vert
ScreenInfo Scr_horiz, Scr_vert 

Dim As Any Ptr CustomGFXMode
CustomGFXMode = imagecreate (Scr_horiz, Scr_vert)

AFlibIII_ClearDisplay 0: Color rgb(255,255,255), 0

? "Take a normal "; Str$(Scr_horiz); "x"; Str$(Scr_vert); " graphics mode"
? "in GFXlib2 for FreeBASIC, add the new"
? "AFlib III with higher than 8bpp,"
? "and such *amazing* things can happen,"
? "like this!!"
AFlibIII_Delay 750

AFlibIII_ClearDisplay 0

Scr_horiz /= 2
Scr_vert /= 2

For e = 0 TO 450
  Line (int(rnd(1)*Scr_horiz)+1, int(rnd(1)*Scr_vert)+1)-(int(rnd(1)*Scr_horiz)+1, int(rnd(1)*Scr_vert)+1), rgb(int(rnd(1)*80) + 1, int(rnd(1)*80) + 1, int(rnd(1)*80) + 1)
next

View (0, 0)-(Scr_horiz / 2, Scr_vert / 2)

For e = 0 TO 450
  Line (int(rnd(1)*Scr_horiz)+1, int(rnd(1)*Scr_vert)+1)-(int(rnd(1)*Scr_horiz)+1, int(rnd(1)*Scr_vert)+1), int(rnd(1)*&hffffff) + 1, bf
next

AFlibIII_Delay 300

View (0, 0)-(Scr_horiz * 2, Scr_vert * 2) 

ScreenLock

ShadowPrint Str$(Scr_horiz) + "x" + Str$(Scr_vert) + "x" + Str$(BitDepth) + "bpp", 0, 0, rgb(255,255,255), 1, 1, rgb(0,0,0), 1
ShadowPrint "Pseudo Graphics Resolution!!!", 24, 8, rgb(255,255,255), 1, 1, rgb(0,0,0), 1
ShadowPrint "Exclusively in AFlib III for FB!!!", 0, 24, rgb(32,255,32), 1, 1, rgb(0,32,0), 1
ShadowPrint "Custom mode by Adigun Azikiwe Polack.", 0, Scr_vert - 32, rgb(128,128,128), 1, 1, rgb(25,25,25), 1

If Scr_horiz >= 400 then
  ShadowPrint "(c)2005-2016 Adigun Azikiwe Polack/Aura Flow.", 0, Scr_vert - 16, rgb(128,128,128), 1, 1, rgb(25,25,25), 1
  ShadowPrint "All Rights Reserved.", 0, Scr_vert - 8, rgb(128,128,128), 1, 1, rgb(25,25,25), 1
else
  ShadowPrint "(c)2005-2016 AAP/Aura Flow.", 0, Scr_vert - 16, rgb(128,128,128), 1, 1, rgb(25,25,25), 1
  ShadowPrint "All Rights Reserved.", 0, Scr_vert - 8, rgb(128,128,128), 1, 1, rgb(25,25,25), 1
End if

'================== Let's unlock the magic now!!!  ^-^ !
'AFlibIII_LowRes2x
AFlibIII_Resize2X_auto 
'=======================================================

ScreenUnlock

AFlibIII_RemoveFontSet 1
imagedestroy ( CustomGFXMode )

AFlibIII_ClearKeyBuffer
Sleep

AFlibIII_EndProgram

'========================================================================== 
'/////// E N D   O F   M A I N   P O R T I O N 
'========================================================================== 




'__________________________________________________________________________ 
Sub ShadowPrint ( Byref text as String, _ 
                  Byval x as Integer, Byval y as Integer, _ 
                  Byval col as Integer, Byval sh_x as Integer, _ 
                  Byval sh_y as Integer, Byval sh_col as Integer, _ 
                  Byval chara_id as Integer ) 

AFlibIII_OptimizedPrint_color text, x + sh_x, y + sh_y, chara_id, 0, sh_col
AFlibIII_OptimizedPrint_color text, x, y, chara_id, 0, col

End Sub