' Please have your graphics mode set to 24- or 32-bit color in order
' for the palette fading routines to work in AFlib III, as it will not
' work in any other color depth whatsoever.  Thanks so much!!!  ;)
'
'                                              - Adigun Azikiwe Polack


#include "AFlib3_Sprite.bi"
#include "AFlib3_Font.bi"
#include "AFlib3_Palette.bi"
#include "AFlib3_Primitives.bi"
#include "AFlib3_Screen.bi"
#include "AFlib3_Miscellaneous.bi"
#include "AFlib3_Constants.bi"
#include "AFlib3_GraphicsFilter.bi"
#include "AFlib3_Resize2X.bi"



const Scr_horiz = 640
const Scr_vert = 480

ScreenRes Scr_horiz, Scr_vert, 24, 2, 0
WindowTitle "AFlib III -- Master System Palette Fade-in/Fade-out Test"
SetMouse , , 0


Declare Sub SMS_PaletteFadeIn (x as integer, y as integer, image as any ptr, _
                               resize_gfx as integer, LowRes_type as integer)
Declare Sub SMS_PaletteFadeOut (x as integer, y as integer, image as any ptr, _
                                resize_gfx as integer, LowRes_type as integer)
                                
Declare Sub PressKey_Notice

Dim Shared as Integer PalColList_X, PalColList_Y, PalPos_X, PalPos_Y, Pal_Size, FadeCTRL
Dim Shared as Integer PicSetupNum
Dim as Any Ptr Scr_ColChanger
Dim as Any Ptr SMSTestIma(1 to 54) 

For PicSetupNum = 1 to 54
  SMSTestIma(PicSetupNum) = ImageCreate(256, 192)
  BLoad "AF3_PaletteSMS_" + str(PicSetupNum) + ".bmp", SMSTestIma(PicSetupNum)
Next


ScreenSet 1, 0

For PicSetupNum = 1 to 54
  SMS_PaletteFadeIn 31, 24, SMSTestIma(PicSetupNum), 1, 0
  PressKey_Notice
  Sleep
  SMS_PaletteFadeOut 31, 24, SMSTestIma(PicSetupNum), 1, 0
Next

For PicSetupNum = 1 to 54
  ImageDestroy SMSTestIma(PicSetupNum)
Next

AFlibIII_EndProgram



Sub SMS_PaletteFadeIn (x as integer, y as integer, image as any ptr, _
                       resize_gfx as integer, LowRes_type as integer)
  For FadeCTRL = -4 to 0 step 1
    AFlibIII_ClearDisplay RGB(1, 1, 1)
    
    AFlibIII_SprBlit x, y, image   
    
    If resize_gfx >= 1 then AFlibIII_Resize2X_640x480
    Select Case LowRes_type
      Case 1: AFlibIII_LowRes_vert
      Case 2: AFlibIII_LowRes_horiz
    End Select
    
    AFlibIII_FadeSMS , FadeCTRL
    AFlibIII_Scanlines_H
    
    AFlibIII_DisplayPal_64Col 7, 7, 0, 8  '<---- Displays the Master System/Mark III Palette.
   
    'AFlibIII_MakeMonochrome 
    ScreenCopy 1, 0
    AFlibIII_CustomSync fps5
  Next
  AFlibIII_ClearKeyBuffer
End Sub

Sub SMS_PaletteFadeOut (x as integer, y as integer, image as any ptr, _
                        resize_gfx as integer, LowRes_type as integer)
  For FadeCTRL = 0 to -4 step -1
    AFlibIII_ClearDisplay RGB(1, 1, 1)
    
    AFlibIII_SprBlit x, y, image   
    
    If resize_gfx >= 1 then AFlibIII_Resize2X_640x480
    Select Case LowRes_type
      Case 1: AFlibIII_LowRes_vert
      Case 2: AFlibIII_LowRes_horiz
    End Select
    
    AFlibIII_FadeSMS , FadeCTRL
    AFlibIII_Scanlines_H

    AFlibIII_DisplayPal_64Col 7, 7, 0, 8  '<---- Displays the Master System/Mark III Palette.

    'AFlibIII_MakeMonochrome 
    ScreenCopy 1, 0
    AFlibIII_CustomSync fps5
  Next
  AFlibIII_ClearKeyBuffer
End Sub

Sub PressKey_Notice
  Dim SetMessage as String
  If PicSetupNum >= 54 then
    SetMessage = "Press any key to end."
  else
    SetMessage = "Press any key, please."
  End if
  
  AFlibIII_Print SetMessage, 1, 464, 1, 1, SMScol(42), 0, 2, 7
  AFlibIII_Print SetMessage, 1, 465, 1, 1, SMScol(42), 0, 2, 7
  AFlibIII_Print SetMessage, 0, 465, 1, 1, SMScol(42), 0, 2, 7
  AFlibIII_Print SetMessage, 0, 464, 1, 1, SMScol(63), 0, 2, 7
  ScreenCopy 1,0
End Sub