'
'                           ___________________________________________
'         _______ _ _ _     \___           ___________________________/
'    /\  (_______) (_) |       /  //  //  /  
'   /  \  _  __  | |_| | _    /  //  //  / << version 0.86 alpha test >>
'  / /\ \| |(__| | | | || \  /  //  //  /  For FreeBASIC (v0.20b or later).
' | |__| | |     | | | |_) )/  //  //  /     
' |_|  |_|_|     |_|_|____//  //  //  /   Original Development by
'  _______________________/  //  //  /___ Adigun Azikiwe Polack for Aura Flow.
' /_____________________________________/
'
'  A  u  r  a      F  l  o  w      L  i  b  r  a  r  y      3
'_________________________________________________________________________
'
' (c)2005-2016 Adigun Azikiwe Polack/Aura Flow.  All Rights Reserved.
'
'
'
'    ____        __     __  __          __  ___          __      __   
'   / __ \____ _/ /__  / /_/ /____     /  |/  /___  ____/ /_  __/ /__ 
'  / /_/ / __ `/ / _ \/ __/ __/ _ \   / /|_/ / __ \/ __  / / / / / _ \
' / ____/ /_/ / /  __/ /_/ /_/  __/  / /  / / /_/ / /_/ / /_/ / /  __/
'/_/    \__,_/_/\___/\__/\__/\___/  /_/  /_/\____/\__,_/\__,_/_/\___/ 
'                                                                            
'
'_________________________________________________________________________
'                        ----- N O T I C E -----
'_________________________________________________________________________
' The following is this piece of source code to this version of AFlib III.
' You are free to look at it to give you some inspiring ideas in your own
' programming in FreeBASIC, but you are *never* to even change or adjust
' any of this source code whatsoever in any way, shape, or form at all.
' EVER.  ;)
'
' The reason for this is to ensure that all of the routines in this source
' code are working as properly as they should in FreeBASIC v0.20b or
' newer.  That is all.
'
' With that said, do enjoy the library and be inspired even more
' greatly than ever!!!  (^-^)//
'_________________________________________________________________________

'$profile
'$stop_scan

#define isBufferNew_f( __buffer__ ) iif( __buffer__ <> 0, *cast( Integer Ptr, __buffer__ ) = 7, 0 )

#include once "fbgfx.bi"
ScreenControl(FB.SET_DRIVER_NAME, "GDI")



'-------------------------------------------------------------------------
' This part of the encoding data features all three (3) built-in 9-bit
' (512-color) palettes in AFlib III:
' 
'    * RGB 9-bit (512-color) Palette
'      (Used primarily on Atari ST, Sega MegaDrive/Genesis,
'       PC-Engine/TurboGrafx-16, and the original MSX2 as well!)
'
'    * Relsoft Extended 512-Color Palette
'      (Based on a 2001 original 8-bit Palette created by Richard Eric M.
'       Lope, and adapted for 512 colors in December 2015 by none other
'       than Adigun Azikiwe Polack to so personally dedicate to that
'       great, GREAT man of Mr. Lope there himself indeed!!!
'       (^-^)=b !!! )
'
'    * The Adigun Azikiwe Polack Super-512 Palette
'      (First Originally Created by Adigun Azikiwe Polack on 12/2015!!)
'-------------------------------------------------------------------------

Dim Shared as UlongInt RGB512col(0 to 511), REL512col(0 to 511), AAP512col(0 to 511)

Dim Shared AF3_512col_array(0 To 2, 0 to 511) As UInteger

Declare Function Uncompress_pal512_extpal() As Any ptr
Declare Sub Init_pal512()
Declare Sub Init_AFlib3_pal512_extpal_dat()
Declare Sub DeInit_AFlib3_pal512_extpal_dat()

#ifndef _AFlib3_pal512_extpal_dat_
#define _AFlib3_pal512_extpal_dat_
extern AFlib3_pal512_extpal_dat As Any ptr
extern AFlib3_pal512_extpal_dat_len As Integer
#endif

Declare Function LZW_pal512_Decode Alias "fb_hDecode" (_
ByVal in_buffer As Any ptr, _
ByVal in_size As Integer, _
ByVal out_buffer As Any ptr, _
ByRef out_size As Integer _
) As Integer
Dim Shared AFlib3_pal512_extpal_dat As Any ptr
Dim Shared AFlib3_pal512_extpal_dat_len As Integer = 6144
Dim Shared LZW_pal512_data(5226) As uByte => {_
0,0,16,0,0,2,1,49,4,1,113,6,1,209,8,1,_
33,11,1,145,13,1,241,15,1,1,16,3,33,17,0,80,_
16,3,113,16,3,145,16,3,177,16,3,209,16,3,241,16,_
3,1,16,21,65,17,35,81,16,7,81,16,9,81,16,11,_
81,16,13,81,16,15,81,16,0,113,17,0,96,18,50,65,_
19,7,145,16,7,177,16,7,209,16,7,241,16,7,1,16,_
25,1,0,40,17,20,52,145,16,69,1,0,11,145,16,13,_
145,16,15,145,16,0,177,17,71,49,18,57,1,21,9,177,_
16,85,1,0,13,177,16,15,177,16,0,209,17,87,49,18,_
59,225,21,73,1,21,13,65,22,0,240,16,13,1,16,31,_
97,22,35,209,19,107,177,20,80,113,22,107,241,15,4,240,_
16,2,17,17,32,49,4,32,113,6,32,209,8,32,33,11,_
32,145,13,32,241,15,32,33,16,18,1,2,3,145,23,22,_
113,24,65,177,24,127,193,17,139,49,24,32,1,2,21,49,_
25,20,81,25,123,113,18,149,241,23,43,81,25,131,241,18,_
32,112,17,160,97,25,7,177,23,54,33,26,127,161,19,162,_
49,24,62,1,2,25,209,26,150,113,19,175,209,23,84,241,_
26,129,177,20,175,33,16,27,1,2,42,177,27,50,209,27,_
125,81,21,189,17,24,89,209,27,2,209,17,32,192,18,200,_
225,27,74,161,28,127,65,22,202,49,24,104,1,2,31,49,_
29,150,209,19,213,209,23,90,81,29,129,241,16,131,81,23,_
159,241,18,67,240,18,103,240,18,141,240,18,178,240,18,217,_
240,18,255,240,18,150,33,16,121,65,17,240,65,30,24,1,_
31,232,193,17,240,193,30,120,81,17,226,17,31,37,193,31,_
230,145,18,252,161,30,45,193,31,20,113,17,67,96,18,8,_
34,19,10,98,30,56,161,32,234,193,19,10,66,17,25,49,_
4,40,81,33,11,82,20,23,130,30,73,113,33,236,209,20,_
67,176,17,32,18,31,57,33,34,230,81,21,34,162,30,89,_
33,34,20,209,17,67,192,18,46,178,32,74,1,35,232,65,_
22,48,194,30,104,49,4,31,145,35,241,209,19,59,98,30,_
90,177,35,234,209,29,59,66,19,2,225,19,18,114,6,62,_
209,8,62,33,11,62,145,13,62,241,15,62,225,27,70,130,_
24,123,33,19,86,178,36,26,97,37,79,226,17,86,178,32,_
70,82,16,8,82,18,228,17,20,100,210,36,43,65,38,81,_
50,30,23,145,36,6,66,26,109,178,36,56,209,38,79,194,_
19,109,34,19,25,113,6,40,145,39,87,82,20,123,210,36,_
73,177,39,81,210,20,103,176,17,132,98,32,57,97,40,75,_
82,21,134,242,36,89,97,40,50,209,17,103,192,18,146,114,_
37,74,65,41,77,66,22,148,18,37,104,113,6,31,209,41,_
6,210,19,159,178,36,90,241,41,79,210,29,159,50,20,2,_
241,33,131,210,20,141,208,20,178,208,20,217,208,20,255,208,_
20,140,161,42,136,209,23,119,130,17,185,2,43,28,145,43,_
180,194,23,21,97,30,19,82,18,195,226,42,41,49,44,178,_
210,18,195,82,38,170,98,18,75,114,39,54,1,45,176,162,_
19,208,66,43,74,146,17,174,50,33,55,161,45,174,66,21,_
218,34,43,75,161,45,65,177,17,141,160,18,230,114,39,72,_
129,46,176,178,16,178,146,21,232,18,20,29,209,8,44,49,_
47,119,162,20,245,2,43,100,81,47,180,130,22,141,240,17,_
254,50,33,61,1,48,174,162,21,0,35,43,221,1,48,80,_
145,27,33,177,21,143,2,47,178,176,21,217,176,21,255,176,_
21,71,33,17,127,65,17,24,67,40,24,129,49,16,195,17,_
24,67,49,126,81,17,232,145,49,37,65,50,230,146,18,36,_
35,49,45,65,50,71,113,17,77,146,49,164,1,51,230,130,_
19,48,35,49,60,1,51,71,145,17,176,146,49,55,193,51,_
230,66,21,60,35,49,75,193,51,71,177,17,16,147,49,57,_
129,52,230,82,21,72,35,49,89,129,52,71,209,17,178,192,_
18,84,35,19,86,99,46,88,97,53,18,211,16,20,131,22,_
178,240,17,96,147,49,61,33,54,230,162,21,98,35,49,221,_
33,54,94,97,28,33,193,41,253,242,53,104,145,13,104,241,_
15,104,113,21,18,17,24,44,98,17,121,51,47,26,145,55,_
115,227,17,121,115,21,21,161,30,44,82,18,133,51,47,41,_
81,56,115,211,18,133,115,21,23,241,36,44,66,26,145,51,_
47,56,17,57,115,195,19,145,115,21,25,33,43,44,114,19,_
157,51,47,84,209,57,115,179,20,157,115,21,27,33,49,44,_
146,19,169,51,47,85,145,58,115,147,21,169,115,21,29,49,_
55,44,178,19,181,51,47,88,81,59,115,211,53,181,115,21,_
31,145,13,46,17,60,144,194,20,195,67,53,103,49,60,117,_
83,23,117,81,29,20,81,23,168,146,48,107,51,60,102,81,_
23,102,33,17,131,225,60,22,129,61,254,162,17,216,19,60,_
30,129,61,102,81,17,236,225,60,37,65,62,254,146,18,228,_
19,60,45,65,62,102,113,17,81,226,60,164,1,63,254,130,_
19,240,19,60,60,1,63,102,145,17,180,226,60,55,193,63,_
254,66,21,252,19,60,75,193,63,102,177,17,20,227,60,57,_
129,64,254,82,21,8,20,60,89,129,64,102,209,17,117,227,_
60,59,65,65,254,130,21,20,20,60,93,67,65,212,35,16,_
255,224,18,32,36,19,34,228,47,90,33,66,193,211,29,34,_
4,17,6,192,66,0,160,0,47,4,0,14,32,67,0,80,_
1,53,4,0,31,128,67,0,144,2,59,4,0,52,224,67,_
0,208,3,65,4,0,69,64,68,0,208,4,71,4,0,86,_
160,68,0,208,5,77,4,0,102,0,69,0,0,7,83,4,_
0,123,96,69,0,64,8,89,4,0,140,192,69,0,64,9,_
95,4,0,157,32,70,0,80,10,101,4,0,174,128,70,0,_
128,11,107,4,0,195,224,70,0,176,12,113,4,0,211,64,_
71,0,176,13,119,4,0,228,160,71,0,208,14,125,4,0,_
245,0,72,0,192,15,131,68,61,213,3,1,1,65,24,48,_
16,16,64,16,16,84,16,16,100,16,16,116,16,16,132,16,_
16,148,16,16,168,16,16,184,16,16,200,16,16,216,0,0,_
13,208,0,233,0,0,27,176,1,245,0,0,42,160,2,249,_
0,0,56,128,3,253,0,0,71,112,4,174,164,68,174,84,_
6,101,224,74,115,48,7,174,4,8,128,224,15,91,196,8,_
189,148,9,153,208,75,166,96,10,189,4,49,189,244,11,191,_
208,75,202,160,12,189,132,13,216,240,16,229,80,14,15,241,_
14,239,240,16,128,244,16,135,20,17,1,161,72,0,193,72,_
0,225,72,0,1,73,0,33,73,0,65,73,0,97,73,0,_
129,73,0,161,73,0,193,73,0,225,73,0,145,14,160,244,_
71,164,4,0,249,128,74,0,208,15,172,164,79,176,164,79,_
75,212,15,181,164,79,184,4,0,254,176,75,5,213,69,254,_
16,76,5,69,76,5,133,52,254,144,76,5,197,76,102,241,_
76,102,33,77,102,81,77,102,17,72,0,160,77,118,1,16,_
221,4,0,223,4,0,225,4,0,227,4,0,229,132,69,149,_
116,73,153,180,73,157,4,16,161,212,0,163,84,15,27,112,_
74,248,180,74,251,244,74,253,112,4,73,212,15,86,0,0,_
182,84,6,0,144,75,115,0,0,188,4,8,91,228,15,140,_
0,0,194,148,9,0,80,76,166,112,20,254,176,16,202,244,_
11,0,208,76,202,0,0,208,228,73,211,84,14,0,96,77,_
239,240,71,255,96,74,135,116,72,19,161,72,138,196,72,140,_
228,72,142,4,73,144,36,73,146,68,73,148,100,73,150,132,_
73,152,164,73,154,196,73,156,228,73,158,52,79,162,84,15,_
29,96,74,249,192,2,170,212,15,59,224,74,253,160,4,135,_
149,5,135,117,6,135,85,7,174,228,15,130,208,75,254,240,_
8,147,181,9,147,117,10,147,53,11,147,5,12,147,197,12,_
189,244,15,208,100,81,221,97,77,26,149,77,218,180,24,0,_
0,3,221,4,4,223,68,5,225,68,6,227,68,7,229,164,_
69,94,148,78,168,176,78,108,4,0,200,240,78,21,5,0,_
233,48,79,127,52,83,247,100,83,253,128,83,198,181,83,198,_
229,83,198,21,84,198,69,84,254,96,80,5,149,84,210,213,_
84,208,5,85,208,181,16,208,85,85,208,133,85,32,228,73,_
32,212,85,32,4,86,32,100,74,28,133,90,32,177,90,222,_
228,90,176,37,91,180,117,78,96,4,0,184,197,78,237,196,_
91,240,228,73,161,36,74,165,100,74,169,164,74,173,228,74,_
177,36,75,198,245,83,2,150,75,186,4,93,72,5,76,7,_
86,76,198,116,96,202,180,76,7,6,77,209,36,66,214,116,_
77,42,132,0,218,4,1,32,129,1,221,4,2,223,132,2,_
225,4,3,227,132,3,229,68,4,231,196,4,233,68,5,235,_
196,5,237,68,6,239,196,6,247,181,7,249,149,8,251,37,_
9,253,197,9,255,53,10,178,180,10,180,36,11,183,148,11,_
186,212,89,91,100,12,192,212,12,195,36,13,198,148,13,200,_
244,13,203,84,14,206,196,14,209,36,15,212,116,15,215,164,_
15,15,129,0,28,133,101,3,129,1,170,101,23,140,132,2,_
35,197,101,144,132,3,39,5,0,68,144,82,76,224,69,96,_
134,73,92,160,70,37,181,91,0,192,6,89,85,69,161,4,_
0,137,80,74,0,32,9,169,4,0,156,208,74,0,48,10,_
177,4,0,171,96,5,174,36,11,182,4,0,185,144,75,0,_
0,12,188,4,0,198,240,75,0,208,12,194,4,0,210,80,_
76,167,211,75,223,160,76,0,80,14,205,4,0,236,32,90,_
242,48,77,0,112,15,165,165,15,245,144,77,87,38,16,218,_
4,3,91,22,82,32,65,5,95,86,82,221,68,7,99,134,_
69,102,230,69,104,22,95,225,132,11,108,182,91,227,132,13,_
113,246,91,123,16,83,245,96,103,247,148,103,250,196,103,250,_
244,103,250,36,104,250,84,104,250,132,104,5,181,104,5,229,_
104,5,21,105,5,69,105,5,149,58,254,128,105,5,181,105,_
102,225,105,102,1,106,102,49,106,102,81,106,0,128,0,12,_
64,86,24,160,101,36,160,72,32,0,3,94,6,4,142,4,_
3,76,32,102,88,32,73,68,64,6,148,196,4,112,96,73,_
84,0,8,107,198,8,154,68,6,152,192,73,108,64,10,158,_
180,7,180,32,74,137,16,12,166,36,9,199,160,74,156,224,_
12,174,52,10,209,224,74,171,80,13,132,150,13,174,148,11,_
220,224,74,192,0,14,189,100,12,227,208,75,205,96,14,189,_
36,13,233,208,75,217,192,14,151,246,14,189,84,14,242,208,_
75,236,96,106,0,32,15,248,240,16,247,176,15,15,161,15,_
253,96,101,23,102,94,90,182,97,133,225,101,31,166,90,33,_
182,74,35,86,102,37,6,0,76,112,98,35,149,98,0,192,_
5,43,86,82,45,6,103,47,86,69,49,86,103,51,134,103,_
53,182,103,55,230,103,57,22,104,59,102,52,30,247,99,138,_
22,100,198,48,100,144,86,100,147,118,100,179,115,105,75,166,_
105,77,214,105,79,134,115,81,38,106,83,6,0,250,80,101,_
0,145,110,0,1,1,172,134,1,36,16,17,221,132,2,60,_
240,81,72,0,16,56,16,78,68,0,6,0,193,4,192,70,_
5,120,0,16,92,112,78,100,0,9,0,193,6,156,240,73,_
123,192,10,163,148,8,186,112,74,146,16,12,171,196,9,156,_
116,4,163,176,12,73,180,10,208,240,83,178,64,13,66,149,_
11,158,4,8,192,192,13,66,246,13,75,213,12,227,224,84,_
210,96,14,82,35,74,191,240,13,237,96,85,229,0,15,89,_
197,14,244,160,105,57,231,85,60,247,71,250,192,15,0,240,_
0,9,240,0,0,208,1,18,224,1,0,192,2,27,208,2,_
0,176,3,36,160,120,77,208,2,79,64,117,54,224,5,0,_
160,6,63,208,6,0,144,7,76,192,7,0,128,8,85,176,_
8,0,160,9,94,224,9,129,86,6,175,0,0,187,192,6,_
192,0,0,204,48,7,209,0,0,222,16,8,190,183,14,141,_
16,15,94,101,9,166,52,15,160,160,74,244,112,10,170,84,_
15,175,160,15,0,96,15,181,112,129,247,192,11,251,0,0,_
248,32,12,30,152,15,200,48,125,249,240,12,211,167,15,212,_
48,125,251,160,13,174,196,15,224,224,130,41,167,79,237,48,_
89,52,71,110,221,241,119,3,80,0,9,0,0,4,128,0,_
20,0,0,6,192,0,219,119,0,16,144,2,0,144,0,20,_
48,3,0,176,0,24,208,3,159,196,1,59,229,0,36,32,_
5,28,149,2,108,38,1,46,144,6,0,96,1,53,32,73,_
25,176,3,71,85,2,68,240,8,167,196,4,155,0,0,49,_
96,5,162,16,82,99,160,10,70,244,6,11,161,5,121,160,_
73,104,80,8,190,0,0,117,240,8,196,0,0,130,144,9,_
88,213,8,163,224,12,75,197,10,211,0,0,164,80,11,158,_
244,10,190,208,13,253,119,12,226,0,0,197,16,13,231,0,_
0,208,144,13,234,0,0,220,48,14,201,119,14,54,7,0,_
241,48,15,170,100,15,248,224,129,0,65,84,0,177,7,0,_
97,0,131,32,120,136,0,16,24,160,84,2,177,121,0,128,_
2,233,4,3,152,0,16,55,224,121,33,5,10,0,145,4,_
108,8,0,83,0,85,0,176,5,111,88,82,176,192,121,180,_
64,78,237,196,7,188,96,78,0,8,0,139,192,135,94,244,_
78,158,192,12,234,4,123,0,0,11,179,167,70,241,244,11,_
219,224,78,224,208,131,209,64,14,159,164,13,162,52,1,225,_
96,124,27,144,14,11,56,2,243,96,15,58,228,119,16,17,_
132,45,244,66,10,16,67,51,84,67,21,112,67,57,180,67,_
71,232,67,52,0,68,66,68,68,69,96,68,72,164,68,62,_
213,68,93,240,68,81,52,69,112,176,117,169,152,69,148,196,_
69,74,245,69,150,36,70,157,64,70,102,132,70,174,160,70,_
108,228,70,195,0,71,114,68,71,134,120,71,224,168,71,229,_
216,71,198,7,72,166,52,72,211,7,66,213,19,83,3,48,_
0,64,40,0,2,160,1,0,64,147,134,87,0,5,160,72,_
9,144,0,65,0,0,12,192,0,80,64,125,15,16,121,18,_
32,1,111,64,67,21,240,7,0,128,1,24,224,8,163,180,_
1,249,231,1,30,224,145,33,16,2,189,80,24,173,87,2,_
37,80,13,73,215,136,66,32,4,225,0,0,79,240,4,229,_
88,117,193,135,6,104,128,14,0,96,7,118,128,137,131,48,_
8,236,0,0,145,16,9,96,229,9,158,176,128,171,176,10,_
204,183,70,241,88,12,197,128,15,0,16,13,209,112,129,223,_
240,13,174,84,77,189,228,119,213,195,143,1,64,0,31,0,_
0,2,112,0,95,54,0,12,144,3,65,8,1,73,224,66,_
21,176,5,76,152,1,107,48,148,29,144,138,13,16,2,138,_
16,67,37,160,9,49,148,2,111,8,1,45,64,122,17,208,_
2,88,117,1,50,16,150,31,176,3,185,199,2,73,224,13,_
0,112,3,85,96,150,69,32,6,229,24,5,109,16,124,95,_
144,7,162,196,6,132,176,14,238,7,9,238,0,0,133,176,_
9,201,39,9,167,48,15,0,224,9,178,96,74,172,224,11,_
133,153,11,201,112,129,198,176,113,115,20,14,189,4,14,120,_
7,15,58,215,119,34,36,0,10,48,1,58,9,1,25,208,_
131,23,32,2,0,112,0,37,176,132,9,240,2,140,196,0,_
58,224,4,49,68,4,161,25,1,79,176,133,19,144,5,118,_
192,133,251,6,149,110,16,9,163,148,7,159,128,125,131,208,_
10,2,225,8,164,7,2,153,192,135,37,48,10,215,200,2,_
170,96,136,55,16,11,13,1,4,184,32,142,74,0,12,148,_
56,5,199,32,157,92,224,12,204,55,6,212,160,74,111,176,_
13,211,215,7,231,9,0,143,96,14,15,241,9,234,240,16,_
175,80,90,191,48,15,15,241,12,236,57,14,252,64,77,42,_
68,148,61,72,1,64,88,0,29,208,1,232,230,2,46,224,_
66,59,176,3,159,164,4,74,64,125,87,112,5,0,32,1,_
2,69,1,114,32,7,0,112,1,129,16,8,0,144,1,143,_
80,134,27,48,70,28,224,151,2,193,70,37,16,12,167,231,_
2,201,144,12,61,116,152,0,192,3,218,160,13,0,32,4,_
227,224,123,75,176,14,207,57,5,242,32,15,0,224,5,246,_
16,143,106,144,15,133,153,7,251,112,129,134,32,96,151,32,_
66,169,32,66,189,32,66,211,32,66,227,32,66,79,246,16,_
237,160,66,15,80,0,248,121,1,49,117,0,32,32,1,46,_
4,3,81,202,0,61,80,2,28,197,4,47,0,0,19,160,_
5,99,102,1,104,32,148,25,96,7,90,202,1,132,48,5,_
0,224,1,146,192,102,33,0,10,65,53,2,175,224,6,0,_
112,2,188,112,7,0,176,2,197,224,7,170,213,12,148,68,_
3,214,80,127,57,240,13,146,0,0,58,144,14,184,40,4,_
240,32,161,78,48,15,80,5,6,244,128,140,111,96,15,185,_
0,0,127,144,15,194,0,0,142,176,15,88,229,9,253,96,_
136,172,224,15,224,136,169,93,165,169,201,199,169,133,233,163,_
211,135,14,255,224,74,49,4,16,3,96,1,3,208,131,31,_
64,0,248,249,2,7,128,132,60,192,131,12,176,4,12,16,_
67,88,224,0,0,16,1,102,16,1,179,74,7,241,105,1,_
130,96,1,80,249,8,91,198,166,52,213,1,171,16,165,32,_
144,11,3,49,2,199,48,2,0,80,2,212,240,170,33,32,_
14,33,0,0,38,192,14,38,0,0,51,32,15,75,136,4,_
243,192,120,87,80,15,93,122,6,246,112,16,118,112,15,10,_
106,8,249,96,8,0,80,9,250,80,9,100,196,15,165,0,_
0,180,208,15,202,72,12,255,192,135,212,240,15,179,199,169,_
190,23,15,255,176,128,249,240,15,170,20,0,20,11,0,5,_
48,1,8,171,0,29,176,176,20,224,2,14,187,1,16,11,_
0,35,160,4,20,171,2,87,112,177,50,80,6,27,155,3,_
114,16,159,65,16,8,33,139,4,35,11,0,80,208,9,52,_
117,5,170,16,165,95,128,11,3,97,6,198,240,178,110,32,_
179,0,32,7,225,96,179,122,176,14,175,74,8,241,16,3,_
120,70,15,6,201,9,247,240,171,19,24,121,177,176,15,237,_
199,11,253,144,138,67,118,8,134,249,15,151,0,0,218,240,_
15,152,68,14,255,192,149,214,100,136,58,231,123,254,240,15,_
198,39,94,61,136,143,46,4,1,11,43,1,26,48,170,33,_
192,2,87,214,2,58,128,143,57,128,4,49,69,4,86,112,_
125,80,64,6,169,202,5,114,0,132,104,0,8,23,32,84,_
142,64,159,127,192,9,52,181,8,140,11,0,151,240,184,135,_
136,12,148,233,10,149,91,11,217,32,171,186,160,13,140,4,_
12,221,208,4,141,22,14,161,201,12,228,128,6,147,118,14,_
10,138,13,234,192,138,222,224,14,15,74,14,241,144,127,234,_
64,15,161,7,15,247,160,174,246,176,15,199,32,72,253,112,_
13,212,227,123,32,36,74,32,100,124,17,64,0,2,64,166,_
10,176,176,33,32,170,0,32,3,25,192,131,63,0,2,11,_
96,68,41,112,177,90,16,3,135,132,6,57,16,159,118,16,_
4,252,72,8,73,176,101,145,16,5,57,249,9,89,16,165,_
172,16,6,148,169,11,105,112,159,202,0,7,54,91,13,121,_
112,2,179,27,8,159,187,13,139,32,148,221,64,9,1,26,_
14,157,192,102,228,96,10,91,136,14,175,208,172,235,128,11,_
148,228,14,193,160,173,241,160,12,18,90,15,211,80,161,248,_
176,13,164,183,15,229,192,73,253,240,14,223,133,15,23,220,_
15,25,252,15,152,216,81,24,64,0,11,43,2,61,185,179,_
64,25,82,11,160,194,78,240,0,23,187,5,18,112,72,105,_
80,1,51,140,1,54,188,1,57,220,1,60,12,2,63,44,_
2,66,108,2,247,121,12,41,96,120,213,192,2,75,140,14,_
50,192,2,159,152,3,2,89,15,64,160,120,243,240,4,75,_
0,0,244,224,5,89,128,129,109,176,133,247,176,7,150,151,_
15,138,224,138,250,144,9,178,203,15,168,0,85,253,96,11,_
202,248,15,197,192,135,255,80,13,97,249,15,128,106,22,238,_
32,157,255,96,168,52,36,153,0,192,1,6,160,194,37,32,_
116,52,192,0,57,9,4,15,112,159,76,48,1,71,136,5,_
22,160,72,101,160,1,155,9,7,29,32,148,124,16,2,158,_
169,8,37,80,133,150,144,2,88,0,0,161,208,2,97,112,_
70,50,160,6,0,160,11,54,48,166,198,176,3,169,104,13,_
65,208,180,222,160,4,101,8,14,79,16,181,225,144,5,184,_
72,14,100,16,10,0,128,14,115,176,10,0,176,14,129,160,_
140,238,240,8,120,24,15,157,32,193,245,176,10,4,136,15,_
185,208,167,17,92,142,20,60,94,227,80,152,255,176,14,48,_
217,14,211,199,0,103,235,165,6,144,170,28,112,0,52,101,_
2,11,160,179,50,224,0,50,160,167,19,240,132,72,128,1,_
158,73,5,29,224,83,96,16,2,98,0,103,38,192,148,119,_
160,2,18,9,3,174,24,9,52,96,9,97,164,3,108,104,_
10,64,16,209,175,128,4,11,145,11,77,64,122,194,96,5,_
34,153,12,96,208,12,0,240,12,109,96,13,0,64,13,120,_
0,142,217,64,8,187,231,13,144,224,123,227,192,9,148,136,_
14,167,240,156,237,48,11,201,39,15,190,192,124,247,176,12,_
170,228,15,215,224,74,199,252,16,246,224,14,15,177,124,15,_
113,0,7,112,101,12,176,0,23,27,1,15,224,189,26,80,_
1,54,27,2,26,160,2,180,248,1,54,176,179,39,96,144,_
63,0,3,85,0,0,74,128,3,99,144,68,65,48,166,97,_
144,4,71,213,6,82,176,121,121,176,5,13,77,8,100,224,_
145,139,192,6,181,0,0,144,80,7,234,106,9,125,80,85,_
157,96,8,197,224,103,142,128,85,170,112,9,176,7,11,160,_
112,214,182,144,10,185,199,11,177,96,150,195,160,11,148,152,_
12,194,96,124,208,176,12,217,105,13,210,80,152,221,160,13,_
211,55,14,228,80,115,135,141,129,55,231,15,236,105,0,8,_
128,143,12,208,0,144,61,1,252,104,1,27,48,16,26,32,_
2,71,40,2,44,192,217,41,96,3,66,144,134,64,96,126,_
56,160,4,108,22,4,85,176,133,73,240,5,117,0,0,81,_
160,6,130,0,0,248,86,134,96,224,7,158,119,6,136,128,_
73,112,48,9,184,141,7,158,192,135,1,247,12,0,112,8,_
237,155,163,179,112,214,150,128,11,13,225,9,191,208,136,166,_
80,12,226,232,10,203,80,142,181,16,13,111,217,11,215,96,_
151,197,208,13,96,213,123,217,73,13,233,16,143,220,240,14,_
23,88,14,246,224,74,236,208,115,0,113,0,49,53,148,169,_
58,171,219,7,0,33,176,132,0,224,2,59,5,0,62,240,_
5,0,209,4,205,74,140,155,23,0,102,0,85,2,16,7,_
154,20,0,126,32,193,57,42,13,0,49,10,141,168,70,148,_
104,85,201,135,214,217,9,0,224,16,143,191,165,74,31,224,_
14,23,136,4,63,14,0,95,0,15,23,216,6,242,224,129,_
127,48,15,30,24,9,245,48,125,165,96,15,211,103,11,248,_
224,74,195,144,15,174,212,12,63,151,85,144,94,14,252,208,_
75,244,208,15,189,4,116,15,241,255}


Function Uncompress_pal512_extpal() As Any ptr
  Dim ret As Any ptr
    ret = Allocate(6144)
    LZW_pal512_Decode(@LZW_pal512_data(0), 5226, ret, 6144)
    Return ret
End Function

Sub Init_AFlib3_pal512_extpal_dat() constructor
AFlib3_pal512_extpal_dat = Allocate(6144)
LZW_pal512_Decode(@LZW_pal512_data(0), 5226, AFlib3_pal512_extpal_dat, 6144)
End Sub
Sub DeInit_AFlib3_pal512_extpal_dat() destructor
DeAllocate(AFlib3_pal512_extpal_dat)
End Sub

Sub Init_pal512() Constructor
  Dim As Integer pt, pc, i
  Dim As UInteger ptr fmem
    fmem = Uncompress_pal512_extpal()
    For pt = 0 To 2
      For pc = 0 To 511
        AF3_512col_array(pt, pc) = fmem[i]
        i += 1
      Next pc
    Next pt
    DeAllocate(fmem)
End Sub

For cl as Integer = 0 to 511
  RGB512col(cl) = AF3_512col_array(0, cl)
  REL512col(cl) = AF3_512col_array(1, cl)
  AAP512col(cl) = AF3_512col_array(2, cl)
Next

'_____________________________________________________________________________________________________________________


'-------------------------------------------------------------------------
' This part of the encoding data features all six (6) built-in 256-color
' palettes in AFlib III:
' 
'    * VGA Mode13h Normal Palette
'
'    * Relsoft Palette
'      (First Originally Created by Richard Eric M. Lope in 2001)
'
'    * The Adigun Azikiwe Polack 256-Color Palette
'      (First Originally Created by Adigun Azikiwe Polack in 2002;
'       updated in December 2015!!)
'
'    * Atari 400/800/XL/XE Palette
'
'    * Atari 7800 Palette
'
'    * Enterprise 64/128 Home Computer (64k and 128k models)
'-------------------------------------------------------------------------

Dim Shared as UlongInt VGAcol(0 to 255),        RELcol(0 to 255), _
                       AAPcol(0 to 255),        ATARIcol(0 to 255), _
                       ATARI7800col(0 to 255),  ENTERPRISEcol(0 to 255)

Dim Shared AF3_256col_array(0 To 5, 0 to 255) As UInteger

Declare Function Uncompress_pal256_extpal() As Any ptr
Declare Sub Init_pal256()
Declare Sub Init_AFlib3_pal256_extpal_dat()
Declare Sub DeInit_AFlib3_pal256_extpal_dat()

#ifndef _AFlib3_pal256_extpal_dat_
#define _AFlib3_pal256_extpal_dat_
extern AFlib3_pal256_extpal_dat As Any ptr
extern AFlib3_pal256_extpal_dat_len As Integer
#endif

Declare Function LZW_pal256_Decode Alias "fb_hDecode" (_
ByVal in_buffer As Any ptr, _
ByVal in_size As Integer, _
ByVal out_buffer As Any ptr, _
ByRef out_size As Integer _
) As Integer
Dim Shared AFlib3_pal256_extpal_dat As Any ptr
Dim Shared AFlib3_pal256_extpal_dat_len As Integer = 6144
Dim Shared LZW_pal256_data(5355) As uByte => {_
0,0,16,0,160,10,1,33,16,0,161,10,3,17,16,3,_
161,16,0,81,5,10,113,16,0,80,5,17,1,0,255,32,_
17,85,64,17,19,113,17,17,241,15,19,97,17,16,241,15,_
27,241,17,27,65,16,20,64,18,0,0,2,39,1,0,44,_
160,18,0,128,3,45,1,0,69,0,19,0,16,5,51,1,_
0,97,96,19,0,16,7,57,1,0,130,192,19,0,32,9,_
63,1,0,162,32,20,0,96,11,69,1,0,203,128,20,0,_
48,14,75,129,17,32,17,16,27,17,4,19,1,0,125,32,_
21,190,0,0,254,64,0,27,97,21,27,65,21,80,33,21,_
0,33,18,65,32,18,125,32,18,190,32,18,31,1,22,86,_
49,17,84,49,17,81,241,21,98,1,16,100,1,16,102,1,_
22,103,161,22,255,192,22,255,224,22,120,209,21,125,224,9,_
107,177,21,125,240,13,107,177,17,223,32,23,190,32,23,158,_
32,23,125,176,24,158,192,21,116,33,24,92,129,22,100,49,_
24,100,97,21,100,241,23,100,65,21,142,65,21,102,65,21,_
223,128,23,24,209,21,134,49,17,136,49,17,138,49,17,70,_
241,15,182,112,12,169,177,13,169,177,14,169,177,17,235,96,_
11,27,177,13,181,1,0,199,128,27,69,177,17,172,209,27,_
219,208,27,235,208,27,104,81,27,177,81,27,175,81,27,173,_
81,27,182,144,27,171,1,0,192,193,28,194,193,28,31,49,_
29,180,49,17,183,49,17,186,129,19,1,17,7,0,192,1,_
219,129,3,219,81,5,219,209,29,227,209,29,225,209,29,223,_
209,29,0,177,30,28,176,30,56,176,30,85,176,30,58,129,_
19,227,129,19,225,129,19,223,177,29,222,241,30,241,49,31,_
243,97,31,113,128,31,113,160,31,2,130,30,56,80,4,247,_
97,30,56,16,6,247,209,29,97,0,31,16,17,33,69,16,_
33,45,113,30,69,112,30,242,193,18,97,112,30,58,1,31,_
13,2,31,227,1,31,9,2,31,225,129,33,225,33,31,225,_
193,33,232,33,32,56,1,33,245,129,30,20,130,19,52,17,_
7,81,144,5,51,210,32,53,146,6,51,210,29,105,16,5,_
15,242,35,0,144,5,65,50,19,221,97,35,70,194,33,50,_
145,6,70,162,19,63,178,35,63,210,32,63,114,35,63,18,_
5,66,82,35,53,113,37,75,82,37,57,177,37,62,226,34,_
91,50,36,0,224,22,98,2,0,16,64,38,32,64,38,48,_
64,38,81,161,38,81,129,38,81,97,38,99,226,22,16,224,_
22,32,224,22,48,224,22,65,144,39,106,34,38,104,34,38,_
102,66,38,101,82,39,119,146,39,123,2,16,65,224,39,65,_
0,40,136,242,38,32,128,2,125,210,38,32,16,30,136,18,_
21,56,96,39,0,0,3,151,130,2,151,114,18,110,130,2,_
110,130,39,38,129,3,110,162,39,38,17,4,225,97,39,106,_
98,39,143,98,39,104,242,41,104,130,39,104,50,42,111,130,_
40,98,98,41,98,146,41,98,178,41,98,178,18,65,192,2,_
109,194,2,52,192,43,60,192,43,81,193,3,44,16,21,52,_
128,44,152,178,44,42,17,21,191,242,44,52,240,44,60,240,_
44,165,130,44,196,130,44,194,130,44,106,130,44,44,128,41,_
190,2,0,210,226,45,212,226,45,122,82,46,199,34,38,202,_
130,43,222,66,16,237,226,46,239,2,47,238,130,16,6,97,_
16,243,82,16,11,1,17,14,49,16,17,49,30,20,49,30,_
22,209,47,25,209,17,20,177,17,22,1,18,104,49,18,37,_
113,18,104,162,18,222,210,18,225,65,4,17,3,0,80,64,_
49,0,0,6,23,3,0,112,160,49,0,0,8,29,3,0,_
144,0,50,0,0,10,35,3,0,180,96,50,0,128,12,41,_
3,0,224,192,50,0,192,15,47,243,46,128,98,18,1,193,_
39,0,0,4,1,65,5,1,65,6,1,65,7,1,65,8,_
1,65,9,1,129,10,1,129,11,1,129,12,1,129,13,1,_
129,14,1,193,15,237,34,51,126,130,41,1,113,51,0,145,_
51,0,177,51,0,209,51,0,241,51,0,17,52,0,49,52,_
0,81,52,0,113,52,0,145,52,0,177,52,0,209,52,49,_
19,16,80,83,51,83,3,0,85,3,0,87,3,0,89,3,_
0,91,3,0,93,3,0,95,3,0,97,131,50,72,163,52,_
76,227,46,102,98,38,104,2,43,81,115,51,55,147,51,57,_
179,51,59,211,51,61,243,51,63,19,52,65,51,52,67,83,_
52,69,115,52,71,147,52,73,179,52,75,195,15,4,144,54,_
1,1,1,128,130,18,152,194,39,64,48,53,84,80,53,100,_
112,53,116,144,53,132,176,53,148,208,53,168,240,53,184,16,_
54,42,3,0,216,80,54,232,112,54,48,19,56,162,227,39,_
48,80,58,167,147,58,171,211,58,175,19,59,179,83,59,99,_
131,59,102,179,59,159,19,16,8,0,40,16,224,39,24,192,_
39,32,48,53,40,80,53,48,112,53,56,144,53,68,176,53,_
76,208,53,84,240,53,92,16,54,100,48,54,108,80,54,116,_
112,54,128,224,60,0,128,0,101,2,63,104,130,1,81,131,_
38,55,243,40,57,163,38,59,19,30,61,67,4,117,3,0,_
76,112,55,111,147,55,0,192,5,123,19,55,125,195,6,183,_
51,55,0,176,52,128,224,50,78,243,62,38,1,40,48,48,_
63,54,227,39,84,240,40,113,195,39,116,128,31,132,208,63,_
119,3,64,121,83,53,184,80,64,40,115,53,216,144,64,12,_
148,53,252,224,64,237,130,0,12,32,56,24,32,63,36,160,_
42,48,96,63,64,128,63,76,160,63,88,192,63,100,240,51,_
76,0,7,65,67,5,128,48,52,92,192,8,69,67,6,152,_
112,52,108,64,10,73,67,7,176,208,64,192,208,62,8,0,_
61,101,34,61,0,128,1,212,99,18,214,3,0,40,128,61,_
164,163,63,220,3,0,17,243,67,224,243,54,226,67,64,228,_
19,55,230,3,0,108,128,62,115,163,62,28,195,62,238,242,_
66,0,1,1,21,132,1,36,0,16,32,192,39,40,64,44,_
152,130,4,0,129,3,85,67,4,96,0,16,76,144,66,84,_
128,7,0,193,5,91,67,6,144,0,16,108,192,9,88,243,_
53,128,192,55,241,130,73,153,164,73,155,20,47,45,4,1,_
136,176,71,144,132,41,152,0,16,64,0,10,84,243,53,100,_
0,11,88,19,54,132,0,12,92,51,54,168,0,13,96,83,_
54,200,0,14,100,115,54,232,0,15,104,211,62,14,224,75,_
0,240,1,193,20,46,52,32,44,48,145,32,86,128,76,0,_
96,6,203,4,0,123,224,76,0,192,8,209,4,0,157,64,_
77,0,224,10,215,4,0,195,160,77,0,48,13,221,4,0,_
228,0,78,0,80,15,227,212,20,0,48,0,3,64,1,230,_
52,0,35,0,0,9,144,0,81,241,0,15,96,72,21,80,_
1,127,0,0,27,176,1,127,17,2,33,208,11,0,80,2,_
37,80,13,0,32,4,66,16,14,105,100,14,0,96,7,118,_
160,14,0,16,9,145,240,14,0,176,10,171,64,15,0,80,_
12,197,128,15,0,240,13,223,208,15,0,160,15,250,176,17,_
3,96,0,33,96,78,12,144,3,0,160,0,21,176,5,0,_
192,0,29,176,7,0,224,0,37,160,9,101,210,2,186,0,_
0,23,32,3,1,197,2,73,224,13,47,33,6,228,0,0,_
95,144,7,233,0,0,121,0,9,238,224,19,167,48,15,0,_
192,10,190,112,81,198,80,13,27,5,14,236,176,17,30,245,_
81,16,144,1,0,112,0,37,48,3,42,165,3,78,0,0,_
17,240,4,59,98,1,62,116,79,121,240,9,38,225,8,52,_
85,2,163,192,12,0,112,3,177,144,13,0,160,4,192,112,_
14,4,228,12,19,245,6,219,208,52,143,96,14,27,241,10,_
239,176,17,207,128,15,27,1,88,27,65,0,37,129,0,46,_
224,2,0,208,0,74,160,4,0,32,1,101,80,6,53,21,_
8,129,112,79,213,4,2,180,3,0,46,144,12,201,0,0,_
60,160,13,218,0,0,75,176,14,177,225,5,246,96,15,67,_
181,15,250,0,0,151,128,22,189,128,22,227,128,22,237,128,_
22,7,112,1,13,96,82,48,208,1,101,194,4,47,0,0,_
22,128,6,81,193,1,132,48,5,0,16,2,160,48,89,39,_
192,11,119,128,41,205,240,51,57,240,13,146,32,80,240,112,_
86,96,64,15,171,244,7,249,32,12,0,224,9,253,48,13,_
0,0,91,229,160,20,255,112,81,232,240,15,27,53,0,22,_
48,0,88,245,2,7,160,82,75,192,0,95,101,6,17,240,_
91,130,96,1,151,181,1,38,145,11,104,82,2,212,80,2,_
0,96,2,236,96,2,0,128,4,243,16,72,103,96,15,103,_
0,0,134,144,15,134,0,0,165,192,15,165,0,0,196,240,_
15,196,48,94,227,0,0,249,240,15,249,0,0,5,48,1,_
235,69,1,46,224,94,35,160,4,241,37,3,101,64,95,65,_
16,8,247,5,5,157,144,95,95,128,11,104,226,6,254,5,_
0,122,176,14,255,37,9,244,144,32,167,144,15,134,196,11,_
253,208,82,209,240,15,151,240,77,255,208,79,131,133,97,31,_
241,80,10,0,1,4,96,92,44,240,62,57,128,4,184,5,_
5,100,32,1,0,128,6,128,112,1,0,240,7,156,144,95,_
151,16,99,214,68,99,186,160,13,55,99,12,225,144,82,210,_
112,14,118,0,0,222,224,14,145,0,0,234,64,15,172,0,_
0,246,176,15,173,241,17,73,246,15,11,117,1,10,224,100,_
50,144,1,9,0,0,77,144,2,14,128,101,57,48,1,117,_
147,4,243,243,9,89,176,91,186,144,6,34,0,0,213,144,_
7,39,240,28,139,16,21,225,208,9,5,132,14,175,192,92,_
238,16,12,210,85,15,211,208,10,0,176,15,229,112,52,228,_
165,103,11,133,1,4,224,100,51,224,78,0,224,4,15,96,_
104,105,80,1,137,70,8,27,192,104,32,240,104,38,32,105,_
213,192,2,150,22,15,50,208,2,0,48,15,79,176,4,117,_
214,6,59,146,15,138,0,74,252,128,10,166,48,17,197,96,_
97,255,192,20,255,32,15,242,0,0,26,80,0,130,38,3,_
11,48,63,74,32,1,143,34,6,25,112,3,53,6,2,71,_
224,19,39,96,5,2,225,2,102,0,0,194,80,3,117,240,_
28,60,80,8,0,16,14,87,64,74,232,48,7,171,0,0,_
238,240,8,86,81,15,171,16,13,166,118,12,62,101,109,23,_
245,15,237,208,52,18,96,0,87,70,2,10,160,71,60,48,_
1,61,240,54,29,208,110,108,96,2,111,80,55,48,0,74,_
157,160,3,162,0,0,175,128,4,178,16,111,86,48,12,0,_
240,12,109,96,13,0,144,13,132,48,24,227,192,9,117,213,_
14,179,176,75,247,176,12,28,102,109,27,193,14,244,176,17,_
7,112,0,134,102,1,17,176,91,39,224,1,194,242,3,48,_
48,30,86,16,4,114,0,0,109,32,5,144,68,8,100,224,_
10,31,83,7,185,48,77,134,80,12,2,113,9,179,100,11,_
169,192,13,217,164,11,117,5,13,203,144,84,221,160,13,77,_
195,14,238,176,17,254,48,88,42,229,0,102,34,1,23,240,_
29,34,192,2,54,0,0,49,0,4,79,32,38,85,240,36,_
106,32,8,22,227,7,147,4,7,147,80,11,28,131,10,207,_
0,0,143,48,11,45,231,9,191,208,13,214,180,12,62,213,_
11,215,192,14,0,208,12,227,144,84,220,240,14,172,197,14,_
251,32,18,24,240,95,110,85,53,86,176,53,117,80,52,2,_
96,8,162,197,93,103,227,11,70,5,0,212,144,84,0,144,_
14,28,134,4,157,247,116,242,176,15,12,85,15,77,99,11,_
248,176,81,205,160,15,27,85,14,252,224,15,0,208,15,8,_
19,16,190,100,104,11,147,119,49,16,3,2,53,80,0,48,_
5,213,183,70,59,83,7,217,183,96,134,224,96,151,224,125,_
121,35,59,0,144,11,227,7,0,202,96,126,207,177,13,175,_
193,14,235,87,78,0,81,82,46,245,88,38,145,82,121,151,_
66,66,192,22,83,224,8,86,115,74,0,80,7,177,0,16,_
134,176,93,173,245,93,10,128,10,62,181,1,185,80,15,41,_
161,12,27,209,3,192,33,107,82,101,49,202,55,38,82,0,_
16,17,48,6,0,33,2,89,51,3,247,54,70,150,0,0,_
1,80,5,167,0,89,102,80,52,35,112,7,158,69,3,136,_
32,90,69,144,9,177,97,5,170,208,52,103,176,11,27,129,_
7,204,176,17,137,208,13,27,161,9,108,23,16,59,16,16,_
0,228,103,93,112,79,21,224,6,41,97,2,14,212,3,55,_
0,103,78,128,4,34,7,6,89,48,11,56,161,6,22,38,_
8,123,16,80,147,192,8,7,69,10,157,112,15,0,80,11,_
174,176,17,198,0,12,27,113,13,66,198,64,226,176,17,37,_
165,2,114,5,0,62,152,82,0,196,6,16,32,132,125,16,_
2,69,232,8,50,224,64,160,48,4,112,22,11,84,32,114,_
194,80,6,81,56,13,118,96,97,228,112,8,1,85,15,152,_
112,80,255,144,10,93,248,15,186,176,17,252,240,12,32,49,_
14,27,229,64,102,2,103,34,37,114,50,0,0,179,0,1,_
67,48,97,33,144,51,213,112,98,0,96,14,67,192,102,247,_
64,5,135,48,17,101,64,74,255,96,7,169,48,17,135,64,_
83,255,128,9,203,48,17,96,55,17,186,208,14,19,177,12,_
32,193,13,27,65,103,0,209,79,235,229,12,6,144,78,224,_
112,1,255,21,15,40,128,119,255,144,3,234,246,15,74,128,_
5,19,177,5,59,242,15,108,160,7,107,177,8,19,225,8,_
147,244,15,160,80,106,255,16,11,91,33,12,179,244,15,211,_
80,80,255,64,14,218,198,28,0,193,12,5,64,54,87,70,_
123,35,32,104,250,64,3,26,48,17,69,176,2,19,97,5,_
196,242,15,103,208,4,19,129,7,94,48,17,137,0,7,19,_
161,9,150,245,15,171,32,93,255,192,11,163,48,17,205,64,_
11,19,225,13,91,247,15,240,208,114,155,16,16,172,96,104,_
224,229,39,206,16,125,43,35,4,6,0,0,241,48,5,91,_
246,15,100,240,40,255,80,7,37,245,15,134,240,88,67,150,_
82,255,128,10,9,244,15,185,208,21,202,144,127,255,176,13,_
167,244,15,236,224,127,31,177,93,97,16,95,0,32,7,187,_
5,0,131,176,88,119,51,53,165,80,37,68,33,6,102,114,_
12,115,32,82,216,64,8,156,152,14,149,0,138,250,96,10,_
57,243,15,183,48,89,255,128,12,108,246,15,217,192,138,123,_
246,138,251,32,139,31,65,83,19,112,85,0,64,2,107,8,_
0,53,224,131,0,96,4,33,116,5,93,224,100,104,224,6,_
21,48,84,128,48,96,138,16,9,231,182,9,162,16,72,172,_
48,11,55,210,11,196,160,6,0,224,12,213,208,82,224,96,_
14,140,112,146,247,208,9,24,81,117,31,241,74,0,224,1,_
52,19,16,19,232,100,6,48,6,128,121,1,116,48,96,40,_
80,8,231,150,3,150,16,72,74,112,10,55,178,5,184,240,_
152,108,144,12,45,213,7,218,96,153,142,176,14,153,9,10,_
252,80,117,177,240,15,175,36,12,255,80,112,158,41,0,0,_
33,3,17,4,4,244,40,5,159,9,0,99,176,65,110,81,_
8,20,8,0,150,112,129,4,112,10,61,83,1,184,112,111,_
38,144,12,30,120,3,218,32,130,72,176,14,69,147,5,252,_
224,89,106,240,15,162,181,7,255,16,27,53,37,104,93,164,_
143,0,144,3,253,40,87,127,180,5,3,217,70,6,57,21,_
9,9,0,142,96,89,34,35,93,0,16,11,18,25,111,21,_
169,0,211,176,117,27,64,14,45,199,2,245,80,87,61,64,_
94,178,134,48,11,48,122,28,128,119,0,208,2,234,6,0,_
62,80,141,19,179,35,53,177,141,72,217,141,75,57,73,119,_
83,106,15,166,22,182,48,75,1,112,12,5,37,1,216,160,_
109,35,144,14,27,65,3,30,245,18,8,51,0,58,80,129,_
241,87,2,37,84,3,41,116,4,126,0,16,90,144,127,79,_
183,127,126,96,114,1,26,128,160,64,13,38,53,11,62,165,_
1,197,144,90,45,80,13,12,216,87,0,240,4,245,176,17,_
97,240,15,169,69,16,89,52,63,192,163,38,198,4,0,87,_
160,166,0,144,6,109,90,99,122,176,141,139,32,167,0,176,_
9,117,42,16,15,65,59,69,115,12,123,58,105,213,16,80,_
230,0,168,226,68,78,33,97,78,9,128,38,10,32,2,196,_
226,0,56,80,92,16,192,4,143,9,1,95,96,79,16,16,_
7,147,0,0,15,48,8,210,198,1,147,192,28,44,48,10,_
198,208,134,177,16,165,115,133,97,88,224,12,241,0,0,103,_
192,13,27,117,7,234,192,90,139,112,15,93,216,9,246,208,_
133,65,87,82,9,48,1,94,213,0,37,160,96,15,144,3,_
84,1,1,77,32,93,16,32,6,164,96,18,114,112,120,48,_
32,8,91,7,4,146,16,80,79,16,10,62,213,5,176,144,_
84,109,240,11,27,241,7,205,176,17,147,160,87,1,154,14,_
172,133,10,232,192,97,9,32,1,234,182,0,23,144,82,12,_
176,1,69,8,1,46,48,8,0,48,2,65,224,129,53,32,_
5,67,99,4,99,80,52,87,64,7,158,117,6,132,16,87,_
117,48,9,75,67,8,162,208,133,148,240,10,27,145,10,116,_
225,11,205,176,81,210,176,13,172,101,14,234,208,133,113,39,_
4,0,208,1,18,144,51,44,80,1,147,245,3,34,144,7,_
212,103,3,141,0,0,101,128,4,103,117,7,89,240,10,11,_
150,6,175,100,9,121,48,75,166,144,8,183,84,11,152,240,_
80,197,112,10,172,165,13,181,208,133,236,48,12,9,232,14,_
210,144,128,241,0,14,19,229,3,6,80,108,78,160,0,55,_
195,5,12,80,37,112,208,1,59,67,8,49,176,72,92,169,_
8,0,112,10,85,48,73,98,73,103,199,80,7,188,0,0,_
215,64,8,109,101,14,147,32,90,232,32,10,177,129,14,178,_
48,81,235,16,12,62,11,13,19,21,15,223,144,128,100,80,_
0,87,38,7,7,32,105,130,176,0,53,0,0,152,16,2,_
201,182,10,52,96,144,189,96,4,9,249,12,88,16,120,224,_
144,6,150,26,15,121,32,114,247,144,8,81,72,15,152,176,_
117,241,128,10,215,0,0,237,96,11,75,195,14,197,48,81,_
238,64,13,19,37,15,227,144,128,118,224,106,75,121,186,153,_
96,1,250,248,10,43,176,88,194,240,3,160,72,13,81,48,_
30,230,48,6,10,102,15,115,192,92,255,64,8,160,244,15,_
147,16,83,255,32,10,254,214,15,178,208,79,250,16,12,206,_
80,103,208,48,24,242,240,13,187,52,15,237,144,128,106,112,_
78,75,41,1,238,197,9,38,176,0,0,0,11,58,48,63,_
197,224,4,222,114,13,97,96,113,233,32,7,124,151,15,130,_
240,5,19,17,9,28,39,188,14,244,15,179,240,144,193,32,_
114,255,0,13,21,201,15,223,176,117,248,208,14,1,101,15,_
244,80,87,80,16,1,242,168,113,10,176,96,58,128,91,158,_
208,4,15,192,189,95,240,29,195,16,7,139,53,13,130,240,_
3,0,80,14,147,0,5,226,52,10,134,68,142,238,59,12,_
70,250,15,210,208,147,226,112,74,251,0,15,171,148,15,241,_
176,93,248,32,15,223,133,2,33,224,94,67,96,3,219,235,_
5,74,96,104,118,192,5,12,188,8,110,112,85,157,0,8,_
253,232,10,145,64,44,191,32,10,3,233,12,177,144,82,222,_
16,12,107,144,185,207,176,141,250,208,13,160,228,15,238,64,_
100,252,240,14,34,184,15,241,80,52,41,220,26,20,208,2,_
12,188,1,64,176,189,46,64,5,91,102,4,102,48,63,92,_
128,7,146,214,6,138,32,44,126,176,9,9,226,8,171,48,_
30,158,176,11,147,213,10,201,48,7,0,192,11,217,16,120,_
203,112,14,112,134,13,244,112,86,228,64,15,85,247,14,242,_
224,181,249,32,15,158,85,1,47,192,192,29,64,4,128,73,_
2,87,112,85,43,176,6,146,182,2,126,112,110,61,224,8,_
234,230,4,159,80,141,94,240,10,104,240,116,192,240,177,124,_
240,12,160,180,8,222,64,100,153,192,14,18,118,10,248,224,_
127,179,160,15,175,196,11,249,160,188,200,128,15,97,39,1,_
41,128,91,28,240,3,233,20,2,83,128,38,35,112,6,231,_
38,2,120,0,64,34,176,8,134,84,2,156,208,51,54,208,_
10,239,90,4,187,0,103,84,176,12,161,0,0,98,144,13,_
41,11,7,232,240,11,0,224,7,246,208,86,139,160,15,175,_
97,9,248,80,87,161,112,15,9,184,0,25,224,94,18,48,_
3,236,84,1,73,224,131,23,208,5,85,98,1,110,0,111,_
22,0,8,45,101,1,146,32,178,31,32,10,127,225,2,177,_
80,106,62,16,12,253,196,4,207,208,86,89,128,118,88,182,_
14,117,101,7,248,144,128,130,128,15,23,37,9,177,106,78,_
15,32,82,10,192,2,196,210,0,71,48,30,15,208,5,76,_
252,0,120,96,89,14,176,8,30,216,0,163,32,139,26,32,_
11,69,147,2,195,224,89,56,32,13,73,115,4,225,80,87,_
86,224,14,19,85,6,128,133,80,241,208,52,133,64,15,187,_
247,9,248,192,97,238,82,160,5,234,19,210,53,47,3,33,_
213,5,170,10,64,1,16,73,16,16,175,225,19,90,237,19,_
175,49,16,90,61,16,96,45,9,98,45,9,92,237,213,0,_
144,4,5,202,213,207,33,213,94,173,10,107,45,16,92,173,_
10,219,80,160,73,224,213,73,192,213,219,224,213,233,39,16,_
120,253,215,96,205,215,115,253,26,246,1,17,62,1,17,5,_
90,5,64,33,18,82,241,144,5,250,15,64,49,30,90,61,_
30,133,93,214,137,253,26,27,161,213,182,49,17,151,29,217,_
133,237,213,85,32,215,85,192,213,164,253,144,94,253,15,114,_
237,147,96,97,215,16,1,216,162,93,216,131,77,218,153,13,_
216,169,157,217,131,237,147,109,173,71,0,241,142,146,176,219,_
146,192,28,3,161,71,3,17,220,190,45,16,192,29,16,109,_
240,20,0,33,9,202,237,19,27,49,16,202,61,16,208,221,_
220,199,45,18,73,176,219,73,240,142,219,176,219,216,17,215,_
195,173,221,115,61,220,216,161,214,206,157,4,34,177,13,206,_
237,128,113,45,221,231,61,215,210,237,128,227,161,71,227,193,_
28,139,61,223,200,189,17,122,212,27,157,173,223,200,61,30,_
202,221,47,137,13,224,146,224,20,202,253,15,89,209,217,6,_
78,224,174,61,223,225,77,218,243,141,29,169,173,223,225,237,_
147,250,141,29,162,13,224,238,77,218,0,238,128,169,109,224,_
238,237,147,6,238,128,114,25,16,36,80,160,239,72,20,82,_
189,219,170,96,226,2,241,142,170,96,11,5,74,2,94,77,_
2,92,109,11,94,109,11,96,61,227,2,81,227,46,46,214,_
57,14,16,206,253,116,144,253,20,82,237,220,170,208,6,82,_
45,18,170,16,217,65,238,213,109,192,213,169,205,218,2,209,_
6,98,13,229,2,33,229,76,94,216,187,93,5,45,94,5,_
239,248,229,15,185,219,255,208,226,206,145,26,210,213,229,148,_
221,227,95,78,217,64,78,230,155,221,227,171,177,217,64,94,_
5,206,93,231,104,46,18,22,241,144,206,253,15,73,142,17,_
117,129,230,85,14,17,87,110,17,148,189,218,125,190,217,87,_
254,17,155,189,218,114,185,219,36,240,142,182,176,219,70,193,_
226,195,13,233,46,62,220,70,33,151,206,77,2,34,97,11,_
206,141,27,44,46,221,157,238,226,210,141,27,79,183,219,109,_
240,142,100,14,22,193,221,6,195,173,234,88,62,220,102,222,_
6,206,221,6,103,193,231,208,93,235,84,14,221,125,142,229,_
5,67,2,243,125,233,95,62,223,170,17,236,19,113,233,171,_
161,223,70,209,229,0,78,234,95,14,224,184,65,230,6,78,_
234,171,97,224,184,81,231,243,29,235,22,49,223,206,209,231,_
250,29,235,31,161,223,206,81,231,0,126,235,30,1,224,104,_
209,231,6,126,238,31,97,224,104,241,255}


Function Uncompress_pal256_extpal() As Any ptr
  Dim ret As Any ptr
    ret = Allocate(6144)
    LZW_pal256_Decode(@LZW_pal256_data(0), 5355, ret, 6144)
    Return ret
End Function

Sub Init_AFlib3_pal256_extpal_dat() constructor
AFlib3_pal256_extpal_dat = Allocate(6144)
LZW_pal256_Decode(@LZW_pal256_data(0), 5355, AFlib3_pal256_extpal_dat, 6144)
End Sub
Sub DeInit_AFlib3_pal256_extpal_dat() destructor
DeAllocate(AFlib3_pal256_extpal_dat)
End Sub

Sub Init_pal256() Constructor
  Dim As Integer pt, pc, i
  Dim As UInteger ptr fmem
    fmem = Uncompress_pal256_extpal()
    For pt = 0 To 5
      For pc = 0 To 255
        AF3_256col_array(pt, pc) = fmem[i]
        i += 1
      Next pc
    Next pt
    DeAllocate(fmem)
End Sub

For cl as Integer = 0 to 255
  VGAcol(cl)        = AF3_256col_array(0, cl)
  RELcol(cl)        = AF3_256col_array(1, cl)
  AAPcol(cl)        = AF3_256col_array(2, cl)
  ATARIcol(cl)      = AF3_256col_array(3, cl)
  ATARI7800col(cl)  = AF3_256col_array(4, cl)
  ENTERPRISEcol(cl) = AF3_256col_array(5, cl)
Next

'_____________________________________________________________________________________________________________________


'-------------------------------------------------------------------------
' This part of the encoding data features all seven (7) built-in 64- to
' 128-color palettes in AFlib III:
' 
'    * Master System/Mark III Palette
'
'    * FC/FDS/NES Palette
'
'    * FamiCube 64-color Palette
'      (Palette Originated in 2015 by Arne Niklas Jansson;
'       added for AFlib III by Adigun Azikiwe Polack.)
'
'    * Atari 2600 Palette (both the NTSC and PAL versions!!)
'
'    * Commodore Plus/4 Palette
'
'    * Sam Coupe 128-color Palette
'-------------------------------------------------------------------------

Dim Shared as UlongInt SMScol(0 to 63),      NEScol(0 to 63), _
                       FCUBEcol(0 to 63),    ATARI2600col(0 to 127), _
                       PAL2600col(0 to 127), PLUS4col(0 to 127), _
                       SAMCOUPEcol(0 to 127)

Dim Shared AF3_64to128col_array(0 To 6, 0 to 127) As UInteger

Declare Function Uncompress_pal64to128col_extpal() As Any ptr
Declare Sub Init_pal64to128col()
Declare Sub Init_AFlib3_pal64to128col_extpal_dat()
Declare Sub DeInit_AFlib3_pal64to128col_extpal_dat()

#ifndef _AFlib3_pal64to128col_extpal_dat_
#define _AFlib3_pal64to128col_extpal_dat_
extern AFlib3_pal64to128col_extpal_dat As Any ptr
extern AFlib3_pal64to128col_extpal_dat_len As Integer
#endif

Declare Function LZW_pal64to128col_Decode Alias "fb_hDecode" (_
ByVal in_buffer As Any ptr, _
ByVal in_size As Integer, _
ByVal out_buffer As Any ptr, _
ByRef out_size As Integer _
) As Integer
Dim Shared AFlib3_pal64to128col_extpal_dat As Any ptr
Dim Shared AFlib3_pal64to128col_extpal_dat_len As Integer = 3584
Dim Shared LZW_pal64to128col_data(2804) As uByte => {_
0,0,16,255,0,16,85,32,16,0,160,10,5,241,15,2,_
81,5,0,160,16,4,1,0,85,112,16,15,145,16,6,193,_
16,6,225,16,170,16,17,7,33,16,27,193,16,14,241,15,_
17,145,16,255,176,16,29,33,17,11,113,16,11,145,16,85,_
128,18,42,65,16,42,113,18,4,33,18,170,208,17,170,208,_
18,24,17,19,41,177,17,45,33,18,31,177,19,9,33,19,_
12,33,19,4,33,19,7,33,19,62,129,18,52,33,20,16,_
241,17,48,129,17,64,65,19,31,97,19,54,193,19,64,177,_
19,68,193,19,33,17,16,10,49,17,26,65,0,33,129,18,_
34,1,19,74,209,19,31,193,16,75,225,19,26,161,17,19,_
225,21,33,145,22,88,225,22,106,1,23,27,17,23,101,33,_
23,117,65,23,119,241,22,118,145,23,120,49,23,123,225,23,_
125,1,24,122,17,24,124,33,24,133,65,24,135,241,23,134,_
145,24,136,49,24,139,225,24,128,193,6,145,241,15,148,0,_
2,12,129,10,1,129,9,0,192,3,255,0,7,0,0,7,_
255,192,3,0,192,7,5,241,25,0,0,1,104,32,16,26,_
96,4,2,193,2,155,1,0,80,192,16,76,16,26,255,96,_
6,58,80,17,1,1,1,185,241,15,185,1,1,255,160,11,_
191,241,15,214,128,5,42,144,16,50,176,25,240,0,2,128,_
240,15,192,0,0,192,240,15,116,64,1,208,240,15,36,160,_
1,210,240,15,30,192,3,166,32,16,82,224,7,2,65,6,_
88,32,16,136,192,16,104,64,7,12,225,9,114,192,16,188,_
177,27,186,161,30,232,224,30,9,1,10,94,144,16,130,192,_
8,9,1,7,196,144,16,92,144,16,188,128,26,255,192,7,_
114,144,16,74,96,9,252,32,16,173,144,13,255,224,2,198,_
128,9,255,224,4,212,224,4,255,160,9,200,160,3,255,192,_
13,190,224,2,255,128,5,25,178,30,189,161,30,33,145,16,_
216,96,12,9,161,12,212,144,16,196,0,15,251,145,16,240,_
128,31,255,64,13,202,144,16,190,128,13,9,97,10,230,144,_
16,178,192,14,234,240,15,198,64,15,33,162,14,236,160,11,_
9,97,14,182,240,15,194,64,36,27,98,36,138,209,24,73,_
130,36,75,194,24,76,242,24,78,162,36,77,34,37,79,50,_
37,81,66,37,87,98,37,128,1,16,12,209,7,23,192,16,_
202,160,4,2,144,16,132,80,22,168,176,5,9,193,13,11,_
242,14,160,176,9,20,66,6,98,240,15,165,64,3,61,240,_
15,64,96,1,33,240,15,145,144,1,90,240,15,202,16,3,_
106,240,15,254,80,7,218,241,15,201,32,14,255,208,14,201,_
224,15,255,192,15,156,80,13,255,64,14,105,192,12,255,48,_
11,40,48,10,255,96,4,22,112,8,255,16,7,60,240,12,_
255,224,12,130,144,16,197,144,14,99,114,11,245,240,15,137,_
32,8,225,240,15,94,80,6,218,240,15,61,192,3,162,114,_
0,21,240,4,255,128,2,60,0,14,255,80,11,215,112,40,_
130,112,9,197,240,15,55,192,6,174,240,15,13,192,3,250,_
33,1,23,48,2,255,160,1,78,208,10,195,242,8,246,48,_
44,231,144,16,49,176,11,9,81,1,143,48,41,23,112,9,_
147,240,15,33,16,12,66,146,10,255,224,14,156,178,14,190,_
240,15,18,96,13,245,113,1,180,0,40,3,208,6,55,240,_
15,8,128,2,23,32,16,78,192,16,8,208,9,19,240,15,_
50,48,13,224,33,6,181,0,2,255,176,4,96,192,16,128,_
32,5,12,193,10,152,160,0,255,208,12,226,80,2,125,242,_
15,189,240,15,161,96,10,113,64,27,93,16,4,255,0,3,_
32,208,0,255,80,1,35,243,15,52,96,50,255,176,7,41,_
243,15,168,192,50,255,112,13,47,227,33,89,2,37,51,83,_
37,52,131,37,54,35,51,53,163,51,55,179,51,57,195,51,_
127,177,37,255,240,4,67,243,15,119,96,52,255,144,9,73,_
243,15,183,192,52,255,240,12,79,243,15,231,32,53,49,83,_
0,78,160,4,255,112,1,113,224,6,255,112,2,145,208,8,_
195,226,10,171,240,15,68,144,12,194,18,5,226,240,13,255,_
208,5,249,64,45,253,241,15,3,32,3,163,129,1,81,64,_
9,184,178,6,167,240,15,58,80,8,63,114,4,156,176,12,_
24,50,11,221,240,15,100,112,12,165,242,6,216,128,15,255,_
64,0,34,16,9,255,176,1,65,80,10,255,240,2,93,240,_
35,68,112,7,205,240,15,84,224,8,130,99,6,165,208,14,_
255,80,7,186,176,15,255,48,8,147,242,15,2,80,0,117,_
243,1,34,128,10,255,144,3,59,192,11,66,35,5,152,83,_
6,104,32,56,121,176,7,235,240,15,140,208,8,249,240,15,_
157,0,10,9,65,6,6,48,8,254,241,1,153,240,15,147,_
128,3,172,240,15,167,16,5,22,147,11,101,128,57,203,160,_
7,220,64,33,139,128,35,235,192,9,137,35,8,4,0,5,_
255,192,9,31,176,6,255,240,10,56,16,8,255,64,12,79,_
176,32,214,96,6,98,115,14,121,160,46,246,160,8,206,144,_
16,156,144,54,148,160,0,28,240,15,162,240,1,53,192,43,_
56,32,5,255,128,12,80,192,6,255,160,13,103,96,8,255,_
144,14,122,208,9,255,144,15,142,64,11,9,225,9,199,240,_
15,144,16,0,12,65,10,31,160,1,75,131,3,48,208,39,_
78,176,26,218,64,6,103,146,14,121,208,6,255,96,15,140,_
240,7,245,243,8,255,80,8,31,16,0,224,3,4,27,240,_
15,178,224,5,50,144,35,122,144,4,255,144,13,149,32,31,_
232,176,10,159,129,15,194,32,42,46,211,56,100,64,3,98,_
34,8,85,208,1,224,83,7,51,192,43,146,112,53,205,176,_
10,95,240,15,226,64,12,0,98,15,218,80,68,241,80,55,_
49,64,4,3,240,15,81,128,6,250,3,7,138,64,3,255,_
160,8,168,192,4,255,48,10,196,0,6,255,144,11,222,160,_
49,207,96,15,197,51,14,255,80,9,167,115,4,98,226,1,_
107,240,1,255,128,3,140,144,3,255,0,5,169,16,5,180,_
81,12,103,224,31,224,48,26,143,112,15,45,20,60,193,35,_
0,65,96,1,255,192,1,101,80,72,52,112,8,89,96,48,_
166,112,7,255,0,6,196,0,46,114,224,13,7,81,8,247,_
32,12,122,228,50,111,195,3,56,196,1,95,64,5,255,48,_
3,127,48,7,255,128,4,157,0,9,255,176,5,185,112,16,_
110,16,13,195,240,15,127,144,14,176,226,8,253,112,34,3,_
16,3,59,148,1,84,80,64,46,48,7,139,240,15,66,16,_
9,7,65,5,172,32,44,101,96,12,130,51,7,221,64,45,_
130,16,15,19,17,16,67,115,43,70,19,74,73,131,60,76,_
115,11,78,3,53,82,99,45,30,18,52,228,84,52,71,131,_
78,75,211,52,79,243,41,238,68,53,86,131,53,90,195,53,_
94,3,54,98,67,54,102,131,54,106,195,54,255,224,54,12,_
96,5,105,84,2,116,208,4,177,226,8,140,116,5,172,160,_
28,108,48,12,150,240,15,128,128,13,120,99,9,238,144,11,_
43,3,49,111,19,55,255,48,55,117,131,2,119,147,55,123,_
243,15,125,243,55,88,16,56,131,83,56,255,112,56,137,83,_
1,93,16,67,49,192,7,9,96,48,149,224,47,100,240,10,_
66,128,50,198,160,31,146,192,13,26,147,10,238,160,8,255,_
16,59,158,112,58,169,243,15,171,211,58,175,19,59,79,48,_
59,255,80,59,183,147,59,187,211,59,191,19,60,66,83,5,_
49,148,6,112,128,0,164,179,8,40,240,15,155,64,10,72,_
240,15,176,160,11,113,36,12,205,64,7,46,51,14,210,132,_
14,241,240,9,131,67,60,198,131,60,202,195,60,206,3,61,_
210,243,15,212,99,61,220,128,61,255,160,61,137,179,6,56,_
16,67,132,80,5,151,212,9,113,224,65,178,176,8,71,240,_
15,199,48,10,242,193,13,184,160,49,237,224,12,132,240,15,_
251,48,14,151,240,15,221,243,61,225,51,62,229,115,62,233,_
179,62,237,19,53,240,131,66,243,83,63,105,67,7,27,176,_
0,255,176,8,57,80,48,163,80,5,244,114,11,113,240,80,_
203,112,8,99,240,15,221,240,9,117,128,40,180,128,8,159,_
149,12,154,48,25,249,179,63,253,243,63,1,52,64,5,116,_
64,9,180,64,13,244,64,17,244,15,19,244,15,226,225,47,_
155,144,0,102,245,10,48,224,3,203,209,4,87,240,15,208,_
80,6,5,4,14,122,176,66,237,32,9,123,180,15,165,208,_
58,241,68,52,230,132,52,74,163,78,236,148,79,83,3,79,_
227,116,95,244,164,95,247,212,78,254,133,21,1,177,2,9,_
182,27,13,192,72,67,224,3,49,228,6,0,0,30,1,208,_
4,49,68,9,27,176,65,3,112,3,56,240,15,1,240,1,_
4,17,0,39,176,4,124,116,73,47,112,0,168,97,2,68,_
144,48,41,96,0,103,53,1,196,17,0,72,80,91,65,211,_
3,53,22,46,29,16,87,78,240,4,49,132,7,16,0,40,_
2,160,5,93,49,10,41,176,2,29,102,4,35,38,0,46,_
128,26,2,96,3,224,49,0,85,112,2,255,16,4,21,96,_
92,61,112,5,98,242,8,60,80,1,255,224,10,34,80,72,_
3,112,5,27,20,52,72,64,102,225,114,2,123,240,15,89,_
80,5,74,148,1,91,163,0,99,240,48,167,48,3,49,208,_
97,80,240,32,3,128,3,183,36,0,63,80,6,167,3,6,_
116,86,4,29,208,7,255,80,4,96,32,38,153,64,4,250,_
211,10,45,0,84,0,16,6,77,20,52,90,80,5,86,0,_
26,59,176,75,114,192,6,24,128,52,44,176,41,23,144,7,_
5,19,12,72,64,89,1,48,6,102,240,15,14,192,4,158,_
37,0,84,0,32,2,0,7,29,115,67,141,195,5,115,144,_
1,92,134,5,80,52,12,62,224,73,2,64,7,56,20,52,_
133,224,7,158,149,6,102,144,45,150,80,9,171,49,12,87,_
240,10,117,82,10,87,195,14,114,16,87,18,192,8,141,35,_
3,119,96,44,33,240,7,161,240,15,19,208,9,5,148,8,_
94,240,35,131,224,9,171,209,13,132,16,6,255,240,14,107,_
224,89,42,16,10,93,80,16,12,49,11,172,32,11,201,19,_
9,165,18,12,194,112,66,240,96,8,49,114,7,207,144,7,_
240,193,84,65,208,11,177,35,6,161,176,13,12,130,10,210,_
225,3,198,0,46,177,144,8,165,210,10,203,240,25,148,34,_
77,72,51,111,90,160,12,201,21,52,202,192,113,92,38,54,_
255,0,14,215,80,8,255,208,15,155,48,15,187,147,14,146,_
144,16,185,176,78,92,32,13,143,162,7,189,32,15,180,65,_
12,52,130,5,223,0,11,160,114,41,2,68,14,137,144,16,_
201,16,57,148,226,34,123,64,14,162,240,110,49,51,15,245,_
176,40,36,103,29,254,144,14,139,66,13,254,112,112,255,80,_
15,39,247,11,129,242,15,193,16,78,255,16,13,239,48,58,_
207,144,15,39,130,40,9,33,15,252,64,14,9,225,15,236,_
144,16,247,144,16,233,176,15,225,20,52,73,16,16,0,177,_
67,114,183,67,0,32,119,255,144,4,121,135,119,117,183,119,_
211,65,2,36,240,15,109,16,120,128,119,66,132,119,66,36,_
64,120,131,183,120,138,119,120,109,112,66,146,16,16,219,16,_
16,146,183,67,148,183,67,146,144,119,219,144,119,154,119,121,_
127,103,11,133,7,120,255,16,122,39,52,29,39,100,11,139,_
55,120,130,151,122,166,7,121,5,161,114,114,167,114,0,113,_
112,114,119,112,120,23,123,73,48,123,73,80,123,188,7,120,_
66,66,120,66,34,122,170,167,120,192,215,6,194,231,122,166,_
39,121,42,71,121,42,39,121,7,71,121,7,167,121,204,167,_
123,255,160,121,208,231,123,161,39,36,211,33,36,161,23,18,_
130,71,122,199,151,16,226,151,122,33,97,122,0,32,121,122,_
151,126,232,87,119,154,39,16,148,167,119,240,7,0,156,23,_
127,59,68,2,222,119,124,130,119,127,135,87,126,250,55,120,_
211,1,128,135,247,127,146,144,126,219,144,126,4,120,121,238,_
39,9,240,183,13,240,183,128,151,71,127,182,224,125,164,199,_
122,229,23,126,164,7,128,9,193,122,255,55,126,2,65,128,_
234,55,123,11,168,126,183,103,128,241,55,123,13,24,127,7,_
119,127,192,39,129,220,55,126,219,183,129,168,151,129,28,104,_
125,31,104,128,206,39,130,6,40,125,37,216,128,206,135,130,_
13,120,112,18,184,125,45,216,130,9,49,132,24,104,132,72,_
24,51,255,15}


Function Uncompress_pal64to128col_extpal() As Any ptr
  Dim ret As Any ptr
    ret = Allocate(3584)
    LZW_pal64to128col_Decode(@LZW_pal64to128col_data(0), 2804, ret, 3584)
    Return ret
End Function

Sub Init_AFlib3_pal64to128col_extpal_dat() constructor
AFlib3_pal64to128col_extpal_dat = Allocate(3584)
LZW_pal64to128col_Decode(@LZW_pal64to128col_data(0), 2804, AFlib3_pal64to128col_extpal_dat, 3584)
End Sub
Sub DeInit_AFlib3_pal64to128col_extpal_dat() destructor
DeAllocate(AFlib3_pal64to128col_extpal_dat)
End Sub

Sub Init_pal64to128col() Constructor
  Dim As Integer pt, pc, i
  Dim As UInteger ptr fmem
    fmem = Uncompress_pal64to128col_extpal()
    For pt = 0 To 6
      For pc = 0 To 127
        AF3_64to128col_array(pt, pc) = fmem[i]
        i += 1
      Next pc
    Next pt
    DeAllocate(fmem)
End Sub

For cl as Integer = 0 to 127
  If cl < 64 then
    SMScol(cl)        = AF3_64to128col_array(0, cl)
    NEScol(cl)        = AF3_64to128col_array(1, cl)
    FCUBEcol(cl)      = AF3_64to128col_array(2, cl)
  End if
  ATARI2600col(cl)  = AF3_64to128col_array(3, cl)
  PAL2600col(cl)    = AF3_64to128col_array(4, cl)
  PLUS4col(cl)      = AF3_64to128col_array(5, cl)
  SAMCOUPEcol(cl)   = AF3_64to128col_array(6, cl)
Next

'_____________________________________________________________________________________________________________________


'-------------------------------------------------------------------------
' This part of the encoding data features all of the additional
' twenty-four (24) built-in 4- to 32-color palettes in AFlib III:
' 
'    * EGA 16-Color Palette
'
'    * Commodore-64 (c64) Palette
'
'    * Arne's 16-Color Palette
'      (Palette Originated in 2007 by Arne Niklas Jansson;
'       added for AFlib III in December 2015 by Adigun Azikiwe Polack.)
'
'    * DawnBringer's FUN16 Palette
'      (Palette Originated in April 2015 by Richard Fhager (DawnBringer);
'       added for AFlib III in December 2015 by Adigun Azikiwe Polack.)
'
'    * Intellivision (INTV) 16-Color Palette
'
'    * NEC PC-6001/PC-6601 Series 16-Color Palette
'
'    * Both the Commodore VIC-20 Palettes (NTSC and PAL versions)
'
'    * MSX/SG-1000/ColecoVision/ADAM and TI-99/4a 16-Color Palette
'
'    * Sinclair ZX Spectrum Palette
'
'    * Apple II/IIc/IIe 16-Color Palette
'
'    * Aquarius 16-Color Palette
'
'    * Amstrad CPC 27-Color Palette
'
'    * DawnBringer's 32-Color Palette (DB32)
'      (Palette Originated in April 2013 by Richard Fhager (DawnBringer);
'       added for AFlib III in December 2015 by Adigun Azikiwe Polack.)
'
'    * CGA 4-color Palette (1st palette; Normal)
'
'    * CGA 4-color Palette (1st palette; High Intensity)
'
'    * CGA 4-color Palette (2nd palette; Normal)
'
'    * CGA 4-color Palette (2nd palette; High Intensity)
'
'    * CGA 4-color Palette (3rd palette; Normal)
'
'    * CGA 4-color Palette (3rd palette; High Intensity)
'
'    * Game Boy Palette
'
'    * Virtual Boy Palette
'
'    * Bandai Original WonderSwan Palette
'
'    * RGB 3-bit (8-color) Palette
'      (Used primarily on the PC-8801 v1, Sharp X1, Fujitsu FM-7,
'       Toshiba Pasopia 7, Sharp MZ-700, and National JR-200 home
'       computers in Japan, as well as the BBC Micro, the Acorn
'       Electron, the Camputers Lynx, the ultra-rare Casio PV-1000
'       game console and the good 'ol Teletext displays... all from
'       ESPECIALLY during the 1980s.  Great times, indeed!!!  ;) )
'
'-------------------------------------------------------------------------

Dim Shared as UlongInt EGAcol(0 to 15),        C64col(0 to 15), _
                       ARNEcol(0 to 15),       FUN16col(0 to 15), _
                       INTVcol(0 to 15),       PC6001col(0 to 15), _
                       VIC20col_NTSC(0 to 15), VIC20col_PAL(0 to 15), _
                       MSXcol(0 to 15),        ZXcol(0 to 15), _
                       APPLEIIcol(0 to 15),    AQUARcol(0 to 15), _
                       CPCcol(0 to 26),        DB32col(0 to 31), _
                       CGAcol_A(0 to 3),       CGAcol_B(0 to 3), _
                       CGAcol_C(0 to 3),       CGAcol_D(0 to 3), _
                       CGAcol_E(0 to 3),       CGAcol_F(0 to 3), _
                       GBcol(0 to 3),          VBcol(0 to 3), _
                       WScol(0 to 7),          RGB8col(0 to 7)

Dim Shared AF3_4to32col_array(0 To 15, 0 to 31) As UInteger

Declare Function Uncompress_pal4to32col_extpal() As Any ptr
Declare Sub Init_pal4to32col()
Declare Sub Init_AFlib3_pal4to32col_extpal_dat()
Declare Sub DeInit_AFlib3_pal4to32col_extpal_dat()

#ifndef _AFlib3_pal4to32col_extpal_dat_
#define _AFlib3_pal4to32col_extpal_dat_
extern AFlib3_pal4to32col_extpal_dat As Any ptr
extern AFlib3_pal4to32col_extpal_dat_len As Integer
#endif

Declare Function LZW_pal4to32col_Decode Alias "fb_hDecode" (_
ByVal in_buffer As Any ptr, _
ByVal in_size As Integer, _
ByVal out_buffer As Any ptr, _
ByRef out_size As Integer _
) As Integer
Dim Shared AFlib3_pal4to32col_extpal_dat As Any ptr
Dim Shared AFlib3_pal4to32col_extpal_dat_len As Integer = 2048
Dim Shared LZW_pal4to32col_data(1239) As uByte => {_
0,0,16,255,160,10,1,1,0,3,33,16,6,1,16,170,_
32,16,5,241,15,0,80,5,10,161,10,17,241,15,85,64,_
17,255,48,17,85,48,17,25,97,17,24,81,17,27,225,17,_
22,1,18,22,1,0,32,49,18,34,65,18,39,97,18,41,_
209,16,40,177,18,42,81,18,45,1,19,47,81,18,0,241,_
18,22,177,2,55,128,6,255,32,11,164,0,7,255,96,8,_
61,240,6,255,48,4,141,128,5,255,144,7,40,80,3,255,_
240,6,199,128,11,255,80,2,79,16,20,0,144,3,67,240,_
15,89,112,6,154,240,15,68,160,21,255,192,6,93,241,15,_
132,32,13,88,81,11,94,192,6,255,80,9,103,225,18,44,_
33,19,106,193,22,105,225,22,49,129,18,52,241,15,157,64,_
23,33,241,15,51,96,2,190,240,15,139,240,6,224,240,15,_
43,192,3,73,240,15,34,64,6,164,240,15,49,144,8,235,_
240,15,107,32,14,247,240,15,78,128,4,47,240,15,26,144,_
8,68,240,15,39,224,12,163,240,15,50,96,2,27,240,21,_
87,48,18,242,32,10,49,240,15,239,192,13,178,240,22,107,_
145,26,109,1,23,171,225,22,8,0,0,8,32,20,52,160,_
2,155,97,4,93,240,15,140,0,5,150,209,4,65,96,10,_
255,0,6,102,224,5,255,96,3,107,128,12,255,240,10,117,_
48,8,255,192,3,144,32,5,255,208,11,126,176,13,255,64,_
15,153,176,5,255,80,8,172,224,13,143,193,12,148,240,15,_
252,176,13,132,240,15,112,224,13,242,240,15,254,240,29,174,_
209,26,235,161,26,236,193,26,170,81,0,0,192,0,22,209,_
2,35,1,0,62,96,17,100,64,13,201,240,15,15,128,7,_
35,1,2,167,48,18,39,160,14,250,96,17,252,96,17,168,_
128,10,167,96,17,203,160,5,13,241,27,13,129,5,60,240,_
15,118,32,3,32,81,9,189,240,15,48,208,12,101,209,7,_
26,112,28,238,161,30,237,65,34,239,209,22,1,97,17,4,_
64,18,35,241,10,43,97,31,48,17,18,20,32,35,13,209,_
34,200,33,19,53,242,10,44,226,34,200,129,28,175,80,35,_
37,50,34,38,18,36,174,33,23,33,113,3,17,144,15,255,_
96,15,249,144,20,198,64,33,255,144,10,237,64,33,247,112,_
5,15,240,15,99,144,14,232,65,4,98,176,15,255,224,13,_
191,208,37,229,192,10,243,240,15,221,160,14,168,240,15,247,_
128,11,230,240,15,164,208,13,171,240,15,231,48,11,106,240,_
15,165,160,13,142,33,34,121,2,36,122,34,36,69,2,18,_
33,240,1,182,96,17,240,208,4,22,241,3,180,240,15,55,_
32,14,150,241,15,52,160,1,255,176,1,215,192,13,13,65,_
5,202,240,15,114,0,11,233,240,15,147,32,9,231,240,15,_
253,112,15,88,241,15,159,224,23,147,64,14,143,96,17,144,_
32,8,216,225,13,229,48,36,124,242,42,123,162,26,114,129,_
4,180,0,4,255,224,7,210,128,7,255,192,13,64,112,4,_
255,0,15,119,16,8,255,160,4,86,128,40,166,113,6,255,_
160,5,102,160,13,255,16,8,141,96,17,88,32,12,204,240,_
15,143,48,13,225,240,15,59,208,8,73,81,11,103,32,40,_
176,0,46,118,1,43,227,34,43,66,210,18,114,1,10,4,_
1,0,160,240,15,233,194,46,235,50,18,160,144,46,13,33,_
47,237,82,47,69,162,46,32,161,34,59,98,18,53,17,18,_
229,18,43,230,2,48,114,1,3,0,80,10,255,16,14,247,_
241,29,0,80,13,255,48,2,255,129,43,126,224,7,223,129,_
9,35,209,15,161,0,39,16,112,5,84,240,15,33,224,5,_
232,225,11,33,243,15,227,48,49,255,224,1,207,48,18,49,_
144,13,209,240,15,153,160,15,254,66,46,2,35,51,68,18,_
16,27,0,0,195,208,16,191,112,0,255,112,0,185,112,28,_
216,96,0,35,17,13,0,112,11,109,98,12,254,2,12,73,_
243,15,122,144,8,73,113,7,33,64,39,104,208,0,5,80,_
45,204,192,50,79,144,8,215,1,0,79,192,46,20,129,17,_
49,19,48,97,115,46,1,1,8,40,162,46,128,240,15,101,_
131,54,13,129,54,40,82,54,250,34,18,111,3,8,111,147,_
54,246,49,55,105,115,55,120,195,54,22,145,55,105,211,47,_
126,179,22,35,129,54,131,3,18,109,83,56,226,18,54,114,_
65,3,32,32,2,204,129,2,69,112,24,57,96,6,217,98,_
5,168,98,2,113,240,13,255,96,6,160,144,13,255,160,9,_
195,224,14,196,33,15,93,2,5,229,144,9,27,226,11,116,_
226,6,148,112,3,255,240,2,105,176,4,255,64,2,75,240,_
28,57,192,3,23,66,7,63,240,3,255,32,8,96,0,3,_
8,227,6,215,241,15,155,48,6,255,64,14,205,240,5,223,_
177,13,203,96,23,183,208,10,155,240,15,135,224,7,226,161,_
6,106,144,6,255,32,5,86,144,5,255,160,8,66,96,7,_
155,33,3,172,112,37,87,208,57,186,176,7,215,64,44,151,_
128,42,48,240,6,138,208,16,1,17,17,35,49,16,16,33,_
17,126,242,53,95,243,47,4,129,16,12,225,16,10,33,23,_
28,113,17,31,241,62,242,179,63,244,227,63,40,146,17,29,_
97,23,0,3,43,123,128,39,74,224,10,181,112,24,105,176,_
6,255,0,1,32,16,2,255,64,0,27,164,65,4,144,65,_
27,84,65,28,100,23,221,64,66,255,176,11,39,212,50,153,_
112,58,119,192,66,23,129,17,51,0,67,255,16,1,51,36,_
54,12,100,67,109,241,255}


Function Uncompress_pal4to32col_extpal() As Any ptr
  Dim ret As Any ptr
    ret = Allocate(2048)
    LZW_pal4to32col_Decode(@LZW_pal4to32col_data(0), 1239, ret, 2048)
    Return ret
End Function

Sub Init_AFlib3_pal4to32col_extpal_dat() constructor
AFlib3_pal4to32col_extpal_dat = Allocate(2048)
LZW_pal4to32col_Decode(@LZW_pal4to32col_data(0), 1239, AFlib3_pal4to32col_extpal_dat, 2048)
End Sub
Sub DeInit_AFlib3_pal4to32col_extpal_dat() destructor
DeAllocate(AFlib3_pal4to32col_extpal_dat)
End Sub

Sub Init_pal4to32col() Constructor
  Dim As Integer pt, pc, i
  Dim As UInteger ptr fmem
    fmem = Uncompress_pal4to32col_extpal()
    For pt = 0 To 15
      For pc = 0 To 31
        AF3_4to32col_array(pt, pc) = fmem[i]
        i += 1
      Next pc
    Next pt
    DeAllocate(fmem)
End Sub

For cl as Integer = 0 to 31
  If cl < 16 then
    EGAcol(cl)        = AF3_4to32col_array(0, cl)
    C64col(cl)        = AF3_4to32col_array(1, cl)
    ARNEcol(cl)       = AF3_4to32col_array(2, cl)
    FUN16col(cl)      = AF3_4to32col_array(3, cl)
    INTVcol(cl)       = AF3_4to32col_array(4, cl)
    PC6001col(cl)     = AF3_4to32col_array(5, cl)
    VIC20col_NTSC(cl) = AF3_4to32col_array(6, cl)
    VIC20col_PAL(cl)  = AF3_4to32col_array(7, cl)
    MSXcol(cl)        = AF3_4to32col_array(8, cl)
    ZXcol(cl)         = AF3_4to32col_array(9, cl)
    AppleIIcol(cl)    = AF3_4to32col_array(10, cl)
    AQUARcol(cl)      = AF3_4to32col_array(11, cl)
  End if
  If cl < 27 then CPCcol(cl) = AF3_4to32col_array(12, cl)
  DB32col(cl) = AF3_4to32col_array(13, cl)
  If cl < 4 then
    CGAcol_A(cl)        = AF3_4to32col_array(14, cl)
    CGAcol_B(cl)        = AF3_4to32col_array(14, cl + 4)
    CGAcol_C(cl)        = AF3_4to32col_array(14, cl + 8)
    CGAcol_D(cl)        = AF3_4to32col_array(14, cl + 12)
    CGAcol_E(cl)        = AF3_4to32col_array(14, cl + 16)
    CGAcol_F(cl)        = AF3_4to32col_array(14, cl + 20)
    GBcol(cl)           = AF3_4to32col_array(15, cl)
    VBcol(cl)           = AF3_4to32col_array(15, cl + 4)
  End if
  If cl < 8 then
    WScol(cl)            = AF3_4to32col_array(15, cl + 8)
    RGB8col(cl)          = AF3_4to32col_array(9, cl + 8)
  End if
Next

'_____________________________________________________________________________________________________________________


'-------------------------------------------------------------------------
' This part of the encoding data for AFlib III fully features the built-in
' RGB 12-bit (4096-color) palette, used quite primarily on the following
' home-computer/consoles:
' 
'    * Neo Geo AES/MVS
'    * WonderSwan Color
'    * Commodore Amiga OCS/ECS
'    * Atari STe
'    * Apple IIgs
'    * Acorn Archimedes
'    * Game Gear
'    * Neo Geo Pocket Color
'    * Atari Lynx
'    * NEC PC-9801 VM/VX
'    * Sharp SuperMZ (aka MZ-2500 series)
'    * Sharp X1 Turbo Z Series
'    * Fujitsu FM-77AV
'    * Amstrad CPC+ (Plus)/GX4000
'    * NeXTstation Color (Original and Turbo versions)
'-------------------------------------------------------------------------

Dim Shared as UlongInt RGB4096col(0 to 4095)

Dim Shared AF3_4096col_array(0 to 4095) As UInteger

Declare Function Uncompress_pal4096_extpal() As Any ptr
Declare Sub Init_pal4096()
Declare Sub Init_AFlib3_pal4096_extpal_dat()
Declare Sub DeInit_AFlib3_pal4096_extpal_dat()

#ifndef _AFlib3_pal4096_extpal_dat_
#define _AFlib3_pal4096_extpal_dat_
extern AFlib3_pal4096_extpal_dat As Any ptr
extern AFlib3_pal4096_extpal_dat_len As Integer
#endif

Declare Function LZW_pal4096_Decode Alias "fb_hDecode" (_
ByVal in_buffer As Any ptr, _
ByVal in_size As Integer, _
ByVal out_buffer As Any ptr, _
ByRef out_size As Integer _
) As Integer
Dim Shared AFlib3_pal4096_extpal_dat As Any ptr
Dim Shared AFlib3_pal4096_extpal_dat_len As Integer = 16384
Dim Shared LZW_pal4096_data(10112) As uByte => {_
0,0,16,0,16,1,1,33,2,1,49,3,1,65,4,1,_
81,5,1,97,6,1,113,7,1,129,8,1,145,9,1,161,_
10,1,177,11,1,193,12,1,209,13,1,225,14,1,241,15,_
1,1,16,3,33,18,0,80,16,3,113,16,3,145,16,3,_
177,16,3,209,16,3,241,16,3,17,17,3,49,17,3,81,_
17,3,113,17,3,145,17,3,177,17,3,209,17,3,241,17,_
3,1,16,37,65,18,67,81,16,7,81,16,9,81,16,11,_
81,16,13,81,16,15,81,16,17,81,16,19,81,16,21,81,_
16,23,81,16,25,81,16,27,81,16,29,81,16,31,81,16,_
0,113,18,0,96,20,98,65,22,7,145,16,7,177,16,7,_
209,16,7,241,16,7,17,17,7,49,17,7,81,17,7,113,_
17,7,145,17,7,177,17,7,209,17,7,241,17,7,1,16,_
41,1,0,72,17,24,100,145,16,133,1,0,11,145,16,13,_
145,16,15,145,16,17,145,16,19,145,16,21,145,16,23,145,_
16,25,145,16,27,145,16,29,145,16,31,145,16,0,177,18,_
135,49,20,105,1,26,9,177,16,165,1,0,13,177,16,15,_
177,16,17,177,16,19,177,16,21,177,16,23,177,16,25,177,_
16,27,177,16,29,177,16,31,177,16,0,209,18,167,49,20,_
107,225,27,137,1,26,13,65,28,0,240,16,13,17,17,13,_
49,17,13,81,17,13,113,17,13,145,17,13,177,17,13,209,_
17,13,241,17,13,1,16,47,97,28,67,209,22,219,177,24,_
160,113,28,219,241,16,15,17,17,15,49,17,15,81,17,15,_
113,17,15,145,17,15,177,17,15,209,17,15,241,17,15,33,_
16,33,1,20,34,0,20,51,0,20,68,0,20,85,0,20,_
102,0,20,119,0,20,136,0,20,153,0,20,170,0,20,187,_
0,20,204,0,20,221,0,20,238,0,20,255,0,20,2,33,_
18,17,48,16,248,97,18,22,18,24,26,226,31,44,161,33,_
2,2,19,26,98,32,52,161,33,10,130,19,26,226,32,60,_
161,33,18,2,20,17,80,18,46,66,18,48,162,31,71,1,_
35,254,177,20,48,34,32,79,1,35,6,50,21,48,162,32,_
87,1,35,14,178,21,48,34,33,95,17,1,39,113,36,49,_
114,16,250,97,22,73,226,31,106,145,36,2,226,22,73,98,_
32,114,145,36,10,98,23,73,226,32,122,145,36,18,226,23,_
17,144,18,96,18,35,103,33,38,252,65,26,98,2,32,139,_
33,38,4,242,24,98,130,32,147,33,38,12,114,25,98,2,_
33,155,33,38,2,177,18,17,160,20,122,34,22,124,194,31,_
165,193,39,0,146,26,124,66,32,173,193,39,8,18,27,124,_
194,32,181,193,39,16,146,27,124,34,16,45,17,1,76,49,_
41,125,162,24,149,226,31,196,81,41,2,130,28,149,98,32,_
204,81,41,10,2,29,149,226,32,212,81,41,18,130,29,17,_
240,18,170,18,35,109,193,42,252,161,26,172,2,32,227,193,_
42,4,98,30,172,130,32,234,193,42,12,226,30,172,2,33,_
242,193,42,67,33,16,95,33,2,95,49,3,95,65,4,95,_
81,5,95,97,6,95,113,7,95,129,8,95,145,9,95,161,_
10,95,177,11,95,193,12,95,209,13,95,225,14,95,241,15,_
95,17,35,195,114,33,248,33,22,228,146,44,42,65,46,205,_
226,18,228,18,45,50,65,46,213,98,19,228,146,45,58,65,_
46,221,226,19,228,66,18,37,81,44,249,82,20,251,146,44,_
73,177,47,205,210,20,251,18,45,81,177,47,213,82,21,251,_
146,45,89,177,47,221,210,21,251,66,18,39,33,2,70,49,_
49,229,98,22,21,179,44,106,81,49,207,226,22,21,51,45,_
114,81,49,215,98,23,21,179,45,122,81,49,223,226,23,34,_
144,18,42,147,47,103,193,50,201,66,26,44,211,44,139,193,_
50,209,242,24,44,83,45,147,193,50,217,114,25,44,211,45,_
155,193,50,36,177,18,34,160,20,68,83,46,136,97,52,203,_
178,16,205,146,26,70,19,45,173,97,52,213,18,27,70,147,_
45,181,97,52,221,146,27,70,67,18,45,33,2,76,209,53,_
229,162,24,95,179,44,196,241,53,207,130,28,95,51,45,204,_
241,53,215,2,29,95,179,45,212,241,53,223,130,29,34,240,_
18,116,147,47,109,97,55,201,162,26,118,211,44,227,97,55,_
209,98,30,118,83,45,234,97,55,217,226,30,118,211,45,242,_
97,55,100,33,16,41,227,23,51,224,23,68,224,23,85,224,_
23,102,224,23,119,224,23,136,224,23,153,224,23,170,224,23,_
187,224,23,204,224,23,221,224,23,238,224,23,255,224,23,125,_
210,56,23,162,31,98,209,58,146,163,18,173,99,57,46,209,_
58,154,35,19,173,227,57,54,209,58,162,163,19,173,99,58,_
62,209,58,229,210,56,5,49,49,69,113,44,129,113,60,148,_
179,20,199,131,57,79,113,60,156,51,21,199,3,58,87,113,_
60,164,179,21,199,131,58,198,114,18,144,19,49,75,194,61,_
146,131,22,220,99,57,108,193,61,154,3,23,220,227,57,116,_
193,61,162,131,23,220,99,58,124,193,61,98,145,18,51,128,_
20,244,227,58,133,97,63,148,147,24,246,131,57,141,97,63,_
156,19,25,246,3,58,149,97,63,164,147,25,246,131,58,157,_
49,3,43,177,64,17,147,22,13,36,57,165,209,64,150,147,_
26,13,164,57,173,209,64,158,19,27,13,36,58,181,209,64,_
166,147,27,13,36,22,45,49,3,76,81,66,174,163,24,39,_
68,57,196,113,66,152,131,28,39,196,57,204,113,66,160,3,_
29,39,68,58,212,113,66,168,131,29,51,240,18,60,20,49,_
109,225,67,146,163,26,62,100,57,227,225,67,154,99,30,62,_
228,57,234,225,67,162,227,30,62,100,58,242,225,67,131,33,_
16,157,17,52,246,19,24,157,81,5,157,97,6,157,113,7,_
157,129,8,157,145,9,157,161,10,157,177,11,157,193,12,157,_
209,13,157,225,14,157,241,15,157,177,33,85,116,33,252,33,_
63,40,65,71,91,196,18,116,244,69,48,65,71,99,68,19,_
116,116,70,56,65,71,107,196,19,116,244,70,251,81,18,201,_
66,18,138,68,63,71,161,72,91,180,20,138,244,69,79,161,_
72,99,52,21,138,116,70,87,161,72,107,180,21,138,244,70,_
200,114,18,146,179,72,75,34,74,68,32,74,91,164,22,162,_
244,69,110,33,74,99,36,23,162,116,70,118,33,74,107,164,_
23,162,244,70,145,147,18,166,180,72,103,161,75,166,68,26,_
186,212,69,139,161,75,97,244,24,186,84,70,147,161,75,105,_
116,25,186,212,70,155,161,75,129,177,18,68,160,20,210,36,_
63,136,65,77,91,180,52,212,244,69,171,65,77,99,244,26,_
212,116,70,179,65,77,107,116,27,212,244,70,187,65,4,45,_
145,78,139,180,22,235,100,74,168,177,78,93,212,16,95,132,_
28,235,52,70,204,177,78,103,4,29,235,180,70,212,177,78,_
111,132,29,68,240,18,2,181,72,109,65,80,166,164,26,4,_
213,69,227,65,80,97,100,30,4,85,70,234,65,80,105,228,_
30,4,213,70,242,65,80,160,129,39,65,177,27,34,68,77,_
135,177,27,102,176,27,119,176,27,136,176,27,153,176,27,170,_
176,27,187,176,27,204,176,27,221,176,27,238,176,27,255,176,_
27,135,33,18,254,33,52,38,129,83,210,164,18,56,37,82,_
46,129,83,38,37,19,56,165,82,54,129,83,46,165,19,56,_
37,83,62,129,83,135,81,18,203,34,52,69,1,85,210,148,_
20,80,37,82,77,1,85,38,21,21,80,165,82,85,1,85,_
46,149,21,80,37,83,93,1,85,135,113,18,148,35,52,75,_
130,86,210,132,22,104,37,82,108,129,86,38,5,23,104,165,_
82,116,129,86,46,133,23,104,37,83,124,129,86,135,145,18,_
91,36,52,103,1,88,210,68,26,128,37,82,139,1,88,38,_
245,24,128,165,82,147,1,88,46,117,25,128,37,83,155,1,_
88,32,133,39,74,81,5,105,145,89,208,84,26,155,37,82,_
169,177,89,38,213,26,155,165,82,177,177,89,46,85,27,155,_
37,83,185,177,89,135,209,18,85,192,20,176,37,22,178,37,_
77,168,33,91,34,53,79,178,101,82,202,33,91,42,229,28,_
178,229,82,210,33,91,50,101,29,178,117,24,47,81,5,78,_
145,92,179,197,24,203,149,89,199,177,92,36,69,30,203,133,_
82,232,177,92,44,197,30,203,5,83,240,177,92,52,69,31,_
169,50,55,59,20,80,216,97,92,102,128,29,119,128,29,136,_
128,29,153,128,29,170,128,29,187,128,29,204,128,29,221,128,_
29,238,128,29,255,128,29,167,33,18,0,178,53,38,193,95,_
233,164,18,252,101,94,46,193,95,234,37,19,252,229,94,54,_
193,95,242,165,19,252,101,95,62,193,95,167,81,18,205,178,_
53,69,65,97,233,148,20,20,102,94,77,65,97,234,21,21,_
20,230,94,85,65,97,242,149,21,20,102,95,93,65,97,167,_
113,18,150,179,53,75,194,98,233,132,22,44,102,94,108,193,_
98,234,5,23,44,230,94,116,193,98,242,133,23,44,102,95,_
124,193,98,167,145,18,93,180,53,103,65,100,233,68,26,68,_
102,94,139,65,100,234,245,24,68,230,94,147,65,100,242,117,_
25,68,102,95,155,65,100,167,177,18,34,181,53,105,193,101,_
233,84,26,92,102,94,169,193,101,234,213,26,92,230,94,177,_
193,101,242,85,27,92,102,95,185,193,101,167,209,18,230,181,_
53,107,65,103,233,132,26,116,102,94,243,68,103,234,165,28,_
116,230,94,206,65,103,242,37,29,116,102,95,214,65,103,167,_
241,18,102,224,20,140,54,66,140,225,104,176,117,28,142,134,_
94,228,225,104,236,133,30,142,6,95,236,225,104,244,5,31,_
142,134,95,244,65,31,193,178,56,83,148,81,203,165,104,217,_
65,31,136,64,31,153,64,31,170,64,31,187,64,31,204,64,_
31,221,64,31,238,64,31,255,64,31,198,33,18,2,66,18,_
190,198,67,40,225,107,201,197,18,190,118,7,190,198,106,50,_
225,107,176,102,19,190,70,107,58,225,107,184,230,19,190,102,_
28,37,241,44,191,86,20,215,38,80,73,113,109,140,214,20,_
215,198,106,81,113,109,176,86,21,215,70,107,89,113,109,184,_
214,21,215,102,28,39,129,57,191,182,36,239,38,80,104,241,_
110,140,198,22,239,198,106,112,241,110,176,70,23,239,70,107,_
120,241,110,184,198,23,239,102,28,41,241,69,191,118,22,7,_
39,80,164,113,112,140,182,24,7,199,106,143,113,112,176,54,_
25,7,71,107,151,113,112,184,182,25,7,103,28,43,65,82,_
191,150,22,31,39,80,165,241,113,140,150,26,31,199,106,173,_
241,113,176,22,27,31,71,107,181,241,113,184,150,27,31,103,_
28,45,129,94,191,182,22,55,39,80,168,113,115,140,54,79,_
55,199,106,202,113,115,176,230,28,55,71,107,210,113,115,184,_
102,29,55,103,28,47,113,108,191,214,22,79,39,80,170,241,_
116,140,54,30,79,199,106,230,241,116,176,166,30,79,71,107,_
238,241,116,184,38,31,79,7,0,17,33,16,102,39,2,102,_
55,3,102,71,4,102,87,5,102,103,6,102,119,7,102,135,_
8,102,151,9,102,167,10,102,183,11,102,199,12,102,215,13,_
102,231,14,102,247,15,102,87,118,34,65,32,36,113,120,107,_
135,18,135,247,118,44,113,120,115,7,19,135,119,119,52,113,_
120,123,135,19,135,247,119,60,113,120,131,55,32,37,17,45,_
136,87,20,159,215,118,73,241,121,113,215,20,159,87,119,81,_
241,121,121,87,21,159,215,119,89,241,121,129,215,21,159,87,_
118,39,161,57,136,183,36,183,215,118,104,113,123,113,199,22,_
183,87,119,112,113,123,121,71,23,183,215,119,120,113,123,129,_
199,23,183,87,118,41,17,70,136,119,22,207,215,118,164,241,_
124,113,183,24,207,87,119,143,241,124,121,55,25,207,215,119,_
151,241,124,129,183,25,207,87,118,43,97,82,136,151,22,231,_
215,118,165,113,126,113,151,26,231,87,119,173,113,126,121,23,_
27,231,215,119,181,113,126,129,151,27,231,87,118,45,161,94,_
136,183,22,255,215,118,168,241,127,113,55,79,255,87,119,202,_
241,127,121,231,28,255,215,119,210,241,127,129,103,29,255,87,_
118,47,193,106,136,215,22,23,216,118,170,113,129,113,55,30,_
23,88,119,230,113,129,121,167,30,23,216,119,238,113,129,129,_
39,31,23,8,0,19,33,16,46,40,2,46,56,3,46,72,_
4,46,88,5,46,104,6,46,120,7,46,136,8,46,152,9,_
46,168,10,46,184,11,46,200,12,46,216,13,46,232,14,46,_
248,15,46,216,130,34,97,32,36,241,132,51,136,18,79,120,_
131,44,241,132,59,8,19,79,248,131,52,241,132,67,136,19,_
79,120,132,60,241,132,75,88,32,37,49,45,80,88,20,103,_
88,131,73,113,134,57,216,20,103,216,131,81,113,134,65,88,_
21,103,88,132,89,113,134,73,216,21,103,216,130,39,193,57,_
80,184,36,127,88,131,104,241,135,57,200,22,127,216,131,112,_
241,135,65,72,23,127,88,132,120,241,135,73,200,23,127,216,_
130,41,49,70,80,120,22,151,88,131,164,113,137,57,184,24,_
151,216,131,143,113,137,65,56,25,151,88,132,151,113,137,73,_
184,25,151,216,130,43,129,82,80,152,22,175,88,131,165,241,_
138,57,152,26,175,216,131,173,241,138,65,24,27,175,88,132,_
181,241,138,73,152,27,175,216,130,45,193,94,80,184,22,199,_
88,131,168,113,140,57,56,79,199,216,131,202,113,140,65,232,_
28,199,88,132,210,113,140,73,104,29,199,216,130,47,225,106,_
80,216,22,223,88,131,170,241,141,57,56,30,223,216,131,230,_
241,141,65,168,30,223,88,132,238,241,141,73,40,31,223,8,_
0,21,33,16,246,40,2,246,56,3,246,72,4,246,88,5,_
246,104,6,246,120,7,246,136,8,246,152,9,246,168,10,246,_
184,11,246,200,12,246,216,13,246,232,14,246,248,15,246,88,_
143,34,129,32,36,113,145,251,136,18,23,249,143,44,113,145,_
3,9,19,23,121,144,52,113,145,11,137,19,23,249,144,60,_
113,145,19,121,32,37,81,45,24,89,20,47,217,143,73,241,_
146,1,217,20,47,89,144,81,241,146,9,89,21,47,217,144,_
89,241,146,17,217,21,47,89,143,39,225,57,24,185,36,71,_
217,143,104,113,148,1,201,22,71,89,144,112,113,148,9,73,_
23,71,217,144,120,113,148,17,201,23,71,89,143,41,81,70,_
24,121,22,95,217,143,164,241,149,1,185,24,95,89,144,143,_
241,149,9,57,25,95,217,144,151,241,149,17,185,25,95,89,_
143,43,161,82,24,153,22,119,217,143,165,113,151,1,153,26,_
119,89,144,173,113,151,9,25,27,119,217,144,181,113,151,17,_
153,27,119,89,143,45,225,94,24,185,22,143,217,143,168,241,_
152,1,57,79,143,89,144,202,241,152,9,233,28,143,217,144,_
210,241,152,17,105,29,143,89,143,47,1,107,24,217,22,167,_
217,143,170,113,154,1,57,30,167,89,144,230,113,154,9,169,_
30,167,217,144,238,113,154,17,41,31,167,9,0,23,33,16,_
190,41,2,190,57,3,190,73,4,190,89,5,190,105,6,190,_
121,7,190,137,8,190,153,9,190,169,10,190,185,11,190,201,_
12,190,217,13,190,233,14,190,249,15,190,217,155,34,161,32,_
36,241,157,195,137,18,223,121,156,44,241,157,203,9,19,223,_
249,156,52,241,157,211,137,19,223,121,157,60,241,157,219,153,_
32,37,113,45,224,89,20,247,89,156,73,113,159,201,217,20,_
247,217,156,81,113,159,209,89,21,247,89,157,89,113,159,217,_
217,21,247,217,155,39,1,58,224,185,36,15,90,156,104,241,_
160,201,201,22,15,218,156,112,241,160,209,73,23,15,90,157,_
120,241,160,217,201,23,15,218,155,41,113,70,224,121,22,39,_
90,156,164,113,162,201,185,24,39,218,156,143,113,162,209,57,_
25,39,90,157,151,113,162,217,185,25,39,218,155,43,193,82,_
224,153,22,63,90,156,165,241,163,201,153,26,63,218,156,173,_
241,163,209,25,27,63,90,157,181,241,163,217,153,27,63,218,_
155,45,1,95,224,185,22,87,90,156,168,113,165,201,57,79,_
87,218,156,202,113,165,209,233,28,87,90,157,210,113,165,217,_
105,29,87,218,155,47,33,107,224,217,22,111,90,156,170,241,_
166,201,57,30,111,218,156,230,241,166,209,169,30,111,90,157,_
238,241,166,217,41,31,111,10,0,25,33,16,134,42,2,134,_
58,3,134,74,4,134,90,5,134,106,6,134,122,7,134,138,_
8,134,154,9,134,170,10,134,186,11,134,202,12,134,218,13,_
134,234,14,134,250,15,134,90,168,34,193,32,36,113,170,139,_
138,18,167,250,168,44,113,170,147,10,19,167,122,169,52,113,_
170,155,138,19,167,250,169,60,113,170,163,186,32,37,145,45,_
168,90,20,191,218,168,73,241,171,145,218,20,191,90,169,81,_
241,171,153,90,21,191,218,169,89,241,171,161,218,21,191,90,_
168,39,33,58,168,186,36,215,218,168,104,113,173,145,202,22,_
215,90,169,112,113,173,153,74,23,215,218,169,120,113,173,161,_
202,23,215,90,168,41,145,70,168,122,22,239,218,168,164,241,_
174,145,186,24,239,90,169,143,241,174,153,58,25,239,218,169,_
151,241,174,161,186,25,239,90,168,43,225,82,168,154,22,7,_
219,168,165,113,176,145,154,26,7,91,169,173,113,176,153,26,_
27,7,219,169,181,113,176,161,154,27,7,91,168,45,33,95,_
168,186,22,31,219,168,168,241,177,145,58,79,31,91,169,202,_
241,177,153,234,28,31,219,169,210,241,177,161,106,29,31,91,_
168,47,65,107,168,218,22,55,219,168,170,113,179,145,58,30,_
55,91,169,230,113,179,153,170,30,55,219,169,238,113,179,161,_
42,31,55,11,0,27,33,16,78,43,2,78,59,3,78,75,_
4,78,91,5,78,107,6,78,123,7,78,139,8,78,155,9,_
78,171,10,78,187,11,78,203,12,78,219,13,78,235,14,78,_
251,15,78,219,180,34,225,32,36,241,182,83,139,18,111,123,_
181,44,241,182,91,11,19,111,251,181,52,241,182,99,139,19,_
111,123,182,60,241,182,107,219,32,37,177,45,112,91,20,135,_
91,181,73,113,184,89,219,20,135,219,181,81,113,184,97,91,_
21,135,91,182,89,113,184,105,219,21,135,219,180,39,65,58,_
112,187,36,159,91,181,104,241,185,89,203,22,159,219,181,112,_
241,185,97,75,23,159,91,182,120,241,185,105,203,23,159,219,_
180,41,177,70,112,123,22,183,91,181,164,113,187,89,187,24,_
183,219,181,143,113,187,97,59,25,183,91,182,151,113,187,105,_
187,25,183,219,180,43,1,83,112,155,22,207,91,181,165,241,_
188,89,155,26,207,219,181,173,241,188,97,27,27,207,91,182,_
181,241,188,105,155,27,207,219,180,45,65,95,112,187,22,231,_
91,181,168,113,190,89,59,79,231,219,181,202,113,190,97,235,_
28,231,91,182,210,113,190,105,107,29,231,219,180,47,97,107,_
112,219,22,255,91,181,170,241,191,89,59,30,255,219,181,230,_
241,191,97,171,30,255,91,182,238,241,191,105,43,31,255,11,_
0,29,33,16,22,44,2,22,60,3,22,76,4,22,92,5,_
22,108,6,22,124,7,22,140,8,22,156,9,22,172,10,22,_
188,11,22,204,12,22,220,13,22,236,14,22,252,15,22,92,_
193,34,1,33,36,113,195,27,140,18,55,252,193,44,113,195,_
35,12,19,55,124,194,52,113,195,43,140,19,55,252,194,60,_
113,195,51,252,32,37,209,45,56,92,20,79,220,193,73,241,_
196,33,220,20,79,92,194,81,241,196,41,92,21,79,220,194,_
89,241,196,49,220,21,79,92,193,39,97,58,56,188,36,103,_
220,193,104,113,198,33,204,22,103,92,194,112,113,198,41,76,_
23,103,220,194,120,113,198,49,204,23,103,92,193,41,209,70,_
56,124,22,127,220,193,164,241,199,33,188,24,127,92,194,143,_
241,199,41,60,25,127,220,194,151,241,199,49,188,25,127,92,_
193,43,33,83,56,156,22,151,220,193,165,113,201,33,156,26,_
151,92,194,173,113,201,41,28,27,151,220,194,181,113,201,49,_
156,27,151,92,193,45,97,95,56,188,22,175,220,193,168,241,_
202,33,60,79,175,92,194,202,241,202,41,236,28,175,220,194,_
210,241,202,49,108,29,175,92,193,47,129,107,56,220,22,199,_
220,193,170,113,204,33,60,30,199,92,194,230,113,204,41,172,_
30,199,220,194,238,113,204,49,44,31,199,12,0,31,33,16,_
222,44,2,222,60,3,222,76,4,222,92,5,222,108,6,222,_
124,7,222,140,8,222,156,9,222,172,10,222,188,11,222,204,_
12,222,220,13,222,236,14,222,252,15,222,220,205,34,33,33,_
36,241,207,227,140,18,255,124,206,44,241,207,235,12,19,255,_
252,206,52,241,207,243,140,19,255,124,207,60,241,207,251,28,_
33,37,241,45,0,93,20,23,93,206,73,113,209,233,220,20,_
23,221,206,81,113,209,241,92,21,23,93,207,89,113,209,249,_
220,21,23,221,205,39,129,58,0,189,36,47,93,206,104,241,_
210,233,204,22,47,221,206,112,241,210,241,76,23,47,93,207,_
120,241,210,249,204,23,47,221,205,41,241,70,0,125,22,71,_
93,206,164,113,212,233,188,24,71,221,206,143,113,212,241,60,_
25,71,93,207,151,113,212,249,188,25,71,221,205,43,65,83,_
0,157,22,95,93,206,165,241,213,233,156,26,95,221,206,173,_
241,213,241,28,27,95,93,207,181,241,213,249,156,27,95,221,_
205,45,129,95,0,189,22,119,93,206,168,113,215,233,60,79,_
119,221,206,202,113,215,241,236,28,119,93,207,210,113,215,249,_
108,29,119,221,205,47,161,107,0,221,22,143,93,206,170,241,_
216,233,60,30,143,221,206,230,241,216,241,172,30,143,93,207,_
238,241,216,249,44,31,143,13,16,49,81,118,67,241,22,167,_
221,24,160,145,28,167,77,30,167,29,17,19,17,17,21,17,_
17,23,17,17,25,17,17,27,17,17,29,17,17,31,65,120,_
51,209,130,67,17,23,193,253,24,160,177,28,193,109,30,167,_
61,17,203,93,143,193,125,17,19,145,17,19,177,17,19,209,_
17,19,241,17,76,88,19,205,61,21,100,33,25,205,253,26,_
190,145,30,205,61,219,193,93,17,229,221,155,205,157,17,21,_
177,17,21,209,17,21,241,17,20,121,19,231,93,21,100,65,_
25,231,29,27,190,177,30,231,93,219,206,221,220,23,225,223,_
133,122,222,27,113,17,29,113,17,31,193,157,57,1,224,87,_
65,22,150,1,224,179,225,27,237,1,224,183,29,220,233,13,_
224,23,145,17,23,222,180,0,222,17,25,241,17,164,186,19,_
25,158,21,100,129,25,25,94,27,190,241,30,25,158,219,193,_
189,222,25,126,17,27,145,17,27,1,227,21,156,225,31,193,_
182,61,33,227,91,65,22,154,33,227,183,225,27,241,33,227,_
187,29,220,237,45,227,3,174,225,25,222,17,71,222,205,50,_
14,16,63,145,228,93,65,22,156,145,228,185,225,27,243,145,_
228,189,29,220,239,157,228,5,14,224,52,158,228,29,241,17,_
255,64,0,222,28,1,49,49,230,49,242,22,101,206,31,172,_
81,230,0,82,30,101,78,32,177,93,230,8,82,219,101,206,_
32,185,93,230,16,210,219,101,254,130,20,34,21,17,16,23,_
126,190,33,174,1,232,0,114,30,128,78,32,203,13,232,8,_
50,17,10,2,221,128,238,32,212,13,232,18,226,130,17,80,_
19,148,30,35,115,97,233,252,1,27,150,14,32,233,97,233,_
4,82,17,6,82,222,150,174,32,21,193,32,234,109,233,16,_
226,222,150,254,155,20,98,21,17,80,23,176,190,33,178,33,_
235,0,178,30,178,78,32,207,45,235,8,226,223,178,206,32,_
45,46,235,16,82,224,178,126,168,20,130,21,17,112,23,200,_
190,33,180,161,236,0,210,30,202,78,32,209,173,236,8,146,_
17,10,114,225,202,238,32,25,1,33,28,174,236,79,75,33,_
90,17,1,121,17,238,27,98,27,227,14,32,239,49,238,4,_
50,221,227,142,32,2,62,238,12,2,227,227,14,33,27,33,_
33,78,27,1,61,113,239,49,178,23,249,206,31,184,145,239,_
0,18,31,249,78,32,213,157,239,8,66,224,249,206,32,29,_
225,32,71,158,239,18,98,193,17,240,19,16,31,35,125,33,_
241,252,161,27,18,15,32,243,33,241,4,114,221,18,143,32,_
6,46,241,12,66,227,18,15,33,95,46,241,136,55,44,80,_
145,118,229,226,24,43,191,44,201,177,242,207,18,17,209,18,_
219,43,95,45,181,189,242,217,146,219,43,223,45,189,189,242,_
80,56,44,82,17,131,229,2,25,67,191,44,203,49,244,207,_
34,219,67,63,45,19,81,45,139,62,244,217,34,221,67,223,_
45,214,61,244,24,57,44,84,145,143,229,34,25,91,191,44,_
205,177,245,207,66,219,91,63,45,229,189,245,215,98,234,91,_
191,45,236,189,245,223,130,143,55,17,156,249,82,23,113,159,_
44,178,17,247,205,178,30,113,31,45,207,29,247,213,226,223,_
113,159,45,45,30,247,221,82,224,113,143,170,195,130,21,137,_
90,46,150,161,248,203,18,29,138,255,44,184,173,248,211,146,_
222,138,127,45,23,174,248,219,162,237,138,255,45,136,186,19,_
81,155,47,121,1,250,201,98,27,160,223,44,239,1,250,209,_
50,221,160,95,45,2,14,250,217,2,227,160,223,45,244,14,_
250,56,60,44,92,145,193,229,162,25,185,191,44,213,145,251,_
207,194,219,185,63,45,237,157,251,215,178,225,185,191,45,71,_
158,251,223,130,193,63,17,206,249,210,23,207,159,44,186,241,_
252,205,50,31,207,31,45,215,253,252,213,98,224,207,159,45,_
52,254,252,221,242,229,207,47,22,49,177,118,17,243,22,231,_
47,57,172,113,254,150,83,30,231,175,57,177,125,254,158,83,_
219,231,47,58,185,125,254,166,211,219,231,47,22,51,49,131,_
17,19,23,51,136,60,174,49,131,42,118,30,51,88,123,203,_
61,131,69,185,232,51,88,173,210,61,131,101,108,221,51,8,_
22,53,177,143,17,51,23,251,136,60,176,177,143,42,150,30,_
251,88,123,161,190,143,69,89,17,160,99,234,251,216,185,236,_
189,143,45,173,143,55,49,156,17,83,23,195,137,60,178,49,_
156,42,182,30,195,89,123,207,61,156,69,233,223,195,89,173,_
45,62,156,101,92,224,195,9,22,57,177,168,17,115,23,139,_
138,60,180,177,168,42,214,30,139,90,123,209,189,168,69,89,_
237,139,90,173,47,190,168,101,204,225,139,10,22,59,49,181,_
17,147,23,83,139,60,182,49,181,42,246,30,83,91,123,211,_
61,181,69,41,224,83,91,173,48,62,181,101,76,239,83,11,_
22,61,177,193,17,179,23,27,140,60,184,177,193,42,22,31,_
27,92,123,213,189,193,69,73,224,27,92,173,10,191,193,101,_
236,229,27,12,22,63,49,206,17,211,23,227,140,60,186,49,_
206,42,54,31,227,92,123,215,61,206,69,105,224,227,92,173,_
52,62,206,101,252,229,227,252,23,49,209,118,139,244,22,109,_
151,69,172,209,118,66,86,30,109,215,124,177,221,118,93,89,_
219,109,215,174,185,221,118,125,220,219,109,247,23,51,81,131,_
139,20,23,53,152,69,174,81,131,66,118,30,53,216,124,203,_
93,131,93,185,232,53,216,174,210,93,131,125,108,221,53,248,_
23,53,209,143,139,52,23,253,152,69,176,209,143,66,150,30,_
253,216,124,161,222,143,93,89,17,103,100,234,253,88,187,236,_
221,143,69,205,143,55,81,156,139,84,23,197,153,69,178,81,_
156,66,182,30,197,217,124,207,93,156,93,233,223,197,217,174,_
45,94,156,125,92,224,197,249,23,57,209,168,139,116,23,141,_
154,69,180,209,168,66,214,30,141,218,124,209,221,168,93,89,_
237,141,218,174,47,222,168,125,204,225,141,250,23,59,81,181,_
139,148,23,85,155,69,182,81,181,66,246,30,85,219,124,211,_
93,181,93,41,224,85,219,174,48,94,181,125,76,239,85,251,_
23,61,209,193,139,180,23,29,156,69,184,209,193,66,22,31,_
29,220,124,213,221,193,93,73,224,29,220,174,10,223,193,125,_
236,229,29,252,23,63,81,206,139,212,23,229,156,69,186,81,_
206,66,54,31,229,220,124,215,93,206,93,105,224,229,220,174,_
52,94,206,125,252,229,229,236,25,49,241,118,66,243,22,111,_
7,77,172,241,118,90,86,30,111,87,126,177,253,118,117,89,_
219,111,87,176,185,253,118,149,220,219,111,231,25,51,113,131,_
66,19,23,55,8,77,174,113,131,90,118,30,55,88,126,203,_
125,131,117,185,232,55,88,176,210,125,131,149,108,221,55,232,_
25,53,241,143,66,51,23,255,8,77,176,241,143,90,150,30,_
255,88,126,161,254,143,117,89,17,44,101,234,255,216,188,236,_
253,143,93,237,143,55,113,156,66,83,23,199,9,77,178,113,_
156,90,182,30,199,89,126,207,125,156,117,233,223,199,89,176,_
45,126,156,149,92,224,199,233,25,57,241,168,66,115,23,143,_
10,77,180,241,168,90,214,30,143,90,126,209,253,168,117,89,_
237,143,90,176,47,254,168,149,204,225,143,234,25,59,113,181,_
66,147,23,87,11,77,182,113,181,90,246,30,87,91,126,211,_
125,181,117,41,224,87,91,176,48,126,181,149,76,239,87,235,_
25,61,241,193,66,179,23,31,12,77,184,241,193,90,22,31,_
31,92,126,213,253,193,117,73,224,31,92,176,10,255,193,149,_
236,229,31,236,25,63,113,206,66,211,23,231,12,77,186,113,_
206,90,54,31,231,92,126,215,125,206,117,105,224,231,92,176,_
52,126,206,149,252,229,231,204,27,49,17,119,91,243,22,113,_
23,24,113,231,90,201,17,119,53,55,243,113,87,140,179,29,_
119,85,122,219,113,87,190,187,29,119,117,13,119,51,145,131,_
91,19,23,57,24,24,57,232,90,203,145,131,53,39,219,57,_
88,140,78,159,131,85,10,221,57,88,190,212,157,131,117,141,_
131,53,17,144,91,51,23,1,25,24,1,233,90,205,17,144,_
53,71,219,1,89,140,229,29,144,85,106,234,1,89,190,236,_
29,144,117,13,144,55,145,156,91,83,23,201,25,24,201,233,_
90,207,145,156,53,103,219,201,89,140,23,225,94,254,157,156,_
29,219,226,201,217,202,5,158,156,188,145,19,145,186,53,119,_
17,169,129,17,169,174,21,29,145,90,115,184,29,169,197,152,_
222,145,90,165,23,30,169,229,171,237,145,90,215,144,186,19,_
89,187,53,121,145,181,129,145,181,174,53,29,89,91,115,186,_
157,181,197,184,222,89,91,165,46,158,181,229,187,17,246,69,_
239,89,203,27,61,17,194,91,179,23,33,28,24,33,236,90,_
213,17,194,53,199,219,33,92,140,237,29,194,85,186,225,33,_
92,190,71,30,194,117,13,194,63,145,206,91,211,23,233,28,_
24,233,236,90,215,145,206,53,231,219,233,92,140,239,157,206,_
85,218,225,233,92,190,31,97,95,95,158,206,217,17,19,115,_
247,107,111,49,119,129,49,119,199,149,28,115,215,116,51,63,_
119,221,56,219,115,215,166,183,61,119,253,187,219,115,215,216,_
114,55,19,59,248,107,113,177,131,129,177,131,199,181,28,59,_
216,116,178,189,131,221,232,244,59,216,166,208,189,131,253,75,_
221,59,216,216,58,88,19,3,249,107,115,49,144,129,49,144,_
199,213,28,3,217,116,180,61,144,221,88,222,3,217,166,166,_
62,144,253,203,222,3,217,216,2,121,19,203,249,107,117,177,_
156,129,177,156,199,245,28,203,217,116,182,189,156,221,120,17,_
176,230,223,203,89,179,45,190,156,197,92,224,203,153,29,57,_
49,169,191,118,23,147,26,24,147,122,92,209,49,169,77,135,_
219,147,218,141,233,61,169,109,122,225,147,218,191,218,62,169,_
141,45,169,59,177,181,191,150,23,91,27,24,91,123,92,211,_
177,181,77,167,219,91,219,141,235,189,181,109,234,226,91,219,_
191,27,129,107,244,190,181,217,209,19,35,252,107,123,49,194,_
129,49,194,199,85,29,35,220,116,188,61,194,221,216,222,35,_
220,166,27,62,194,253,123,228,35,220,216,34,252,19,235,252,_
107,125,177,206,129,177,206,199,117,29,235,220,116,190,189,206,_
221,248,222,235,220,166,29,190,206,253,251,17,184,246,229,235,_
92,218,49,81,119,136,247,22,117,23,24,117,119,24,117,119,_
26,117,103,28,117,87,118,117,215,130,117,87,143,117,215,155,_
117,87,168,117,215,180,117,87,193,117,215,205,117,87,218,51,_
209,131,136,23,23,61,24,24,61,120,24,61,120,26,61,104,_
28,61,88,118,61,216,130,61,88,143,61,216,155,61,88,168,_
61,216,180,61,88,193,61,216,205,61,88,218,53,81,144,136,_
55,23,5,25,24,5,121,24,5,121,26,5,105,28,5,89,_
118,5,217,130,5,89,143,5,217,155,5,89,168,5,217,180,_
5,89,193,5,217,205,5,89,218,55,209,156,136,87,23,205,_
25,24,205,121,24,205,121,26,205,105,28,205,89,118,205,217,_
130,205,89,143,205,217,155,205,89,168,205,217,180,205,89,193,_
205,217,205,205,89,218,57,81,169,136,119,23,149,26,24,149,_
122,24,149,122,26,149,106,28,149,90,118,149,218,130,149,90,_
143,149,218,155,149,90,168,149,218,180,149,90,193,149,218,205,_
149,90,218,59,209,181,136,151,23,93,27,24,93,123,24,93,_
123,26,93,107,28,93,91,118,93,219,130,93,91,143,93,219,_
155,93,91,168,93,219,180,93,91,193,93,219,205,93,91,218,_
61,81,194,136,183,23,37,28,24,37,124,24,37,124,26,37,_
108,28,37,92,118,37,220,130,37,92,143,37,220,155,37,92,_
168,37,220,180,37,92,193,37,220,205,37,92,218,63,209,206,_
136,215,23,237,28,24,237,124,24,237,124,26,237,108,28,237,_
92,118,237,220,130,237,92,143,237,220,155,237,92,168,237,220,_
180,237,92,193,237,220,205,237,12,16,119,247,130,80,113,119,_
253,239,24,119,119,24,119,119,26,119,103,28,119,87,118,119,_
215,130,119,87,143,119,215,155,119,87,168,119,215,180,119,87,_
193,119,215,205,119,7,16,63,248,130,82,241,131,253,15,25,_
63,120,24,63,120,26,63,104,28,63,88,118,63,216,130,63,_
88,143,63,216,155,63,88,168,63,216,180,63,88,193,63,216,_
205,63,8,16,7,249,130,84,113,144,253,47,25,7,121,24,_
7,121,26,7,105,28,7,89,118,7,217,130,7,89,143,7,_
217,155,7,89,168,7,217,180,7,89,193,7,217,205,7,9,_
16,207,249,130,86,241,156,253,79,25,207,121,24,207,121,26,_
207,105,28,207,89,118,207,217,130,207,89,143,207,217,155,207,_
89,168,207,217,180,207,89,193,207,217,205,207,9,16,151,250,_
130,88,113,169,253,111,25,151,122,24,151,122,26,151,106,28,_
151,90,118,151,218,130,151,90,143,151,218,155,151,90,168,151,_
218,180,151,90,193,151,218,205,151,10,16,95,251,130,90,241,_
181,253,143,25,95,123,24,95,123,26,95,107,28,95,91,118,_
95,219,130,95,91,143,95,219,155,95,91,168,95,219,180,95,_
91,193,95,219,205,95,11,16,39,252,130,92,113,194,253,175,_
25,39,124,24,39,124,26,39,108,28,39,92,118,39,220,130,_
39,92,143,39,220,155,39,92,168,39,220,180,39,92,193,39,_
220,205,39,12,16,239,252,130,94,241,206,253,207,25,239,124,_
24,239,124,26,239,108,28,239,92,118,239,220,130,239,92,143,_
239,220,155,239,92,168,239,220,180,239,92,193,239,220,205,239,_
12,16,121,119,143,80,145,119,98,145,119,129,145,119,135,145,_
119,167,145,119,198,145,119,101,151,119,45,152,119,245,152,119,_
189,153,119,133,154,119,77,155,119,21,156,119,221,156,119,0,_
17,132,247,40,21,65,40,22,65,24,24,65,120,24,65,120,_
26,65,104,28,65,88,118,65,216,130,65,88,143,65,216,155,_
65,88,168,65,216,180,65,88,193,65,216,205,65,8,16,9,_
121,143,84,145,144,98,145,144,129,145,144,135,145,144,167,145,_
144,198,145,144,101,151,144,45,152,144,245,152,144,189,153,144,_
133,154,144,77,155,144,21,156,144,221,156,144,0,17,157,247,_
104,21,209,41,22,209,25,24,209,121,24,209,121,26,209,105,_
28,209,89,118,209,217,130,209,89,143,209,217,155,209,89,168,_
209,217,180,209,89,193,209,217,205,209,9,16,153,122,143,88,_
145,169,98,145,169,129,145,169,135,145,169,167,145,169,198,145,_
169,101,151,169,45,152,169,245,152,169,189,153,169,133,154,169,_
77,155,169,21,156,169,221,156,169,0,17,182,247,168,21,97,_
43,22,97,27,24,97,123,24,97,123,26,97,107,28,97,91,_
118,97,219,130,97,91,143,97,219,155,97,91,168,97,219,180,_
97,91,193,97,219,205,97,11,16,41,124,143,92,145,194,98,_
145,194,129,145,194,135,145,194,167,145,194,198,145,194,101,151,_
194,45,152,194,245,152,194,189,153,194,133,154,194,77,155,194,_
21,156,194,221,156,194,0,17,207,247,232,21,241,44,22,241,_
28,24,241,124,24,241,124,26,241,108,28,241,92,118,241,220,_
130,241,92,143,241,220,155,241,92,168,241,220,180,241,92,193,_
241,220,205,241,12,16,123,247,155,80,177,119,98,177,119,129,_
177,119,135,177,119,167,177,119,198,177,119,101,183,119,45,184,_
119,245,184,119,189,185,119,133,186,119,77,187,119,21,188,119,_
221,188,119,0,49,132,191,41,21,67,40,22,67,24,24,67,_
120,24,67,120,26,67,104,28,67,88,118,67,216,130,67,88,_
143,67,216,155,67,88,168,67,216,180,67,88,193,67,216,205,_
67,8,16,11,249,155,84,177,144,98,177,144,129,177,144,135,_
177,144,167,177,144,198,177,144,101,183,144,45,184,144,245,184,_
144,189,185,144,133,186,144,77,187,144,21,188,144,221,188,144,_
0,49,157,191,105,21,211,41,22,211,25,24,211,121,24,211,_
121,26,211,105,28,211,89,118,211,217,130,211,89,143,211,217,_
155,211,89,168,211,217,180,211,89,193,211,217,205,211,9,16,_
155,250,155,88,177,169,98,177,169,129,177,169,135,177,169,167,_
177,169,198,177,169,101,183,169,45,184,169,245,184,169,189,185,_
169,133,186,169,77,187,169,21,188,169,221,188,169,0,49,182,_
191,169,21,99,43,22,99,27,24,99,123,24,99,123,26,99,_
107,28,99,91,118,99,219,130,99,91,143,99,219,155,99,91,_
168,99,219,180,99,91,193,99,219,205,99,11,16,43,252,155,_
92,177,194,98,177,194,129,177,194,135,177,194,167,177,194,198,_
177,194,101,183,194,45,184,194,245,184,194,189,185,194,133,186,_
194,77,187,194,21,188,194,221,188,194,0,49,207,191,233,21,_
243,44,22,243,28,24,243,124,24,243,124,26,243,108,28,243,_
92,118,243,220,130,243,92,143,243,220,155,243,92,168,243,220,_
180,243,92,193,243,220,205,243,12,16,125,119,168,80,209,119,_
98,209,119,129,209,119,135,209,119,167,209,119,198,209,119,101,_
215,119,45,216,119,245,216,119,189,217,119,133,218,119,77,219,_
119,21,220,119,221,220,119,0,81,132,135,42,21,69,40,22,_
69,24,24,69,120,24,69,120,26,69,104,28,69,88,118,69,_
216,130,69,88,143,69,216,155,69,88,168,69,216,180,69,88,_
193,69,216,205,69,8,16,13,121,168,84,209,144,98,209,144,_
129,209,144,135,209,144,167,209,144,198,209,144,101,215,144,45,_
216,144,245,216,144,189,217,144,133,218,144,77,219,144,21,220,_
144,221,220,144,0,81,157,135,106,21,213,41,22,213,25,24,_
213,121,24,213,121,26,213,105,28,213,89,118,213,217,130,213,_
89,143,213,217,155,213,89,168,213,217,180,213,89,193,213,217,_
205,213,9,16,157,122,168,88,209,169,98,209,169,129,209,169,_
135,209,169,167,209,169,198,209,169,101,215,169,45,216,169,245,_
216,169,189,217,169,133,218,169,77,219,169,21,220,169,221,220,_
169,0,81,182,135,170,21,101,43,22,101,27,24,101,123,24,_
101,123,26,101,107,28,101,91,118,101,219,130,101,91,143,101,_
219,155,101,91,168,101,219,180,101,91,193,101,219,205,101,11,_
16,45,124,168,92,209,194,98,209,194,129,209,194,135,209,194,_
167,209,194,198,209,194,101,215,194,45,216,194,245,216,194,189,_
217,194,133,218,194,77,219,194,21,220,194,221,220,194,0,81,_
207,135,234,21,245,44,22,245,28,24,245,124,24,245,124,26,_
245,108,28,245,92,118,245,220,130,245,92,143,245,220,155,245,_
92,168,245,220,180,245,92,193,245,220,205,245,12,16,127,247,_
180,80,241,119,98,241,119,129,241,119,135,241,119,167,241,119,_
198,241,119,101,247,119,45,248,119,245,248,119,189,249,119,133,_
250,119,77,251,119,21,252,119,221,252,119,0,113,132,79,43,_
21,71,40,22,71,24,24,71,120,24,71,120,26,71,104,28,_
71,88,118,71,216,130,71,88,143,71,216,155,71,88,168,71,_
216,180,71,88,193,71,216,205,71,8,16,15,249,180,84,241,_
144,98,241,144,129,241,144,135,241,144,167,241,144,198,241,144,_
101,247,144,45,248,144,245,248,144,189,249,144,133,250,144,77,_
251,144,21,252,144,221,252,144,0,113,157,79,107,21,215,41,_
22,215,25,24,215,121,24,215,121,26,215,105,28,215,89,118,_
215,217,130,215,89,143,215,217,155,215,89,168,215,217,180,215,_
89,193,215,217,205,215,9,16,159,250,180,88,241,169,98,241,_
169,129,241,169,135,241,169,167,241,169,198,241,169,101,247,169,_
45,248,169,245,248,169,189,249,169,133,250,169,77,251,169,21,_
252,169,221,252,169,0,113,182,79,171,21,103,43,22,103,27,_
24,103,123,24,103,123,26,103,107,28,103,91,118,103,219,130,_
103,91,143,103,219,155,103,91,168,103,219,180,103,91,193,103,_
219,205,103,11,16,47,252,180,92,241,194,98,241,194,129,241,_
194,135,241,194,167,241,194,198,241,194,101,247,194,45,248,194,_
245,248,194,189,249,194,133,250,194,77,251,194,21,252,194,221,_
252,194,0,113,207,79,235,21,247,44,22,247,28,24,247,124,_
24,247,124,26,247,108,28,247,92,118,247,220,130,247,92,143,_
247,220,155,247,92,168,247,220,180,247,92,193,247,220,205,247,_
12,16,129,119,193,80,17,120,98,17,120,129,17,120,135,17,_
120,167,17,120,198,17,120,101,23,120,45,24,120,245,24,120,_
189,25,120,133,26,120,77,27,120,21,28,120,221,28,120,0,_
145,132,23,44,21,73,40,22,73,24,24,73,120,24,73,120,_
26,73,104,28,73,88,118,73,216,130,73,88,143,73,216,155,_
73,88,168,73,216,180,73,88,193,73,216,205,73,8,16,17,_
121,193,84,17,145,98,17,145,129,17,145,135,17,145,167,17,_
145,198,17,145,101,23,145,45,24,145,245,24,145,189,25,145,_
133,26,145,77,27,145,21,28,145,221,28,145,0,145,157,23,_
108,21,217,41,22,217,25,24,217,121,24,217,121,26,217,105,_
28,217,89,118,217,217,130,217,89,143,217,217,155,217,89,168,_
217,217,180,217,89,193,217,217,205,217,9,16,161,122,193,88,_
17,170,98,17,170,129,17,170,135,17,170,167,17,170,198,17,_
170,101,23,170,45,24,170,245,24,170,189,25,170,133,26,170,_
77,27,170,21,28,170,221,28,170,0,145,182,23,172,21,105,_
43,22,105,27,24,105,123,24,105,123,26,105,107,28,105,91,_
118,105,219,130,105,91,143,105,219,155,105,91,168,105,219,180,_
105,91,193,105,219,205,105,11,16,49,124,193,92,17,195,98,_
17,195,129,17,195,135,17,195,167,17,195,198,17,195,101,23,_
195,45,24,195,245,24,195,189,25,195,133,26,195,77,27,195,_
21,28,195,221,28,195,0,145,207,23,236,21,249,44,22,249,_
28,24,249,124,24,249,124,26,249,108,28,249,92,118,249,220,_
130,249,92,143,249,220,155,249,92,168,249,220,180,249,92,193,_
249,220,205,249,188,228,49,49,120,0,253,22,131,23,24,131,_
119,24,131,119,26,131,103,28,131,87,118,131,215,130,131,87,_
143,131,215,155,131,87,168,131,215,180,131,87,193,131,215,205,_
131,183,228,51,177,132,0,29,23,75,24,24,75,120,24,75,_
120,26,75,104,28,75,88,118,75,216,130,75,88,143,75,216,_
155,75,88,168,75,216,180,75,88,193,75,216,205,75,184,228,_
53,49,145,0,61,23,19,25,24,19,121,24,19,121,26,19,_
105,28,19,89,118,19,217,130,19,89,143,19,217,155,19,89,_
168,19,217,180,19,89,193,19,217,205,19,185,228,55,177,157,_
0,93,23,219,25,24,219,121,24,219,121,26,219,105,28,219,_
89,118,219,217,130,219,89,143,219,217,155,219,89,168,219,217,_
180,219,89,193,219,217,205,219,185,228,57,49,170,0,125,23,_
163,26,24,163,122,24,163,122,26,163,106,28,163,90,118,163,_
218,130,163,90,143,163,218,155,163,90,168,163,218,180,163,90,_
193,163,218,205,163,186,228,59,177,182,0,157,23,107,27,24,_
107,123,24,107,123,26,107,107,28,107,91,118,107,219,130,107,_
91,143,107,219,155,107,91,168,107,219,180,107,91,193,107,219,_
205,107,187,228,61,49,195,0,189,23,51,28,24,51,124,24,_
51,124,26,51,108,28,51,92,118,51,220,130,51,92,143,51,_
220,155,51,92,168,51,220,180,51,92,193,51,220,205,51,188,_
228,63,177,207,0,221,23,251,28,24,251,124,24,251,124,26,_
251,108,28,251,92,118,251,220,130,251,92,143,251,220,155,251,_
92,168,251,220,180,251,92,193,251,220,205,251,12,0,255,15}


Function Uncompress_pal4096_extpal() As Any ptr
  Dim ret As Any ptr
    ret = Allocate(16384)
    LZW_pal4096_Decode(@LZW_pal4096_data(0), 10112, ret, 16384)
    Return ret
End Function

Sub Init_AFlib3_pal4096_extpal_dat() constructor
AFlib3_pal4096_extpal_dat = Allocate(16384)
LZW_pal4096_Decode(@LZW_pal4096_data(0), 10112, AFlib3_pal4096_extpal_dat, 16384)
End Sub
Sub DeInit_AFlib3_pal4096_extpal_dat() destructor
DeAllocate(AFlib3_pal4096_extpal_dat)
End Sub

Sub Init_pal4096() Constructor
  Dim As Integer pc, i
  Dim As UInteger ptr fmem
    fmem = Uncompress_pal4096_extpal()
    For pc = 0 To 4095
      AF3_4096col_array(pc) = fmem[i]
      i += 1
    Next pc
    DeAllocate(fmem)
End Sub

For cl as Integer = 0 to 4095
  RGB4096col(cl) = AF3_4096col_array(cl)
Next

'_____________________________________________________________________________________________________________________



Dim Shared AF3_palFTarray(1 to 2, 0 to 255, 0 to 7) As uByte

Declare Function Uncompress_AFlibIII_palFT() As Any ptr
Declare Sub Init_AFlibIII_palFT()
Declare Sub Init_AFlibIII_palFT_dat()
Declare Sub DeInit_AFlibIII_palFT_dat()

Dim Shared AFlibIII_palFT_dat As Any ptr
Dim Shared AFlibIII_palFT_dat_len As Integer = 37212
Declare Function AF3_palFTdata_LZW_Decode Alias "fb_hDecode" (_
ByVal in_buffer As Any ptr, _
ByVal in_size As Integer, _
ByVal out_buffer As Any ptr, _
ByRef out_size As Integer _
) As Integer
Dim Shared AFlibIII_palFT_lzw_data(5421) As uByte => {_
0,0,16,1,1,16,40,64,5,40,32,8,16,16,16,8,_
0,3,10,0,0,10,0,3,8,0,0,4,48,0,20,0,_
0,20,48,0,4,0,0,128,16,16,21,0,0,133,0,16,_
7,0,16,64,32,16,1,0,0,2,32,16,160,48,5,160,_
128,0,64,16,0,38,129,0,208,0,2,25,129,7,1,33,_
0,24,1,1,8,128,17,52,161,0,1,144,19,36,1,4,_
80,16,8,49,1,0,192,16,16,224,0,16,9,32,1,16,_
176,19,1,1,2,8,1,1,32,64,18,37,81,0,2,128,_
0,1,96,20,0,32,8,65,160,8,32,176,19,38,1,4,_
26,81,18,129,32,18,0,240,21,1,161,17,128,48,22,2,_
161,22,2,16,21,2,1,4,66,161,22,113,33,23,115,65,_
23,117,97,23,119,129,23,113,1,4,123,1,12,64,64,20,_
0,0,5,80,0,15,113,1,1,16,0,3,87,1,0,77,_
1,3,144,0,1,176,0,6,100,1,13,48,0,6,145,1,_
16,134,1,1,80,0,1,131,145,24,32,240,24,2,97,24,_
32,0,2,80,0,3,0,17,26,133,33,25,1,1,5,176,_
32,24,2,209,20,142,33,23,156,241,23,0,144,25,115,193,_
25,149,241,25,96,240,23,151,17,24,135,65,26,32,0,10,_
77,161,25,32,0,13,150,17,28,145,33,26,87,241,19,152,_
65,25,178,1,7,194,193,27,204,113,25,179,33,27,145,1,_
26,157,17,29,152,161,25,209,49,28,154,65,26,96,80,27,_
76,225,29,184,33,27,146,1,10,162,17,16,153,33,29,100,_
81,30,146,241,23,206,17,30,164,17,24,112,0,9,112,64,_
26,215,17,28,162,129,29,149,1,5,112,144,31,137,17,24,_
199,81,25,205,1,6,210,1,1,2,226,23,1,18,24,210,_
145,32,129,17,28,160,81,29,250,17,29,154,177,27,151,161,_
25,123,177,23,10,82,24,12,2,31,255,145,29,255,65,32,_
152,1,7,7,34,27,9,178,24,244,17,26,248,145,29,112,_
0,1,219,81,25,176,224,32,157,241,31,253,65,34,226,1,_
24,152,65,33,0,129,25,176,112,35,53,210,24,223,177,34,_
146,65,32,48,0,26,5,18,18,190,113,25,163,145,24,191,_
1,26,87,17,26,220,33,23,8,128,15,234,209,25,158,1,_
9,253,113,33,253,193,28,64,64,32,25,146,30,71,18,36,_
61,50,37,218,49,27,87,178,26,137,225,29,15,50,30,186,_
49,38,152,1,3,101,226,27,67,66,31,245,177,35,35,162,_
33,250,129,37,106,2,7,185,145,32,203,113,25,33,18,27,_
134,193,24,13,210,24,68,130,35,9,194,29,187,65,35,128,_
97,26,136,145,26,77,130,26,202,65,32,144,0,3,65,98,_
36,113,82,29,104,98,36,66,114,21,133,225,36,240,145,30,_
119,17,19,112,81,23,248,0,5,113,129,2,240,32,42,100,_
129,9,24,160,22,168,0,9,104,128,23,111,129,16,158,1,_
2,105,1,16,112,128,10,169,2,26,180,97,43,117,145,42,_
101,161,22,200,128,8,113,194,20,32,64,44,164,1,4,81,_
34,16,8,48,44,106,1,9,248,48,43,9,209,44,2,129,_
8,211,82,44,169,82,45,199,2,0,204,162,45,164,241,26,_
182,210,20,16,33,16,202,162,22,181,2,22,76,145,24,106,_
1,11,128,48,19,212,130,15,136,160,22,213,210,41,128,96,_
45,0,129,8,144,128,24,0,1,8,128,64,46,250,178,47,_
106,129,9,245,2,0,213,2,47,172,97,44,206,2,9,83,_
2,16,224,0,11,152,160,22,251,210,47,0,128,10,168,80,_
48,1,129,9,1,19,47,2,3,15,255,34,16,174,2,43,_
2,1,15,144,80,49,0,193,45,229,178,43,212,34,48,251,_
145,42,168,64,42,106,193,31,35,179,25,191,130,8,17,179,_
23,237,114,30,226,226,25,159,114,23,252,112,23,120,128,9,_
31,19,16,136,128,12,176,240,48,2,131,8,63,163,22,248,_
192,46,106,97,33,0,131,6,8,112,44,4,99,50,218,82,_
24,9,35,16,224,0,13,48,3,26,218,50,49,48,35,53,_
40,163,45,67,195,49,0,241,51,8,128,51,25,49,54,183,_
130,0,157,2,4,72,128,36,65,131,52,2,129,13,205,209,_
42,240,0,10,229,2,5,48,83,54,78,82,43,17,3,26,_
172,34,16,48,32,56,38,19,27,117,129,10,115,147,23,137,_
163,56,139,195,56,141,227,56,118,1,3,40,16,57,40,16,_
16,24,0,2,40,128,2,128,3,0,145,195,57,143,195,56,_
130,144,7,166,242,12,113,33,2,156,16,23,176,0,51,106,_
129,2,108,0,6,124,128,3,158,115,23,16,128,2,68,64,_
4,198,96,13,198,0,0,240,192,12,196,96,12,196,192,12,_
131,49,12,204,128,12,216,128,12,204,48,12,0,128,1,216,_
144,60,200,240,12,38,241,13,216,0,61,23,195,42,192,0,_
12,193,16,12,195,128,61,0,48,4,160,0,1,17,128,1,_
88,144,1,0,48,15,35,48,4,243,48,4,131,176,15,0,_
32,6,100,128,6,120,192,6,102,48,6,0,208,6,243,211,_
6,101,96,6,98,0,0,183,96,11,251,99,10,102,112,4,_
0,16,12,1,16,0,1,20,0,225,144,59,137,176,8,241,_
176,47,131,0,0,198,96,2,54,96,2,198,96,0,247,0,_
0,45,65,0,4,192,0,13,192,14,21,100,8,68,192,4,_
100,96,6,97,0,0,140,192,6,13,240,0,13,192,6,140,_
64,22,96,1,8,192,240,24,192,66,23,45,17,23,181,146,_
52,248,16,37,198,130,15,32,128,15,205,113,67,112,144,67,_
112,1,26,59,4,68,96,128,15,222,193,20,48,128,15,66,_
2,16,153,160,5,36,176,13,219,64,2,90,144,9,0,64,_
2,102,240,15,102,64,2,172,225,67,73,67,55,117,177,47,_
103,17,16,160,112,55,113,1,6,224,80,56,64,96,70,101,_
52,22,128,96,46,112,1,6,104,4,10,136,177,23,51,100,_
33,112,241,22,160,97,43,160,0,4,99,20,16,104,212,43,_
125,116,46,0,144,47,76,3,30,126,113,46,96,32,70,160,_
16,27,126,177,23,136,1,12,176,225,72,181,2,2,177,1,_
8,98,4,14,112,1,14,45,52,73,69,1,8,224,16,71,_
69,81,43,115,180,48,113,244,73,163,116,73,131,36,18,189,_
146,74,96,97,46,111,113,53,130,36,16,104,97,46,1,241,_
72,169,212,71,98,4,8,83,2,71,158,68,75,138,84,74,_
130,4,10,149,228,72,137,20,27,153,4,12,157,196,73,199,_
116,46,153,100,73,97,68,74,124,100,33,162,4,0,103,242,_
75,98,4,12,188,228,47,251,130,24,113,228,73,124,4,12,_
137,196,71,221,244,75,158,148,73,203,100,73,46,4,16,223,_
228,75,156,116,74,69,17,77,206,212,76,0,113,78,231,98,_
73,216,4,0,113,4,71,206,4,14,210,116,73,95,129,24,_
111,180,23,83,210,66,64,96,68,233,100,33,139,196,71,115,_
161,25,104,33,23,224,128,72,136,161,77,191,36,72,218,84,_
44,228,116,53,138,244,79,126,100,43,228,4,2,87,17,81,_
208,68,22,210,20,19,222,81,74,194,244,77,180,100,33,10,_
115,77,246,4,76,98,116,81,18,213,77,153,84,20,150,132,_
73,193,20,72,105,36,71,126,164,48,137,148,47,214,20,72,_
220,84,56,122,180,71,39,17,71,29,85,20,184,145,81,125,_
161,75,169,148,22,74,37,34,130,52,72,33,33,81,180,225,_
32,2,241,31,113,1,5,45,195,20,120,0,10,199,2,12,_
200,240,20,172,17,24,10,83,85,180,34,77,100,209,20,209,_
146,24,168,176,69,6,19,49,163,130,23,8,16,86,1,1,_
7,71,131,10,172,113,38,2,81,87,136,160,86,208,210,20,_
158,209,38,144,48,46,128,0,15,35,83,87,132,53,46,213,_
162,86,123,117,44,123,101,51,172,241,26,203,242,20,127,20,_
49,178,180,88,138,165,87,136,128,10,184,144,89,213,2,50,_
242,146,89,105,3,14,34,51,50,74,131,88,1,97,90,78,_
178,87,129,68,48,253,210,28,39,3,16,56,80,24,106,85,_
45,152,64,52,102,241,69,212,2,61,253,34,52,200,112,87,_
116,245,53,0,81,88,158,5,92,196,37,92,193,5,0,135,_
117,44,63,36,42,4,51,50,4,131,13,212,50,49,191,101,_
47,42,131,50,136,131,90,124,37,42,120,208,52,177,228,74,_
1,1,15,179,37,86,169,35,23,178,34,23,112,112,54,251,_
2,11,200,16,23,117,181,44,8,128,6,14,227,50,35,3,_
3,72,0,4,157,2,0,120,48,50,234,197,94,232,82,80,_
149,1,0,178,21,75,128,96,91,2,113,38,169,2,0,176,_
240,86,235,213,94,169,83,88,113,161,95,167,211,95,2,129,_
7,129,180,23,240,240,71,198,21,52,169,163,89,113,129,8,_
165,146,49,113,1,45,2,97,57,155,20,16,130,243,54,233,_
244,55,2,129,6,183,165,87,216,176,89,2,241,0,51,246,_
0,32,3,15,55,166,80,55,230,36,52,246,0,58,6,15,_
255,0,100,255,192,99,65,70,100,66,70,99,68,230,99,1,_
48,0,7,240,0,31,240,3,127,240,15,45,4,14,240,128,_
15,252,224,15,64,230,15,252,128,15,240,96,70,128,240,15,_
127,240,3,31,240,0,7,48,0,109,17,16,64,70,61,105,_
150,102,3,192,102,109,198,102,64,22,23,124,224,12,214,48,_
103,214,192,7,0,192,7,230,224,13,214,96,13,230,112,103,_
114,70,103,116,118,103,150,133,19,108,97,65,114,101,46,129,_
32,4,36,128,1,24,64,2,66,16,8,178,1,0,84,32,_
105,1,145,7,130,32,8,193,130,57,106,193,1,34,32,2,_
106,49,92,52,81,19,4,240,97,49,129,3,84,32,9,158,_
32,8,68,240,58,124,64,4,174,35,59,175,134,1,60,224,_
7,64,230,7,60,192,42,124,128,7,112,128,6,68,96,18,_
14,2,26,49,48,3,50,208,0,10,0,108,199,118,108,56,_
80,108,200,198,108,32,32,108,52,176,108,205,118,108,207,22,_
109,210,230,32,202,102,108,214,230,32,194,70,108,217,166,109,_
32,32,3,52,208,109,223,6,26,48,80,109,218,134,109,228,_
230,108,53,96,3,231,102,109,49,32,110,238,38,109,49,192,_
110,242,214,108,233,70,110,230,230,109,218,166,111,234,214,111,_
249,102,111,204,102,3,208,182,111,214,38,3,225,22,112,200,_
22,3,55,208,110,5,39,109,255,246,109,16,199,111,9,119,_
108,18,103,109,22,55,111,12,71,113,192,118,112,4,167,110,_
3,183,113,14,130,113,205,54,114,204,86,114,200,118,114,21,_
23,114,229,182,114,32,144,114,192,246,114,34,215,114,49,199,_
114,14,215,108,32,103,115,2,231,113,228,134,115,234,22,3,_
57,48,110,60,183,115,223,246,115,65,23,113,51,215,114,240,_
54,116,218,166,116,73,23,3,70,55,113,57,135,114,72,39,_
117,42,87,117,48,71,117,234,38,3,48,128,111,223,182,117,_
93,167,109,52,0,118,214,150,3,13,231,111,89,7,112,87,_
231,32,195,214,114,95,215,114,98,215,114,56,64,115,224,198,_
117,73,167,113,106,7,26,29,135,118,223,214,115,228,22,3,_
102,71,110,112,135,119,224,134,112,131,247,119,118,7,120,71,_
55,120,115,231,118,131,39,120,90,87,119,134,71,3,75,103,_
112,145,231,115,79,183,119,81,167,110,108,55,120,156,167,117,_
133,119,118,139,151,121,23,55,122,210,38,119,111,55,118,210,_
230,121,228,182,122,68,55,121,136,87,122,36,215,114,173,199,_
116,175,55,120,167,119,123,115,247,120,228,166,119,162,231,123,_
161,231,115,182,231,115,119,23,124,148,55,111,152,247,123,105,_
7,124,202,199,122,80,87,121,169,215,108,11,151,120,218,214,_
123,203,167,120,214,167,121,204,119,125,218,167,109,180,103,112,_
160,231,119,64,23,123,38,55,126,200,214,120,151,231,124,15,_
87,126,86,135,125,164,151,124,219,7,127,221,151,126,205,86,_
125,220,231,126,234,134,123,144,7,125,204,182,123,223,230,125,_
210,86,127,68,39,126,239,151,125,94,103,121,126,39,124,8,_
104,124,209,151,128,223,214,127,218,86,118,235,135,117,157,55,_
127,204,246,127,209,103,3,115,119,129,204,118,126,126,135,124,_
237,167,126,20,152,116,211,247,124,168,215,118,7,72,116,31,_
104,127,33,184,121,21,168,112,36,40,109,15,248,110,13,24,_
118,251,135,108,17,72,128,247,39,116,73,71,131,51,184,128,_
28,136,130,76,7,131,209,71,124,43,40,123,131,215,129,94,_
71,3,26,232,130,211,54,132,252,103,131,199,134,131,32,120,_
132,250,215,118,75,120,130,81,8,108,77,135,132,65,248,110,_
42,24,127,58,104,128,90,184,109,79,136,108,50,168,122,77,_
8,108,27,104,126,224,23,134,44,200,123,94,56,111,61,8,_
128,114,200,128,63,104,126,118,200,108,49,0,134,5,232,135,_
37,40,121,120,120,108,73,40,132,89,232,116,106,40,115,57,_
8,135,111,216,108,108,56,136,110,40,127,109,7,137,98,248,_
135,139,88,137,141,136,136,121,55,137,105,40,137,130,184,133,_
3,72,133,204,150,127,129,71,134,154,232,137,101,56,119,92,_
56,124,102,200,126,70,72,126,93,88,138,206,214,135,128,136,_
126,18,152,136,161,136,108,125,71,116,25,200,131,167,8,26,_
104,72,127,155,24,125,160,232,138,83,39,130,134,199,138,192,_
6,140,28,40,140,22,152,137,132,231,139,46,103,139,160,225,_
136,91,72,135,119,120,133,115,55,138,74,56,119,221,56,123,_
207,72,136,62,104,136,129,120,136,211,40,141,199,88,124,38,_
72,142,176,88,142,138,88,133,113,24,139,170,200,123,88,184,_
142,86,104,120,179,104,137,148,104,109,213,184,109,215,184,135,_
254,168,112,0,121,108,203,120,131,201,120,139,197,56,136,122,_
104,126,244,216,130,157,56,142,181,232,142,175,104,143,90,199,_
144,205,231,144,131,167,139,76,71,140,140,40,145,240,152,141,_
189,8,146,236,120,143,207,232,141,245,168,128,15,121,146,38,_
153,130,36,105,142,252,72,141,207,232,146,32,16,147,49,25,_
128,151,216,145,99,24,146,248,151,138,2,201,113,10,57,109,_
248,248,142,28,25,144,209,40,143,14,24,139,225,56,135,68,_
9,148,55,105,147,185,24,141,25,105,109,80,41,109,82,73,_
127,62,185,133,75,105,140,184,56,109,60,233,32,72,89,149,_
241,200,149,193,22,150,178,200,146,17,137,108,49,89,148,181,_
71,148,99,153,150,95,88,150,90,217,147,96,185,150,115,137,_
146,43,105,142,140,103,149,253,24,141,94,201,129,21,201,119,_
68,185,145,77,217,138,56,169,146,106,89,151,53,24,119,140,_
231,151,130,185,134,207,216,150,73,169,142,233,56,146,119,121,_
152,6,183,152,180,232,119,6,153,119,121,25,108,88,57,152,_
140,217,149,156,233,108,69,232,127,48,105,154,23,9,151,7,_
233,122,116,89,152,226,40,146,16,153,154,53,39,153,179,233,_
145,142,119,148,205,168,112,129,169,143,249,8,153,173,89,135,_
71,41,154,143,25,125,158,57,129,177,233,108,99,201,151,10,_
71,154,212,23,156,108,73,156,170,9,154,98,201,154,19,233,_
119,203,185,143,224,136,155,159,185,155,95,57,130,145,201,123,_
217,25,151,237,104,156,120,25,139,4,121,108,51,9,142,162,_
25,110,37,105,156,84,233,140,35,72,158,57,89,157,154,121,_
142,198,137,150,188,136,142,22,153,159,223,54,133,8,89,156,_
250,73,155,118,105,150,218,201,155,65,25,157,245,233,159,208,_
185,157,76,89,121,218,24,139,115,231,158,47,200,120,224,169,_
160,5,202,160,22,154,149,9,186,153,177,184,141,134,249,154,_
30,248,150,26,10,2,17,122,108,36,26,158,190,201,157,147,_
57,160,255,41,148,9,121,148,151,57,149,123,25,156,207,41,_
155,34,218,161,214,118,163,191,41,159,132,9,155,34,202,158,_
181,25,160,136,249,161,2,58,158,149,25,131,192,25,143,214,_
201,137,72,72,161,53,218,162,44,202,156,114,105,164,24,56,_
165,123,72,163,8,250,151,45,103,162,161,41,165,40,106,165,_
33,250,164,107,135,157,209,136,158,223,136,154,62,154,152,176,_
55,164,30,26,164,152,73,164,34,186,165,210,89,165,103,216,_
165,61,26,166,78,26,137,200,200,132,102,186,166,150,249,163,_
119,138,165,121,74,157,60,154,146,118,122,160,127,26,165,59,_
202,166,133,10,162,148,185,162,92,170,168,174,57,168,76,119,_
165,136,186,160,121,88,167,140,74,168,220,152,116,186,137,161,_
4,154,162,109,218,155,147,250,110,244,41,125,142,74,170,163,_
58,143,16,10,152,96,122,168,115,58,144,28,26,159,42,90,_
164,251,41,168,64,58,159,176,202,113,48,106,160,151,10,170,_
255,56,157,154,154,168,180,138,166,143,42,167,94,74,167,103,_
42,128,174,234,171,80,42,169,184,186,169,66,170,110,253,9,_
168,150,170,170,68,167,164,152,24,169,199,199,172,159,234,172,_
215,186,168,209,90,170,186,186,109,149,106,142,201,153,108,186,_
135,164,226,89,172,169,218,108,230,217,152,240,73,174,121,199,_
171,23,218,171,75,218,144,76,74,166,167,169,175,168,10,160,_
153,57,171,234,6,175,98,218,114,212,250,170,125,170,163,196,_
90,173,254,186,176,182,250,172,226,202,173,12,123,176,181,74,_
177,237,10,167,79,137,177,90,74,148,248,105,156,127,103,173,_
24,152,138,28,11,176,18,219,172,21,122,175,39,187,135,34,_
139,173,166,170,178,232,38,171,36,27,163,106,250,113,123,217,_
164,206,54,3,166,122,165,30,107,142,79,247,178,14,27,179,_
24,73,148,91,119,133,15,170,177,242,170,167,157,250,140,153,_
106,128,31,171,115,69,11,180,48,139,178,25,10,168,49,25,_
167,206,38,3,241,120,181,78,235,115,45,59,174,198,106,181,_
177,88,181,101,138,140,70,59,179,230,88,181,135,215,175,134,_
151,173,125,169,141,100,107,177,89,250,180,106,203,178,33,203,_
180,82,59,177,111,123,183,187,200,170,80,107,175,123,184,182,_
118,91,178,120,26,184,129,58,184,117,251,171,128,59,111,92,_
235,173,38,11,132,177,72,181,25,107,120,89,235,181,19,42,_
163,47,26,178,35,24,143,48,176,151,245,138,184,55,215,170,_
90,187,131,71,43,186,20,105,184,28,87,179,232,122,162,249,_
186,181,123,123,123,68,43,183,124,90,182,62,75,127,104,169,_
185,31,233,181,49,105,176,165,186,167,200,154,108,241,72,159,_
169,248,183,135,251,136,149,219,118,180,187,185,165,219,149,167,_
43,154,148,155,116,181,107,120,206,75,186,59,27,188,169,11,_
173,183,170,183,110,123,189,94,91,147,110,58,172,159,71,148,_
208,235,119,224,203,169,218,171,188,235,250,186,72,104,188,182,_
91,177,13,27,187,235,43,132,200,43,184,139,27,191,158,203,_
183,18,10,186,16,171,173,113,235,115,146,187,186,221,137,190,_
221,26,181,194,187,133,211,203,184,200,134,3,174,235,190,131,_
203,179,247,107,189,239,203,192,239,198,191,34,186,189,9,235,_
174,239,57,186,34,170,179,228,75,188,99,107,155,222,73,116,_
17,236,117,104,107,156,19,28,170,213,203,189,239,38,190,46,_
219,188,209,200,188,8,91,194,94,87,179,49,144,194,40,172,_
148,0,204,140,27,156,192,243,6,194,76,55,195,0,200,185,_
2,188,109,158,154,191,21,140,169,43,188,173,205,150,187,242,_
59,154,191,123,174,49,188,195,16,204,161,8,156,171,147,171,_
172,76,247,196,58,140,181,82,12,195,56,108,194,74,252,116,_
169,216,195,244,247,195,223,250,194,221,219,197,68,104,170,97,_
188,135,106,172,112,108,12,196,166,248,192,63,219,190,35,123,_
193,227,107,156,3,251,146,176,251,175,171,121,196,55,124,174,_
234,169,158,99,236,32,73,140,196,244,137,199,86,11,191,132,_
171,196,137,188,192,145,27,197,127,28,143,57,155,179,4,12,_
26,28,106,196,218,43,154,57,122,111,151,27,185,169,40,180,_
207,203,194,85,124,194,20,124,198,107,252,189,199,219,196,92,_
140,191,141,203,174,31,156,197,169,60,175,116,103,190,248,215,_
199,121,152,200,36,204,202,46,156,203,134,250,176,60,28,202,_
105,75,196,111,12,141,197,235,152,110,188,171,140,76,201,35,_
10,185,115,156,189,253,91,199,7,138,186,144,170,203,69,12,_
202,151,28,189,152,60,203,165,172,112,87,170,201,108,139,189,_
208,28,156,44,235,191,180,220,186,105,138,205,223,252,125,203,_
188,170,230,236,115,198,92,192,46,26,203,124,56,166,232,156,_
184,116,43,189,244,25,205,121,172,191,161,219,206,209,120,192,_
247,156,116,87,28,125,2,189,135,4,237,148,113,76,127,34,_
140,183,10,108,208,37,186,177,196,92,191,195,171,199,165,57,_
209,133,200,193,188,172,196,103,171,184,101,92,184,17,77,198,_
125,219,185,32,45,204,137,156,138,255,236,200,8,109,193,57,_
28,192,31,29,210,45,45,204,184,76,205,90,167,208,31,140,_
151,36,109,142,132,44,138,96,188,177,229,169,197,121,75,125,_
229,27,208,153,139,202,231,60,205,91,57,212,253,28,208,53,_
237,209,239,108,186,170,172,194,39,141,132,51,125,160,56,109,_
192,158,124,155,234,12,183,204,236,211,10,156,204,249,140,200,_
39,200,120,52,41,200,243,43,210,192,70,213,233,106,205,225,_
123,202,102,251,203,62,39,196,77,251,204,186,171,190,34,26,_
147,234,90,209,93,187,181,181,44,209,84,140,132,99,13,2,_
103,109,214,248,28,156,238,76,214,185,249,140,85,139,216,27,_
107,207,125,109,211,94,11,216,219,150,204,150,92,205,124,109,_
156,143,93,201,58,157,214,68,71,216,138,188,210,76,157,188,_
78,77,195,153,77,125,126,221,216,222,27,207,54,192,211,65,_
173,218,148,61,197,193,188,133,159,12,121,97,13,142,117,125,_
211,244,217,205,10,215,208,175,253,202,172,13,168,167,170,189,_
126,45,3,104,105,174,80,189,191,87,189,218,90,109,109,126,_
237,219,42,93,214,210,236,218,219,182,217,95,12,214,75,93,_
216,240,92,212,91,136,3,71,77,199,204,237,210,212,187,139,_
113,215,202,13,220,209,68,237,204,229,77,110,183,61,109,155,_
93,218,218,108,221,251,171,212,255,27,222,227,189,138,119,93,_
207,40,109,192,61,237,167,246,237,208,199,189,221,253,173,132,_
248,45,109,150,253,215,244,41,224,192,107,170,201,188,220,24,_
156,219,14,146,216,115,221,204,254,173,145,54,60,148,5,203,_
196,188,189,213,74,12,211,63,233,152,134,44,217,62,151,221,_
14,126,160,11,71,148,55,48,226,37,78,221,156,221,220,112,_
12,204,223,73,179,109,189,208,139,124,226,45,108,218,43,190,_
197,49,46,189,38,174,182,56,62,227,59,206,226,162,60,135,_
142,25,111,146,7,228,142,73,226,118,167,227,213,185,150,67,_
206,131,74,46,228,75,238,228,77,158,227,70,46,229,81,14,_
229,193,199,228,86,238,227,193,216,226,89,206,129,146,40,137,_
68,46,163,166,154,228,79,222,177,11,30,108,111,221,134,35,_
110,170,176,141,128,59,121,229,109,158,212,50,219,227,134,135,_
230,211,102,230,40,30,144,111,238,122,39,120,224,52,139,157,_
109,103,227,22,174,192,65,142,229,196,237,119,119,222,200,197,_
205,223,174,188,232,86,124,155,94,206,164,144,254,121,146,254,_
157,148,238,122,122,126,225,157,93,221,44,45,204,210,205,164,_
186,39,137,160,238,120,113,238,181,158,30,124,71,121,179,111,_
167,234,146,135,181,140,204,230,48,44,234,159,23,235,223,233,_
201,235,205,232,251,76,209,215,29,154,120,9,232,72,120,130,_
211,173,235,250,140,220,88,124,174,60,216,225,235,204,216,224,_
205,234,189,110,159,18,158,222,46,158,235,220,61,210,118,7,_
156,191,110,120,51,112,148,11,23,232,58,57,206,153,153,116,_
169,142,190,219,238,119,31,126,123,254,60,226,19,106,235,208,_
12,212,193,14,2,135,44,195,208,206,156,214,30,219,192,254,_
220,193,182,209,112,125,199,150,75,225,118,151,180,50,78,138,_
59,251,234,218,118,3,142,25,240,201,237,184,27,222,114,3,_
79,234,215,76,145,96,233,230,100,14,231,125,173,239,165,94,_
240,25,135,207,49,60,150,10,223,133,84,247,255}


Function Uncompress_AFlibIII_palFT() As Any ptr
  Dim ret As Any ptr
    ret = Allocate(37212)
    AF3_palFTdata_LZW_Decode(@AFlibIII_palFT_lzw_data(0), 5421, ret, 37212)
    Return ret
End Function

Sub Init_AFlibIII_palFT_dat() constructor
AFlibIII_palFT_dat = Allocate(37212)
AF3_palFTdata_LZW_Decode(@AFlibIII_palFT_lzw_data(0), 5421, AFlibIII_palFT_dat, 37212)
End Sub
Sub DeInit_AFlibIII_palFT_dat() destructor
DeAllocate(AFlibIII_palFT_dat)
End Sub

Sub Init_AFlibIII_palFT() Constructor
  Dim As Integer f, c, r, i
  Dim As uByte ptr fmem
    fmem = Uncompress_AFlibIII_palFT()
    For f = 1 To 2
      For c = 0 To 255
        For r = 0 To 7
          AF3_palFTarray(f, c, r) = fmem[i]
          i += 1
        Next r
      Next c
    Next f
    DeAllocate(fmem)
End Sub

'_____________________________________________________________________________________________________________________


Dim Shared as Integer Any_16_Color_Set(0 to 15)

Static Shared as UlongInt USERcol(0 to 255)

Dim Shared as Integer Start64_CUSTcol(0 to 63), End64_CUSTcol(0 to 63)
Dim Shared as Integer Start256_CUSTcol(0 to 255), End256_CUSTcol(0 to 255)

Dim Shared as Integer StartNES_CUSTcol(0 to 63), EndNES_CUSTcol(0 to 63)
Dim Shared as Integer StartSMS_CUSTcol(0 to 63), EndSMS_CUSTcol(0 to 63)
Dim Shared as Integer StartUser256_CUSTcol(0 to 255), EndUser256_CUSTcol(0 to 255)

Declare Sub AFlibIII_DisplayColorInfo ( Byval x as Integer, _ 
                                        Byval y as Integer, _
                                        Byval col as Uinteger, _
                                        Byval buffer as Any Ptr = 0 )

Declare Sub AFlibIII_DisplayPal_4Col ( Byval sx as Integer, _ 
                                       Byval sy as Integer, _
                                       Byval palette_type as Integer, _
                                       Byval size as Integer = 16, _
                                       Byval alpha_blend as Integer = 255, _
                                       Byval buffer as Any Ptr = 0 )

Declare Sub AFlibIII_DisplayPal_8Col ( Byval sx as Integer, _ 
                                       Byval sy as Integer, _
                                       Byval palette_type as Integer, _
                                       Byval size as Integer = 16, _
                                       Byval alpha_blend as Integer = 255, _
                                       Byval buffer as Any Ptr = 0 )

Declare Sub AFlibIII_DisplayPal_16Col ( Byval sx as Integer, _ 
                                        Byval sy as Integer, _
                                        Byval palette_type as Integer, _
                                        Byval size as Integer = 16, _
                                        Byval alpha_blend as Integer = 255, _
                                        Byval buffer as Any Ptr = 0 )

Declare Sub AFlibIII_DisplayPal_32Col ( Byval sx as Integer, _ 
                                        Byval sy as Integer, _
                                        Byval palette_type as Integer, _
                                        Byval size as Integer = 16, _
                                        Byval alpha_blend as Integer = 255, _
                                        Byval buffer as Any Ptr = 0 )

Declare Sub AFlibIII_DisplayPal_64Col ( Byval sx as Integer, _ 
                                        Byval sy as Integer, _
                                        Byval palette_type as Integer, _
                                        Byval size as Integer = 16, _
                                        Byval alpha_blend as Integer = 255, _
                                        Byval buffer as Any Ptr = 0 )

Declare Sub AFlibIII_DisplayPal_128Col ( Byval sx as Integer, _ 
                                         Byval sy as Integer, _
                                         Byval palette_type as Integer, _
                                         Byval size as Integer = 16, _
                                         Byval alpha_blend as Integer = 255, _
                                         Byval buffer as Any Ptr = 0 )

Declare Sub AFlibIII_DisplayPal_256Col ( Byval sx as Integer, _ 
                                         Byval sy as Integer, _
                                         Byval palette_type as Integer, _
                                         Byval size as Integer = 16, _
                                         Byval alpha_blend as Integer = 255, _
                                         Byval buffer as Any Ptr = 0 )

Declare Sub AFlibIII_DisplayPal_512Col ( Byval sx as Integer, _ 
                                         Byval sy as Integer, _
                                         Byval palette_type as Integer, _
                                         Byval size as Integer = 16, _
                                         Byval alpha_blend as Integer = 255, _
                                         Byval buffer as Any Ptr = 0 )

Declare Sub AFlibIII_DisplayPal_4096Col ( Byval sx as Integer, _ 
                                          Byval sy as Integer, _
                                          Byval size as Integer = 6, _
                                          Byval alpha_blend as Integer = 255, _
                                          Byval buffer as Any Ptr = 0 )

Declare Sub AFlibIII_DisplayPal_CPC ( Byval sx as Integer, _ 
                                      Byval sy as Integer, _
                                      Byval size as Integer = 16, _
                                      Byval alpha_blend as Integer = 255, _
                                      Byval buffer as Any Ptr = 0 )
                                         
Declare Sub AFlibIII_DisplayPal_4Col_RicherDetail ( Byval sx as Integer, _ 
                                                    Byval sy as Integer, _
                                                    Byval palette_type as Integer, _
                                                    Byval Show_PalNo_Label as Integer = 1, _
                                                    Byval buffer as Any Ptr = 0 )

Declare Sub AFlibIII_DisplayPal_8Col_RicherDetail ( Byval sx as Integer, _ 
                                                    Byval sy as Integer, _
                                                    Byval palette_type as Integer, _
                                                    Byval Show_PalNo_Label as Integer = 1, _
                                                    Byval buffer as Any Ptr = 0 )

Declare Sub AFlibIII_DisplayPal_16Col_RicherDetail ( Byval sx as Integer, _ 
                                                     Byval sy as Integer, _
                                                     Byval palette_type as Integer, _
                                                     Byval Show_PalNo_Label as Integer = 1, _
                                                     Byval buffer as Any Ptr = 0 )

Declare Sub AFlibIII_DisplayPal_32Col_RicherDetail ( Byval sx as Integer, _ 
                                                     Byval sy as Integer, _
                                                     Byval palette_type as Integer, _
                                                     Byval Show_PalNo_Label as Integer = 1, _
                                                     Byval buffer as Any Ptr = 0 )

Declare Sub AFlibIII_DisplayPal_64Col_RicherDetail ( Byval sx as Integer, _ 
                                                     Byval sy as Integer, _
                                                     Byval palette_type as Integer, _
                                                     Byval Show_PalNo_Label as Integer = 1, _
                                                     Byval buffer as Any Ptr = 0 )

Declare Sub AFlibIII_DisplayPal_128Col_RicherDetail ( Byval sx as Integer, _ 
                                                      Byval sy as Integer, _
                                                      Byval palette_type as Integer, _
                                                      Byval Show_PalNo_Label as Integer = 1, _
                                                      Byval buffer as Any Ptr = 0 )

Declare Sub AFlibIII_DisplayPal_256Col_RicherDetail ( Byval sx as Integer, _ 
                                                      Byval sy as Integer, _
                                                      Byval palette_type as Integer, _
                                                      Byval Show_PalNo_Label as Integer = 1, _
                                                      Byval buffer as Any Ptr = 0 )

Declare Sub AFlibIII_DisplayPal_512Col_RicherDetail ( Byval sx as Integer, _ 
                                                      Byval sy as Integer, _
                                                      Byval palette_type as Integer, _
                                                      Byval Show_PalNo_Label as Integer = 1, _
                                                      Byval buffer as Any Ptr = 0 )

Declare Sub AFlibIII_DisplayPal_CPC_RicherDetail ( Byval sx as Integer, _ 
                                                   Byval sy as Integer, _
                                                   Byval Show_PalNo_Label as Integer = 1, _
                                                   Byval buffer as Any Ptr = 0 )

Declare Sub AFlibIII_ReplaceColor ( Byval buffer as Any Ptr = 0, _
                                    Byval From_col As Integer, _
                                    Byval To_col As Integer )

Declare Sub AFlibIII_Replace2Colors ( Byval buffer as Any Ptr = 0, _
                                      Byval From_col_1 As Integer, Byval To_col_1 As Integer, _
                                      Byval From_col_2 As Integer, Byval To_col_2 As Integer )

Declare Sub AFlibIII_Replace4Colors ( Byval buffer as Any Ptr = 0, _
                                      Byval From_col_1 As Integer, Byval To_col_1 As Integer, _
                                      Byval From_col_2 As Integer, Byval To_col_2 As Integer, _
                                      Byval From_col_3 As Integer, Byval To_col_3 As Integer, _
                                      Byval From_col_4 As Integer, Byval To_col_4 As Integer )

Declare Sub AFlibIII_Replace8Colors ( Byval buffer as Any Ptr = 0, _
                                      Byval From_col_1 As Integer, Byval To_col_1 As Integer, _
                                      Byval From_col_2 As Integer, Byval To_col_2 As Integer, _
                                      Byval From_col_3 As Integer, Byval To_col_3 As Integer, _
                                      Byval From_col_4 As Integer, Byval To_col_4 As Integer, _
                                      Byval From_col_5 As Integer, Byval To_col_5 As Integer, _
                                      Byval From_col_6 As Integer, Byval To_col_6 As Integer, _
                                      Byval From_col_7 As Integer, Byval To_col_7 As Integer, _
                                      Byval From_col_8 As Integer, Byval To_col_8 As Integer )

Declare Sub AFlibIII_Replace16Colors ( Byval buffer as Any Ptr = 0, _
                                       Byval From_col_1 As Integer, Byval To_col_1 As Integer, _
                                       Byval From_col_2 As Integer, Byval To_col_2 As Integer, _
                                       Byval From_col_3 As Integer, Byval To_col_3 As Integer, _
                                       Byval From_col_4 As Integer, Byval To_col_4 As Integer, _
                                       Byval From_col_5 As Integer, Byval To_col_5 As Integer, _
                                       Byval From_col_6 As Integer, Byval To_col_6 As Integer, _
                                       Byval From_col_7 As Integer, Byval To_col_7 As Integer, _
                                       Byval From_col_8 As Integer, Byval To_col_8 As Integer, _
                                       Byval From_col_9 As Integer, Byval To_col_9 As Integer, _
                                       Byval From_col_10 As Integer, Byval To_col_10 As Integer, _
                                       Byval From_col_11 As Integer, Byval To_col_11 As Integer, _
                                       Byval From_col_12 As Integer, Byval To_col_12 As Integer, _
                                       Byval From_col_13 As Integer, Byval To_col_13 As Integer, _
                                       Byval From_col_14 As Integer, Byval To_col_14 As Integer, _
                                       Byval From_col_15 As Integer, Byval To_col_15 As Integer, _
                                       Byval From_col_16 As Integer, Byval To_col_16 As Integer )

Declare Sub AFlibIII_ReplaceColor_Wildcard ( Byval buffer as Any Ptr = 0, _
                                             Byval From_col_1 As Integer,     Byval To_col_1 As Integer, _
                                             Byval From_col_2 As Integer = 0, Byval To_col_2 As Integer = 0, _
                                             Byval From_col_3 As Integer = 0, Byval To_col_3 As Integer = 0, _
                                             Byval From_col_4 As Integer = 0, Byval To_col_4 As Integer = 0, _
                                             Byval From_col_5 As Integer = 0, Byval To_col_5 As Integer = 0, _
                                             Byval From_col_6 As Integer = 0, Byval To_col_6 As Integer = 0, _
                                             Byval From_col_7 As Integer = 0, Byval To_col_7 As Integer = 0, _
                                             Byval From_col_8 As Integer = 0, Byval To_col_8 As Integer = 0, _
                                             Byval From_col_9 As Integer = 0, Byval To_col_9 As Integer = 0, _
                                             Byval From_col_10 As Integer = 0, Byval To_col_10 As Integer = 0, _
                                             Byval From_col_11 As Integer = 0, Byval To_col_11 As Integer = 0, _
                                             Byval From_col_12 As Integer = 0, Byval To_col_12 As Integer = 0, _
                                             Byval From_col_13 As Integer = 0, Byval To_col_13 As Integer = 0, _
                                             Byval From_col_14 As Integer = 0, Byval To_col_14 As Integer = 0, _
                                             Byval From_col_15 As Integer = 0, Byval To_col_15 As Integer = 0, _
                                             Byval From_col_16 As Integer = 0, Byval To_col_16 As Integer = 0, _
                                             Byval From_col_17 As Integer = 0, Byval To_col_17 As Integer = 0, _
                                             Byval From_col_18 As Integer = 0, Byval To_col_18 As Integer = 0, _
                                             Byval From_col_19 As Integer = 0, Byval To_col_19 As Integer = 0, _
                                             Byval From_col_20 As Integer = 0, Byval To_col_20 As Integer = 0, _
                                             Byval From_col_21 As Integer = 0, Byval To_col_21 As Integer = 0, _
                                             Byval From_col_22 As Integer = 0, Byval To_col_22 As Integer = 0, _
                                             Byval From_col_23 As Integer = 0, Byval To_col_23 As Integer = 0, _
                                             Byval From_col_24 As Integer = 0, Byval To_col_24 As Integer = 0, _
                                             Byval From_col_25 As Integer = 0, Byval To_col_25 As Integer = 0, _
                                             Byval From_col_26 As Integer = 0, Byval To_col_26 As Integer = 0, _
                                             Byval From_col_27 As Integer = 0, Byval To_col_27 As Integer = 0, _
                                             Byval From_col_28 As Integer = 0, Byval To_col_28 As Integer = 0, _
                                             Byval From_col_29 As Integer = 0, Byval To_col_29 As Integer = 0, _
                                             Byval From_col_30 As Integer = 0, Byval To_col_30 As Integer = 0)

Declare Sub AFlibIII_Any64Color_LockON ( Byval Any16ColorColumn_from_0_to_3 As Integer, _
                                         Byval From_col_1 As Integer,     Byval To_col_1 As Integer, _
                                         Byval From_col_2 As Integer = 0, Byval To_col_2 As Integer = 0, _
                                         Byval From_col_3 As Integer = 0, Byval To_col_3 As Integer = 0, _
                                         Byval From_col_4 As Integer = 0, Byval To_col_4 As Integer = 0, _
                                         Byval From_col_5 As Integer = 0, Byval To_col_5 As Integer = 0, _
                                         Byval From_col_6 As Integer = 0, Byval To_col_6 As Integer = 0, _
                                         Byval From_col_7 As Integer = 0, Byval To_col_7 As Integer = 0, _
                                         Byval From_col_8 As Integer = 0, Byval To_col_8 As Integer = 0, _
                                         Byval From_col_9 As Integer = 0, Byval To_col_9 As Integer = 0, _
                                         Byval From_col_10 As Integer = 0, Byval To_col_10 As Integer = 0, _
                                         Byval From_col_11 As Integer = 0, Byval To_col_11 As Integer = 0, _
                                         Byval From_col_12 As Integer = 0, Byval To_col_12 As Integer = 0, _
                                         Byval From_col_13 As Integer = 0, Byval To_col_13 As Integer = 0, _
                                         Byval From_col_14 As Integer = 0, Byval To_col_14 As Integer = 0, _
                                         Byval From_col_15 As Integer = 0, Byval To_col_15 As Integer = 0, _
                                         Byval From_col_16 As Integer = 0, Byval To_col_16 As Integer = 0 )

Declare Sub AFlibIII_Any256Color_LockON ( Byval Any16ColorColumn_from_0_to_15 As Integer, _
                                          Byval From_col_1 As Integer,     Byval To_col_1 As Integer, _
                                          Byval From_col_2 As Integer = 0, Byval To_col_2 As Integer = 0, _
                                          Byval From_col_3 As Integer = 0, Byval To_col_3 As Integer = 0, _
                                          Byval From_col_4 As Integer = 0, Byval To_col_4 As Integer = 0, _
                                          Byval From_col_5 As Integer = 0, Byval To_col_5 As Integer = 0, _
                                          Byval From_col_6 As Integer = 0, Byval To_col_6 As Integer = 0, _
                                          Byval From_col_7 As Integer = 0, Byval To_col_7 As Integer = 0, _
                                          Byval From_col_8 As Integer = 0, Byval To_col_8 As Integer = 0, _
                                          Byval From_col_9 As Integer = 0, Byval To_col_9 As Integer = 0, _
                                          Byval From_col_10 As Integer = 0, Byval To_col_10 As Integer = 0, _
                                          Byval From_col_11 As Integer = 0, Byval To_col_11 As Integer = 0, _
                                          Byval From_col_12 As Integer = 0, Byval To_col_12 As Integer = 0, _
                                          Byval From_col_13 As Integer = 0, Byval To_col_13 As Integer = 0, _
                                          Byval From_col_14 As Integer = 0, Byval To_col_14 As Integer = 0, _
                                          Byval From_col_15 As Integer = 0, Byval To_col_15 As Integer = 0, _
                                          Byval From_col_16 As Integer = 0, Byval To_col_16 As Integer = 0 )

Declare Sub AFlibIII_Any64Color_Click ( Byval buffer as Any Ptr = 0 )
Declare Sub AFlibIII_Any256Color_Click ( Byval buffer as Any Ptr = 0 )

Declare Sub AFlibIII_CopyPal_to_UserPal ( Byval PaletteType as Integer )

Declare Sub AFlibIII_LoadDOS768Pal_to_UserPal (Byref PalFile as String)
Declare Sub AFlibIII_Load768Pal_to_UserPal (Byref PalFile as String)
Declare Sub AFlibIII_LoadPP256Pal_to_UserPal (Byref PP256PalFile as String)
Declare Sub AFlibIII_PaintShopProPal_to_UserPal (Byref JASCPalFile as String)

Declare Sub AFlibIII_StoreColor_UserPal ( Byval UserPalette_ColorNumber as Integer, _
                                          Byval r as Integer, _
                                          Byval g as Integer, _
                                          Byval b as Integer )

Declare Sub AFlibIII_MakeTransColor_UserPal ( Byval UserPalette_ColorNumber as Integer )

Declare Sub AFlibIII_MakeGradient_UserPal ( Byval UserPalette_StartPoint as Integer, _
                                            Byval r_from as Integer, _
                                            Byval g_from as Integer, _
                                            Byval b_from as Integer, _
                                            Byval UserPalette_EndPoint as Integer, _
                                            Byval r_to as Integer, _
                                            Byval g_to as Integer, _
                                            Byval b_to as Integer )

Declare Sub AFlibIII_SwapCGA ( Byval buffer as any Ptr = 0, _
                               Byval CGApal_SwapFrom as Integer, _
                               Byval CGApal_SwapTo as Integer, _
                               Byval CGApal_SetBGcol as Integer = 0 )

Declare Sub AFlibIII_FadeEGA ( Byval buffer as Any Ptr = 0, _
                               Byval Fade_Lvl As Integer )

Declare Sub AFlibIII_FadeNES ( Byval buffer as Any Ptr = 0, _
                               Byval Fade_Lvl As Integer )
                       
Declare Sub AFlibIII_FadeSMS ( Byval buffer as Any Ptr = 0, _
                               Byval Fade_Lvl As Integer )

Declare Sub AFlibIII_FadeGB ( Byval buffer as Any Ptr = 0, _
                              Byval Fade_Lvl As Integer )
                              
Declare Sub AFlibIII_FadeC64 ( Byval buffer as Any Ptr = 0, _
                               Byval Fade_Lvl As Integer )

Declare Sub AFlibIII_FadeCPC ( Byval buffer as Any Ptr = 0, _
                               Byval Fade_Lvl As Integer )







Declare Function ENTERPRISEeasy ( Byval R_col as Integer, _
                                  Byval G_col as Integer, _
                                  Byval B_col as Integer ) as Integer
                                  
Declare Function SAMCOUPEeasy ( Byval R_col as Integer, _
                                Byval G_col as Integer, _
                                Byval B_col as Integer, _
                                Byval Intensity as Integer = 0 ) as Integer

Declare Function SMSeasy ( Byval R_col as Integer, _
                           Byval G_col as Integer, _
                           Byval B_col as Integer ) as Integer

Declare Function RGB512easy ( Byval R_col as Integer, _
                              Byval G_col as Integer, _
                              Byval B_col as Integer ) as Integer

Declare Function RGB4096easy ( Byval R_col as Integer, _
                               Byval G_col as Integer, _
                               Byval B_col as Integer ) as Integer
                               
Declare Sub PrivateCol_check_buffersize ( Byval buffer As Any Ptr, Byref x As Integer, _
                                          Byref y As Integer )

Declare Sub PrivateCol_Print ( Byref text as string, _
                               Byval x AS integer, Byval y AS integer, _
                               Byval scale_x as single, Byval scale_y as single, _
                               Byval col_1 as integer, Byval col_2 as integer, _
                               Byval italic as integer, Byval style as integer, _
                               Byval fonttype as integer = 0, Byval buffer as Any Ptr = 0 )

Declare Sub PrivateCol_Insignia ( Byval x AS integer, Byval y AS integer, _
                                  Byval scale_x as single, Byval scale_y as single, _
                                  Byval col_1 as integer, Byval col_2 as integer, _
                                  Byval italic as integer, Byval style as integer, _
                                  Byval buffer as Any Ptr = 0 )

Declare Sub PrivateCol_Print_Shadow ( Byref text as string, _
                                      Byval x AS integer, Byval y AS integer, _
                                      Byval col_1 as integer, Byval col_2 as integer, _
                                      Byval shadcol as integer, Byval buffer as Any Ptr = 0 )

Declare Sub PrivateCol_FilledBox ( Byval sx1 as Integer, Byval sy1 as Integer, _
                                   Byval sx2 as Integer, Byval sy2 as Integer, _
                                   Byval col as Integer, Byval alpha_blend as Integer = 255, _
                                   Byval buffer as any Ptr = 0 )

Declare Sub PrivateCol_NESColor_LockON ( Byval Any16ColorColumn_from_0_to_3 As Integer, _
                                         Byval From_col_1 As Integer,     Byval To_col_1 As Integer, _
                                         Byval From_col_2 As Integer = 0, Byval To_col_2 As Integer = 0, _
                                         Byval From_col_3 As Integer = 0, Byval To_col_3 As Integer = 0, _
                                         Byval From_col_4 As Integer = 0, Byval To_col_4 As Integer = 0, _
                                         Byval From_col_5 As Integer = 0, Byval To_col_5 As Integer = 0, _
                                         Byval From_col_6 As Integer = 0, Byval To_col_6 As Integer = 0, _
                                         Byval From_col_7 As Integer = 0, Byval To_col_7 As Integer = 0, _
                                         Byval From_col_8 As Integer = 0, Byval To_col_8 As Integer = 0, _
                                         Byval From_col_9 As Integer = 0, Byval To_col_9 As Integer = 0, _
                                         Byval From_col_10 As Integer = 0, Byval To_col_10 As Integer = 0, _
                                         Byval From_col_11 As Integer = 0, Byval To_col_11 As Integer = 0, _
                                         Byval From_col_12 As Integer = 0, Byval To_col_12 As Integer = 0, _
                                         Byval From_col_13 As Integer = 0, Byval To_col_13 As Integer = 0, _
                                         Byval From_col_14 As Integer = 0, Byval To_col_14 As Integer = 0, _
                                         Byval From_col_15 As Integer = 0, Byval To_col_15 As Integer = 0, _
                                         Byval From_col_16 As Integer = 0, Byval To_col_16 As Integer = 0 )

Declare Sub PrivateCol_SMSColor_LockON ( Byval Any16ColorColumn_from_0_to_3 As Integer, _
                                         Byval From_col_1 As Integer,     Byval To_col_1 As Integer, _
                                         Byval From_col_2 As Integer = 0, Byval To_col_2 As Integer = 0, _
                                         Byval From_col_3 As Integer = 0, Byval To_col_3 As Integer = 0, _
                                         Byval From_col_4 As Integer = 0, Byval To_col_4 As Integer = 0, _
                                         Byval From_col_5 As Integer = 0, Byval To_col_5 As Integer = 0, _
                                         Byval From_col_6 As Integer = 0, Byval To_col_6 As Integer = 0, _
                                         Byval From_col_7 As Integer = 0, Byval To_col_7 As Integer = 0, _
                                         Byval From_col_8 As Integer = 0, Byval To_col_8 As Integer = 0, _
                                         Byval From_col_9 As Integer = 0, Byval To_col_9 As Integer = 0, _
                                         Byval From_col_10 As Integer = 0, Byval To_col_10 As Integer = 0, _
                                         Byval From_col_11 As Integer = 0, Byval To_col_11 As Integer = 0, _
                                         Byval From_col_12 As Integer = 0, Byval To_col_12 As Integer = 0, _
                                         Byval From_col_13 As Integer = 0, Byval To_col_13 As Integer = 0, _
                                         Byval From_col_14 As Integer = 0, Byval To_col_14 As Integer = 0, _
                                         Byval From_col_15 As Integer = 0, Byval To_col_15 As Integer = 0, _
                                         Byval From_col_16 As Integer = 0, Byval To_col_16 As Integer = 0 )

Declare Function PrivateColRep ( Byval Image As Uinteger Ptr,_
                                 Byval ReplaceThis As Uinteger, _
                                 Byval WithThis As Uinteger ) As Uinteger Ptr

Declare Function PrivateColRep_2colors( Byval Image As Uinteger ptr, _
                                        Byval ReplaceThis_1 As Uinteger, Byval WithThis_1 As Uinteger, _
                                        Byval ReplaceThis_2 As Uinteger, Byval WithThis_2 As Uinteger ) As Uinteger ptr

Declare Function PrivateColRep_4colors( Byval Image As Uinteger ptr, _
                                        Byval ReplaceThis_1 As Uinteger, Byval WithThis_1 As Uinteger, _
                                        Byval ReplaceThis_2 As Uinteger, Byval WithThis_2 As Uinteger, _
                                        Byval ReplaceThis_3 As Uinteger, Byval WithThis_3 As Uinteger, _
                                        Byval ReplaceThis_4 As Uinteger, Byval WithThis_4 As Uinteger ) As Uinteger ptr

Declare Function PrivateColRep_8colors( Byval Image As Uinteger ptr, _
                                        Byval ReplaceThis_1 As Uinteger, Byval WithThis_1 As Uinteger, _
                                        Byval ReplaceThis_2 As Uinteger, Byval WithThis_2 As Uinteger, _
                                        Byval ReplaceThis_3 As Uinteger, Byval WithThis_3 As Uinteger, _
                                        Byval ReplaceThis_4 As Uinteger, Byval WithThis_4 As Uinteger, _
                                        Byval ReplaceThis_5 As Uinteger, Byval WithThis_5 As Uinteger, _
                                        Byval ReplaceThis_6 As Uinteger, Byval WithThis_6 As Uinteger, _
                                        Byval ReplaceThis_7 As Uinteger, Byval WithThis_7 As Uinteger, _
                                        Byval ReplaceThis_8 As Uinteger, Byval WithThis_8 As Uinteger ) As Uinteger ptr

Declare Function PrivateColRep_16colors( Byval Image As Uinteger ptr, _
                                         Byval ReplaceThis_1 As Uinteger, Byval WithThis_1 As Uinteger, _
                                         Byval ReplaceThis_2 As Uinteger, Byval WithThis_2 As Uinteger, _
                                         Byval ReplaceThis_3 As Uinteger, Byval WithThis_3 As Uinteger, _
                                         Byval ReplaceThis_4 As Uinteger, Byval WithThis_4 As Uinteger, _
                                         Byval ReplaceThis_5 As Uinteger, Byval WithThis_5 As Uinteger, _
                                         Byval ReplaceThis_6 As Uinteger, Byval WithThis_6 As Uinteger, _
                                         Byval ReplaceThis_7 As Uinteger, Byval WithThis_7 As Uinteger, _
                                         Byval ReplaceThis_8 As Uinteger, Byval WithThis_8 As Uinteger, _
                                         Byval ReplaceThis_9 As Uinteger, Byval WithThis_9 As Uinteger, _
                                         Byval ReplaceThis_10 As Uinteger, Byval WithThis_10 As Uinteger, _
                                         Byval ReplaceThis_11 As Uinteger, Byval WithThis_11 As Uinteger, _
                                         Byval ReplaceThis_12 As Uinteger, Byval WithThis_12 As Uinteger, _
                                         Byval ReplaceThis_13 As Uinteger, Byval WithThis_13 As Uinteger, _
                                         Byval ReplaceThis_14 As Uinteger, Byval WithThis_14 As Uinteger, _
                                         Byval ReplaceThis_15 As Uinteger, Byval WithThis_15 As Uinteger, _
                                         Byval ReplaceThis_16 As Uinteger, Byval WithThis_16 As Uinteger ) As Uinteger ptr

Declare Function PrivateColRep_30colors( Byval Image As Uinteger ptr, _
                                         Byval ReplaceThis_1 As Uinteger, Byval WithThis_1 As Uinteger, _
                                         Byval ReplaceThis_2 As Uinteger, Byval WithThis_2 As Uinteger, _
                                         Byval ReplaceThis_3 As Uinteger, Byval WithThis_3 As Uinteger, _
                                         Byval ReplaceThis_4 As Uinteger, Byval WithThis_4 As Uinteger, _
                                         Byval ReplaceThis_5 As Uinteger, Byval WithThis_5 As Uinteger, _
                                         Byval ReplaceThis_6 As Uinteger, Byval WithThis_6 As Uinteger, _
                                         Byval ReplaceThis_7 As Uinteger, Byval WithThis_7 As Uinteger, _
                                         Byval ReplaceThis_8 As Uinteger, Byval WithThis_8 As Uinteger, _
                                         Byval ReplaceThis_9 As Uinteger, Byval WithThis_9 As Uinteger, _
                                         Byval ReplaceThis_10 As Uinteger, Byval WithThis_10 As Uinteger, _
                                         Byval ReplaceThis_11 As Uinteger, Byval WithThis_11 As Uinteger, _
                                         Byval ReplaceThis_12 As Uinteger, Byval WithThis_12 As Uinteger, _
                                         Byval ReplaceThis_13 As Uinteger, Byval WithThis_13 As Uinteger, _
                                         Byval ReplaceThis_14 As Uinteger, Byval WithThis_14 As Uinteger, _
                                         Byval ReplaceThis_15 As Uinteger, Byval WithThis_15 As Uinteger, _
                                         Byval ReplaceThis_16 As Uinteger, Byval WithThis_16 As Uinteger, _
                                         Byval ReplaceThis_17 As Uinteger, Byval WithThis_17 As Uinteger, _
                                         Byval ReplaceThis_18 As Uinteger, Byval WithThis_18 As Uinteger, _
                                         Byval ReplaceThis_19 As Uinteger, Byval WithThis_19 As Uinteger, _
                                         Byval ReplaceThis_20 As Uinteger, Byval WithThis_20 As Uinteger, _
                                         Byval ReplaceThis_21 As Uinteger, Byval WithThis_21 As Uinteger, _
                                         Byval ReplaceThis_22 As Uinteger, Byval WithThis_22 As Uinteger, _
                                         Byval ReplaceThis_23 As Uinteger, Byval WithThis_23 As Uinteger, _
                                         Byval ReplaceThis_24 As Uinteger, Byval WithThis_24 As Uinteger, _
                                         Byval ReplaceThis_25 As Uinteger, Byval WithThis_25 As Uinteger, _
                                         Byval ReplaceThis_26 As Uinteger, Byval WithThis_26 As Uinteger, _
                                         Byval ReplaceThis_27 As Uinteger, Byval WithThis_27 As Uinteger, _
                                         Byval ReplaceThis_28 As Uinteger, Byval WithThis_28 As Uinteger, _
                                         Byval ReplaceThis_29 As Uinteger, Byval WithThis_29 As Uinteger, _
                                         Byval ReplaceThis_30 As Uinteger, Byval WithThis_30 As Uinteger ) As Uinteger ptr

Declare Function PrivateColRep_64colors( Byval Image As Uinteger ptr ) As Uinteger ptr
Declare Function PrivateColRep_64colors_FC( Byval Image As Uinteger ptr, _
                                            Byval Normal_or_Reverse as Integer = 0 ) As Uinteger ptr
Declare Function PrivateColRep_64colors_SMS( Byval Image As Uinteger ptr, _
                                             Byval Normal_or_Reverse as Integer = 0 ) As Uinteger ptr
Declare Function PrivateColRep_256colors( Byval Image As Uinteger ptr ) As Uinteger ptr









'_________________________________________________________________________
Sub AFlibIII_DisplayColorInfo ( Byval x as Integer, _ 
                                Byval y as Integer, _
                                Byval col as Uinteger, _
                                Byval buffer as Any Ptr = 0 )

  Line buffer, (x, y)-(x + 87, y + 31), RGB(16, 16, 16), BF
  If ((col shr 16) and &hFF) = 255 and ((col shr 8) and &hFF) = 0 and (col and &hFF) = 255 then
    Line buffer, (x, y)-(x + 31, y + 31), RGB(255, 255, 255)
    Line buffer, (x + 31, y)-(x, y + 31), RGB(255, 255, 255)
  else
    Line buffer, (x, y)-(x + 31, y + 31), col, BF
  End if

  Line buffer, (x, y)-(x + 31, y + 31), RGB(176, 176, 176), B
  Line buffer, (x + 1, y + 31)-(x + 31, y + 31), RGB(48, 48, 48)
  Line buffer, (x + 31, y + 31)-(x + 31, y + 1), RGB(48, 48, 48)
  Pset buffer, (x, y + 31), RGB(96, 96, 96)
  Pset buffer, (x + 31, y), RGB(96, 96, 96)

  Line buffer, (x + 1, y + 1)-(x + 30, y + 30), RGB(255, 255, 255), B
  Line buffer, (x + 2, y + 30)-(x + 30, y + 30), RGB(128, 128, 128)
  Line buffer, (x + 30, y + 30)-(x + 30, y + 2), RGB(128, 128, 128)
  Pset buffer, (x + 1, y + 30), RGB(176, 176, 176)
  Pset buffer, (x + 30, y + 1), RGB(176, 176, 176)

  Line buffer, (x + 2, y + 2)-(x + 29, y + 29), RGB(176, 176, 176), B
  Line buffer, (x + 3, y + 29)-(x + 29, y + 29), RGB(48, 48, 48)
  Line buffer, (x + 29, y + 29)-(x + 29, y + 3), RGB(48, 48, 48)
  Pset buffer, (x + 2, y + 29), RGB(96, 96, 96)
  Pset buffer, (x + 29, y + 2), RGB(96, 96, 96)

  PrivateCol_Print_Shadow chr(144), x + 36, y + 2, RGB(64, 0, 0), RGB(255, 88, 88), RGB(48, 48, 48), buffer
  PrivateCol_Print_Shadow "= " + str(((col shr 16) and &hFF)), x + 50, y + 2, RGB(255, 255, 255), RGB(192, 192, 192), RGB(48, 48, 48), buffer
  PrivateCol_Print_Shadow chr(145), x + 36, y + 12, RGB(0, 64, 0), RGB(88, 255, 88), RGB(48, 48, 48), buffer
  PrivateCol_Print_Shadow "= " + str(((col shr 8) and &hFF)), x + 50, y + 12, RGB(255, 255, 255), RGB(192, 192, 192), RGB(48, 48, 48), buffer
  PrivateCol_Print_Shadow chr(146), x + 36, y + 22, RGB(0, 0, 64), RGB(88, 88, 255), RGB(48, 48, 48), buffer
  PrivateCol_Print_Shadow "= " + str(col and &hFF), x + 50, y + 22, RGB(255, 255, 255), RGB(192, 192, 192), RGB(48, 48, 48), buffer

End Sub



'_________________________________________________________________________
Sub AFlibIII_DisplayPal_4Col ( Byval sx as Integer, _ 
                               Byval sy as Integer, _
                               Byval palette_type as Integer, _
                               Byval size as Integer = 16, _
                               Byval alpha_blend as Integer = 255, _
                               Byval buffer as Any Ptr = 0 )

'----------------------------------------------------------------------
' On "palette_type", pass:
'       0 = CGA 4-color Palette (1st palette; Normal)
'       1 = CGA 4-color Palette (1st palette; High Intensity)
'       2 = CGA 4-color Palette (2nd palette; Normal)
'       3 = CGA 4-color Palette (2nd palette; High Intensity)
'       4 = CGA 4-color Palette (3rd palette; Normal)
'       5 = CGA 4-color Palette (3rd palette; High Intensity)
'       6 = Game Boy Palette
'       7 = Virtual Boy Palette
'       8 = Custom AFlib III User-Defined Palette (first 4 colors ONLY!)
'----------------------------------------------------------------------
  
  If size < 1 then size = 1
  If size > 256 then size = 256
  
  For PalColList_X as Integer = 0 to 3 step 1
    Select Case palette_type
      Case is < 1
        PrivateCol_FilledBox (PalColList_X * size) + sx, sy, ((PalColList_X * size) + (size - 1)) + sx, (size - 1) + sy, CGAcol_A(PalColList_X), alpha_blend, buffer
      Case 1
        PrivateCol_FilledBox (PalColList_X * size) + sx, sy, ((PalColList_X * size) + (size - 1)) + sx, (size - 1) + sy, CGAcol_B(PalColList_X), alpha_blend, buffer
      Case 2
        PrivateCol_FilledBox (PalColList_X * size) + sx, sy, ((PalColList_X * size) + (size - 1)) + sx, (size - 1) + sy, CGAcol_C(PalColList_X), alpha_blend, buffer
      Case 3
        PrivateCol_FilledBox (PalColList_X * size) + sx, sy, ((PalColList_X * size) + (size - 1)) + sx, (size - 1) + sy, CGAcol_D(PalColList_X), alpha_blend, buffer
      Case 4
        PrivateCol_FilledBox (PalColList_X * size) + sx, sy, ((PalColList_X * size) + (size - 1)) + sx, (size - 1) + sy, CGAcol_E(PalColList_X), alpha_blend, buffer
      Case 5
        PrivateCol_FilledBox (PalColList_X * size) + sx, sy, ((PalColList_X * size) + (size - 1)) + sx, (size - 1) + sy, CGAcol_F(PalColList_X), alpha_blend, buffer
      Case 6
        PrivateCol_FilledBox (PalColList_X * size) + sx, sy, ((PalColList_X * size) + (size - 1)) + sx, (size - 1) + sy, GBcol(PalColList_X), alpha_blend, buffer
      Case 7
        PrivateCol_FilledBox (PalColList_X * size) + sx, sy, ((PalColList_X * size) + (size - 1)) + sx, (size - 1) + sy, VBcol(PalColList_X), alpha_blend, buffer
      Case is > 7
        PrivateCol_FilledBox (PalColList_X * size) + sx, sy, ((PalColList_X * size) + (size - 1)) + sx, (size - 1) + sy, USERcol(PalColList_X), alpha_blend, buffer
    End Select  
  Next

End Sub



'_________________________________________________________________________
Sub AFlibIII_DisplayPal_8Col ( Byval sx as Integer, _ 
                               Byval sy as Integer, _
                               Byval palette_type as Integer, _
                               Byval size as Integer = 16, _
                               Byval alpha_blend as Integer = 255, _
                               Byval buffer as Any Ptr = 0 )

'----------------------------------------------------------------------
' On "palette_type", pass:
'       0 = WonderSwan Palette
'       1 = RGB 3-bit (8-color) Palette
'       2 = Custom AFlib III User-Defined Palette (first 8 colors ONLY!)
'----------------------------------------------------------------------
  
  If size < 1 then size = 1
  If size > 256 then size = 256
  
  For PalColList_X as Integer = 0 to 7 step 1
    Select Case palette_type
      Case is < 1
        PrivateCol_FilledBox (PalColList_X * size) + sx, sy, ((PalColList_X * size) + (size - 1)) + sx, (size - 1) + sy, WScol(PalColList_X), alpha_blend, buffer
      Case 1
        PrivateCol_FilledBox (PalColList_X * size) + sx, sy, ((PalColList_X * size) + (size - 1)) + sx, (size - 1) + sy, RGB8col(PalColList_X), alpha_blend, buffer
      Case is > 1
        PrivateCol_FilledBox (PalColList_X * size) + sx, sy, ((PalColList_X * size) + (size - 1)) + sx, (size - 1) + sy, USERcol(PalColList_X), alpha_blend, buffer
    End Select  
  Next

End Sub



'_________________________________________________________________________
Sub AFlibIII_DisplayPal_16Col ( Byval sx as Integer, _ 
                                Byval sy as Integer, _
                                Byval palette_type as Integer, _
                                Byval size as Integer = 16, _
                                Byval alpha_blend as Integer = 255, _
                                Byval buffer as Any Ptr = 0 )

'----------------------------------------------------------------------
' On "palette_type", pass:
'       0 = EGA 16-color Palette
'       1 = Commodore-64 (c64) Palette
'       2 = Arne's 16-color Palette
'       3 = DawnBringer's FUN16 Palette
'       4 = Intellivision (INTV) 16-color Palette
'       5 = NEC PC-6001/PC-6601 Series 16-color Palette
'       6 = Commodore VIC-20 Palette (NTSC version)
'       7 = Commodore VIC-20 Palette (PAL version)
'       8 = MSX/SG-1000/ColecoVision/ADAM and TI-99/4a 16-color Palette
'       9 = Sinclair ZX Spectrum 16-color Palette
'      10 = Apple II/IIc/IIe 16-color Palette
'      11 = Aquarius 16-color Palette
'      12 = Custom AFlib III User-Defined Palette (first 16 colors ONLY!)
'----------------------------------------------------------------------
  
  If size < 1 then size = 1
  If size > 256 then size = 256
  
  For PalColList_X as Integer = 0 to 15 step 1
    Select Case palette_type
      Case is < 1
        PrivateCol_FilledBox (PalColList_X * size) + sx, sy, ((PalColList_X * size) + (size - 1)) + sx, (size - 1) + sy, EGAcol(PalColList_X), alpha_blend, buffer
      Case 1
        PrivateCol_FilledBox (PalColList_X * size) + sx, sy, ((PalColList_X * size) + (size - 1)) + sx, (size - 1) + sy, C64col(PalColList_X), alpha_blend, buffer
      Case 2
        PrivateCol_FilledBox (PalColList_X * size) + sx, sy, ((PalColList_X * size) + (size - 1)) + sx, (size - 1) + sy, ARNEcol(PalColList_X), alpha_blend, buffer
      Case 3
        PrivateCol_FilledBox (PalColList_X * size) + sx, sy, ((PalColList_X * size) + (size - 1)) + sx, (size - 1) + sy, FUN16col(PalColList_X), alpha_blend, buffer
      Case 4
        PrivateCol_FilledBox (PalColList_X * size) + sx, sy, ((PalColList_X * size) + (size - 1)) + sx, (size - 1) + sy, INTVcol(PalColList_X), alpha_blend, buffer
      Case 5
        PrivateCol_FilledBox (PalColList_X * size) + sx, sy, ((PalColList_X * size) + (size - 1)) + sx, (size - 1) + sy, PC6001col(PalColList_X), alpha_blend, buffer
      Case 6
        PrivateCol_FilledBox (PalColList_X * size) + sx, sy, ((PalColList_X * size) + (size - 1)) + sx, (size - 1) + sy, VIC20col_NTSC(PalColList_X), alpha_blend, buffer
      Case 7
        PrivateCol_FilledBox (PalColList_X * size) + sx, sy, ((PalColList_X * size) + (size - 1)) + sx, (size - 1) + sy, VIC20col_PAL(PalColList_X), alpha_blend, buffer
      Case 8
        PrivateCol_FilledBox (PalColList_X * size) + sx, sy, ((PalColList_X * size) + (size - 1)) + sx, (size - 1) + sy, MSXcol(PalColList_X), alpha_blend, buffer
      Case 9
        PrivateCol_FilledBox (PalColList_X * size) + sx, sy, ((PalColList_X * size) + (size - 1)) + sx, (size - 1) + sy, ZXcol(PalColList_X), alpha_blend, buffer
      Case 10
        PrivateCol_FilledBox (PalColList_X * size) + sx, sy, ((PalColList_X * size) + (size - 1)) + sx, (size - 1) + sy, APPLEIIcol(PalColList_X), alpha_blend, buffer
      Case 11
        PrivateCol_FilledBox (PalColList_X * size) + sx, sy, ((PalColList_X * size) + (size - 1)) + sx, (size - 1) + sy, AQUARcol(PalColList_X), alpha_blend, buffer
      Case is > 11
        PrivateCol_FilledBox (PalColList_X * size) + sx, sy, ((PalColList_X * size) + (size - 1)) + sx, (size - 1) + sy, USERcol(PalColList_X), alpha_blend, buffer
    End Select  
  Next

End Sub



'_________________________________________________________________________
Sub AFlibIII_DisplayPal_32Col ( Byval sx as Integer, _ 
                                Byval sy as Integer, _
                                Byval palette_type as Integer, _
                                Byval size as Integer = 16, _
                                Byval alpha_blend as Integer = 255, _
                                Byval buffer as Any Ptr = 0 )

'----------------------------------------------------------------------
' On "palette_type", pass:
'       0 = DawnBringer's 32-Color Palette (DB32)
'       1 = Custom AFlib III User-Defined Palette (first 32 colors ONLY!)
'----------------------------------------------------------------------

  If size < 1 then size = 1
  If size > 256 then size = 256
  
  For PalColList_Y as Integer = 0 to 1 step 1
    For PalColList_X as Integer = 0 to 15 step 1
      Select Case palette_type
        Case is < 1
          PrivateCol_FilledBox (PalColList_X * size) + sx, (PalColList_Y * size) + sy, ((PalColList_X * size) + (size - 1)) + sx, ((PalColList_Y * size) + (size - 1)) + sy, DB32col(PalColList_X + (PalColList_Y * 16)), alpha_blend, buffer
        Case is > 0
          PrivateCol_FilledBox (PalColList_X * size) + sx, (PalColList_Y * size) + sy, ((PalColList_X * size) + (size - 1)) + sx, ((PalColList_Y * size) + (size - 1)) + sy, USERcol(PalColList_X + (PalColList_Y * 16)), alpha_blend, buffer
      End Select  
    Next
  Next

End Sub



'_________________________________________________________________________
Sub AFlibIII_DisplayPal_64Col ( Byval sx as Integer, _ 
                                Byval sy as Integer, _
                                Byval palette_type as Integer, _
                                Byval size as Integer = 16, _
                                Byval alpha_blend as Integer = 255, _
                                Byval buffer as Any Ptr = 0 )

'----------------------------------------------------------------------
' On "palette_type", pass:
'       0 = Master System/Mark III Palette
'       1 = FC/FDS/NES Palette
'       2 = FamiCube 64-color Palette
'       3 = Custom AFlib III User-Defined Palette (first 64 colors ONLY!)
'----------------------------------------------------------------------

  If size < 1 then size = 1
  If size > 256 then size = 256
  
  For PalColList_Y as Integer = 0 to 3 step 1
    For PalColList_X as Integer = 0 to 15 step 1
      Select Case palette_type
        Case is < 1
          PrivateCol_FilledBox (PalColList_X * size) + sx, (PalColList_Y * size) + sy, ((PalColList_X * size) + (size - 1)) + sx, ((PalColList_Y * size) + (size - 1)) + sy, SMScol(PalColList_X + (PalColList_Y * 16)), alpha_blend, buffer
        Case 1
          PrivateCol_FilledBox (PalColList_X * size) + sx, (PalColList_Y * size) + sy, ((PalColList_X * size) + (size - 1)) + sx, ((PalColList_Y * size) + (size - 1)) + sy, NEScol(PalColList_X + (PalColList_Y * 16)), alpha_blend, buffer
        Case 2
          PrivateCol_FilledBox (PalColList_X * size) + sx, (PalColList_Y * size) + sy, ((PalColList_X * size) + (size - 1)) + sx, ((PalColList_Y * size) + (size - 1)) + sy, FCUBEcol(PalColList_X + (PalColList_Y * 16)), alpha_blend, buffer
        Case is > 2
          PrivateCol_FilledBox (PalColList_X * size) + sx, (PalColList_Y * size) + sy, ((PalColList_X * size) + (size - 1)) + sx, ((PalColList_Y * size) + (size - 1)) + sy, USERcol(PalColList_X + (PalColList_Y * 16)), alpha_blend, buffer
      End Select  
    Next
  Next

End Sub



'_________________________________________________________________________
Sub AFlibIII_DisplayPal_128Col ( Byval sx as Integer, _ 
                                 Byval sy as Integer, _
                                 Byval palette_type as Integer, _
                                 Byval size as Integer = 16, _
                                 Byval alpha_blend as Integer = 255, _
                                 Byval buffer as Any Ptr = 0 )

'----------------------------------------------------------------------
' On "palette_type", pass:
'       0 = Atari 2600 Palette (NTSC version)
'       1 = Atari 2600 Palette (PAL version)
'       2 = Commodore Plus/4 Palette
'       3 = Sam Coupe 128-color Palette
'       4 = Custom AFlib III User-Defined Palette (first 128 colors ONLY!)
'----------------------------------------------------------------------

  If size < 1 then size = 1
  If size > 256 then size = 256
  
  If palette_type > 1 then
    For PalColList_Y as Integer = 0 to 7 step 1
      For PalColList_X as Integer = 0 to 15 step 1
        Select Case palette_type
          Case 2
            PrivateCol_FilledBox (PalColList_X * size) + sx, (PalColList_Y * size) + sy, ((PalColList_X * size) + (size - 1)) + sx, ((PalColList_Y * size) + (size - 1)) + sy, PLUS4col(PalColList_X + (PalColList_Y * 16)), alpha_blend, buffer
          Case 3
            PrivateCol_FilledBox (PalColList_X * size) + sx, (PalColList_Y * size) + sy, ((PalColList_X * size) + (size - 1)) + sx, ((PalColList_Y * size) + (size - 1)) + sy, SAMCOUPEcol(PalColList_X + (PalColList_Y * 16)), alpha_blend, buffer
          Case is > 3
            PrivateCol_FilledBox (PalColList_X * size) + sx, (PalColList_Y * size) + sy, ((PalColList_X * size) + (size - 1)) + sx, ((PalColList_Y * size) + (size - 1)) + sy, USERcol(PalColList_X + (PalColList_Y * 16)), alpha_blend, buffer
        End Select  
      Next
    Next
  else
    For PalColList_Y as Integer = 0 to 15 step 1
      For PalColList_X as Integer = 0 to 7 step 1
        Select Case palette_type
          Case is < 1
            PrivateCol_FilledBox (PalColList_X * size) + sx, (PalColList_Y * size) + sy, ((PalColList_X * size) + (size - 1)) + sx, ((PalColList_Y * size) + (size - 1)) + sy, ATARI2600col(PalColList_X + (PalColList_Y * 8)), alpha_blend, buffer
          Case 1
            PrivateCol_FilledBox (PalColList_X * size) + sx, (PalColList_Y * size) + sy, ((PalColList_X * size) + (size - 1)) + sx, ((PalColList_Y * size) + (size - 1)) + sy, PAL2600col(PalColList_X + (PalColList_Y * 8)), alpha_blend, buffer
        End Select
      Next
    Next
  End if

End Sub



'_________________________________________________________________________
Sub AFlibIII_DisplayPal_256Col ( Byval sx as Integer, _ 
                                 Byval sy as Integer, _
                                 Byval palette_type as Integer, _
                                 Byval size as Integer = 16, _
                                 Byval alpha_blend as Integer = 255, _
                                 Byval buffer as Any Ptr = 0 )

'----------------------------------------------------------------------
' On "palette_type", pass:
'       0 = VGA 13h Palette
'       1 = Relsoft (Richard Eric M. Lope) Palette
'       2 = The AAP (Adigun Azikiwe Polack) 256-color Palette
'       3 = Atari 400/800/XL/XE Palette
'       4 = Atari 7800 Palette
'       5 = Enterprise 64/128 Home Computer 256-Color Palette
'       6 = Custom AFlib III User-Defined Palette (all 256 colors!!)
'----------------------------------------------------------------------

  If size < 1 then size = 1
  If size > 256 then size = 256
  
  For PalColList_Y as Integer = 0 to 15 step 1
    For PalColList_X as Integer = 0 to 15 step 1
      Select Case palette_type
        Case is < 1
          PrivateCol_FilledBox (PalColList_X * size) + sx, (PalColList_Y * size) + sy, ((PalColList_X * size) + (size - 1)) + sx, ((PalColList_Y * size) + (size - 1)) + sy, VGAcol(PalColList_X + (PalColList_Y * 16)), alpha_blend, buffer
        Case 1
          PrivateCol_FilledBox (PalColList_X * size) + sx, (PalColList_Y * size) + sy, ((PalColList_X * size) + (size - 1)) + sx, ((PalColList_Y * size) + (size - 1)) + sy, RELcol(PalColList_X + (PalColList_Y * 16)), alpha_blend, buffer
        Case 2
          PrivateCol_FilledBox (PalColList_X * size) + sx, (PalColList_Y * size) + sy, ((PalColList_X * size) + (size - 1)) + sx, ((PalColList_Y * size) + (size - 1)) + sy, AAPcol(PalColList_X + (PalColList_Y * 16)), alpha_blend, buffer
        Case 3
          PrivateCol_FilledBox (PalColList_X * size) + sx, (PalColList_Y * size) + sy, ((PalColList_X * size) + (size - 1)) + sx, ((PalColList_Y * size) + (size - 1)) + sy, ATARIcol(PalColList_X + (PalColList_Y * 16)), alpha_blend, buffer
        Case 4
          PrivateCol_FilledBox (PalColList_X * size) + sx, (PalColList_Y * size) + sy, ((PalColList_X * size) + (size - 1)) + sx, ((PalColList_Y * size) + (size - 1)) + sy, ATARI7800col(PalColList_X + (PalColList_Y * 16)), alpha_blend, buffer
        Case 5
          PrivateCol_FilledBox (PalColList_X * size) + sx, (PalColList_Y * size) + sy, ((PalColList_X * size) + (size - 1)) + sx, ((PalColList_Y * size) + (size - 1)) + sy, ENTERPRISEcol(PalColList_X + (PalColList_Y * 16)), alpha_blend, buffer
        Case is > 5
          PrivateCol_FilledBox (PalColList_X * size) + sx, (PalColList_Y * size) + sy, ((PalColList_X * size) + (size - 1)) + sx, ((PalColList_Y * size) + (size - 1)) + sy, USERcol(PalColList_X + (PalColList_Y * 16)), alpha_blend, buffer
      End Select  
    Next
  Next

End Sub



'_________________________________________________________________________
Sub AFlibIII_DisplayPal_512Col ( Byval sx as Integer, _ 
                                 Byval sy as Integer, _
                                 Byval palette_type as Integer, _
                                 Byval size as Integer = 16, _
                                 Byval alpha_blend as Integer = 255, _
                                 Byval buffer as Any Ptr = 0 )

'----------------------------------------------------------------------
' On "palette_type", pass:
'       0 = RGB 9-bit (512-color) Palette
'       1 = Relsoft (Richard Eric M. Lope) Extended 512-Color Palette
'       2 = The AAP (Adigun Azikiwe Polack) Super-512 Palette
'----------------------------------------------------------------------

  If size < 1 then size = 1
  If size > 256 then size = 256
  
  For PalColList_Y as Integer = 0 to 15 step 1
    For PalColList_X as Integer = 0 to 31 step 1
      Select Case palette_type
        Case is < 1
          PrivateCol_FilledBox (PalColList_X * size) + sx, (PalColList_Y * size) + sy, ((PalColList_X * size) + (size - 1)) + sx, ((PalColList_Y * size) + (size - 1)) + sy, RGB512col(PalColList_X + (PalColList_Y * 32)), alpha_blend, buffer
        Case 1
          PrivateCol_FilledBox (PalColList_X * size) + sx, (PalColList_Y * size) + sy, ((PalColList_X * size) + (size - 1)) + sx, ((PalColList_Y * size) + (size - 1)) + sy, REL512col(PalColList_X + (PalColList_Y * 32)), alpha_blend, buffer
        Case is > 1
          PrivateCol_FilledBox (PalColList_X * size) + sx, (PalColList_Y * size) + sy, ((PalColList_X * size) + (size - 1)) + sx, ((PalColList_Y * size) + (size - 1)) + sy, AAP512col(PalColList_X + (PalColList_Y * 32)), alpha_blend, buffer
      End Select  
    Next
  Next

End Sub



'_________________________________________________________________________
Sub AFlibIII_DisplayPal_4096Col ( Byval sx as Integer, _ 
                                  Byval sy as Integer, _
                                  Byval size as Integer = 6, _
                                  Byval alpha_blend as Integer = 255, _
                                  Byval buffer as Any Ptr = 0 )

  If size < 1 then size = 1
  If size > 256 then size = 256
  
  For PalColList_Y as Integer = 0 to 31 step 1
    For PalColList_X as Integer = 0 to 127 step 1
      PrivateCol_FilledBox (PalColList_X * size) + sx, (PalColList_Y * size) + sy, ((PalColList_X * size) + (size - 1)) + sx, ((PalColList_Y * size) + (size - 1)) + sy, RGB4096col(PalColList_X + (PalColList_Y * 128)), alpha_blend, buffer
    Next
  Next

End Sub



'_________________________________________________________________________
Sub AFlibIII_DisplayPal_CPC ( Byval sx as Integer, _ 
                              Byval sy as Integer, _
                              Byval size as Integer = 16, _
                              Byval alpha_blend as Integer = 255, _
                              Byval buffer as Any Ptr = 0 )

  If size < 1 then size = 1
  If size > 256 then size = 256
  
  For PalColList_Y as Integer = 0 to 2 step 1
    For PalColList_X as Integer = 0 to 8 step 1
      PrivateCol_FilledBox (PalColList_X * size) + sx, (PalColList_Y * size) + sy, ((PalColList_X * size) + (size - 1)) + sx, ((PalColList_Y * size) + (size - 1)) + sy, CPCcol(PalColList_X + (PalColList_Y * 9)), alpha_blend, buffer
    Next
  Next

End Sub



'_________________________________________________________________________
Sub AFlibIII_DisplayPal_4Col_RicherDetail ( Byval sx as Integer, _ 
                                            Byval sy as Integer, _
                                            Byval palette_type as Integer, _
                                            Byval Show_PalNo_Label as Integer = 1, _
                                            Byval buffer as Any Ptr = 0 )

'----------------------------------------------------------------------
' On "palette_type", pass:
'       0 = CGA 4-color Palette (1st palette; Normal)
'       1 = CGA 4-color Palette (1st palette; High Intensity)
'       2 = CGA 4-color Palette (2nd palette; Normal)
'       3 = CGA 4-color Palette (2nd palette; High Intensity)
'       4 = CGA 4-color Palette (3rd palette; Normal)
'       5 = CGA 4-color Palette (3rd palette; High Intensity)
'       6 = Game Boy Palette
'       7 = Virtual Boy Palette
'       8 = Custom AFlib III User-Defined Palette (first 4 colors ONLY!)
'----------------------------------------------------------------------

  Dim as Integer PalList_Y

  For PalList_Y = 0 to 3 step 1
    Select Case palette_type
      Case is < 1
        AFlibIII_DisplayColorInfo sx, sy + (PalList_Y * 34), CGAcol_A(PalList_Y), buffer
      Case 1
        AFlibIII_DisplayColorInfo sx, sy + (PalList_Y * 34), CGAcol_B(PalList_Y), buffer
      Case 2
        AFlibIII_DisplayColorInfo sx, sy + (PalList_Y * 34), CGAcol_C(PalList_Y), buffer
      Case 3
        AFlibIII_DisplayColorInfo sx, sy + (PalList_Y * 34), CGAcol_D(PalList_Y), buffer
      Case 4
        AFlibIII_DisplayColorInfo sx, sy + (PalList_Y * 34), CGAcol_E(PalList_Y), buffer
      Case 5
        AFlibIII_DisplayColorInfo sx, sy + (PalList_Y * 34), CGAcol_F(PalList_Y), buffer
      Case 6
        AFlibIII_DisplayColorInfo sx, sy + (PalList_Y * 34), GBcol(PalList_Y), buffer
      Case 7
        AFlibIII_DisplayColorInfo sx, sy + (PalList_Y * 34), VBcol(PalList_Y), buffer
      Case is > 7
        AFlibIII_DisplayColorInfo sx, sy + (PalList_Y * 34), USERcol(PalList_Y), buffer
    End Select
    If not Show_PalNo_Label = 0 then
      PrivateCol_Print Str(PalList_Y), sx + 3, sy + ((PalList_Y * 34) + 3), 1, 1, RGB(16, 16, 16), RGB(16, 16, 16), 0, 2, 0, buffer
      PrivateCol_Print Str(PalList_Y), sx + 3, sy + ((PalList_Y * 34) + 4), 1, 1, RGB(16, 16, 16), RGB(16, 16, 16), 0, 2, 0, buffer
      PrivateCol_Print Str(PalList_Y), sx + 4, sy + ((PalList_Y * 34) + 3), 1, 1, RGB(16, 16, 16), RGB(16, 16, 16), 0, 2, 0, buffer
      PrivateCol_Print Str(PalList_Y), sx + 4, sy + ((PalList_Y * 34) + 4), 1, 1, RGB(255, 255, 255), RGB(16, 16, 16), 0, 2, 0, buffer
    End If
  Next

End Sub



'_________________________________________________________________________
Sub AFlibIII_DisplayPal_8Col_RicherDetail ( Byval sx as Integer, _ 
                                            Byval sy as Integer, _
                                            Byval palette_type as Integer, _
                                            Byval Show_PalNo_Label as Integer = 1, _
                                            Byval buffer as Any Ptr = 0 )

'----------------------------------------------------------------------
' On "palette_type", pass:
'       0 = WonderSwan Palette
'       1 = RGB 3-bit (8-color) Palette
'       2 = Custom AFlib III User-Defined Palette (first 8 colors ONLY!)
'----------------------------------------------------------------------

  Dim as Integer PalList_Y

  For PalList_Y = 0 to 7 step 1
    Select Case palette_type
      Case is < 1
        AFlibIII_DisplayColorInfo sx, sy + (PalList_Y * 34), WScol(PalList_Y), buffer
      Case 1
        AFlibIII_DisplayColorInfo sx, sy + (PalList_Y * 34), RGB8col(PalList_Y), buffer
      Case is > 1
        AFlibIII_DisplayColorInfo sx, sy + (PalList_Y * 34), USERcol(PalList_Y), buffer
    End Select
    If not Show_PalNo_Label = 0 then
      PrivateCol_Print Str(PalList_Y), sx + 3, sy + ((PalList_Y * 34) + 3), 1, 1, RGB(16, 16, 16), RGB(16, 16, 16), 0, 2, 0, buffer
      PrivateCol_Print Str(PalList_Y), sx + 3, sy + ((PalList_Y * 34) + 4), 1, 1, RGB(16, 16, 16), RGB(16, 16, 16), 0, 2, 0, buffer
      PrivateCol_Print Str(PalList_Y), sx + 4, sy + ((PalList_Y * 34) + 3), 1, 1, RGB(16, 16, 16), RGB(16, 16, 16), 0, 2, 0, buffer
      PrivateCol_Print Str(PalList_Y), sx + 4, sy + ((PalList_Y * 34) + 4), 1, 1, RGB(255, 255, 255), RGB(16, 16, 16), 0, 2, 0, buffer
    End If
  Next

End Sub



'_________________________________________________________________________
Sub AFlibIII_DisplayPal_16Col_RicherDetail ( Byval sx as Integer, _ 
                                             Byval sy as Integer, _
                                             Byval palette_type as Integer, _
                                             Byval Show_PalNo_Label as Integer = 1, _
                                             Byval buffer as Any Ptr = 0 )

'----------------------------------------------------------------------
' On "palette_type", pass:
'       0 = EGA 16-color Palette
'       1 = Commodore-64 (c64) Palette
'       2 = Arne's 16-color Palette
'       3 = DawnBringer's FUN16 Palette
'       4 = Intellivision (INTV) 16-color Palette
'       5 = NEC PC-6001/PC-6601 Series 16-color Palette
'       6 = Commodore VIC-20 Palette (NTSC version)
'       7 = Commodore VIC-20 Palette (PAL version)
'       8 = MSX/SG-1000/ColecoVision/ADAM and TI-99/4a 16-color Palette
'       9 = Sinclair ZX Spectrum 16-color Palette
'      10 = Apple II/IIc/IIe 16-color Palette
'      11 = Aquarius 16-color Palette
'      12 = Custom AFlib III User-Defined Palette (first 16 colors ONLY!)
'----------------------------------------------------------------------

  Dim as Integer PalList_X, PalList_Y

  For PalList_X = 0 to 1 step 1
    For PalList_Y = 0 to 7 step 1
      Select Case palette_type
        Case is < 1
          AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 34), EGAcol(PalList_Y + (PalList_X * 8)), buffer
        Case 1
          AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 34), C64col(PalList_Y + (PalList_X * 8)), buffer
        Case 2
          AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 34), ARNEcol(PalList_Y + (PalList_X * 8)), buffer
        Case 3
          AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 34), FUN16col(PalList_Y + (PalList_X * 8)), buffer
        Case 4
          AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 34), INTVcol(PalList_Y + (PalList_X * 8)), buffer
        Case 5
          AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 34), PC6001col(PalList_Y + (PalList_X * 8)), buffer
        Case 6
          AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 34), VIC20col_NTSC(PalList_Y + (PalList_X * 8)), buffer
        Case 7
          AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 34), VIC20col_PAL(PalList_Y + (PalList_X * 8)), buffer
        Case 8
          AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 34), MSXcol(PalList_Y + (PalList_X * 8)), buffer
        Case 9
          AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 34), ZXcol(PalList_Y + (PalList_X * 8)), buffer
        Case 10
          AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 34), APPLEIIcol(PalList_Y + (PalList_X * 8)), buffer
        Case 11
          AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 34), AQUARcol(PalList_Y + (PalList_X * 8)), buffer
        Case is > 11
          AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 34), USERcol(PalList_Y + (PalList_X * 8)), buffer
      End Select
      If not Show_PalNo_Label = 0 then
        PrivateCol_Print Str(PalList_Y + (PalList_X * 8)), sx + ((PalList_X * 96) + 3), sy + ((PalList_Y * 34) + 3), 1, 1, RGB(16, 16, 16), RGB(16, 16, 16), 0, 2, 0, buffer
        PrivateCol_Print Str(PalList_Y + (PalList_X * 8)), sx + ((PalList_X * 96) + 3), sy + ((PalList_Y * 34) + 4), 1, 1, RGB(16, 16, 16), RGB(16, 16, 16), 0, 2, 0, buffer
        PrivateCol_Print Str(PalList_Y + (PalList_X * 8)), sx + ((PalList_X * 96) + 4), sy + ((PalList_Y * 34) + 3), 1, 1, RGB(16, 16, 16), RGB(16, 16, 16), 0, 2, 0, buffer
        PrivateCol_Print Str(PalList_Y + (PalList_X * 8)), sx + ((PalList_X * 96) + 4), sy + ((PalList_Y * 34) + 4), 1, 1, RGB(255, 255, 255), RGB(16, 16, 16), 0, 2, 0, buffer
      End If
    Next
  Next

End Sub



'_________________________________________________________________________
Sub AFlibIII_DisplayPal_32Col_RicherDetail ( Byval sx as Integer, _ 
                                             Byval sy as Integer, _
                                             Byval palette_type as Integer, _
                                             Byval Show_PalNo_Label as Integer = 1, _
                                             Byval buffer as Any Ptr = 0 )

'----------------------------------------------------------------------
' On "palette_type", pass:
'       0 = DawnBringer's 32-Color Palette (DB32)
'       1 = Custom AFlib III User-Defined Palette (first 32 colors ONLY!)
'----------------------------------------------------------------------

  Dim as Integer PalList_X, PalList_Y

  For PalList_X = 0 to 1 step 1
    For PalList_Y = 0 to 15 step 1
      Select Case palette_type
        Case is < 1
          AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 34), DB32col(PalList_Y + (PalList_X * 16)), buffer
        Case is > 0
          AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 34), USERcol(PalList_Y + (PalList_X * 16)), buffer
      End Select
      If not Show_PalNo_Label = 0 then
        PrivateCol_Print Str(PalList_Y + (PalList_X * 16)), sx + ((PalList_X * 96) + 3), sy + ((PalList_Y * 34) + 3), 1, 1, RGB(16, 16, 16), RGB(16, 16, 16), 0, 2, 0, buffer
        PrivateCol_Print Str(PalList_Y + (PalList_X * 16)), sx + ((PalList_X * 96) + 3), sy + ((PalList_Y * 34) + 4), 1, 1, RGB(16, 16, 16), RGB(16, 16, 16), 0, 2, 0, buffer
        PrivateCol_Print Str(PalList_Y + (PalList_X * 16)), sx + ((PalList_X * 96) + 4), sy + ((PalList_Y * 34) + 3), 1, 1, RGB(16, 16, 16), RGB(16, 16, 16), 0, 2, 0, buffer
        PrivateCol_Print Str(PalList_Y + (PalList_X * 16)), sx + ((PalList_X * 96) + 4), sy + ((PalList_Y * 34) + 4), 1, 1, RGB(255, 255, 255), RGB(16, 16, 16), 0, 2, 0, buffer
      End If
    Next
  Next

End Sub



'_________________________________________________________________________
Sub AFlibIII_DisplayPal_64Col_RicherDetail ( Byval sx as Integer, _ 
                                             Byval sy as Integer, _
                                             Byval palette_type as Integer, _
                                             Byval Show_PalNo_Label as Integer = 1, _
                                             Byval buffer as Any Ptr = 0 )

'----------------------------------------------------------------------
' On "palette_type", pass:
'       0 = Master System/Mark III Palette
'       1 = FC/FDS/NES Palette
'       2 = FamiCube 64-color Palette
'       3 = Custom AFlib III User-Defined Palette (first 64 colors ONLY!)
'----------------------------------------------------------------------

  Dim as Integer PalList_X, PalList_Y

  For PalList_X = 0 to 3 step 1
    For PalList_Y = 0 to 15 step 1
      Select Case palette_type
        Case is < 1
          AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 34), SMScol(PalList_Y + (PalList_X * 16)), buffer
        Case 1
          AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 34), NEScol(PalList_Y + (PalList_X * 16)), buffer
        Case 2
          AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 34), FCUBEcol(PalList_Y + (PalList_X * 16)), buffer
        Case is > 2
          AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 34), USERcol(PalList_Y + (PalList_X * 16)), buffer
      End Select
      If not Show_PalNo_Label = 0 then
        PrivateCol_Print Str(PalList_Y + (PalList_X * 16)), sx + ((PalList_X * 96) + 3), sy + ((PalList_Y * 34) + 3), 1, 1, RGB(16, 16, 16), RGB(16, 16, 16), 0, 2, 0, buffer
        PrivateCol_Print Str(PalList_Y + (PalList_X * 16)), sx + ((PalList_X * 96) + 3), sy + ((PalList_Y * 34) + 4), 1, 1, RGB(16, 16, 16), RGB(16, 16, 16), 0, 2, 0, buffer
        PrivateCol_Print Str(PalList_Y + (PalList_X * 16)), sx + ((PalList_X * 96) + 4), sy + ((PalList_Y * 34) + 3), 1, 1, RGB(16, 16, 16), RGB(16, 16, 16), 0, 2, 0, buffer
        PrivateCol_Print Str(PalList_Y + (PalList_X * 16)), sx + ((PalList_X * 96) + 4), sy + ((PalList_Y * 34) + 4), 1, 1, RGB(255, 255, 255), RGB(16, 16, 16), 0, 2, 0, buffer
      End If
    Next
  Next

End Sub



'_________________________________________________________________________
Sub AFlibIII_DisplayPal_128Col_RicherDetail ( Byval sx as Integer, _ 
                                              Byval sy as Integer, _
                                              Byval palette_type as Integer, _
                                              Byval Show_PalNo_Label as Integer = 1, _
                                              Byval buffer as Any Ptr = 0 )

'----------------------------------------------------------------------
' On "palette_type", pass:
'       0 = Atari 2600 Palette (NTSC version)
'       1 = Atari 2600 Palette (PAL version)
'       2 = Commodore Plus/4 Palette
'       3 = Sam Coupe 128-color Palette
'       4 = Custom AFlib III User-Defined Palette (first 128 colors ONLY!)
'----------------------------------------------------------------------

  Dim as Integer PalList_X, PalList_Y

  If palette_type > 1 then
    For PalList_X = 0 to 7 step 1
      For PalList_Y = 0 to 15 step 1
        Select Case palette_type
          Case 2
            AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 34), PLUS4col(PalList_Y + (PalList_X * 16)), buffer
          Case 3
            AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 34), SAMCOUPEcol(PalList_Y + (PalList_X * 16)), buffer
          Case is > 3
            AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 34), USERcol(PalList_Y + (PalList_X * 16)), buffer
        End Select
        If not Show_PalNo_Label = 0 then
          PrivateCol_Print Str(PalList_Y + (PalList_X * 16)), sx + ((PalList_X * 96) + 3), sy + ((PalList_Y * 34) + 3), 1, 1, RGB(16, 16, 16), RGB(16, 16, 16), 0, 2, 0, buffer
          PrivateCol_Print Str(PalList_Y + (PalList_X * 16)), sx + ((PalList_X * 96) + 3), sy + ((PalList_Y * 34) + 4), 1, 1, RGB(16, 16, 16), RGB(16, 16, 16), 0, 2, 0, buffer
          PrivateCol_Print Str(PalList_Y + (PalList_X * 16)), sx + ((PalList_X * 96) + 4), sy + ((PalList_Y * 34) + 3), 1, 1, RGB(16, 16, 16), RGB(16, 16, 16), 0, 2, 0, buffer
          PrivateCol_Print Str(PalList_Y + (PalList_X * 16)), sx + ((PalList_X * 96) + 4), sy + ((PalList_Y * 34) + 4), 1, 1, RGB(255, 255, 255), RGB(16, 16, 16), 0, 2, 0, buffer
        End If
      Next
    Next
  else
    For PalColumnDown as Integer = 0 to 1 step 1
      For PalList_X = 0 to 7 step 1
        For PalList_Y = 0 to 7 step 1
          Select Case palette_type
            Case is < 1
              AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 34) + (PalColumnDown * 296), ATARI2600col(PalList_Y + (PalList_X * 8) + (PalColumnDown * 64)), buffer
            Case 1
              AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 34) + (PalColumnDown * 296), PAL2600col(PalList_Y + (PalList_X * 8) + (PalColumnDown * 64)), buffer
          End Select
          If not Show_PalNo_Label = 0 then
            PrivateCol_Print Str(PalList_Y + (PalList_X * 8) + (PalColumnDown * 64)), sx + ((PalList_X * 96) + 3), sy + ((PalList_Y * 34) + (PalColumnDown * 296) + 3), 1, 1, RGB(16, 16, 16), RGB(16, 16, 16), 0, 2, 0, buffer
            PrivateCol_Print Str(PalList_Y + (PalList_X * 8) + (PalColumnDown * 64)), sx + ((PalList_X * 96) + 3), sy + ((PalList_Y * 34) + (PalColumnDown * 296) + 4), 1, 1, RGB(16, 16, 16), RGB(16, 16, 16), 0, 2, 0, buffer
            PrivateCol_Print Str(PalList_Y + (PalList_X * 8) + (PalColumnDown * 64)), sx + ((PalList_X * 96) + 4), sy + ((PalList_Y * 34) + (PalColumnDown * 296) + 3), 1, 1, RGB(16, 16, 16), RGB(16, 16, 16), 0, 2, 0, buffer
            PrivateCol_Print Str(PalList_Y + (PalList_X * 8) + (PalColumnDown * 64)), sx + ((PalList_X * 96) + 4), sy + ((PalList_Y * 34) + (PalColumnDown * 296) + 4), 1, 1, RGB(255, 255, 255), RGB(16, 16, 16), 0, 2, 0, buffer
          End If
        Next
      Next
    Next
  End if

End Sub



'_________________________________________________________________________
Sub AFlibIII_DisplayPal_256Col_RicherDetail ( Byval sx as Integer, _ 
                                              Byval sy as Integer, _
                                              Byval palette_type as Integer, _
                                              Byval Show_PalNo_Label as Integer = 1, _
                                              Byval buffer as Any Ptr = 0 )

'----------------------------------------------------------------------
' On "palette_type", pass:
'       0 = VGA 13h Palette
'       1 = Relsoft (Richard Eric M. Lope) Palette
'       2 = The AAP (Adigun Azikiwe Polack) 256-color Palette
'       3 = Atari 400/800/XL/XE Palette
'       4 = Atari 7800 Palette
'       5 = Enterprise 64/128 Home Computer 256-Color Palette
'       6 = Custom AFlib III User-Defined Palette (all 256 colors!!)
'----------------------------------------------------------------------

  Dim as Integer PalList_X, PalList_Y

  For PalList_X = 0 to 15 step 1
    For PalList_Y = 0 to 15 step 1
      Select Case palette_type
        Case is < 1
          AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 34), VGAcol(PalList_Y + (PalList_X * 16)), buffer
        Case 1
          AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 34), RELcol(PalList_Y + (PalList_X * 16)), buffer
        Case 2
          AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 34), AAPcol(PalList_Y + (PalList_X * 16)), buffer
        Case 3
          AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 34), ATARIcol(PalList_Y + (PalList_X * 16)), buffer
        Case 4
          AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 34), ATARI7800col(PalList_Y + (PalList_X * 16)), buffer
        Case 5
          AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 34), ENTERPRISEcol(PalList_Y + (PalList_X * 16)), buffer
        Case is > 5
          AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 34), USERcol(PalList_Y + (PalList_X * 16)), buffer
      End Select
      If not Show_PalNo_Label = 0 then
        PrivateCol_Print Str(PalList_Y + (PalList_X * 16)), sx + ((PalList_X * 96) + 3), sy + ((PalList_Y * 34) + 3), 1, 1, RGB(16, 16, 16), RGB(16, 16, 16), 0, 2, 0, buffer
        PrivateCol_Print Str(PalList_Y + (PalList_X * 16)), sx + ((PalList_X * 96) + 3), sy + ((PalList_Y * 34) + 4), 1, 1, RGB(16, 16, 16), RGB(16, 16, 16), 0, 2, 0, buffer
        PrivateCol_Print Str(PalList_Y + (PalList_X * 16)), sx + ((PalList_X * 96) + 4), sy + ((PalList_Y * 34) + 3), 1, 1, RGB(16, 16, 16), RGB(16, 16, 16), 0, 2, 0, buffer
        PrivateCol_Print Str(PalList_Y + (PalList_X * 16)), sx + ((PalList_X * 96) + 4), sy + ((PalList_Y * 34) + 4), 1, 1, RGB(255, 255, 255), RGB(16, 16, 16), 0, 2, 0, buffer
      End If
    Next
  Next

End Sub



'_________________________________________________________________________
Sub AFlibIII_DisplayPal_512Col_RicherDetail ( Byval sx as Integer, _ 
                                              Byval sy as Integer, _
                                              Byval palette_type as Integer, _
                                              Byval Show_PalNo_Label as Integer = 1, _
                                              Byval buffer as Any Ptr = 0 )

'----------------------------------------------------------------------
' On "palette_type", pass:
'       0 = RGB 9-bit (512-color) Palette
'       1 = Relsoft (Richard Eric M. Lope) Extended 512-Color Palette
'       2 = The AAP (Adigun Azikiwe Polack) Super-512 Palette
'----------------------------------------------------------------------

  Dim as Integer PalList_X, PalList_Y

  For PalList_X = 0 to 15 step 1
    For PalList_Y = 0 to 31 step 1
      Select Case palette_type
        Case is < 1
          AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 33), RGB512col(PalList_Y + (PalList_X * 32)), buffer
        Case 1
          AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 33), REL512col(PalList_Y + (PalList_X * 32)), buffer
        Case is > 1
          AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 33), AAP512col(PalList_Y + (PalList_X * 32)), buffer
      End Select
      If not Show_PalNo_Label = 0 then
        PrivateCol_Print Str(PalList_Y + (PalList_X * 32)), sx + ((PalList_X * 96) + 3), sy + ((PalList_Y * 33) + 3), 1, 1, RGB(16, 16, 16), RGB(16, 16, 16), 0, 2, 0, buffer
        PrivateCol_Print Str(PalList_Y + (PalList_X * 32)), sx + ((PalList_X * 96) + 3), sy + ((PalList_Y * 33) + 4), 1, 1, RGB(16, 16, 16), RGB(16, 16, 16), 0, 2, 0, buffer
        PrivateCol_Print Str(PalList_Y + (PalList_X * 32)), sx + ((PalList_X * 96) + 4), sy + ((PalList_Y * 33) + 3), 1, 1, RGB(16, 16, 16), RGB(16, 16, 16), 0, 2, 0, buffer
        PrivateCol_Print Str(PalList_Y + (PalList_X * 32)), sx + ((PalList_X * 96) + 4), sy + ((PalList_Y * 33) + 4), 1, 1, RGB(255, 255, 255), RGB(16, 16, 16), 0, 2, 0, buffer
      End If
    Next
  Next

End Sub



'_________________________________________________________________________
Sub AFlibIII_DisplayPal_CPC_RicherDetail ( Byval sx as Integer, _ 
                                           Byval sy as Integer, _
                                           Byval Show_PalNo_Label as Integer = 1, _
                                           Byval buffer as Any Ptr = 0 )

  Dim as Integer PalList_X, PalList_Y

  For PalList_X = 0 to 2 step 1
    For PalList_Y = 0 to 8 step 1
      AFlibIII_DisplayColorInfo sx + (PalList_X * 96), sy + (PalList_Y * 34), CPCcol(PalList_Y + (PalList_X * 9)), buffer
      If not Show_PalNo_Label = 0 then
        PrivateCol_Print Str(PalList_Y + (PalList_X * 9)), sx + ((PalList_X * 96) + 3), sy + ((PalList_Y * 34) + 3), 1, 1, RGB(16, 16, 16), RGB(16, 16, 16), 0, 2, 0, buffer
        PrivateCol_Print Str(PalList_Y + (PalList_X * 9)), sx + ((PalList_X * 96) + 3), sy + ((PalList_Y * 34) + 4), 1, 1, RGB(16, 16, 16), RGB(16, 16, 16), 0, 2, 0, buffer
        PrivateCol_Print Str(PalList_Y + (PalList_X * 9)), sx + ((PalList_X * 96) + 4), sy + ((PalList_Y * 34) + 3), 1, 1, RGB(16, 16, 16), RGB(16, 16, 16), 0, 2, 0, buffer
        PrivateCol_Print Str(PalList_Y + (PalList_X * 9)), sx + ((PalList_X * 96) + 4), sy + ((PalList_Y * 34) + 4), 1, 1, RGB(255, 255, 255), RGB(16, 16, 16), 0, 2, 0, buffer
      End If
    Next
  Next

End Sub



'_________________________________________________________________________
Sub AFlibIII_ReplaceColor ( Byval buffer as Any Ptr = 0, _
                            Byval From_col As Integer, _
                            Byval To_col As Integer )

'----------------------------------------------------------------------
' BIG special thanks to dodicat for this FANTASTIC color-changing
' pixel routine in 24- to 32-bit color!!!  d=^-^=b !!
'----------------------------------------------------------------------

  Dim as Integer Gfx_horiz, Gfx_vert, BPP
  ScreenInfo , , BPP
  If BPP < 24 then Exit Sub
  
  Dim tempbuffer as any ptr = 0
  Dim AF3_PaletteSnapshot as any ptr = 0

  If buffer = 0 then
    ScreenInfo Gfx_horiz, Gfx_vert
    AF3_PaletteSnapshot = ImageCreate(Gfx_horiz, Gfx_vert)
    Get (0, 0)-(Gfx_horiz - 1, Gfx_vert - 1), AF3_PaletteSnapshot
    AF3_PaletteSnapshot = PrivateColRep(AF3_PaletteSnapshot, From_col, To_col)
    Put (0, 0), AF3_PaletteSnapshot, trans
    ImageDestroy AF3_PaletteSnapshot
  else
    PrivateCol_check_buffersize buffer, Gfx_horiz, Gfx_vert
    tempbuffer = ImageCreate (Gfx_horiz, Gfx_vert)
    Get buffer, (0, 0)-(Gfx_horiz - 1, Gfx_vert - 1), tempbuffer
    tempbuffer = PrivateColRep(tempbuffer, From_col, To_col)
    Put buffer, (0, 0), tempbuffer, trans
    ImageDestroy tempbuffer
  End if
End Sub



'_________________________________________________________________________
Sub AFlibIII_Replace2Colors ( Byval buffer as Any Ptr = 0, _
                              Byval From_col_1 As Integer, Byval To_col_1 As Integer, _
                              Byval From_col_2 As Integer, Byval To_col_2 As Integer )

'----------------------------------------------------------------------
' BIG special thanks to dodicat for this FANTASTIC color-changing
' pixel routine in 24- to 32-bit color!!!  d=^-^=b !!
'----------------------------------------------------------------------

  Dim as Integer Gfx_horiz, Gfx_vert, BPP
  ScreenInfo , , BPP
  If BPP < 24 then Exit Sub
  
  Dim tempbuffer as any ptr = 0
  Dim AF3_PaletteSnapshot as any ptr = 0
  
  If buffer = 0 then
    ScreenInfo Gfx_horiz, Gfx_vert
    AF3_PaletteSnapshot = ImageCreate(Gfx_horiz, Gfx_vert)
    Get (0, 0)-(Gfx_horiz - 1, Gfx_vert - 1), AF3_PaletteSnapshot
    AF3_PaletteSnapshot = PrivateColRep_2colors(AF3_PaletteSnapshot, _
                                                From_col_1, To_col_1, _
                                                From_col_2, To_col_2)
    Put (0, 0), AF3_PaletteSnapshot, trans
    ImageDestroy AF3_PaletteSnapshot
  else
    PrivateCol_check_buffersize buffer, Gfx_horiz, Gfx_vert
    tempbuffer = ImageCreate (Gfx_horiz, Gfx_vert)
    Get buffer, (0, 0)-(Gfx_horiz - 1, Gfx_vert - 1), tempbuffer
    tempbuffer = PrivateColRep_2colors(tempbuffer, _
                                       From_col_1, To_col_1, _
                                       From_col_2, To_col_2)
    Put buffer, (0, 0), tempbuffer, trans
    ImageDestroy tempbuffer
  End if
End Sub



'_________________________________________________________________________
Sub AFlibIII_Replace4Colors ( Byval buffer as Any Ptr = 0, _
                              Byval From_col_1 As Integer, Byval To_col_1 As Integer, _
                              Byval From_col_2 As Integer, Byval To_col_2 As Integer, _
                              Byval From_col_3 As Integer, Byval To_col_3 As Integer, _
                              Byval From_col_4 As Integer, Byval To_col_4 As Integer )

'----------------------------------------------------------------------
' BIG special thanks to dodicat for this FANTASTIC color-changing
' pixel routine in 24- to 32-bit color!!!  d=^-^=b !!
'----------------------------------------------------------------------

  Dim as Integer Gfx_horiz, Gfx_vert, BPP
  ScreenInfo , , BPP
  If BPP < 24 then Exit Sub
  
  Dim tempbuffer as any ptr = 0
  Dim AF3_PaletteSnapshot as any ptr = 0

  If buffer = 0 then
    ScreenInfo Gfx_horiz, Gfx_vert
    AF3_PaletteSnapshot = ImageCreate(Gfx_horiz, Gfx_vert)
    Get (0, 0)-(Gfx_horiz - 1, Gfx_vert - 1), AF3_PaletteSnapshot
    AF3_PaletteSnapshot = PrivateColRep_4colors(AF3_PaletteSnapshot, _
                                                From_col_1, To_col_1, _
                                                From_col_2, To_col_2, _
                                                From_col_3, To_col_3, _
                                                From_col_4, To_col_4)
    Put (0, 0), AF3_PaletteSnapshot, trans
    ImageDestroy AF3_PaletteSnapshot
  else
    PrivateCol_check_buffersize buffer, Gfx_horiz, Gfx_vert
    tempbuffer = ImageCreate (Gfx_horiz, Gfx_vert)
    Get buffer, (0, 0)-(Gfx_horiz - 1, Gfx_vert - 1), tempbuffer
    tempbuffer = PrivateColRep_4colors(tempbuffer, _
                                       From_col_1, To_col_1, _
                                       From_col_2, To_col_2, _
                                       From_col_3, To_col_3, _
                                       From_col_4, To_col_4)
    Put buffer, (0, 0), tempbuffer, trans
    ImageDestroy tempbuffer
  End if
End Sub



'_________________________________________________________________________
Sub AFlibIII_Replace8Colors ( Byval buffer as Any Ptr = 0, _
                              Byval From_col_1 As Integer, Byval To_col_1 As Integer, _
                              Byval From_col_2 As Integer, Byval To_col_2 As Integer, _
                              Byval From_col_3 As Integer, Byval To_col_3 As Integer, _
                              Byval From_col_4 As Integer, Byval To_col_4 As Integer, _
                              Byval From_col_5 As Integer, Byval To_col_5 As Integer, _
                              Byval From_col_6 As Integer, Byval To_col_6 As Integer, _
                              Byval From_col_7 As Integer, Byval To_col_7 As Integer, _
                              Byval From_col_8 As Integer, Byval To_col_8 As Integer )

'----------------------------------------------------------------------
' BIG special thanks to dodicat for this FANTASTIC color-changing
' pixel routine in 24- to 32-bit color!!!  d=^-^=b !!
'----------------------------------------------------------------------

  Dim as Integer Gfx_horiz, Gfx_vert, BPP
  ScreenInfo , , BPP
  If BPP < 24 then Exit Sub
  
  Dim tempbuffer as any ptr = 0
  Dim AF3_PaletteSnapshot as any ptr = 0

  If buffer = 0 then
    ScreenInfo Gfx_horiz, Gfx_vert
    AF3_PaletteSnapshot = ImageCreate(Gfx_horiz, Gfx_vert)
    Get (0, 0)-(Gfx_horiz - 1, Gfx_vert - 1), AF3_PaletteSnapshot
    AF3_PaletteSnapshot = PrivateColRep_8colors(AF3_PaletteSnapshot, _
                                                From_col_1, To_col_1, _
                                                From_col_2, To_col_2, _
                                                From_col_3, To_col_3, _
                                                From_col_4, To_col_4, _
                                                From_col_5, To_col_5, _
                                                From_col_6, To_col_6, _
                                                From_col_7, To_col_7, _
                                                From_col_8, To_col_8)
    Put (0, 0), AF3_PaletteSnapshot, trans
    ImageDestroy AF3_PaletteSnapshot
  else
    PrivateCol_check_buffersize buffer, Gfx_horiz, Gfx_vert
    tempbuffer = ImageCreate (Gfx_horiz, Gfx_vert)
    Get buffer, (0, 0)-(Gfx_horiz - 1, Gfx_vert - 1), tempbuffer
    tempbuffer = PrivateColRep_8colors(tempbuffer, _
                                       From_col_1, To_col_1, _
                                       From_col_2, To_col_2, _
                                       From_col_3, To_col_3, _
                                       From_col_4, To_col_4, _
                                       From_col_5, To_col_5, _
                                       From_col_6, To_col_6, _
                                       From_col_7, To_col_7, _
                                       From_col_8, To_col_8)
    Put buffer, (0, 0), tempbuffer, trans
    ImageDestroy tempbuffer
  End if
End Sub



'_________________________________________________________________________
Sub AFlibIII_Replace16Colors ( Byval buffer as Any Ptr = 0, _
                               Byval From_col_1 As Integer, Byval To_col_1 As Integer, _
                               Byval From_col_2 As Integer, Byval To_col_2 As Integer, _
                               Byval From_col_3 As Integer, Byval To_col_3 As Integer, _
                               Byval From_col_4 As Integer, Byval To_col_4 As Integer, _
                               Byval From_col_5 As Integer, Byval To_col_5 As Integer, _
                               Byval From_col_6 As Integer, Byval To_col_6 As Integer, _
                               Byval From_col_7 As Integer, Byval To_col_7 As Integer, _
                               Byval From_col_8 As Integer, Byval To_col_8 As Integer, _
                               Byval From_col_9 As Integer, Byval To_col_9 As Integer, _
                               Byval From_col_10 As Integer, Byval To_col_10 As Integer, _
                               Byval From_col_11 As Integer, Byval To_col_11 As Integer, _
                               Byval From_col_12 As Integer, Byval To_col_12 As Integer, _
                               Byval From_col_13 As Integer, Byval To_col_13 As Integer, _
                               Byval From_col_14 As Integer, Byval To_col_14 As Integer, _
                               Byval From_col_15 As Integer, Byval To_col_15 As Integer, _
                               Byval From_col_16 As Integer, Byval To_col_16 As Integer )

'----------------------------------------------------------------------
' BIG special thanks to dodicat for this FANTASTIC color-changing
' pixel routine in 24- to 32-bit color!!!  d=^-^=b !!
'----------------------------------------------------------------------

  Dim as Integer Gfx_horiz, Gfx_vert, BPP
  ScreenInfo , , BPP
  If BPP < 24 then Exit Sub
  
  Dim tempbuffer as any ptr = 0
  Dim AF3_PaletteSnapshot as any ptr = 0

  If buffer = 0 then
    ScreenInfo Gfx_horiz, Gfx_vert
    AF3_PaletteSnapshot = ImageCreate(Gfx_horiz, Gfx_vert)
    Get (0, 0)-(Gfx_horiz - 1, Gfx_vert - 1), AF3_PaletteSnapshot
    AF3_PaletteSnapshot = PrivateColRep_16colors(AF3_PaletteSnapshot, _
                                                 From_col_1, To_col_1, _
                                                 From_col_2, To_col_2, _
                                                 From_col_3, To_col_3, _
                                                 From_col_4, To_col_4, _
                                                 From_col_5, To_col_5, _
                                                 From_col_6, To_col_6, _
                                                 From_col_7, To_col_7, _
                                                 From_col_8, To_col_8, _
                                                 From_col_9, To_col_9, _
                                                 From_col_10, To_col_10, _
                                                 From_col_11, To_col_11, _
                                                 From_col_12, To_col_12, _
                                                 From_col_13, To_col_13, _
                                                 From_col_14, To_col_14, _
                                                 From_col_15, To_col_15, _
                                                 From_col_16, To_col_16)
    Put (0, 0), AF3_PaletteSnapshot, trans
    ImageDestroy AF3_PaletteSnapshot
  else
    PrivateCol_check_buffersize buffer, Gfx_horiz, Gfx_vert
    tempbuffer = ImageCreate (Gfx_horiz, Gfx_vert)
    Get buffer, (0, 0)-(Gfx_horiz - 1, Gfx_vert - 1), tempbuffer
    tempbuffer = PrivateColRep_16colors(tempbuffer, _
                                        From_col_1, To_col_1, _
                                        From_col_2, To_col_2, _
                                        From_col_3, To_col_3, _
                                        From_col_4, To_col_4, _
                                        From_col_5, To_col_5, _
                                        From_col_6, To_col_6, _
                                        From_col_7, To_col_7, _
                                        From_col_8, To_col_8, _
                                        From_col_9, To_col_9, _
                                        From_col_10, To_col_10, _
                                        From_col_11, To_col_11, _
                                        From_col_12, To_col_12, _
                                        From_col_13, To_col_13, _
                                        From_col_14, To_col_14, _
                                        From_col_15, To_col_15, _
                                        From_col_16, To_col_16)
    Put buffer, (0, 0), tempbuffer, trans
    ImageDestroy tempbuffer
  End if
End Sub



'_________________________________________________________________________
Sub AFlibIII_ReplaceColor_Wildcard ( Byval buffer as Any Ptr = 0, _
                                     Byval From_col_1 As Integer,     Byval To_col_1 As Integer, _
                                     Byval From_col_2 As Integer = 0, Byval To_col_2 As Integer = 0, _
                                     Byval From_col_3 As Integer = 0, Byval To_col_3 As Integer = 0, _
                                     Byval From_col_4 As Integer = 0, Byval To_col_4 As Integer = 0, _
                                     Byval From_col_5 As Integer = 0, Byval To_col_5 As Integer = 0, _
                                     Byval From_col_6 As Integer = 0, Byval To_col_6 As Integer = 0, _
                                     Byval From_col_7 As Integer = 0, Byval To_col_7 As Integer = 0, _
                                     Byval From_col_8 As Integer = 0, Byval To_col_8 As Integer = 0, _
                                     Byval From_col_9 As Integer = 0, Byval To_col_9 As Integer = 0, _
                                     Byval From_col_10 As Integer = 0, Byval To_col_10 As Integer = 0, _
                                     Byval From_col_11 As Integer = 0, Byval To_col_11 As Integer = 0, _
                                     Byval From_col_12 As Integer = 0, Byval To_col_12 As Integer = 0, _
                                     Byval From_col_13 As Integer = 0, Byval To_col_13 As Integer = 0, _
                                     Byval From_col_14 As Integer = 0, Byval To_col_14 As Integer = 0, _
                                     Byval From_col_15 As Integer = 0, Byval To_col_15 As Integer = 0, _
                                     Byval From_col_16 As Integer = 0, Byval To_col_16 As Integer = 0, _
                                     Byval From_col_17 As Integer = 0, Byval To_col_17 As Integer = 0, _
                                     Byval From_col_18 As Integer = 0, Byval To_col_18 As Integer = 0, _
                                     Byval From_col_19 As Integer = 0, Byval To_col_19 As Integer = 0, _
                                     Byval From_col_20 As Integer = 0, Byval To_col_20 As Integer = 0, _
                                     Byval From_col_21 As Integer = 0, Byval To_col_21 As Integer = 0, _
                                     Byval From_col_22 As Integer = 0, Byval To_col_22 As Integer = 0, _
                                     Byval From_col_23 As Integer = 0, Byval To_col_23 As Integer = 0, _
                                     Byval From_col_24 As Integer = 0, Byval To_col_24 As Integer = 0, _
                                     Byval From_col_25 As Integer = 0, Byval To_col_25 As Integer = 0, _
                                     Byval From_col_26 As Integer = 0, Byval To_col_26 As Integer = 0, _
                                     Byval From_col_27 As Integer = 0, Byval To_col_27 As Integer = 0, _
                                     Byval From_col_28 As Integer = 0, Byval To_col_28 As Integer = 0, _
                                     Byval From_col_29 As Integer = 0, Byval To_col_29 As Integer = 0, _
                                     Byval From_col_30 As Integer = 0, Byval To_col_30 As Integer = 0)

'----------------------------------------------------------------------
' BIG special thanks to dodicat for this FANTASTIC color-changing
' pixel routine in 24- to 32-bit color!!!  d=^-^=b !!
'----------------------------------------------------------------------

  Dim as Integer Gfx_horiz, Gfx_vert, BPP
  ScreenInfo , , BPP
  If BPP < 24 then Exit Sub
  
  Dim tempbuffer as any ptr = 0
  Dim AF3_PaletteSnapshot as any ptr = 0

  If buffer = 0 then
    ScreenInfo Gfx_horiz, Gfx_vert
    AF3_PaletteSnapshot = ImageCreate(Gfx_horiz, Gfx_vert)
    Get (0, 0)-(Gfx_horiz - 1, Gfx_vert - 1), AF3_PaletteSnapshot
    AF3_PaletteSnapshot = PrivateColRep_30colors(AF3_PaletteSnapshot, _
                                                 From_col_1, To_col_1, _
                                                 From_col_2, To_col_2, _
                                                 From_col_3, To_col_3, _
                                                 From_col_4, To_col_4, _
                                                 From_col_5, To_col_5, _
                                                 From_col_6, To_col_6, _
                                                 From_col_7, To_col_7, _
                                                 From_col_8, To_col_8, _
                                                 From_col_9, To_col_9, _
                                                 From_col_10, To_col_10, _
                                                 From_col_11, To_col_11, _
                                                 From_col_12, To_col_12, _
                                                 From_col_13, To_col_13, _
                                                 From_col_14, To_col_14, _
                                                 From_col_15, To_col_15, _
                                                 From_col_16, To_col_16, _
                                                 From_col_17, To_col_17, _
                                                 From_col_18, To_col_18, _
                                                 From_col_19, To_col_19, _
                                                 From_col_20, To_col_20, _
                                                 From_col_21, To_col_21, _
                                                 From_col_22, To_col_22, _
                                                 From_col_23, To_col_23, _
                                                 From_col_24, To_col_24, _
                                                 From_col_25, To_col_25, _
                                                 From_col_26, To_col_26, _
                                                 From_col_27, To_col_27, _
                                                 From_col_28, To_col_28, _
                                                 From_col_29, To_col_29, _
                                                 From_col_30, To_col_30)
    Put (0, 0), AF3_PaletteSnapshot, trans
    ImageDestroy AF3_PaletteSnapshot
  else
    PrivateCol_check_buffersize buffer, Gfx_horiz, Gfx_vert
    tempbuffer = ImageCreate (Gfx_horiz, Gfx_vert)
    Get buffer, (0, 0)-(Gfx_horiz - 1, Gfx_vert - 1), tempbuffer
    tempbuffer = PrivateColRep_30colors(tempbuffer, _
                                        From_col_1, To_col_1, _
                                        From_col_2, To_col_2, _
                                        From_col_3, To_col_3, _
                                        From_col_4, To_col_4, _
                                        From_col_5, To_col_5, _
                                        From_col_6, To_col_6, _
                                        From_col_7, To_col_7, _
                                        From_col_8, To_col_8, _
                                        From_col_9, To_col_9, _
                                        From_col_10, To_col_10, _
                                        From_col_11, To_col_11, _
                                        From_col_12, To_col_12, _
                                        From_col_13, To_col_13, _
                                        From_col_14, To_col_14, _
                                        From_col_15, To_col_15, _
                                        From_col_16, To_col_16, _
                                        From_col_17, To_col_17, _
                                        From_col_18, To_col_18, _
                                        From_col_19, To_col_19, _
                                        From_col_20, To_col_20, _
                                        From_col_21, To_col_21, _
                                        From_col_22, To_col_22, _
                                        From_col_23, To_col_23, _
                                        From_col_24, To_col_24, _
                                        From_col_25, To_col_25, _
                                        From_col_26, To_col_26, _
                                        From_col_27, To_col_27, _
                                        From_col_28, To_col_28, _
                                        From_col_29, To_col_29, _
                                        From_col_30, To_col_30)
    Put buffer, (0, 0), tempbuffer, trans
    ImageDestroy tempbuffer
  End if
End Sub



'_________________________________________________________________________
Sub AFlibIII_Any64Color_LockON ( Byval Any16ColorColumn_from_0_to_3 As Integer, _
                                 Byval From_col_1 As Integer,     Byval To_col_1 As Integer, _
                                 Byval From_col_2 As Integer = 0, Byval To_col_2 As Integer = 0, _
                                 Byval From_col_3 As Integer = 0, Byval To_col_3 As Integer = 0, _
                                 Byval From_col_4 As Integer = 0, Byval To_col_4 As Integer = 0, _
                                 Byval From_col_5 As Integer = 0, Byval To_col_5 As Integer = 0, _
                                 Byval From_col_6 As Integer = 0, Byval To_col_6 As Integer = 0, _
                                 Byval From_col_7 As Integer = 0, Byval To_col_7 As Integer = 0, _
                                 Byval From_col_8 As Integer = 0, Byval To_col_8 As Integer = 0, _
                                 Byval From_col_9 As Integer = 0, Byval To_col_9 As Integer = 0, _
                                 Byval From_col_10 As Integer = 0, Byval To_col_10 As Integer = 0, _
                                 Byval From_col_11 As Integer = 0, Byval To_col_11 As Integer = 0, _
                                 Byval From_col_12 As Integer = 0, Byval To_col_12 As Integer = 0, _
                                 Byval From_col_13 As Integer = 0, Byval To_col_13 As Integer = 0, _
                                 Byval From_col_14 As Integer = 0, Byval To_col_14 As Integer = 0, _
                                 Byval From_col_15 As Integer = 0, Byval To_col_15 As Integer = 0, _
                                 Byval From_col_16 As Integer = 0, Byval To_col_16 As Integer = 0 )

  Dim Any16CC_Use as Integer
  If Any16ColorColumn_from_0_to_3 < 0 then Any16ColorColumn_from_0_to_3 = 0
  If Any16ColorColumn_from_0_to_3 > 3 then Any16ColorColumn_from_0_to_3 = 3
  
  Any16CC_Use = Any16ColorColumn_from_0_to_3
  
  Start64_CUSTcol(0 + (Any16CC_Use * 16)) = From_col_1: End64_CUSTcol(0 + (Any16CC_Use * 16)) = To_col_1
  Start64_CUSTcol(1 + (Any16CC_Use * 16)) = From_col_2: End64_CUSTcol(1 + (Any16CC_Use * 16)) = To_col_2
  Start64_CUSTcol(2 + (Any16CC_Use * 16)) = From_col_3: End64_CUSTcol(2 + (Any16CC_Use * 16)) = To_col_3
  Start64_CUSTcol(3 + (Any16CC_Use * 16)) = From_col_4: End64_CUSTcol(3 + (Any16CC_Use * 16)) = To_col_4
  Start64_CUSTcol(4 + (Any16CC_Use * 16)) = From_col_5: End64_CUSTcol(4 + (Any16CC_Use * 16)) = To_col_5
  Start64_CUSTcol(5 + (Any16CC_Use * 16)) = From_col_6: End64_CUSTcol(5 + (Any16CC_Use * 16)) = To_col_6
  Start64_CUSTcol(6 + (Any16CC_Use * 16)) = From_col_7: End64_CUSTcol(6 + (Any16CC_Use * 16)) = To_col_7
  Start64_CUSTcol(7 + (Any16CC_Use * 16)) = From_col_8: End64_CUSTcol(7 + (Any16CC_Use * 16)) = To_col_8
  Start64_CUSTcol(8 + (Any16CC_Use * 16)) = From_col_9: End64_CUSTcol(8 + (Any16CC_Use * 16)) = To_col_9
  Start64_CUSTcol(9 + (Any16CC_Use * 16)) = From_col_10: End64_CUSTcol(9 + (Any16CC_Use * 16)) = To_col_10
  Start64_CUSTcol(10 + (Any16CC_Use * 16)) = From_col_11: End64_CUSTcol(10 + (Any16CC_Use * 16)) = To_col_11
  Start64_CUSTcol(11 + (Any16CC_Use * 16)) = From_col_12: End64_CUSTcol(11 + (Any16CC_Use * 16)) = To_col_12
  Start64_CUSTcol(12 + (Any16CC_Use * 16)) = From_col_13: End64_CUSTcol(12 + (Any16CC_Use * 16)) = To_col_13
  Start64_CUSTcol(13 + (Any16CC_Use * 16)) = From_col_14: End64_CUSTcol(13 + (Any16CC_Use * 16)) = To_col_14
  Start64_CUSTcol(14 + (Any16CC_Use * 16)) = From_col_15: End64_CUSTcol(14 + (Any16CC_Use * 16)) = To_col_15
  Start64_CUSTcol(15 + (Any16CC_Use * 16)) = From_col_16: End64_CUSTcol(15 + (Any16CC_Use * 16)) = To_col_16
End Sub



'_________________________________________________________________________
Sub AFlibIII_Any256Color_LockON ( Byval Any16ColorColumn_from_0_to_15 As Integer, _
                                  Byval From_col_1 As Integer,     Byval To_col_1 As Integer, _
                                  Byval From_col_2 As Integer = 0, Byval To_col_2 As Integer = 0, _
                                  Byval From_col_3 As Integer = 0, Byval To_col_3 As Integer = 0, _
                                  Byval From_col_4 As Integer = 0, Byval To_col_4 As Integer = 0, _
                                  Byval From_col_5 As Integer = 0, Byval To_col_5 As Integer = 0, _
                                  Byval From_col_6 As Integer = 0, Byval To_col_6 As Integer = 0, _
                                  Byval From_col_7 As Integer = 0, Byval To_col_7 As Integer = 0, _
                                  Byval From_col_8 As Integer = 0, Byval To_col_8 As Integer = 0, _
                                  Byval From_col_9 As Integer = 0, Byval To_col_9 As Integer = 0, _
                                  Byval From_col_10 As Integer = 0, Byval To_col_10 As Integer = 0, _
                                  Byval From_col_11 As Integer = 0, Byval To_col_11 As Integer = 0, _
                                  Byval From_col_12 As Integer = 0, Byval To_col_12 As Integer = 0, _
                                  Byval From_col_13 As Integer = 0, Byval To_col_13 As Integer = 0, _
                                  Byval From_col_14 As Integer = 0, Byval To_col_14 As Integer = 0, _
                                  Byval From_col_15 As Integer = 0, Byval To_col_15 As Integer = 0, _
                                  Byval From_col_16 As Integer = 0, Byval To_col_16 As Integer = 0 )

  Dim Any16CC_Use as Integer
  If Any16ColorColumn_from_0_to_15 < 0 then Any16ColorColumn_from_0_to_15 = 0
  If Any16ColorColumn_from_0_to_15 > 15 then Any16ColorColumn_from_0_to_15 = 15
  
  Any16CC_Use = Any16ColorColumn_from_0_to_15
  
  Start256_CUSTcol(0 + (Any16CC_Use * 16)) = From_col_1: End256_CUSTcol(0 + (Any16CC_Use * 16)) = To_col_1
  Start256_CUSTcol(1 + (Any16CC_Use * 16)) = From_col_2: End256_CUSTcol(1 + (Any16CC_Use * 16)) = To_col_2
  Start256_CUSTcol(2 + (Any16CC_Use * 16)) = From_col_3: End256_CUSTcol(2 + (Any16CC_Use * 16)) = To_col_3
  Start256_CUSTcol(3 + (Any16CC_Use * 16)) = From_col_4: End256_CUSTcol(3 + (Any16CC_Use * 16)) = To_col_4
  Start256_CUSTcol(4 + (Any16CC_Use * 16)) = From_col_5: End256_CUSTcol(4 + (Any16CC_Use * 16)) = To_col_5
  Start256_CUSTcol(5 + (Any16CC_Use * 16)) = From_col_6: End256_CUSTcol(5 + (Any16CC_Use * 16)) = To_col_6
  Start256_CUSTcol(6 + (Any16CC_Use * 16)) = From_col_7: End256_CUSTcol(6 + (Any16CC_Use * 16)) = To_col_7
  Start256_CUSTcol(7 + (Any16CC_Use * 16)) = From_col_8: End256_CUSTcol(7 + (Any16CC_Use * 16)) = To_col_8
  Start256_CUSTcol(8 + (Any16CC_Use * 16)) = From_col_9: End256_CUSTcol(8 + (Any16CC_Use * 16)) = To_col_9
  Start256_CUSTcol(9 + (Any16CC_Use * 16)) = From_col_10: End256_CUSTcol(9 + (Any16CC_Use * 16)) = To_col_10
  Start256_CUSTcol(10 + (Any16CC_Use * 16)) = From_col_11: End256_CUSTcol(10 + (Any16CC_Use * 16)) = To_col_11
  Start256_CUSTcol(11 + (Any16CC_Use * 16)) = From_col_12: End256_CUSTcol(11 + (Any16CC_Use * 16)) = To_col_12
  Start256_CUSTcol(12 + (Any16CC_Use * 16)) = From_col_13: End256_CUSTcol(12 + (Any16CC_Use * 16)) = To_col_13
  Start256_CUSTcol(13 + (Any16CC_Use * 16)) = From_col_14: End256_CUSTcol(13 + (Any16CC_Use * 16)) = To_col_14
  Start256_CUSTcol(14 + (Any16CC_Use * 16)) = From_col_15: End256_CUSTcol(14 + (Any16CC_Use * 16)) = To_col_15
  Start256_CUSTcol(15 + (Any16CC_Use * 16)) = From_col_16: End256_CUSTcol(15 + (Any16CC_Use * 16)) = To_col_16
End Sub



'_________________________________________________________________________
Sub AFlibIII_Any64Color_Click ( Byval buffer as Any Ptr = 0 )
  Dim as Integer Gfx_horiz, Gfx_vert, BPP
  ScreenInfo , , BPP
  If BPP < 24 then Exit Sub
  
  Dim tempbuffer as any ptr = 0
  Dim AF3_PaletteSnapshot as any ptr = 0

  If buffer = 0 then
    ScreenInfo Gfx_horiz, Gfx_vert
    AF3_PaletteSnapshot = ImageCreate(Gfx_horiz, Gfx_vert)
    Get (0, 0)-(Gfx_horiz - 1, Gfx_vert - 1), AF3_PaletteSnapshot
    AF3_PaletteSnapshot = PrivateColRep_64colors(AF3_PaletteSnapshot)
    Put (0, 0), AF3_PaletteSnapshot, trans
    ImageDestroy AF3_PaletteSnapshot
  else
    PrivateCol_check_buffersize buffer, Gfx_horiz, Gfx_vert
    tempbuffer = ImageCreate (Gfx_horiz, Gfx_vert)
    Get buffer, (0, 0)-(Gfx_horiz - 1, Gfx_vert - 1), tempbuffer
    tempbuffer = PrivateColRep_64colors(tempbuffer)
    Put buffer, (0, 0), tempbuffer, trans
    ImageDestroy tempbuffer
  End if
End Sub



'_________________________________________________________________________
Sub AFlibIII_Any256Color_Click ( Byval buffer as Any Ptr = 0 )
  Dim as Integer Gfx_horiz, Gfx_vert, BPP
  ScreenInfo , , BPP
  If BPP < 24 then Exit Sub
  
  Dim tempbuffer as any ptr = 0
  Dim AF3_PaletteSnapshot as any ptr = 0

  If buffer = 0 then
    ScreenInfo Gfx_horiz, Gfx_vert
    AF3_PaletteSnapshot = ImageCreate(Gfx_horiz, Gfx_vert)
    Get (0, 0)-(Gfx_horiz - 1, Gfx_vert - 1), AF3_PaletteSnapshot
    AF3_PaletteSnapshot = PrivateColRep_256colors(AF3_PaletteSnapshot)
    Put (0, 0), AF3_PaletteSnapshot, trans
    ImageDestroy AF3_PaletteSnapshot
  else
    PrivateCol_check_buffersize buffer, Gfx_horiz, Gfx_vert
    tempbuffer = ImageCreate (Gfx_horiz, Gfx_vert)
    Get buffer, (0, 0)-(Gfx_horiz - 1, Gfx_vert - 1), tempbuffer
    tempbuffer = PrivateColRep_256colors(tempbuffer)
    Put buffer, (0, 0), tempbuffer, trans
    ImageDestroy tempbuffer
  End if
End Sub



'_________________________________________________________________________
Sub AFlibIII_CopyPal_to_UserPal ( Byval PaletteType as Integer )
  
  Dim PalArray as Integer

  Select Case PaletteType
    Case 0:
      For PalArray = 0 to 255
        If ATARIcol(PalArray) = RGB(255, 0, 255) then ATARIcol(PalArray) = RGB(255, 4, 255)
        USERcol(PalArray) = ATARIcol(PalArray)
      Next
    Case 1:
      For PalArray = 0 to 255
        If RELcol(PalArray) = RGB(255, 0, 255) then RELcol(PalArray) = RGB(255, 4, 255)
        USERcol(PalArray) = RELcol(PalArray)
      Next
    Case 2:
      For PalArray = 0 to 255
        If AAPcol(PalArray) = RGB(255, 0, 255) then AAPcol(PalArray) = RGB(255, 4, 255)
        USERcol(PalArray) = AAPcol(PalArray)
      Next
    Case 3:
      For PalArray = 0 to 255
        If VGAcol(PalArray) = RGB(255, 0, 255) then VGAcol(PalArray) = RGB(255, 4, 255)
        USERcol(PalArray) = VGAcol(PalArray)
      Next
  End Select

End Sub



'_________________________________________________________________________
Sub AFlibIII_LoadDOS768Pal_to_UserPal (Byref PalFile as String)

  Dim ff as Integer
  Dim as String Bc, Red, Green, Blue

  Bc = " ": ff = FREEFILE             '\
  Open PalFile for Binary as ff       ' \
    For I as Integer = 0 TO 255       '  \
      Get #1, , Bc: Red = Bc          '   \ This .PAL entry ONLY applies
      Get #1, , Bc: Green = Bc        '    >for palettes with 768 bytes!
      Get #1, , Bc: Blue = Bc         '   /                    ~~~~~~~~~
      USERcol(I) = RGB(ASC(Red) * 4.05, ASC(Green) * 4.05, ASC(Blue) * 4.05)
      If USERcol(I) = RGB(255, 0, 255) then USERcol(I) = RGB(255, 4, 255)
    Next                              ' /
  Close ff                            '/

End Sub



'_________________________________________________________________________
Sub AFlibIII_Load768Pal_to_UserPal (Byref PalFile as String)

  Dim ff as Integer
  Dim as String Bc, Red, Green, Blue

  Bc = " ": ff = FREEFILE             '\
  Open PalFile for Binary as ff       ' \
    For I as Integer = 0 TO 255       '  \
      Get #1, , Bc: Red = Bc          '   \ This .PAL entry ONLY applies
      Get #1, , Bc: Green = Bc        '    >for palettes with 768 bytes!
      Get #1, , Bc: Blue = Bc         '   /                    ~~~~~~~~~
      USERcol(I) = RGB(ASC(Red), ASC(Green), ASC(Blue))
      If USERcol(I) = RGB(255, 0, 255) then USERcol(I) = RGB(255, 4, 255)
    Next                              ' /
  Close ff                            '/

End Sub



'_________________________________________________________________________
Sub AFlibIII_LoadPP256Pal_to_UserPal (Byref PP256PalFile as String)

  Dim FR as Integer
  Dim as Integer B, G, R, C

  FR = FREEFILE
  Open PP256PalFile for Binary as #FR
    For n as Integer = 0 TO 255
      Get #FR, , C
      B = C \ 65536: C = C - B * 65536
      G = C \ 256: C = C - G * 256
      R = C
      USERcol(n) = RGB(R * 4.05, G * 4.05, B * 4.05)
      If USERcol(n) = RGB(255, 0, 255) then USERcol(n) = RGB(255, 4, 255)
    NEXT
  Close #FR

End Sub



'_________________________________________________________________________
Sub AFlibIII_PaintShopProPal_to_UserPal (Byref JASCPalFile as String)

  Dim as Integer PalFileHandle, TotalColors, Red, Green, Blue, PalColorList
  Dim PalLineRead as String

  'If Instr(JASCPalFile, ".") = 0 then JASCPalFile += ".pal"
  PalFileHandle = FREEFILE

  Open JASCPalFile for Input as #PalFileHandle
    Input #PalFileHandle, PalLineRead
    If Ucase(PalLineRead) <> "JASC-PAL" then Exit Sub
    Input #PalFileHandle, PalLineRead
    Input #PalFileHandle, TotalColors
    For PalColorList = 0 TO (TotalColors - 1)
      Input #PalFileHandle, PalLineRead
      Red = Val(Left(PalLineRead, Instr(PalLineRead, Chr(32))))
      PalLineRead = Right(PalLineRead, Len(PalLineRead) - Instr(PalLineRead, Chr(32)))
      Green = Val(Left(PalLineRead, Instr(PalLineRead, " ")))
      PalLineRead = Right(PalLineRead, Len(PalLineRead) - Instr(PalLineRead, Chr(32)))
      Blue = Val(PalLineRead)
      USERcol(PalColorList) = RGB(Red, Green, Blue)
      If USERcol(PalColorList) = RGB(255, 0, 255) then USERcol(PalColorList) = RGB(255, 4, 255)
    Next
  Close #PalFileHandle
  
End Sub



'_________________________________________________________________________
Sub AFlibIII_StoreColor_UserPal ( Byval UserPalette_ColorNumber as Integer, _
                                  Byval r as Integer, _
                                  Byval g as Integer, _
                                  Byval b as Integer )

  If USERcol(UserPalette_ColorNumber) < 0 then USERcol(UserPalette_ColorNumber) = 0
  If USERcol(UserPalette_ColorNumber) > 255 then USERcol(UserPalette_ColorNumber) = 255

  USERcol(UserPalette_ColorNumber) = RGB(r, g, b)
End Sub



'_________________________________________________________________________
Sub AFlibIII_MakeTransColor_UserPal ( Byval UserPalette_ColorNumber as Integer )

  If USERcol(UserPalette_ColorNumber) < 0 then USERcol(UserPalette_ColorNumber) = 0
  If USERcol(UserPalette_ColorNumber) > 255 then USERcol(UserPalette_ColorNumber) = 255

  USERcol(UserPalette_ColorNumber) = RGB(255, 0, 255)
End Sub



'_________________________________________________________________________
Sub AFlibIII_MakeGradient_UserPal ( Byval UserPalette_StartPoint as Integer, _
                                    Byval r_from as Integer, _
                                    Byval g_from as Integer, _
                                    Byval b_from as Integer, _
                                    Byval UserPalette_EndPoint as Integer, _
                                    Byval r_to as Integer, _
                                    Byval g_to as Integer, _
                                    Byval b_to as Integer )

  'This command makes a gradient color by interpolating the RGB values of
  'the starting point of the user-defined 256-color palette index (UserPalette_StartPoint)
  'and its ending point (UserPalette_EndPoint) by the number of colors.

  Dim as Single R, G, B
  Dim as Single Rstep, Gstep, Bstep
  Dim as Single col, cols

  If r_from <= -24 then r_from = -24
  If g_from <= -24 then g_from = -24
  If b_from <= -24 then b_from = -24
  If r_to <= -24 then r_to = -24
  If g_to <= -24 then g_to = -24
  If b_to <= -24 then b_to = -24

  If r_from >= 255 then r_from = 255
  If g_from >= 255 then g_from = 255
  If b_from >= 255 then b_from = 255
  If r_to >= 255 then r_to = 255
  If g_to >= 255 then g_to = 255
  If b_to >= 255 then b_to = 255

  If UserPalette_StartPoint > UserPalette_EndPoint then
    Swap UserPalette_EndPoint, UserPalette_StartPoint
    Swap r_to, r_from
    Swap g_to, g_from
    Swap b_to, b_from
  End if

  R = (r_from - 1)
  G = (g_from - 1)
  B = (b_from - 1)
  cols = (UserPalette_EndPoint - UserPalette_StartPoint + 1)
  Rstep = (r_to - r_from + 1) / cols
  Gstep = (g_to - g_from + 1) / cols
  Bstep = (b_to - b_from + 1) / cols
  
  For col = UserPalette_StartPoint TO UserPalette_EndPoint
    R += Rstep
    G += Gstep
    B += Bstep
    If R > 255 then R = 255
    If R < 0 then R = 0
    If G > 255 then G = 255
    If G < 0 then G = 0
    If B > 255 then B = 255
    If B < 0 then B = 0
    USERcol(col) = RGB(Fix(R), Fix(G), Fix(B))
    If USERcol(col) = RGB(255, 0, 255) then USERcol(col) = RGB(255, 4, 255)
  Next col

End Sub



'_________________________________________________________________________
Sub AFlibIII_SwapCGA ( Byval buffer as any Ptr = 0, _
                       Byval CGApal_SwapFrom as Integer, _
                       Byval CGApal_SwapTo as Integer, _
                       Byval CGApal_SetBGcol as Integer = 0 )

  Dim as Integer CGAcol_from(0 to 3), CGAcol_to(0 to 3)
  Dim as Integer CGAcol_reg

  Select Case CGApal_SwapFrom
    Case is < 1
      For CGAcol_reg = 0 to 3
        CGAcol_from(CGAcol_reg) = CGAcol_A(CGAcol_reg)
      Next    
    Case 1
      For CGAcol_reg = 0 to 3
        CGAcol_from(CGAcol_reg) = CGAcol_B(CGAcol_reg)
      Next    
    Case 2
      For CGAcol_reg = 0 to 3
        CGAcol_from(CGAcol_reg) = CGAcol_C(CGAcol_reg)
      Next    
    Case 3
      For CGAcol_reg = 0 to 3
        CGAcol_from(CGAcol_reg) = CGAcol_D(CGAcol_reg)
      Next    
    Case 4
      For CGAcol_reg = 0 to 3
        CGAcol_from(CGAcol_reg) = CGAcol_E(CGAcol_reg)
      Next    
    Case is > 4
      For CGAcol_reg = 0 to 3
        CGAcol_from(CGAcol_reg) = CGAcol_F(CGAcol_reg)
      Next    
  End Select

  Select Case CGApal_SwapTo
    Case is < 1
      For CGAcol_reg = 0 to 3
        CGAcol_to(CGAcol_reg) = CGAcol_A(CGAcol_reg)
      Next    
    Case 1
      For CGAcol_reg = 0 to 3
        CGAcol_to(CGAcol_reg) = CGAcol_B(CGAcol_reg)
      Next    
    Case 2
      For CGAcol_reg = 0 to 3
        CGAcol_to(CGAcol_reg) = CGAcol_C(CGAcol_reg)
      Next    
    Case 3
      For CGAcol_reg = 0 to 3
        CGAcol_to(CGAcol_reg) = CGAcol_D(CGAcol_reg)
      Next    
    Case 4
      For CGAcol_reg = 0 to 3
        CGAcol_to(CGAcol_reg) = CGAcol_E(CGAcol_reg)
      Next    
    Case is > 4
      For CGAcol_reg = 0 to 3
        CGAcol_to(CGAcol_reg) = CGAcol_F(CGAcol_reg)
      Next    
  End Select

  If CGApal_SwapFrom <> CGApal_SwapTo then
    AFlibIII_Replace4Colors buffer, CGAcol_from(0), CGAcol_to(0), _
                                    CGAcol_from(1), CGAcol_to(1), _
                                    CGAcol_from(2), CGAcol_to(2), _
                                    CGAcol_from(3), CGAcol_to(3)
  End if

  AFlibIII_ReplaceColor buffer, CGAcol_to(0), EGAcol(CGApal_SetBGcol)

End Sub



'_________________________________________________________________________
Sub AFlibIII_FadeEGA ( Byval buffer as Any Ptr = 0, _
                       Byval Fade_Lvl As Integer )
                                     
'----------------------------------------------------------------------
' Fades in and out ONLY within the EGA 16-color palette, using
' exclusively all those 16 very colors within the entire constraints
' of that very same palette alone indeed.
'
' On "Fade_Lvl", pass:
'       5 = maximum fade-level to full white
'       0 = no change 
'      -5 = maximum "fade out"-level to full black
'----------------------------------------------------------------------

  Select Case Fade_Lvl
    Case is > 4
      'EGA 16-color Fade-to-White (5th and Final Phase)
      AFlibIII_Replace16Colors buffer, EGAcol(0), EGAcol(15), _
                                       EGAcol(1), EGAcol(15), _
                                       EGAcol(2), EGAcol(15), _
                                       EGAcol(3), EGAcol(15), _
                                       EGAcol(4), EGAcol(15), _
                                       EGAcol(5), EGAcol(15), _
                                       EGAcol(6), EGAcol(15), _
                                       EGAcol(7), EGAcol(15), _
                                       EGAcol(8), EGAcol(15), _
                                       EGAcol(9), EGAcol(15), _
                                       EGAcol(10), EGAcol(15), _
                                       EGAcol(11), EGAcol(15), _
                                       EGAcol(12), EGAcol(15), _
                                       EGAcol(13), EGAcol(15), _
                                       EGAcol(14), EGAcol(15), _
                                       EGAcol(15), EGAcol(15)
    Case 4
      'EGA 16-color Fade-to-White (4th Phase)
      AFlibIII_Replace16Colors buffer, EGAcol(0), EGAcol(11), _
                                       EGAcol(1), EGAcol(14), _
                                       EGAcol(2), EGAcol(15), _
                                       EGAcol(3), EGAcol(15), _
                                       EGAcol(4), EGAcol(15), _
                                       EGAcol(5), EGAcol(15), _
                                       EGAcol(6), EGAcol(15), _
                                       EGAcol(7), EGAcol(15), _
                                       EGAcol(8), EGAcol(15), _
                                       EGAcol(9), EGAcol(15), _
                                       EGAcol(10), EGAcol(15), _
                                       EGAcol(11), EGAcol(15), _
                                       EGAcol(12), EGAcol(15), _
                                       EGAcol(13), EGAcol(15), _
                                       EGAcol(14), EGAcol(15), _
                                       EGAcol(15), EGAcol(15)
    Case 3
      'EGA 16-color Fade-to-White (3rd Phase)
      AFlibIII_Replace16Colors buffer, EGAcol(0), EGAcol(7), _
                                       EGAcol(1), EGAcol(11), _
                                       EGAcol(2), EGAcol(15), _
                                       EGAcol(3), EGAcol(15), _
                                       EGAcol(4), EGAcol(14), _
                                       EGAcol(5), EGAcol(15), _
                                       EGAcol(6), EGAcol(15), _
                                       EGAcol(7), EGAcol(15), _
                                       EGAcol(8), EGAcol(15), _
                                       EGAcol(9), EGAcol(14), _
                                       EGAcol(10), EGAcol(15), _
                                       EGAcol(11), EGAcol(15), _
                                       EGAcol(12), EGAcol(15), _
                                       EGAcol(13), EGAcol(15), _
                                       EGAcol(14), EGAcol(15), _
                                       EGAcol(15), EGAcol(15)
    Case 2
      'EGA 16-color Fade-to-White (2nd Phase)
      AFlibIII_Replace16Colors buffer, EGAcol(0), EGAcol(8), _
                                       EGAcol(1), EGAcol(3), _
                                       EGAcol(2), EGAcol(14), _
                                       EGAcol(3), EGAcol(14), _
                                       EGAcol(4), EGAcol(12), _
                                       EGAcol(5), EGAcol(14), _
                                       EGAcol(6), EGAcol(14), _
                                       EGAcol(7), EGAcol(15), _
                                       EGAcol(8), EGAcol(11), _
                                       EGAcol(9), EGAcol(11), _
                                       EGAcol(10), EGAcol(15), _
                                       EGAcol(11), EGAcol(15), _
                                       EGAcol(12), EGAcol(15), _
                                       EGAcol(13), EGAcol(15), _
                                       EGAcol(14), EGAcol(15), _
                                       EGAcol(15), EGAcol(15)
    Case 1
      'EGA 16-color Fade-to-White (1st Phase)      
      AFlibIII_Replace16Colors buffer, EGAcol(0), EGAcol(1), _
                                       EGAcol(1), EGAcol(9), _
                                       EGAcol(2), EGAcol(10), _
                                       EGAcol(3), EGAcol(11), _
                                       EGAcol(4), EGAcol(6), _
                                       EGAcol(5), EGAcol(13), _
                                       EGAcol(6), EGAcol(12), _
                                       EGAcol(7), EGAcol(11), _
                                       EGAcol(8), EGAcol(7), _
                                       EGAcol(9), EGAcol(3), _
                                       EGAcol(10), EGAcol(14), _
                                       EGAcol(11), EGAcol(14), _
                                       EGAcol(12), EGAcol(14), _
                                       EGAcol(13), EGAcol(14), _
                                       EGAcol(14), EGAcol(15), _
                                       EGAcol(15), EGAcol(15)
    Case 0
      Exit Sub  '<---- No change in fading; Neutral
    Case -1
      'EGA 16-color Fade-to-Black (1st Phase)
      AFlibIII_Replace16Colors buffer, EGAcol(0), EGAcol(0), _
                                       EGAcol(1), EGAcol(0), _
                                       EGAcol(2), EGAcol(9), _
                                       EGAcol(3), EGAcol(9), _
                                       EGAcol(4), EGAcol(0), _
                                       EGAcol(5), EGAcol(1), _
                                       EGAcol(6), EGAcol(4), _
                                       EGAcol(7), EGAcol(8), _
                                       EGAcol(8), EGAcol(1), _
                                       EGAcol(9), EGAcol(1), _
                                       EGAcol(10), EGAcol(2), _
                                       EGAcol(11), EGAcol(3), _
                                       EGAcol(12), EGAcol(6), _
                                       EGAcol(13), EGAcol(5), _
                                       EGAcol(14), EGAcol(12), _
                                       EGAcol(15), EGAcol(11)
    Case -2
      'EGA 16-color Fade-to-Black (2nd Phase)
      AFlibIII_Replace16Colors buffer, EGAcol(0), EGAcol(0), _
                                       EGAcol(1), EGAcol(0), _
                                       EGAcol(2), EGAcol(1), _
                                       EGAcol(3), EGAcol(1), _
                                       EGAcol(4), EGAcol(0), _
                                       EGAcol(5), EGAcol(0), _
                                       EGAcol(6), EGAcol(0), _
                                       EGAcol(7), EGAcol(1), _
                                       EGAcol(8), EGAcol(0), _
                                       EGAcol(9), EGAcol(0), _
                                       EGAcol(10), EGAcol(9), _
                                       EGAcol(11), EGAcol(9), _
                                       EGAcol(12), EGAcol(4), _
                                       EGAcol(13), EGAcol(1), _
                                       EGAcol(14), EGAcol(5), _
                                       EGAcol(15), EGAcol(7)
    Case -3
      'EGA 16-color Fade-to-Black (3rd Phase)
      AFlibIII_Replace16Colors buffer, EGAcol(0), EGAcol(0), _
                                       EGAcol(1), EGAcol(0), _
                                       EGAcol(2), EGAcol(0), _
                                       EGAcol(3), EGAcol(0), _
                                       EGAcol(4), EGAcol(0), _
                                       EGAcol(5), EGAcol(0), _
                                       EGAcol(6), EGAcol(0), _
                                       EGAcol(7), EGAcol(0), _
                                       EGAcol(8), EGAcol(0), _
                                       EGAcol(9), EGAcol(0), _
                                       EGAcol(10), EGAcol(1), _
                                       EGAcol(11), EGAcol(1), _
                                       EGAcol(12), EGAcol(0), _
                                       EGAcol(13), EGAcol(0), _
                                       EGAcol(14), EGAcol(4), _
                                       EGAcol(15), EGAcol(8)
    Case -4
      'EGA 16-color Fade-to-Black (4th Phase)
      AFlibIII_Replace16Colors buffer, EGAcol(0), EGAcol(0), _
                                       EGAcol(1), EGAcol(0), _
                                       EGAcol(2), EGAcol(0), _
                                       EGAcol(3), EGAcol(0), _
                                       EGAcol(4), EGAcol(0), _
                                       EGAcol(5), EGAcol(0), _
                                       EGAcol(6), EGAcol(0), _
                                       EGAcol(7), EGAcol(0), _
                                       EGAcol(8), EGAcol(0), _
                                       EGAcol(9), EGAcol(0), _
                                       EGAcol(10), EGAcol(0), _
                                       EGAcol(11), EGAcol(0), _
                                       EGAcol(12), EGAcol(0), _
                                       EGAcol(13), EGAcol(0), _
                                       EGAcol(14), EGAcol(0), _
                                       EGAcol(15), EGAcol(1)
    Case is < -4
      'EGA 16-color Fade-to-Black (5th and Final Phase)
      AFlibIII_Replace16Colors buffer, EGAcol(0), EGAcol(0), _
                                       EGAcol(1), EGAcol(0), _
                                       EGAcol(2), EGAcol(0), _
                                       EGAcol(3), EGAcol(0), _
                                       EGAcol(4), EGAcol(0), _
                                       EGAcol(5), EGAcol(0), _
                                       EGAcol(6), EGAcol(0), _
                                       EGAcol(7), EGAcol(0), _
                                       EGAcol(8), EGAcol(0), _
                                       EGAcol(9), EGAcol(0), _
                                       EGAcol(10), EGAcol(0), _
                                       EGAcol(11), EGAcol(0), _
                                       EGAcol(12), EGAcol(0), _
                                       EGAcol(13), EGAcol(0), _
                                       EGAcol(14), EGAcol(0), _
                                       EGAcol(15), EGAcol(0)
  End Select
End Sub



'_________________________________________________________________________
Sub AFlibIII_FadeNES ( Byval buffer as Any Ptr = 0, _
                       Byval Fade_Lvl As Integer )
                                     
'----------------------------------------------------------------------
' Fades in and out ONLY within the whole NES 64-color palette, using
' exclusively all those 64 very colors within the entire constraints
' of that very same palette alone indeed.
'
' On "Fade_Lvl", pass:
'       4 = maximum fade-level to full white
'       0 = no change 
'      -7 = maximum "fade out"-level to full black
'----------------------------------------------------------------------

  Dim as Integer Gfx_horiz, Gfx_vert, BPP
  ScreenInfo Gfx_horiz, Gfx_vert, BPP
  If BPP < 24 then Exit Sub

  Dim tempbuffer as Any Ptr
  Dim AF3_PaletteSnapshot as any ptr = 0
  
  Dim as Integer Fade_NESPalOrder
  
  Select Case Fade_Lvl
    Case is > 3
      'FC/FDS/NES 64-color Fade-to-White (4th and Final Phase)      
      PrivateCol_NESColor_LockON 0, _
                                 NEScol(0), NEScol(48), _
                                 NEScol(1), NEScol(48), _
                                 NEScol(2), NEScol(48), _
                                 NEScol(3), NEScol(48), _
                                 NEScol(4), NEScol(48), _
                                 NEScol(5), NEScol(48), _
                                 NEScol(6), NEScol(48), _
                                 NEScol(7), NEScol(48), _
                                 NEScol(8), NEScol(48), _
                                 NEScol(9), NEScol(48), _
                                 NEScol(10), NEScol(48), _
                                 NEScol(11), NEScol(48), _
                                 NEScol(12), NEScol(48), _
                                 NEScol(13), NEScol(48), _
                                 NEScol(14), NEScol(48), _
                                 NEScol(15), NEScol(48)
      PrivateCol_NESColor_LockON 1, _
                                 NEScol(16), NEScol(48), _
                                 NEScol(17), NEScol(48), _
                                 NEScol(18), NEScol(48), _
                                 NEScol(19), NEScol(48), _
                                 NEScol(20), NEScol(48), _
                                 NEScol(21), NEScol(48), _
                                 NEScol(22), NEScol(48), _
                                 NEScol(23), NEScol(48), _
                                 NEScol(24), NEScol(48), _
                                 NEScol(25), NEScol(48), _
                                 NEScol(26), NEScol(48), _
                                 NEScol(27), NEScol(48), _
                                 NEScol(28), NEScol(48), _
                                 NEScol(29), NEScol(48), _
                                 NEScol(30), NEScol(48), _
                                 NEScol(31), NEScol(48)
      PrivateCol_NESColor_LockON 2, _
                                 NEScol(32), NEScol(48), _
                                 NEScol(33), NEScol(48), _
                                 NEScol(34), NEScol(48), _
                                 NEScol(35), NEScol(48), _
                                 NEScol(36), NEScol(48), _
                                 NEScol(37), NEScol(48), _
                                 NEScol(38), NEScol(48), _
                                 NEScol(39), NEScol(48), _
                                 NEScol(40), NEScol(48), _
                                 NEScol(41), NEScol(48), _
                                 NEScol(42), NEScol(48), _
                                 NEScol(43), NEScol(48), _
                                 NEScol(44), NEScol(48), _
                                 NEScol(45), NEScol(48), _
                                 NEScol(46), NEScol(48), _
                                 NEScol(47), NEScol(48)
      PrivateCol_NESColor_LockON 3, _
                                 NEScol(48), NEScol(48), _
                                 NEScol(49), NEScol(48), _
                                 NEScol(50), NEScol(48), _
                                 NEScol(51), NEScol(48), _
                                 NEScol(52), NEScol(48), _
                                 NEScol(53), NEScol(48), _
                                 NEScol(54), NEScol(48), _
                                 NEScol(55), NEScol(48), _
                                 NEScol(56), NEScol(48), _
                                 NEScol(57), NEScol(48), _
                                 NEScol(58), NEScol(48), _
                                 NEScol(59), NEScol(48), _
                                 NEScol(60), NEScol(48), _
                                 NEScol(61), NEScol(48), _
                                 NEScol(62), NEScol(48), _
                                 NEScol(63), NEScol(48)
    Case 3
      'FC/FDS/NES 64-color Fade-to-White (3rd Phase)      
      PrivateCol_NESColor_LockON 0, _
                                 NEScol(0), NEScol(48), _
                                 NEScol(1), NEScol(49), _
                                 NEScol(2), NEScol(50), _
                                 NEScol(3), NEScol(51), _
                                 NEScol(4), NEScol(52), _
                                 NEScol(5), NEScol(53), _
                                 NEScol(6), NEScol(54), _
                                 NEScol(7), NEScol(55), _
                                 NEScol(8), NEScol(56), _
                                 NEScol(9), NEScol(57), _
                                 NEScol(10), NEScol(58), _
                                 NEScol(11), NEScol(59), _
                                 NEScol(12), NEScol(60), _
                                 NEScol(13), NEScol(61), _
                                 NEScol(14), NEScol(15), _
                                 NEScol(15), NEScol(15)
      PrivateCol_NESColor_LockON 1, _
                                 NEScol(16), NEScol(48), _
                                 NEScol(17), NEScol(48), _
                                 NEScol(18), NEScol(48), _
                                 NEScol(19), NEScol(48), _
                                 NEScol(20), NEScol(48), _
                                 NEScol(21), NEScol(48), _
                                 NEScol(22), NEScol(48), _
                                 NEScol(23), NEScol(48), _
                                 NEScol(24), NEScol(48), _
                                 NEScol(25), NEScol(48), _
                                 NEScol(26), NEScol(48), _
                                 NEScol(27), NEScol(48), _
                                 NEScol(28), NEScol(48), _
                                 NEScol(29), NEScol(48), _
                                 NEScol(30), NEScol(15), _
                                 NEScol(31), NEScol(15)
      PrivateCol_NESColor_LockON 2, _
                                 NEScol(32), NEScol(48), _
                                 NEScol(33), NEScol(48), _
                                 NEScol(34), NEScol(48), _
                                 NEScol(35), NEScol(48), _
                                 NEScol(36), NEScol(48), _
                                 NEScol(37), NEScol(48), _
                                 NEScol(38), NEScol(48), _
                                 NEScol(39), NEScol(48), _
                                 NEScol(40), NEScol(48), _
                                 NEScol(41), NEScol(48), _
                                 NEScol(42), NEScol(48), _
                                 NEScol(43), NEScol(48), _
                                 NEScol(44), NEScol(48), _
                                 NEScol(45), NEScol(48), _
                                 NEScol(46), NEScol(15), _
                                 NEScol(47), NEScol(15)
      PrivateCol_NESColor_LockON 3, _
                                 NEScol(48), NEScol(48), _
                                 NEScol(49), NEScol(48), _
                                 NEScol(50), NEScol(48), _
                                 NEScol(51), NEScol(48), _
                                 NEScol(52), NEScol(48), _
                                 NEScol(53), NEScol(48), _
                                 NEScol(54), NEScol(48), _
                                 NEScol(55), NEScol(48), _
                                 NEScol(56), NEScol(48), _
                                 NEScol(57), NEScol(48), _
                                 NEScol(58), NEScol(48), _
                                 NEScol(59), NEScol(48), _
                                 NEScol(60), NEScol(48), _
                                 NEScol(61), NEScol(48), _
                                 NEScol(62), NEScol(15), _
                                 NEScol(63), NEScol(15)
    Case 2
      'FC/FDS/NES 64-color Fade-to-White (2nd Phase)      
      PrivateCol_NESColor_LockON 0, _
                                 NEScol(0), NEScol(32), _
                                 NEScol(1), NEScol(33), _
                                 NEScol(2), NEScol(34), _
                                 NEScol(3), NEScol(35), _
                                 NEScol(4), NEScol(36), _
                                 NEScol(5), NEScol(37), _
                                 NEScol(6), NEScol(38), _
                                 NEScol(7), NEScol(39), _
                                 NEScol(8), NEScol(40), _
                                 NEScol(9), NEScol(41), _
                                 NEScol(10), NEScol(42), _
                                 NEScol(11), NEScol(43), _
                                 NEScol(12), NEScol(44), _
                                 NEScol(13), NEScol(45), _
                                 NEScol(14), NEScol(15), _
                                 NEScol(15), NEScol(15)
      PrivateCol_NESColor_LockON 1, _
                                 NEScol(16), NEScol(48), _
                                 NEScol(17), NEScol(49), _
                                 NEScol(18), NEScol(50), _
                                 NEScol(19), NEScol(51), _
                                 NEScol(20), NEScol(52), _
                                 NEScol(21), NEScol(53), _
                                 NEScol(22), NEScol(54), _
                                 NEScol(23), NEScol(55), _
                                 NEScol(24), NEScol(56), _
                                 NEScol(25), NEScol(57), _
                                 NEScol(26), NEScol(58), _
                                 NEScol(27), NEScol(59), _
                                 NEScol(28), NEScol(60), _
                                 NEScol(29), NEScol(61), _
                                 NEScol(30), NEScol(15), _
                                 NEScol(31), NEScol(15)
      PrivateCol_NESColor_LockON 2, _
                                 NEScol(32), NEScol(48), _
                                 NEScol(33), NEScol(48), _
                                 NEScol(34), NEScol(48), _
                                 NEScol(35), NEScol(48), _
                                 NEScol(36), NEScol(48), _
                                 NEScol(37), NEScol(48), _
                                 NEScol(38), NEScol(48), _
                                 NEScol(39), NEScol(48), _
                                 NEScol(40), NEScol(48), _
                                 NEScol(41), NEScol(48), _
                                 NEScol(42), NEScol(48), _
                                 NEScol(43), NEScol(48), _
                                 NEScol(44), NEScol(48), _
                                 NEScol(45), NEScol(48), _
                                 NEScol(46), NEScol(15), _
                                 NEScol(47), NEScol(15)
      PrivateCol_NESColor_LockON 3, _
                                 NEScol(48), NEScol(48), _
                                 NEScol(49), NEScol(48), _
                                 NEScol(50), NEScol(48), _
                                 NEScol(51), NEScol(48), _
                                 NEScol(52), NEScol(48), _
                                 NEScol(53), NEScol(48), _
                                 NEScol(54), NEScol(48), _
                                 NEScol(55), NEScol(48), _
                                 NEScol(56), NEScol(48), _
                                 NEScol(57), NEScol(48), _
                                 NEScol(58), NEScol(48), _
                                 NEScol(59), NEScol(48), _
                                 NEScol(60), NEScol(48), _
                                 NEScol(61), NEScol(48), _
                                 NEScol(62), NEScol(15), _
                                 NEScol(63), NEScol(15)
    Case 1
      'FC/FDS/NES 64-color Fade-to-White (1st Phase)      
      PrivateCol_NESColor_LockON 0, _
                                 NEScol(0), NEScol(16), _
                                 NEScol(1), NEScol(17), _
                                 NEScol(2), NEScol(18), _
                                 NEScol(3), NEScol(19), _
                                 NEScol(4), NEScol(20), _
                                 NEScol(5), NEScol(21), _
                                 NEScol(6), NEScol(22), _
                                 NEScol(7), NEScol(23), _
                                 NEScol(8), NEScol(24), _
                                 NEScol(9), NEScol(25), _
                                 NEScol(10), NEScol(26), _
                                 NEScol(11), NEScol(27), _
                                 NEScol(12), NEScol(28), _
                                 NEScol(13), NEScol(29), _
                                 NEScol(14), NEScol(15), _
                                 NEScol(15), NEScol(15)
      PrivateCol_NESColor_LockON 1, _
                                 NEScol(16), NEScol(32), _
                                 NEScol(17), NEScol(33), _
                                 NEScol(18), NEScol(34), _
                                 NEScol(19), NEScol(35), _
                                 NEScol(20), NEScol(36), _
                                 NEScol(21), NEScol(37), _
                                 NEScol(22), NEScol(38), _
                                 NEScol(23), NEScol(39), _
                                 NEScol(24), NEScol(40), _
                                 NEScol(25), NEScol(41), _
                                 NEScol(26), NEScol(42), _
                                 NEScol(27), NEScol(43), _
                                 NEScol(28), NEScol(44), _
                                 NEScol(29), NEScol(45), _
                                 NEScol(30), NEScol(15), _
                                 NEScol(31), NEScol(15)
      PrivateCol_NESColor_LockON 2, _
                                 NEScol(32), NEScol(48), _
                                 NEScol(33), NEScol(49), _
                                 NEScol(34), NEScol(50), _
                                 NEScol(35), NEScol(51), _
                                 NEScol(36), NEScol(52), _
                                 NEScol(37), NEScol(53), _
                                 NEScol(38), NEScol(54), _
                                 NEScol(39), NEScol(55), _
                                 NEScol(40), NEScol(56), _
                                 NEScol(41), NEScol(57), _
                                 NEScol(42), NEScol(58), _
                                 NEScol(43), NEScol(59), _
                                 NEScol(44), NEScol(60), _
                                 NEScol(45), NEScol(61), _
                                 NEScol(46), NEScol(15), _
                                 NEScol(47), NEScol(15)
      PrivateCol_NESColor_LockON 3, _
                                 NEScol(48), NEScol(48), _
                                 NEScol(49), NEScol(48), _
                                 NEScol(50), NEScol(48), _
                                 NEScol(51), NEScol(48), _
                                 NEScol(52), NEScol(48), _
                                 NEScol(53), NEScol(48), _
                                 NEScol(54), NEScol(48), _
                                 NEScol(55), NEScol(48), _
                                 NEScol(56), NEScol(48), _
                                 NEScol(57), NEScol(48), _
                                 NEScol(58), NEScol(48), _
                                 NEScol(59), NEScol(48), _
                                 NEScol(60), NEScol(48), _
                                 NEScol(61), NEScol(48), _
                                 NEScol(62), NEScol(15), _
                                 NEScol(63), NEScol(15)
    Case 0
      Exit Sub  '<---- No change in fading; Neutral
    Case -1
      'FC/FDS/NES 64-color Fade-to-Black (1st Phase)      
      PrivateCol_NESColor_LockON 0, _
                                 NEScol(0), NEScol(27), _
                                 NEScol(1), NEScol(18), _
                                 NEScol(2), NEScol(15), _
                                 NEScol(3), NEScol(2), _
                                 NEScol(4), NEScol(3), _
                                 NEScol(5), NEScol(24), _
                                 NEScol(6), NEScol(24), _
                                 NEScol(7), NEScol(24), _
                                 NEScol(8), NEScol(15), _
                                 NEScol(9), NEScol(24), _
                                 NEScol(10), NEScol(27), _
                                 NEScol(11), NEScol(1), _
                                 NEScol(12), NEScol(1), _
                                 NEScol(13), NEScol(15), _
                                 NEScol(14), NEScol(15), _
                                 NEScol(15), NEScol(15)
      PrivateCol_NESColor_LockON 1, _
                                 NEScol(16), NEScol(0), _
                                 NEScol(17), NEScol(1), _
                                 NEScol(18), NEScol(2), _
                                 NEScol(19), NEScol(3), _
                                 NEScol(20), NEScol(4), _
                                 NEScol(21), NEScol(5), _
                                 NEScol(22), NEScol(6), _
                                 NEScol(23), NEScol(7), _
                                 NEScol(24), NEScol(8), _
                                 NEScol(25), NEScol(9), _
                                 NEScol(26), NEScol(10), _
                                 NEScol(27), NEScol(11), _
                                 NEScol(28), NEScol(12), _
                                 NEScol(29), NEScol(15), _
                                 NEScol(30), NEScol(14), _
                                 NEScol(31), NEScol(15)
      PrivateCol_NESColor_LockON 2, _
                                 NEScol(32), NEScol(16), _
                                 NEScol(33), NEScol(17), _
                                 NEScol(34), NEScol(18), _
                                 NEScol(35), NEScol(19), _
                                 NEScol(36), NEScol(20), _
                                 NEScol(37), NEScol(21), _
                                 NEScol(38), NEScol(22), _
                                 NEScol(39), NEScol(23), _
                                 NEScol(40), NEScol(24), _
                                 NEScol(41), NEScol(25), _
                                 NEScol(42), NEScol(26), _
                                 NEScol(43), NEScol(27), _
                                 NEScol(44), NEScol(28), _
                                 NEScol(45), NEScol(12), _
                                 NEScol(46), NEScol(30), _
                                 NEScol(47), NEScol(31)
      PrivateCol_NESColor_LockON 3, _
                                 NEScol(48), NEScol(32), _
                                 NEScol(49), NEScol(33), _
                                 NEScol(50), NEScol(34), _
                                 NEScol(51), NEScol(35), _
                                 NEScol(52), NEScol(36), _
                                 NEScol(53), NEScol(37), _
                                 NEScol(54), NEScol(38), _
                                 NEScol(55), NEScol(39), _
                                 NEScol(56), NEScol(40), _
                                 NEScol(57), NEScol(41), _
                                 NEScol(58), NEScol(42), _
                                 NEScol(59), NEScol(43), _
                                 NEScol(60), NEScol(44), _
                                 NEScol(61), NEScol(45), _
                                 NEScol(62), NEScol(46), _
                                 NEScol(63), NEScol(47)
    Case -2
      'FC/FDS/NES 64-color Fade-to-Black (2nd Phase)      
      PrivateCol_NESColor_LockON 0, _
                                 NEScol(0), NEScol(10), _
                                 NEScol(1), NEScol(15), _
                                 NEScol(2), NEScol(15), _
                                 NEScol(3), NEScol(15), _
                                 NEScol(4), NEScol(2), _
                                 NEScol(5), NEScol(15), _
                                 NEScol(6), NEScol(15), _
                                 NEScol(7), NEScol(15), _
                                 NEScol(8), NEScol(15), _
                                 NEScol(9), NEScol(15), _
                                 NEScol(10), NEScol(1), _
                                 NEScol(11), NEScol(2), _
                                 NEScol(12), NEScol(2), _
                                 NEScol(13), NEScol(15), _
                                 NEScol(14), NEScol(15), _
                                 NEScol(15), NEScol(15)
      PrivateCol_NESColor_LockON 1, _
                                 NEScol(16), NEScol(11), _
                                 NEScol(17), NEScol(19), _
                                 NEScol(18), NEScol(15), _
                                 NEScol(19), NEScol(2), _
                                 NEScol(20), NEScol(3), _
                                 NEScol(21), NEScol(8), _
                                 NEScol(22), NEScol(8), _
                                 NEScol(23), NEScol(8), _
                                 NEScol(24), NEScol(15), _
                                 NEScol(25), NEScol(8), _
                                 NEScol(26), NEScol(11), _
                                 NEScol(27), NEScol(1), _
                                 NEScol(28), NEScol(1), _
                                 NEScol(29), NEScol(15), _
                                 NEScol(30), NEScol(15), _
                                 NEScol(31), NEScol(15)
      PrivateCol_NESColor_LockON 2, _
                                 NEScol(32), NEScol(0), _
                                 NEScol(33), NEScol(1), _
                                 NEScol(34), NEScol(2), _
                                 NEScol(35), NEScol(3), _
                                 NEScol(36), NEScol(4), _
                                 NEScol(37), NEScol(5), _
                                 NEScol(38), NEScol(6), _
                                 NEScol(39), NEScol(7), _
                                 NEScol(40), NEScol(8), _
                                 NEScol(41), NEScol(9), _
                                 NEScol(42), NEScol(10), _
                                 NEScol(43), NEScol(11), _
                                 NEScol(44), NEScol(12), _
                                 NEScol(45), NEScol(1), _
                                 NEScol(46), NEScol(14), _
                                 NEScol(47), NEScol(15)
      PrivateCol_NESColor_LockON 3, _
                                 NEScol(48), NEScol(16), _
                                 NEScol(49), NEScol(17), _
                                 NEScol(50), NEScol(18), _
                                 NEScol(51), NEScol(19), _
                                 NEScol(52), NEScol(20), _
                                 NEScol(53), NEScol(21), _
                                 NEScol(54), NEScol(22), _
                                 NEScol(55), NEScol(23), _
                                 NEScol(56), NEScol(24), _
                                 NEScol(57), NEScol(25), _
                                 NEScol(58), NEScol(26), _
                                 NEScol(59), NEScol(27), _
                                 NEScol(60), NEScol(28), _
                                 NEScol(61), NEScol(12), _
                                 NEScol(62), NEScol(30), _
                                 NEScol(63), NEScol(31)
    Case -3
      'FC/FDS/NES 64-color Fade-to-Black (3rd Phase)      
      PrivateCol_NESColor_LockON 0, _
                                 NEScol(0), NEScol(10), _
                                 NEScol(1), NEScol(15), _
                                 NEScol(2), NEScol(15), _
                                 NEScol(3), NEScol(15), _
                                 NEScol(4), NEScol(15), _
                                 NEScol(5), NEScol(15), _
                                 NEScol(6), NEScol(15), _
                                 NEScol(7), NEScol(15), _
                                 NEScol(8), NEScol(15), _
                                 NEScol(9), NEScol(15), _
                                 NEScol(10), NEScol(2), _
                                 NEScol(11), NEScol(15), _
                                 NEScol(12), NEScol(15), _
                                 NEScol(13), NEScol(15), _
                                 NEScol(14), NEScol(15), _
                                 NEScol(15), NEScol(15)
      PrivateCol_NESColor_LockON 1, _
                                 NEScol(16), NEScol(26), _
                                 NEScol(17), NEScol(15), _
                                 NEScol(18), NEScol(15), _
                                 NEScol(19), NEScol(15), _
                                 NEScol(20), NEScol(2), _
                                 NEScol(21), NEScol(15), _
                                 NEScol(22), NEScol(15), _
                                 NEScol(23), NEScol(15), _
                                 NEScol(24), NEScol(15), _
                                 NEScol(25), NEScol(15), _
                                 NEScol(26), NEScol(1), _
                                 NEScol(27), NEScol(2), _
                                 NEScol(28), NEScol(2), _
                                 NEScol(29), NEScol(15), _
                                 NEScol(30), NEScol(14), _
                                 NEScol(31), NEScol(15)
      PrivateCol_NESColor_LockON 2, _
                                 NEScol(32), NEScol(11), _
                                 NEScol(33), NEScol(2), _
                                 NEScol(34), NEScol(15), _
                                 NEScol(35), NEScol(2), _
                                 NEScol(36), NEScol(3), _
                                 NEScol(37), NEScol(8), _
                                 NEScol(38), NEScol(8), _
                                 NEScol(39), NEScol(8), _
                                 NEScol(40), NEScol(15), _
                                 NEScol(41), NEScol(8), _
                                 NEScol(42), NEScol(11), _
                                 NEScol(43), NEScol(1), _
                                 NEScol(44), NEScol(1), _
                                 NEScol(45), NEScol(2), _
                                 NEScol(46), NEScol(15), _
                                 NEScol(47), NEScol(15)
      PrivateCol_NESColor_LockON 3, _
                                 NEScol(48), NEScol(0), _
                                 NEScol(49), NEScol(1), _
                                 NEScol(50), NEScol(2), _
                                 NEScol(51), NEScol(3), _
                                 NEScol(52), NEScol(4), _
                                 NEScol(53), NEScol(5), _
                                 NEScol(54), NEScol(6), _
                                 NEScol(55), NEScol(7), _
                                 NEScol(56), NEScol(8), _
                                 NEScol(57), NEScol(9), _
                                 NEScol(58), NEScol(10), _
                                 NEScol(59), NEScol(11), _
                                 NEScol(60), NEScol(12), _
                                 NEScol(61), NEScol(1), _
                                 NEScol(62), NEScol(14), _
                                 NEScol(63), NEScol(15)
    Case -4
      'FC/FDS/NES 64-color Fade-to-Black (4th Phase)      
      PrivateCol_NESColor_LockON 0, _
                                 NEScol(0), NEScol(15), _
                                 NEScol(1), NEScol(15), _
                                 NEScol(2), NEScol(15), _
                                 NEScol(3), NEScol(15), _
                                 NEScol(4), NEScol(15), _
                                 NEScol(5), NEScol(15), _
                                 NEScol(6), NEScol(15), _
                                 NEScol(7), NEScol(15), _
                                 NEScol(8), NEScol(15), _
                                 NEScol(9), NEScol(15), _
                                 NEScol(10), NEScol(15), _
                                 NEScol(11), NEScol(15), _
                                 NEScol(12), NEScol(15), _
                                 NEScol(13), NEScol(15), _
                                 NEScol(14), NEScol(15), _
                                 NEScol(15), NEScol(15)
      PrivateCol_NESColor_LockON 1, _
                                 NEScol(16), NEScol(2), _
                                 NEScol(17), NEScol(15), _
                                 NEScol(18), NEScol(15), _
                                 NEScol(19), NEScol(15), _
                                 NEScol(20), NEScol(15), _
                                 NEScol(21), NEScol(15), _
                                 NEScol(22), NEScol(15), _
                                 NEScol(23), NEScol(15), _
                                 NEScol(24), NEScol(15), _
                                 NEScol(25), NEScol(15), _
                                 NEScol(26), NEScol(2), _
                                 NEScol(27), NEScol(15), _
                                 NEScol(28), NEScol(15), _
                                 NEScol(29), NEScol(15), _
                                 NEScol(30), NEScol(15), _
                                 NEScol(31), NEScol(15)
      PrivateCol_NESColor_LockON 2, _
                                 NEScol(32), NEScol(1), _
                                 NEScol(33), NEScol(15), _
                                 NEScol(34), NEScol(15), _
                                 NEScol(35), NEScol(15), _
                                 NEScol(36), NEScol(2), _
                                 NEScol(37), NEScol(15), _
                                 NEScol(38), NEScol(15), _
                                 NEScol(39), NEScol(15), _
                                 NEScol(40), NEScol(15), _
                                 NEScol(41), NEScol(15), _
                                 NEScol(42), NEScol(1), _
                                 NEScol(43), NEScol(2), _
                                 NEScol(44), NEScol(2), _
                                 NEScol(45), NEScol(15), _
                                 NEScol(46), NEScol(14), _
                                 NEScol(47), NEScol(15)
      PrivateCol_NESColor_LockON 3, _
                                 NEScol(48), NEScol(11), _
                                 NEScol(49), NEScol(2), _
                                 NEScol(50), NEScol(15), _
                                 NEScol(51), NEScol(2), _
                                 NEScol(52), NEScol(3), _
                                 NEScol(53), NEScol(8), _
                                 NEScol(54), NEScol(8), _
                                 NEScol(55), NEScol(8), _
                                 NEScol(56), NEScol(15), _
                                 NEScol(57), NEScol(8), _
                                 NEScol(58), NEScol(11), _
                                 NEScol(59), NEScol(1), _
                                 NEScol(60), NEScol(1), _
                                 NEScol(61), NEScol(2), _
                                 NEScol(62), NEScol(15), _
                                 NEScol(63), NEScol(15)
    Case -5
      'FC/FDS/NES 64-color Fade-to-Black (5th Phase)      
      PrivateCol_NESColor_LockON 0, _
                                 NEScol(0), NEScol(15), _
                                 NEScol(1), NEScol(15), _
                                 NEScol(2), NEScol(15), _
                                 NEScol(3), NEScol(15), _
                                 NEScol(4), NEScol(15), _
                                 NEScol(5), NEScol(15), _
                                 NEScol(6), NEScol(15), _
                                 NEScol(7), NEScol(15), _
                                 NEScol(8), NEScol(15), _
                                 NEScol(9), NEScol(15), _
                                 NEScol(10), NEScol(15), _
                                 NEScol(11), NEScol(15), _
                                 NEScol(12), NEScol(15), _
                                 NEScol(13), NEScol(15), _
                                 NEScol(14), NEScol(15), _
                                 NEScol(15), NEScol(15)
      PrivateCol_NESColor_LockON 1, _
                                 NEScol(16), NEScol(15), _
                                 NEScol(17), NEScol(15), _
                                 NEScol(18), NEScol(15), _
                                 NEScol(19), NEScol(15), _
                                 NEScol(20), NEScol(15), _
                                 NEScol(21), NEScol(15), _
                                 NEScol(22), NEScol(15), _
                                 NEScol(23), NEScol(15), _
                                 NEScol(24), NEScol(15), _
                                 NEScol(25), NEScol(15), _
                                 NEScol(26), NEScol(15), _
                                 NEScol(27), NEScol(15), _
                                 NEScol(28), NEScol(15), _
                                 NEScol(29), NEScol(15), _
                                 NEScol(30), NEScol(15), _
                                 NEScol(31), NEScol(15)
      PrivateCol_NESColor_LockON 2, _
                                 NEScol(32), NEScol(2), _
                                 NEScol(33), NEScol(15), _
                                 NEScol(34), NEScol(15), _
                                 NEScol(35), NEScol(15), _
                                 NEScol(36), NEScol(15), _
                                 NEScol(37), NEScol(15), _
                                 NEScol(38), NEScol(15), _
                                 NEScol(39), NEScol(15), _
                                 NEScol(40), NEScol(15), _
                                 NEScol(41), NEScol(15), _
                                 NEScol(42), NEScol(2), _
                                 NEScol(43), NEScol(15), _
                                 NEScol(44), NEScol(15), _
                                 NEScol(45), NEScol(15), _
                                 NEScol(46), NEScol(15), _
                                 NEScol(47), NEScol(15)
      PrivateCol_NESColor_LockON 3, _
                                 NEScol(48), NEScol(1), _
                                 NEScol(49), NEScol(15), _
                                 NEScol(50), NEScol(15), _
                                 NEScol(51), NEScol(15), _
                                 NEScol(52), NEScol(2), _
                                 NEScol(53), NEScol(15), _
                                 NEScol(54), NEScol(15), _
                                 NEScol(55), NEScol(15), _
                                 NEScol(56), NEScol(15), _
                                 NEScol(57), NEScol(15), _
                                 NEScol(58), NEScol(1), _
                                 NEScol(59), NEScol(2), _
                                 NEScol(60), NEScol(2), _
                                 NEScol(61), NEScol(15), _
                                 NEScol(62), NEScol(14), _
                                 NEScol(63), NEScol(15)
    Case -6
      'FC/FDS/NES 64-color Fade-to-Black (6th Phase)      
      PrivateCol_NESColor_LockON 0, _
                                 NEScol(0), NEScol(15), _
                                 NEScol(1), NEScol(15), _
                                 NEScol(2), NEScol(15), _
                                 NEScol(3), NEScol(15), _
                                 NEScol(4), NEScol(15), _
                                 NEScol(5), NEScol(15), _
                                 NEScol(6), NEScol(15), _
                                 NEScol(7), NEScol(15), _
                                 NEScol(8), NEScol(15), _
                                 NEScol(9), NEScol(15), _
                                 NEScol(10), NEScol(15), _
                                 NEScol(11), NEScol(15), _
                                 NEScol(12), NEScol(15), _
                                 NEScol(13), NEScol(15), _
                                 NEScol(14), NEScol(15), _
                                 NEScol(15), NEScol(15)
      PrivateCol_NESColor_LockON 1, _
                                 NEScol(16), NEScol(15), _
                                 NEScol(17), NEScol(15), _
                                 NEScol(18), NEScol(15), _
                                 NEScol(19), NEScol(15), _
                                 NEScol(20), NEScol(15), _
                                 NEScol(21), NEScol(15), _
                                 NEScol(22), NEScol(15), _
                                 NEScol(23), NEScol(15), _
                                 NEScol(24), NEScol(15), _
                                 NEScol(25), NEScol(15), _
                                 NEScol(26), NEScol(15), _
                                 NEScol(27), NEScol(15), _
                                 NEScol(28), NEScol(15), _
                                 NEScol(29), NEScol(15), _
                                 NEScol(30), NEScol(15), _
                                 NEScol(31), NEScol(15)
      PrivateCol_NESColor_LockON 2, _
                                 NEScol(32), NEScol(15), _
                                 NEScol(33), NEScol(15), _
                                 NEScol(34), NEScol(15), _
                                 NEScol(35), NEScol(15), _
                                 NEScol(36), NEScol(15), _
                                 NEScol(37), NEScol(15), _
                                 NEScol(38), NEScol(15), _
                                 NEScol(39), NEScol(15), _
                                 NEScol(40), NEScol(15), _
                                 NEScol(41), NEScol(15), _
                                 NEScol(42), NEScol(15), _
                                 NEScol(43), NEScol(15), _
                                 NEScol(44), NEScol(15), _
                                 NEScol(45), NEScol(15), _
                                 NEScol(46), NEScol(15), _
                                 NEScol(47), NEScol(15)
      PrivateCol_NESColor_LockON 3, _
                                 NEScol(48), NEScol(2), _
                                 NEScol(49), NEScol(15), _
                                 NEScol(50), NEScol(15), _
                                 NEScol(51), NEScol(15), _
                                 NEScol(52), NEScol(15), _
                                 NEScol(53), NEScol(15), _
                                 NEScol(54), NEScol(15), _
                                 NEScol(55), NEScol(15), _
                                 NEScol(56), NEScol(15), _
                                 NEScol(57), NEScol(15), _
                                 NEScol(58), NEScol(2), _
                                 NEScol(59), NEScol(15), _
                                 NEScol(60), NEScol(15), _
                                 NEScol(61), NEScol(15), _
                                 NEScol(62), NEScol(15), _
                                 NEScol(63), NEScol(15)
    Case is < -6
      'FC/FDS/NES 64-color Fade-to-Black (7th and Final Phase)      
      PrivateCol_NESColor_LockON 0, _
                                 NEScol(0), NEScol(15), _
                                 NEScol(1), NEScol(15), _
                                 NEScol(2), NEScol(15), _
                                 NEScol(3), NEScol(15), _
                                 NEScol(4), NEScol(15), _
                                 NEScol(5), NEScol(15), _
                                 NEScol(6), NEScol(15), _
                                 NEScol(7), NEScol(15), _
                                 NEScol(8), NEScol(15), _
                                 NEScol(9), NEScol(15), _
                                 NEScol(10), NEScol(15), _
                                 NEScol(11), NEScol(15), _
                                 NEScol(12), NEScol(15), _
                                 NEScol(13), NEScol(15), _
                                 NEScol(14), NEScol(15), _
                                 NEScol(15), NEScol(15)
                                 
      PrivateCol_NESColor_LockON 1, _
                                 NEScol(16), NEScol(15), _
                                 NEScol(17), NEScol(15), _
                                 NEScol(18), NEScol(15), _
                                 NEScol(19), NEScol(15), _
                                 NEScol(20), NEScol(15), _
                                 NEScol(21), NEScol(15), _
                                 NEScol(22), NEScol(15), _
                                 NEScol(23), NEScol(15), _
                                 NEScol(24), NEScol(15), _
                                 NEScol(25), NEScol(15), _
                                 NEScol(26), NEScol(15), _
                                 NEScol(27), NEScol(15), _
                                 NEScol(28), NEScol(15), _
                                 NEScol(29), NEScol(15), _
                                 NEScol(30), NEScol(15), _
                                 NEScol(31), NEScol(15)

      PrivateCol_NESColor_LockON 2, _
                                 NEScol(32), NEScol(15), _
                                 NEScol(33), NEScol(15), _
                                 NEScol(34), NEScol(15), _
                                 NEScol(35), NEScol(15), _
                                 NEScol(36), NEScol(15), _
                                 NEScol(37), NEScol(15), _
                                 NEScol(38), NEScol(15), _
                                 NEScol(39), NEScol(15), _
                                 NEScol(40), NEScol(15), _
                                 NEScol(41), NEScol(15), _
                                 NEScol(42), NEScol(15), _
                                 NEScol(43), NEScol(15), _
                                 NEScol(44), NEScol(15), _
                                 NEScol(45), NEScol(15), _
                                 NEScol(46), NEScol(15), _
                                 NEScol(47), NEScol(15)

      PrivateCol_NESColor_LockON 3, _
                                 NEScol(48), NEScol(15), _
                                 NEScol(49), NEScol(15), _
                                 NEScol(50), NEScol(15), _
                                 NEScol(51), NEScol(15), _
                                 NEScol(52), NEScol(15), _
                                 NEScol(53), NEScol(15), _
                                 NEScol(54), NEScol(15), _
                                 NEScol(55), NEScol(15), _
                                 NEScol(56), NEScol(15), _
                                 NEScol(57), NEScol(15), _
                                 NEScol(58), NEScol(15), _
                                 NEScol(59), NEScol(15), _
                                 NEScol(60), NEScol(15), _
                                 NEScol(61), NEScol(15), _
                                 NEScol(62), NEScol(15), _
                                 NEScol(63), NEScol(15)
  End Select
  
  If Fade_Lvl > 0 then
    Fade_NESPalOrder = 1 'Reverse order from NES Color Numbers 63 to 0
  else
    Fade_NESPalOrder = 0 'Normal order from NES Color Numbers 0 to 63
  End if

  If buffer = 0 then
    ScreenInfo Gfx_horiz, Gfx_vert
    AF3_PaletteSnapshot = ImageCreate(Gfx_horiz, Gfx_vert)
    Get (0, 0)-(Gfx_horiz - 1, Gfx_vert - 1), AF3_PaletteSnapshot
    AF3_PaletteSnapshot = PrivateColRep_64colors_FC(AF3_PaletteSnapshot, Fade_NESPalOrder)
    Put (0, 0), AF3_PaletteSnapshot, trans
    ImageDestroy AF3_PaletteSnapshot
  else
    PrivateCol_check_buffersize buffer, Gfx_horiz, Gfx_vert
    tempbuffer = ImageCreate (Gfx_horiz, Gfx_vert)
    Get buffer, (0, 0)-(Gfx_horiz - 1, Gfx_vert - 1), tempbuffer
    tempbuffer = PrivateColRep_64colors_FC(tempbuffer, Fade_NESPalOrder)
    Put buffer, (0, 0), tempbuffer, trans
    ImageDestroy tempbuffer
  End if
End Sub



'_________________________________________________________________________
Sub AFlibIII_FadeSMS ( Byval buffer as Any Ptr = 0, _
                       Byval Fade_Lvl As Integer )
                                     
'----------------------------------------------------------------------
' Fades in and out ONLY within the whole Master System/Mark III
' 64-color palette, using exclusively all those 64 very colors within
' the entire constraints of that very same palette alone indeed.
'
' On "Fade_Lvl", pass:
'       5 = maximum fade-level to full white
'       0 = no change 
'      -4 = maximum "fade out"-level to full black
'----------------------------------------------------------------------

  Dim as Integer Gfx_horiz, Gfx_vert, BPP
  ScreenInfo Gfx_horiz, Gfx_vert, BPP
  If BPP < 24 then Exit Sub

  Dim tempbuffer as Any Ptr
  Dim AF3_PaletteSnapshot as any ptr = 0
  
  Dim as Integer Fade_SMSPalOrder
  
  Select Case Fade_Lvl
    Case is > 4
      'Master System/Mark III Fade-to-White (5th and Final Phase)      
      PrivateCol_SMSColor_LockON 0, _
                                 SMScol(0), SMScol(63), _
                                 SMScol(1), SMScol(63), _
                                 SMScol(2), SMScol(63), _
                                 SMScol(3), SMScol(63), _
                                 SMScol(4), SMScol(63), _
                                 SMScol(5), SMScol(63), _
                                 SMScol(6), SMScol(63), _
                                 SMScol(7), SMScol(63), _
                                 SMScol(8), SMScol(63), _
                                 SMScol(9), SMScol(63), _
                                 SMScol(10), SMScol(63), _
                                 SMScol(11), SMScol(63), _
                                 SMScol(12), SMScol(63), _
                                 SMScol(13), SMScol(63), _
                                 SMScol(14), SMScol(63), _
                                 SMScol(15), SMScol(63)
      PrivateCol_SMSColor_LockON 1, _
                                 SMScol(16), SMScol(63), _
                                 SMScol(17), SMScol(63), _
                                 SMScol(18), SMScol(63), _
                                 SMScol(19), SMScol(63), _
                                 SMScol(20), SMScol(63), _
                                 SMScol(21), SMScol(63), _
                                 SMScol(22), SMScol(63), _
                                 SMScol(23), SMScol(63), _
                                 SMScol(24), SMScol(63), _
                                 SMScol(25), SMScol(63), _
                                 SMScol(26), SMScol(63), _
                                 SMScol(27), SMScol(63), _
                                 SMScol(28), SMScol(63), _
                                 SMScol(29), SMScol(63), _
                                 SMScol(30), SMScol(63), _
                                 SMScol(31), SMScol(63)
      PrivateCol_SMSColor_LockON 2, _
                                 SMScol(32), SMScol(63), _
                                 SMScol(33), SMScol(63), _
                                 SMScol(34), SMScol(63), _
                                 SMScol(35), SMScol(63), _
                                 SMScol(36), SMScol(63), _
                                 SMScol(37), SMScol(63), _
                                 SMScol(38), SMScol(63), _
                                 SMScol(39), SMScol(63), _
                                 SMScol(40), SMScol(63), _
                                 SMScol(41), SMScol(63), _
                                 SMScol(42), SMScol(63), _
                                 SMScol(43), SMScol(63), _
                                 SMScol(44), SMScol(63), _
                                 SMScol(45), SMScol(63), _
                                 SMScol(46), SMScol(63), _
                                 SMScol(47), SMScol(63)
      PrivateCol_SMSColor_LockON 3, _
                                 SMScol(48), SMScol(63), _
                                 SMScol(49), SMScol(63), _
                                 SMScol(50), SMScol(63), _
                                 SMScol(51), SMScol(63), _
                                 SMScol(52), SMScol(63), _
                                 SMScol(53), SMScol(63), _
                                 SMScol(54), SMScol(63), _
                                 SMScol(55), SMScol(63), _
                                 SMScol(56), SMScol(63), _
                                 SMScol(57), SMScol(63), _
                                 SMScol(58), SMScol(63), _
                                 SMScol(59), SMScol(63), _
                                 SMScol(60), SMScol(63), _
                                 SMScol(61), SMScol(63), _
                                 SMScol(62), SMScol(63), _
                                 SMScol(63), SMScol(63)
    Case 4
      'Master System/Mark III Fade-to-Black (4th Phase)      
      PrivateCol_SMSColor_LockON 0, _
                                 SMScol(0), SMScol(63), _
                                 SMScol(1), SMScol(63), _
                                 SMScol(2), SMScol(63), _
                                 SMScol(3), SMScol(63), _
                                 SMScol(4), SMScol(63), _
                                 SMScol(5), SMScol(63), _
                                 SMScol(6), SMScol(63), _
                                 SMScol(7), SMScol(63), _
                                 SMScol(8), SMScol(63), _
                                 SMScol(9), SMScol(63), _
                                 SMScol(10), SMScol(63), _
                                 SMScol(11), SMScol(63), _
                                 SMScol(12), SMScol(63), _
                                 SMScol(13), SMScol(63), _
                                 SMScol(14), SMScol(63), _
                                 SMScol(15), SMScol(63)
      PrivateCol_SMSColor_LockON 1, _
                                 SMScol(16), SMScol(47), _
                                 SMScol(17), SMScol(63), _
                                 SMScol(18), SMScol(63), _
                                 SMScol(19), SMScol(63), _
                                 SMScol(20), SMScol(63), _
                                 SMScol(21), SMScol(63), _
                                 SMScol(22), SMScol(63), _
                                 SMScol(23), SMScol(63), _
                                 SMScol(24), SMScol(63), _
                                 SMScol(25), SMScol(63), _
                                 SMScol(26), SMScol(63), _
                                 SMScol(27), SMScol(63), _
                                 SMScol(28), SMScol(63), _
                                 SMScol(29), SMScol(63), _
                                 SMScol(30), SMScol(63), _
                                 SMScol(31), SMScol(63)
      PrivateCol_SMSColor_LockON 2, _
                                 SMScol(32), SMScol(47), _
                                 SMScol(33), SMScol(63), _
                                 SMScol(34), SMScol(63), _
                                 SMScol(35), SMScol(63), _
                                 SMScol(36), SMScol(63), _
                                 SMScol(37), SMScol(63), _
                                 SMScol(38), SMScol(63), _
                                 SMScol(39), SMScol(63), _
                                 SMScol(40), SMScol(63), _
                                 SMScol(41), SMScol(63), _
                                 SMScol(42), SMScol(63), _
                                 SMScol(43), SMScol(63), _
                                 SMScol(44), SMScol(63), _
                                 SMScol(45), SMScol(63), _
                                 SMScol(46), SMScol(63), _
                                 SMScol(47), SMScol(63)
      PrivateCol_SMSColor_LockON 3, _
                                 SMScol(48), SMScol(32), _
                                 SMScol(49), SMScol(63), _
                                 SMScol(50), SMScol(63), _
                                 SMScol(51), SMScol(63), _
                                 SMScol(52), SMScol(63), _
                                 SMScol(53), SMScol(63), _
                                 SMScol(54), SMScol(63), _
                                 SMScol(55), SMScol(63), _
                                 SMScol(56), SMScol(63), _
                                 SMScol(57), SMScol(63), _
                                 SMScol(58), SMScol(63), _
                                 SMScol(59), SMScol(63), _
                                 SMScol(60), SMScol(63), _
                                 SMScol(61), SMScol(63), _
                                 SMScol(62), SMScol(63), _
                                 SMScol(63), SMScol(63)
    Case 3
      'Master System/Mark III Fade-to-White (3rd Phase)      
      PrivateCol_SMSColor_LockON 0, _
                                 SMScol(0), SMScol(47), _
                                 SMScol(1), SMScol(47), _
                                 SMScol(2), SMScol(47), _
                                 SMScol(3), SMScol(47), _
                                 SMScol(4), SMScol(47), _
                                 SMScol(5), SMScol(63), _
                                 SMScol(6), SMScol(63), _
                                 SMScol(7), SMScol(63), _
                                 SMScol(8), SMScol(47), _
                                 SMScol(9), SMScol(63), _
                                 SMScol(10), SMScol(63), _
                                 SMScol(11), SMScol(63), _
                                 SMScol(12), SMScol(47), _
                                 SMScol(13), SMScol(63), _
                                 SMScol(14), SMScol(63), _
                                 SMScol(15), SMScol(63)
      PrivateCol_SMSColor_LockON 1, _
                                 SMScol(16), SMScol(62), _
                                 SMScol(17), SMScol(47), _
                                 SMScol(18), SMScol(47), _
                                 SMScol(19), SMScol(47), _
                                 SMScol(20), SMScol(47), _
                                 SMScol(21), SMScol(63), _
                                 SMScol(22), SMScol(63), _
                                 SMScol(23), SMScol(63), _
                                 SMScol(24), SMScol(47), _
                                 SMScol(25), SMScol(63), _
                                 SMScol(26), SMScol(63), _
                                 SMScol(27), SMScol(63), _
                                 SMScol(28), SMScol(47), _
                                 SMScol(29), SMScol(63), _
                                 SMScol(30), SMScol(63), _
                                 SMScol(31), SMScol(63)
      PrivateCol_SMSColor_LockON 2, _
                                 SMScol(32), SMScol(62), _
                                 SMScol(33), SMScol(47), _
                                 SMScol(34), SMScol(47), _
                                 SMScol(35), SMScol(47), _
                                 SMScol(36), SMScol(47), _
                                 SMScol(37), SMScol(63), _
                                 SMScol(38), SMScol(63), _
                                 SMScol(39), SMScol(63), _
                                 SMScol(40), SMScol(47), _
                                 SMScol(41), SMScol(63), _
                                 SMScol(42), SMScol(63), _
                                 SMScol(43), SMScol(63), _
                                 SMScol(44), SMScol(47), _
                                 SMScol(45), SMScol(63), _
                                 SMScol(46), SMScol(63), _
                                 SMScol(47), SMScol(63)
      PrivateCol_SMSColor_LockON 3, _
                                 SMScol(48), SMScol(62), _
                                 SMScol(49), SMScol(44), _
                                 SMScol(50), SMScol(44), _
                                 SMScol(51), SMScol(44), _
                                 SMScol(52), SMScol(44), _
                                 SMScol(53), SMScol(63), _
                                 SMScol(54), SMScol(63), _
                                 SMScol(55), SMScol(63), _
                                 SMScol(56), SMScol(44), _
                                 SMScol(57), SMScol(63), _
                                 SMScol(58), SMScol(63), _
                                 SMScol(59), SMScol(63), _
                                 SMScol(60), SMScol(44), _
                                 SMScol(61), SMScol(63), _
                                 SMScol(62), SMScol(63), _
                                 SMScol(63), SMScol(63)
    Case 2
      'Master System/Mark III Fade-to-White (2nd Phase)      
      PrivateCol_SMSColor_LockON 0, _
                                 SMScol(0), SMScol(42), _
                                 SMScol(1), SMScol(43), _
                                 SMScol(2), SMScol(43), _
                                 SMScol(3), SMScol(43), _
                                 SMScol(4), SMScol(46), _
                                 SMScol(5), SMScol(47), _
                                 SMScol(6), SMScol(47), _
                                 SMScol(7), SMScol(47), _
                                 SMScol(8), SMScol(46), _
                                 SMScol(9), SMScol(47), _
                                 SMScol(10), SMScol(47), _
                                 SMScol(11), SMScol(47), _
                                 SMScol(12), SMScol(46), _
                                 SMScol(13), SMScol(47), _
                                 SMScol(14), SMScol(47), _
                                 SMScol(15), SMScol(47)
      PrivateCol_SMSColor_LockON 1, _
                                 SMScol(16), SMScol(58), _
                                 SMScol(17), SMScol(59), _
                                 SMScol(18), SMScol(59), _
                                 SMScol(19), SMScol(59), _
                                 SMScol(20), SMScol(62), _
                                 SMScol(21), SMScol(47), _
                                 SMScol(22), SMScol(47), _
                                 SMScol(23), SMScol(47), _
                                 SMScol(24), SMScol(62), _
                                 SMScol(25), SMScol(47), _
                                 SMScol(26), SMScol(63), _
                                 SMScol(27), SMScol(63), _
                                 SMScol(28), SMScol(62), _
                                 SMScol(29), SMScol(47), _
                                 SMScol(30), SMScol(63), _
                                 SMScol(31), SMScol(63)
      PrivateCol_SMSColor_LockON 2, _
                                 SMScol(32), SMScol(58), _
                                 SMScol(33), SMScol(59), _
                                 SMScol(34), SMScol(59), _
                                 SMScol(35), SMScol(59), _
                                 SMScol(36), SMScol(62), _
                                 SMScol(37), SMScol(47), _
                                 SMScol(38), SMScol(47), _
                                 SMScol(39), SMScol(47), _
                                 SMScol(40), SMScol(62), _
                                 SMScol(41), SMScol(47), _
                                 SMScol(42), SMScol(63), _
                                 SMScol(43), SMScol(63), _
                                 SMScol(44), SMScol(62), _
                                 SMScol(45), SMScol(47), _
                                 SMScol(46), SMScol(63), _
                                 SMScol(47), SMScol(63)
      PrivateCol_SMSColor_LockON 3, _
                                 SMScol(48), SMScol(58), _  
                                 SMScol(49), SMScol(59), _
                                 SMScol(50), SMScol(59), _
                                 SMScol(51), SMScol(59), _
                                 SMScol(52), SMScol(62), _
                                 SMScol(53), SMScol(45), _
                                 SMScol(54), SMScol(45), _
                                 SMScol(55), SMScol(45), _
                                 SMScol(56), SMScol(62), _
                                 SMScol(57), SMScol(45), _
                                 SMScol(58), SMScol(63), _
                                 SMScol(59), SMScol(63), _
                                 SMScol(60), SMScol(62), _
                                 SMScol(61), SMScol(45), _
                                 SMScol(62), SMScol(63), _
                                 SMScol(63), SMScol(63)
    Case 1
      'Master System/Mark III Fade-to-Black (1st Phase)      
      PrivateCol_SMSColor_LockON 0, _
                                 SMScol(0), SMScol(21), _
                                 SMScol(1), SMScol(22), _
                                 SMScol(2), SMScol(23), _
                                 SMScol(3), SMScol(23), _
                                 SMScol(4), SMScol(25), _
                                 SMScol(5), SMScol(26), _
                                 SMScol(6), SMScol(27), _
                                 SMScol(7), SMScol(27), _
                                 SMScol(8), SMScol(29), _
                                 SMScol(9), SMScol(30), _
                                 SMScol(10), SMScol(31), _
                                 SMScol(11), SMScol(31), _
                                 SMScol(12), SMScol(29), _
                                 SMScol(13), SMScol(30), _
                                 SMScol(14), SMScol(31), _
                                 SMScol(15), SMScol(31)
      PrivateCol_SMSColor_LockON 1, _
                                 SMScol(16), SMScol(37), _
                                 SMScol(17), SMScol(38), _
                                 SMScol(18), SMScol(39), _
                                 SMScol(19), SMScol(39), _
                                 SMScol(20), SMScol(41), _
                                 SMScol(21), SMScol(42), _
                                 SMScol(22), SMScol(43), _
                                 SMScol(23), SMScol(43), _
                                 SMScol(24), SMScol(45), _
                                 SMScol(25), SMScol(46), _
                                 SMScol(26), SMScol(47), _
                                 SMScol(27), SMScol(47), _
                                 SMScol(28), SMScol(45), _
                                 SMScol(29), SMScol(46), _
                                 SMScol(30), SMScol(47), _
                                 SMScol(31), SMScol(47)
      PrivateCol_SMSColor_LockON 2, _
                                 SMScol(32), SMScol(53), _
                                 SMScol(33), SMScol(54), _
                                 SMScol(34), SMScol(55), _
                                 SMScol(35), SMScol(55), _
                                 SMScol(36), SMScol(57), _
                                 SMScol(37), SMScol(58), _
                                 SMScol(38), SMScol(59), _
                                 SMScol(39), SMScol(59), _
                                 SMScol(40), SMScol(61), _
                                 SMScol(41), SMScol(62), _
                                 SMScol(42), SMScol(47), _
                                 SMScol(43), SMScol(47), _
                                 SMScol(44), SMScol(61), _
                                 SMScol(45), SMScol(62), _
                                 SMScol(46), SMScol(47), _
                                 SMScol(47), SMScol(63)
      PrivateCol_SMSColor_LockON 3, _
                                 SMScol(48), SMScol(53), _
                                 SMScol(49), SMScol(54), _
                                 SMScol(50), SMScol(55), _
                                 SMScol(51), SMScol(55), _
                                 SMScol(52), SMScol(57), _
                                 SMScol(53), SMScol(58), _
                                 SMScol(54), SMScol(59), _
                                 SMScol(55), SMScol(59), _
                                 SMScol(56), SMScol(61), _
                                 SMScol(57), SMScol(62), _
                                 SMScol(58), SMScol(46), _
                                 SMScol(59), SMScol(46), _
                                 SMScol(60), SMScol(61), _
                                 SMScol(61), SMScol(62), _
                                 SMScol(62), SMScol(46), _
                                 SMScol(63), SMScol(63)
    Case 0
      Exit Sub  '<---- No change in fading; Neutral
    Case -1
      'Master System/Mark III Fade-to-Black (1st Phase)      
      PrivateCol_SMSColor_LockON 0, _
                                 SMScol(0), SMScol(0), _
                                 SMScol(1), SMScol(17), _
                                 SMScol(2), SMScol(1), _
                                 SMScol(3), SMScol(2), _
                                 SMScol(4), SMScol(17), _
                                 SMScol(5), SMScol(17), _
                                 SMScol(6), SMScol(1), _
                                 SMScol(7), SMScol(2), _
                                 SMScol(8), SMScol(4), _
                                 SMScol(9), SMScol(4), _
                                 SMScol(10), SMScol(5), _
                                 SMScol(11), SMScol(6), _
                                 SMScol(12), SMScol(8), _
                                 SMScol(13), SMScol(8), _
                                 SMScol(14), SMScol(9), _
                                 SMScol(15), SMScol(10)
                                 
      PrivateCol_SMSColor_LockON 1, _
                                 SMScol(16), SMScol(0), _
                                 SMScol(17), SMScol(16), _
                                 SMScol(18), SMScol(1), _
                                 SMScol(19), SMScol(2), _
                                 SMScol(20), SMScol(16), _
                                 SMScol(21), SMScol(16), _
                                 SMScol(22), SMScol(1), _
                                 SMScol(23), SMScol(2), _
                                 SMScol(24), SMScol(4), _
                                 SMScol(25), SMScol(4), _
                                 SMScol(26), SMScol(5), _
                                 SMScol(27), SMScol(6), _
                                 SMScol(28), SMScol(8), _
                                 SMScol(29), SMScol(8), _
                                 SMScol(30), SMScol(9), _
                                 SMScol(31), SMScol(10)

      PrivateCol_SMSColor_LockON 2, _
                                 SMScol(32), SMScol(16), _
                                 SMScol(33), SMScol(16), _
                                 SMScol(34), SMScol(17), _
                                 SMScol(35), SMScol(18), _
                                 SMScol(36), SMScol(16), _
                                 SMScol(37), SMScol(16), _
                                 SMScol(38), SMScol(17), _
                                 SMScol(39), SMScol(18), _
                                 SMScol(40), SMScol(20), _
                                 SMScol(41), SMScol(20), _
                                 SMScol(42), SMScol(21), _
                                 SMScol(43), SMScol(22), _
                                 SMScol(44), SMScol(24), _
                                 SMScol(45), SMScol(24), _
                                 SMScol(46), SMScol(25), _
                                 SMScol(47), SMScol(26)

      PrivateCol_SMSColor_LockON 3, _
                                 SMScol(48), SMScol(32), _
                                 SMScol(49), SMScol(32), _
                                 SMScol(50), SMScol(33), _
                                 SMScol(51), SMScol(34), _
                                 SMScol(52), SMScol(32), _
                                 SMScol(53), SMScol(32), _
                                 SMScol(54), SMScol(33), _
                                 SMScol(55), SMScol(34), _
                                 SMScol(56), SMScol(36), _
                                 SMScol(57), SMScol(36), _
                                 SMScol(58), SMScol(37), _
                                 SMScol(59), SMScol(38), _
                                 SMScol(60), SMScol(40), _
                                 SMScol(61), SMScol(40), _
                                 SMScol(62), SMScol(41), _
                                 SMScol(63), SMScol(42)
    Case -2
      'Master System/Mark III Fade-to-Black (2nd Phase)      
      PrivateCol_SMSColor_LockON 0, _
                                 SMScol(0), SMScol(0), _
                                 SMScol(1), SMScol(0), _
                                 SMScol(2), SMScol(18), _
                                 SMScol(3), SMScol(19), _
                                 SMScol(4), SMScol(0), _
                                 SMScol(5), SMScol(0), _
                                 SMScol(6), SMScol(18), _
                                 SMScol(7), SMScol(19), _
                                 SMScol(8), SMScol(18), _
                                 SMScol(9), SMScol(18), _
                                 SMScol(10), SMScol(18), _
                                 SMScol(11), SMScol(19), _
                                 SMScol(12), SMScol(4), _
                                 SMScol(13), SMScol(4), _
                                 SMScol(14), SMScol(4), _
                                 SMScol(15), SMScol(5)
                                 
      PrivateCol_SMSColor_LockON 1, _
                                 SMScol(16), SMScol(0), _
                                 SMScol(17), SMScol(0), _
                                 SMScol(18), SMScol(16), _
                                 SMScol(19), SMScol(1), _
                                 SMScol(20), SMScol(0), _
                                 SMScol(21), SMScol(0), _
                                 SMScol(22), SMScol(16), _
                                 SMScol(23), SMScol(1), _
                                 SMScol(24), SMScol(16), _
                                 SMScol(25), SMScol(16), _
                                 SMScol(26), SMScol(16), _
                                 SMScol(27), SMScol(1), _
                                 SMScol(28), SMScol(4), _
                                 SMScol(29), SMScol(4), _
                                 SMScol(30), SMScol(4), _
                                 SMScol(31), SMScol(5)

      PrivateCol_SMSColor_LockON 2, _
                                 SMScol(32), SMScol(0), _
                                 SMScol(33), SMScol(0), _
                                 SMScol(34), SMScol(16), _
                                 SMScol(35), SMScol(1), _
                                 SMScol(36), SMScol(0), _
                                 SMScol(37), SMScol(0), _
                                 SMScol(38), SMScol(16), _
                                 SMScol(39), SMScol(1), _
                                 SMScol(40), SMScol(16), _
                                 SMScol(41), SMScol(16), _
                                 SMScol(42), SMScol(16), _
                                 SMScol(43), SMScol(1), _
                                 SMScol(44), SMScol(4), _
                                 SMScol(45), SMScol(4), _
                                 SMScol(46), SMScol(4), _
                                 SMScol(47), SMScol(5)

      PrivateCol_SMSColor_LockON 3, _
                                 SMScol(48), SMScol(16), _
                                 SMScol(49), SMScol(16), _
                                 SMScol(50), SMScol(16), _
                                 SMScol(51), SMScol(17), _
                                 SMScol(52), SMScol(16), _
                                 SMScol(53), SMScol(16), _
                                 SMScol(54), SMScol(16), _
                                 SMScol(55), SMScol(17), _
                                 SMScol(56), SMScol(16), _
                                 SMScol(57), SMScol(16), _
                                 SMScol(58), SMScol(16), _
                                 SMScol(59), SMScol(17), _
                                 SMScol(60), SMScol(20), _
                                 SMScol(61), SMScol(20), _
                                 SMScol(62), SMScol(20), _
                                 SMScol(63), SMScol(21)
    Case -3
      'Master System/Mark III Fade-to-Black (3rd Phase)      
      PrivateCol_SMSColor_LockON 0, _
                                 SMScol(0), SMScol(0), _
                                 SMScol(1), SMScol(0), _
                                 SMScol(2), SMScol(0), _
                                 SMScol(3), SMScol(19), _
                                 SMScol(4), SMScol(0), _
                                 SMScol(5), SMScol(0), _
                                 SMScol(6), SMScol(0), _
                                 SMScol(7), SMScol(19), _
                                 SMScol(8), SMScol(0), _
                                 SMScol(9), SMScol(0), _
                                 SMScol(10), SMScol(0), _
                                 SMScol(11), SMScol(19), _
                                 SMScol(12), SMScol(19), _
                                 SMScol(13), SMScol(19), _
                                 SMScol(14), SMScol(19), _
                                 SMScol(15), SMScol(19)
                                 
      PrivateCol_SMSColor_LockON 1, _
                                 SMScol(16), SMScol(0), _
                                 SMScol(17), SMScol(0), _
                                 SMScol(18), SMScol(0), _
                                 SMScol(19), SMScol(16), _
                                 SMScol(20), SMScol(0), _
                                 SMScol(21), SMScol(0), _
                                 SMScol(22), SMScol(0), _
                                 SMScol(23), SMScol(16), _
                                 SMScol(24), SMScol(0), _
                                 SMScol(25), SMScol(0), _
                                 SMScol(26), SMScol(0), _
                                 SMScol(27), SMScol(16), _
                                 SMScol(28), SMScol(16), _
                                 SMScol(29), SMScol(16), _
                                 SMScol(30), SMScol(16), _
                                 SMScol(31), SMScol(16)

      PrivateCol_SMSColor_LockON 2, _
                                 SMScol(32), SMScol(0), _
                                 SMScol(33), SMScol(0), _
                                 SMScol(34), SMScol(0), _
                                 SMScol(35), SMScol(16), _
                                 SMScol(36), SMScol(0), _
                                 SMScol(37), SMScol(0), _
                                 SMScol(38), SMScol(0), _
                                 SMScol(39), SMScol(16), _
                                 SMScol(40), SMScol(0), _
                                 SMScol(41), SMScol(0), _
                                 SMScol(42), SMScol(0), _
                                 SMScol(43), SMScol(16), _
                                 SMScol(44), SMScol(16), _
                                 SMScol(45), SMScol(16), _
                                 SMScol(46), SMScol(16), _
                                 SMScol(47), SMScol(16)

      PrivateCol_SMSColor_LockON 3, _
                                 SMScol(48), SMScol(0), _
                                 SMScol(49), SMScol(0), _
                                 SMScol(50), SMScol(0), _
                                 SMScol(51), SMScol(16), _
                                 SMScol(52), SMScol(0), _
                                 SMScol(53), SMScol(0), _
                                 SMScol(54), SMScol(0), _
                                 SMScol(55), SMScol(16), _
                                 SMScol(56), SMScol(0), _
                                 SMScol(57), SMScol(0), _
                                 SMScol(58), SMScol(0), _
                                 SMScol(59), SMScol(16), _
                                 SMScol(60), SMScol(16), _
                                 SMScol(61), SMScol(16), _
                                 SMScol(62), SMScol(16), _
                                 SMScol(63), SMScol(16)
    Case is < -3
      'Master System/Mark III Fade-to-Black (4th and Final Phase)      
      PrivateCol_SMSColor_LockON 0, _
                                 SMScol(0), SMScol(0), _
                                 SMScol(1), SMScol(0), _
                                 SMScol(2), SMScol(0), _
                                 SMScol(3), SMScol(0), _
                                 SMScol(4), SMScol(0), _
                                 SMScol(5), SMScol(0), _
                                 SMScol(6), SMScol(0), _
                                 SMScol(7), SMScol(0), _
                                 SMScol(8), SMScol(0), _
                                 SMScol(9), SMScol(0), _
                                 SMScol(10), SMScol(0), _
                                 SMScol(11), SMScol(0), _
                                 SMScol(12), SMScol(0), _
                                 SMScol(13), SMScol(0), _
                                 SMScol(14), SMScol(0), _
                                 SMScol(15), SMScol(0)
                                 
      PrivateCol_SMSColor_LockON 1, _
                                 SMScol(16), SMScol(0), _
                                 SMScol(17), SMScol(0), _
                                 SMScol(18), SMScol(0), _
                                 SMScol(19), SMScol(0), _
                                 SMScol(20), SMScol(0), _
                                 SMScol(21), SMScol(0), _
                                 SMScol(22), SMScol(0), _
                                 SMScol(23), SMScol(0), _
                                 SMScol(24), SMScol(0), _
                                 SMScol(25), SMScol(0), _
                                 SMScol(26), SMScol(0), _
                                 SMScol(27), SMScol(0), _
                                 SMScol(28), SMScol(0), _
                                 SMScol(29), SMScol(0), _
                                 SMScol(30), SMScol(0), _
                                 SMScol(31), SMScol(0)

      PrivateCol_SMSColor_LockON 2, _
                                 SMScol(32), SMScol(0), _
                                 SMScol(33), SMScol(0), _
                                 SMScol(34), SMScol(0), _
                                 SMScol(35), SMScol(0), _
                                 SMScol(36), SMScol(0), _
                                 SMScol(37), SMScol(0), _
                                 SMScol(38), SMScol(0), _
                                 SMScol(39), SMScol(0), _
                                 SMScol(40), SMScol(0), _
                                 SMScol(41), SMScol(0), _
                                 SMScol(42), SMScol(0), _
                                 SMScol(43), SMScol(0), _
                                 SMScol(44), SMScol(0), _
                                 SMScol(45), SMScol(0), _
                                 SMScol(46), SMScol(0), _
                                 SMScol(47), SMScol(0)

      PrivateCol_SMSColor_LockON 3, _
                                 SMScol(48), SMScol(0), _
                                 SMScol(49), SMScol(0), _
                                 SMScol(50), SMScol(0), _
                                 SMScol(51), SMScol(0), _
                                 SMScol(52), SMScol(0), _
                                 SMScol(53), SMScol(0), _
                                 SMScol(54), SMScol(0), _
                                 SMScol(55), SMScol(0), _
                                 SMScol(56), SMScol(0), _
                                 SMScol(57), SMScol(0), _
                                 SMScol(58), SMScol(0), _
                                 SMScol(59), SMScol(0), _
                                 SMScol(60), SMScol(0), _
                                 SMScol(61), SMScol(0), _
                                 SMScol(62), SMScol(0), _
                                 SMScol(63), SMScol(0)
  End Select
  
  If Fade_Lvl > 0 then
    Fade_SMSPalOrder = 1 'Reverse order from SMS Color Numbers 63 to 0
  else
    Fade_SMSPalOrder = 0 'Normal order from SMS Color Numbers 0 to 63
  End if

  If buffer = 0 then
    ScreenInfo Gfx_horiz, Gfx_vert
    AF3_PaletteSnapshot = ImageCreate(Gfx_horiz, Gfx_vert)
    Get (0, 0)-(Gfx_horiz - 1, Gfx_vert - 1), AF3_PaletteSnapshot
    AF3_PaletteSnapshot = PrivateColRep_64colors_SMS(AF3_PaletteSnapshot, Fade_SMSPalOrder)
    Put (0, 0), AF3_PaletteSnapshot, trans
    ImageDestroy AF3_PaletteSnapshot
  else
    PrivateCol_check_buffersize buffer, Gfx_horiz, Gfx_vert
    tempbuffer = ImageCreate (Gfx_horiz, Gfx_vert)
    Get buffer, (0, 0)-(Gfx_horiz - 1, Gfx_vert - 1), tempbuffer
    tempbuffer = PrivateColRep_64colors_SMS(tempbuffer, Fade_SMSPalOrder)
    Put buffer, (0, 0), tempbuffer, trans
    ImageDestroy tempbuffer
  End if
End Sub



'_________________________________________________________________________
Sub AFlibIII_FadeGB ( Byval buffer as Any Ptr = 0, _
                      Byval Fade_Lvl As Integer )
                                     
'----------------------------------------------------------------------
' Fades in and out ONLY within the Game Boy (GB) 4-color palette, using
' exclusively all those 4 very colors within the entire constraints
' of that very same palette alone indeed.
'
' On "Fade_Lvl", pass:
'       3 = maximum fade-level to full white
'       0 = no change 
'      -3 = maximum "fade out"-level to full black
'----------------------------------------------------------------------

  Select Case Fade_Lvl
    Case is > 2
      'Game Boy (GB) Fade-to-White (3rd and Final Phase)
      AFlibIII_Replace4Colors buffer, GBcol(0), GBcol(0), _
                                      GBcol(1), GBcol(0), _
                                      GBcol(2), GBcol(0), _
                                      GBcol(3), GBcol(0)
    Case 2
      'Game Boy (GB) Fade-to-White (2nd Phase)
      AFlibIII_Replace4Colors buffer, GBcol(0), GBcol(0), _
                                      GBcol(1), GBcol(0), _
                                      GBcol(2), GBcol(0), _
                                      GBcol(3), GBcol(1)
    Case 1
      'Game Boy (GB) Fade-to-White (1st Phase)
      AFlibIII_Replace4Colors buffer, GBcol(0), GBcol(0), _
                                      GBcol(1), GBcol(0), _
                                      GBcol(2), GBcol(1), _
                                      GBcol(3), GBcol(2)
    Case 0
      Exit Sub  '<---- No change in fading; Neutral
    Case -1
      'Game Boy (GB) Fade-to-Black (1st Phase)
      AFlibIII_Replace4Colors buffer, GBcol(0), GBcol(1), _
                                      GBcol(1), GBcol(2), _
                                      GBcol(2), GBcol(3), _
                                      GBcol(3), GBcol(3)
    Case -2
      'Game Boy (GB) Fade-to-Black (2nd Phase)
      AFlibIII_Replace4Colors buffer, GBcol(0), GBcol(2), _
                                      GBcol(1), GBcol(3), _
                                      GBcol(2), GBcol(3), _
                                      GBcol(3), GBcol(3)
    Case is < -2
      'Game Boy (GB) Fade-to-Black (3rd and Final Phase)
      AFlibIII_Replace4Colors buffer, GBcol(0), GBcol(3), _
                                      GBcol(1), GBcol(3), _
                                      GBcol(2), GBcol(3), _
                                      GBcol(3), GBcol(3)
  End Select
End Sub



'_________________________________________________________________________
Sub AFlibIII_FadeC64 ( Byval buffer as Any Ptr = 0, _
                       Byval Fade_Lvl As Integer )
                                     
'----------------------------------------------------------------------
' Fades in and out ONLY within the Commodore 64 (C64) 16-color palette,
' using exclusively all those 16 very colors within the entire
' constraints of that very same palette alone indeed.
'
' On "Fade_Lvl", pass:
'       6 = maximum fade-level to full white
'       0 = no change 
'      -6 = maximum "fade out"-level to full black
'----------------------------------------------------------------------

  Select Case Fade_Lvl
    Case is > 5
      'C64 Fade-to-White (6th and Final Phase)
      AFlibIII_Replace16Colors buffer, C64col(0), C64col(1), _
                                       C64col(1), C64col(1), _
                                       C64col(2), C64col(1), _
                                       C64col(3), C64col(1), _
                                       C64col(4), C64col(1), _
                                       C64col(5), C64col(1), _
                                       C64col(6), C64col(1), _
                                       C64col(7), C64col(1), _
                                       C64col(8), C64col(1), _
                                       C64col(9), C64col(1), _
                                       C64col(10), C64col(1), _
                                       C64col(11), C64col(1), _
                                       C64col(12), C64col(1), _
                                       C64col(13), C64col(1), _
                                       C64col(14), C64col(1), _
                                       C64col(15), C64col(1)
    Case 5
      'C64 Fade-to-White (5th Phase)
      AFlibIII_Replace16Colors buffer, C64col(0), C64col(7), _
                                       C64col(1), C64col(1), _
                                       C64col(2), C64col(1), _
                                       C64col(3), C64col(1), _
                                       C64col(4), C64col(1), _
                                       C64col(5), C64col(1), _
                                       C64col(6), C64col(1), _
                                       C64col(7), C64col(1), _
                                       C64col(8), C64col(1), _
                                       C64col(9), C64col(7), _
                                       C64col(10), C64col(1), _
                                       C64col(11), C64col(1), _
                                       C64col(12), C64col(1), _
                                       C64col(13), C64col(1), _
                                       C64col(14), C64col(1), _
                                       C64col(15), C64col(1)
    Case 4
      'C64 Fade-to-White (4th Phase)
      AFlibIII_Replace16Colors buffer, C64col(0), C64col(15), _
                                       C64col(1), C64col(1), _
                                       C64col(2), C64col(7), _
                                       C64col(3), C64col(1), _
                                       C64col(4), C64col(1), _
                                       C64col(5), C64col(1), _
                                       C64col(6), C64col(7), _
                                       C64col(7), C64col(1), _
                                       C64col(8), C64col(1), _
                                       C64col(9), C64col(15), _
                                       C64col(10), C64col(1), _
                                       C64col(11), C64col(1), _
                                       C64col(12), C64col(1), _
                                       C64col(13), C64col(1), _
                                       C64col(14), C64col(1), _
                                       C64col(15), C64col(1)
    Case 3
      'C64 Fade-to-White (3rd Phase)
      AFlibIII_Replace16Colors buffer, C64col(0), C64col(12), _
                                       C64col(1), C64col(1), _
                                       C64col(2), C64col(15), _
                                       C64col(3), C64col(1), _
                                       C64col(4), C64col(7), _
                                       C64col(5), C64col(1), _
                                       C64col(6), C64col(15), _
                                       C64col(7), C64col(1), _
                                       C64col(8), C64col(7), _
                                       C64col(9), C64col(10), _
                                       C64col(10), C64col(1), _
                                       C64col(11), C64col(7), _
                                       C64col(12), C64col(1), _
                                       C64col(13), C64col(1), _
                                       C64col(14), C64col(1), _
                                       C64col(15), C64col(1)
    Case 2
      'C64 Fade-to-White (2nd Phase)
      AFlibIII_Replace16Colors buffer, C64col(0), C64col(11), _
                                       C64col(1), C64col(1), _
                                       C64col(2), C64col(10), _
                                       C64col(3), C64col(1), _
                                       C64col(4), C64col(15), _
                                       C64col(5), C64col(1), _
                                       C64col(6), C64col(12), _
                                       C64col(7), C64col(1), _
                                       C64col(8), C64col(15), _
                                       C64col(9), C64col(8), _
                                       C64col(10), C64col(7), _
                                       C64col(11), C64col(15), _
                                       C64col(12), C64col(7), _
                                       C64col(13), C64col(1), _
                                       C64col(14), C64col(7), _
                                       C64col(15), C64col(1)
    Case 1
      'C64 Fade-to-White (1st Phase)
      AFlibIII_Replace16Colors buffer, C64col(0), C64col(6), _
                                       C64col(1), C64col(1), _
                                       C64col(2), C64col(8), _
                                       C64col(3), C64col(7), _
                                       C64col(4), C64col(10), _
                                       C64col(5), C64col(13), _
                                       C64col(6), C64col(11), _
                                       C64col(7), C64col(1), _
                                       C64col(8), C64col(10), _
                                       C64col(9), C64col(2), _
                                       C64col(10), C64col(15), _
                                       C64col(11), C64col(12), _
                                       C64col(12), C64col(15), _
                                       C64col(13), C64col(1), _
                                       C64col(14), C64col(3), _
                                       C64col(15), C64col(7)
    Case 0
      Exit Sub  '<---- No change in fading; Neutral
    Case -1
      'C64 Fade-to-Black (1st Phase)
      AFlibIII_Replace16Colors buffer, C64col(0), C64col(0), _
                                       C64col(1), C64col(7), _
                                       C64col(2), C64col(9), _
                                       C64col(3), C64col(14), _
                                       C64col(4), C64col(2), _
                                       C64col(5), C64col(12), _
                                       C64col(6), C64col(0), _
                                       C64col(7), C64col(15), _
                                       C64col(8), C64col(2), _
                                       C64col(9), C64col(0), _
                                       C64col(10), C64col(8), _
                                       C64col(11), C64col(6), _
                                       C64col(12), C64col(11), _
                                       C64col(13), C64col(5), _
                                       C64col(14), C64col(11), _
                                       C64col(15), C64col(12)
    Case -2
      'C64 Fade-to-Black (2nd Phase)
      AFlibIII_Replace16Colors buffer, C64col(0), C64col(0), _
                                       C64col(1), C64col(15), _
                                       C64col(2), C64col(0), _
                                       C64col(3), C64col(11), _
                                       C64col(4), C64col(9), _
                                       C64col(5), C64col(11), _
                                       C64col(6), C64col(0), _
                                       C64col(7), C64col(12), _
                                       C64col(8), C64col(9), _
                                       C64col(9), C64col(0), _
                                       C64col(10), C64col(2), _
                                       C64col(11), C64col(0), _
                                       C64col(12), C64col(6), _
                                       C64col(13), C64col(12), _
                                       C64col(14), C64col(6), _
                                       C64col(15), C64col(11)
    Case -3
      'C64 Fade-to-Black (3rd Phase)
      AFlibIII_Replace16Colors buffer, C64col(0), C64col(0), _
                                       C64col(1), C64col(12), _
                                       C64col(2), C64col(0), _
                                       C64col(3), C64col(6), _
                                       C64col(4), C64col(0), _
                                       C64col(5), C64col(6), _
                                       C64col(6), C64col(0), _
                                       C64col(7), C64col(11), _
                                       C64col(8), C64col(0), _
                                       C64col(9), C64col(0), _
                                       C64col(10), C64col(9), _
                                       C64col(11), C64col(0), _
                                       C64col(12), C64col(0), _
                                       C64col(13), C64col(11), _
                                       C64col(14), C64col(0), _
                                       C64col(15), C64col(6)
    Case -4
      'C64 Fade-to-Black (4th Phase)
      AFlibIII_Replace16Colors buffer, C64col(0), C64col(0), _
                                       C64col(1), C64col(11), _
                                       C64col(2), C64col(0), _
                                       C64col(3), C64col(0), _
                                       C64col(4), C64col(0), _
                                       C64col(5), C64col(0), _
                                       C64col(6), C64col(0), _
                                       C64col(7), C64col(6), _
                                       C64col(8), C64col(0), _
                                       C64col(9), C64col(0), _
                                       C64col(10), C64col(0), _
                                       C64col(11), C64col(0), _
                                       C64col(12), C64col(0), _
                                       C64col(13), C64col(6), _
                                       C64col(14), C64col(0), _
                                       C64col(15), C64col(0)
    Case -5
      'C64 Fade-to-Black (5th Phase)
      AFlibIII_Replace16Colors buffer, C64col(0), C64col(0), _
                                       C64col(1), C64col(6), _
                                       C64col(2), C64col(0), _
                                       C64col(3), C64col(0), _
                                       C64col(4), C64col(0), _
                                       C64col(5), C64col(0), _
                                       C64col(6), C64col(0), _
                                       C64col(7), C64col(0), _
                                       C64col(8), C64col(0), _
                                       C64col(9), C64col(0), _
                                       C64col(10), C64col(0), _
                                       C64col(11), C64col(0), _
                                       C64col(12), C64col(0), _
                                       C64col(13), C64col(0), _
                                       C64col(14), C64col(0), _
                                       C64col(15), C64col(0)
    Case is < -5
      'C64 Fade-to-Black (5th Phase)
      AFlibIII_Replace16Colors buffer, C64col(0), C64col(0), _
                                       C64col(1), C64col(0), _
                                       C64col(2), C64col(0), _
                                       C64col(3), C64col(0), _
                                       C64col(4), C64col(0), _
                                       C64col(5), C64col(0), _
                                       C64col(6), C64col(0), _
                                       C64col(7), C64col(0), _
                                       C64col(8), C64col(0), _
                                       C64col(9), C64col(0), _
                                       C64col(10), C64col(0), _
                                       C64col(11), C64col(0), _
                                       C64col(12), C64col(0), _
                                       C64col(13), C64col(0), _
                                       C64col(14), C64col(0), _
                                       C64col(15), C64col(0)
  End Select
End Sub



'_________________________________________________________________________
Sub AFlibIII_FadeCPC ( Byval buffer as Any Ptr = 0, _
                       Byval Fade_Lvl As Integer )
                                     
'----------------------------------------------------------------------
' Fades in and out ONLY within the Amstrad CPC 27-color palette, using
' exclusively all those 27 very colors within the entire constraints
' of that very same palette alone indeed.
'
' On "Fade_Lvl", pass:
'       8 = maximum fade-level to full white
'       0 = no change 
'      -8 = maximum "fade out"-level to full black
'----------------------------------------------------------------------

  Select Case Fade_Lvl
    Case is > 7
      'Amstrad CPC 27-color Fade-to-White (8th and Final Phase)
      AFlibIII_ReplaceColor_Wildcard buffer, CPCcol(0), CPCcol(26), _
                                             CPCcol(1), CPCcol(26), _
                                             CPCcol(2), CPCcol(26), _
                                             CPCcol(3), CPCcol(26), _
                                             CPCcol(4), CPCcol(26), _
                                             CPCcol(5), CPCcol(26), _
                                             CPCcol(6), CPCcol(26), _
                                             CPCcol(7), CPCcol(26), _
                                             CPCcol(8), CPCcol(26), _
                                             CPCcol(9), CPCcol(26), _
                                             CPCcol(10), CPCcol(26), _
                                             CPCcol(11), CPCcol(26), _
                                             CPCcol(12), CPCcol(26), _
                                             CPCcol(13), CPCcol(26), _
                                             CPCcol(14), CPCcol(26), _
                                             CPCcol(15), CPCcol(26), _
                                             CPCcol(16), CPCcol(26), _
                                             CPCcol(17), CPCcol(26), _
                                             CPCcol(18), CPCcol(26), _
                                             CPCcol(19), CPCcol(26), _
                                             CPCcol(20), CPCcol(26), _
                                             CPCcol(21), CPCcol(26), _
                                             CPCcol(22), CPCcol(26), _
                                             CPCcol(23), CPCcol(26), _
                                             CPCcol(24), CPCcol(26), _
                                             CPCcol(25), CPCcol(26), _
                                             CPCcol(26), CPCcol(26)
    Case 7
      'Amstrad CPC 27-color Fade-to-White (7th Phase)
      AFlibIII_ReplaceColor_Wildcard buffer, CPCcol(0), CPCcol(25), _
                                             CPCcol(1), CPCcol(26), _
                                             CPCcol(2), CPCcol(26), _
                                             CPCcol(3), CPCcol(26), _
                                             CPCcol(4), CPCcol(26), _
                                             CPCcol(5), CPCcol(26), _
                                             CPCcol(6), CPCcol(26), _
                                             CPCcol(7), CPCcol(26), _
                                             CPCcol(8), CPCcol(26), _
                                             CPCcol(9), CPCcol(26), _
                                             CPCcol(10), CPCcol(26), _
                                             CPCcol(11), CPCcol(26), _
                                             CPCcol(12), CPCcol(26), _
                                             CPCcol(13), CPCcol(26), _
                                             CPCcol(14), CPCcol(26), _
                                             CPCcol(15), CPCcol(26), _
                                             CPCcol(16), CPCcol(26), _
                                             CPCcol(17), CPCcol(26), _
                                             CPCcol(18), CPCcol(26), _
                                             CPCcol(19), CPCcol(26), _
                                             CPCcol(20), CPCcol(26), _
                                             CPCcol(21), CPCcol(26), _
                                             CPCcol(22), CPCcol(26), _
                                             CPCcol(23), CPCcol(26), _
                                             CPCcol(24), CPCcol(26), _
                                             CPCcol(25), CPCcol(26), _
                                             CPCcol(26), CPCcol(26)
    Case 6
      'Amstrad CPC 27-color Fade-to-White (6th Phase)
      AFlibIII_ReplaceColor_Wildcard buffer, CPCcol(0), CPCcol(24), _
                                             CPCcol(1), CPCcol(26), _
                                             CPCcol(2), CPCcol(26), _
                                             CPCcol(3), CPCcol(26), _
                                             CPCcol(4), CPCcol(26), _
                                             CPCcol(5), CPCcol(26), _
                                             CPCcol(6), CPCcol(26), _
                                             CPCcol(7), CPCcol(26), _
                                             CPCcol(8), CPCcol(26), _
                                             CPCcol(9), CPCcol(26), _
                                             CPCcol(10), CPCcol(26), _
                                             CPCcol(11), CPCcol(26), _
                                             CPCcol(12), CPCcol(26), _
                                             CPCcol(13), CPCcol(26), _
                                             CPCcol(14), CPCcol(26), _
                                             CPCcol(15), CPCcol(26), _
                                             CPCcol(16), CPCcol(26), _
                                             CPCcol(17), CPCcol(26), _
                                             CPCcol(18), CPCcol(26), _
                                             CPCcol(19), CPCcol(26), _
                                             CPCcol(20), CPCcol(26), _
                                             CPCcol(21), CPCcol(26), _
                                             CPCcol(22), CPCcol(26), _
                                             CPCcol(23), CPCcol(26), _
                                             CPCcol(24), CPCcol(26), _
                                             CPCcol(25), CPCcol(26), _
                                             CPCcol(26), CPCcol(26)
    Case 5
      'Amstrad CPC 27-color Fade-to-White (5th Phase)
      AFlibIII_ReplaceColor_Wildcard buffer, CPCcol(0), CPCcol(17), _
                                             CPCcol(1), CPCcol(25), _
                                             CPCcol(2), CPCcol(26), _
                                             CPCcol(3), CPCcol(26), _
                                             CPCcol(4), CPCcol(26), _
                                             CPCcol(5), CPCcol(26), _
                                             CPCcol(6), CPCcol(26), _
                                             CPCcol(7), CPCcol(26), _
                                             CPCcol(8), CPCcol(26), _
                                             CPCcol(9), CPCcol(26), _
                                             CPCcol(10), CPCcol(26), _
                                             CPCcol(11), CPCcol(26), _
                                             CPCcol(12), CPCcol(26), _
                                             CPCcol(13), CPCcol(26), _
                                             CPCcol(14), CPCcol(26), _
                                             CPCcol(15), CPCcol(26), _
                                             CPCcol(16), CPCcol(26), _
                                             CPCcol(17), CPCcol(26), _
                                             CPCcol(18), CPCcol(26), _
                                             CPCcol(19), CPCcol(26), _
                                             CPCcol(20), CPCcol(26), _
                                             CPCcol(21), CPCcol(26), _
                                             CPCcol(22), CPCcol(26), _
                                             CPCcol(23), CPCcol(26), _
                                             CPCcol(24), CPCcol(26), _
                                             CPCcol(25), CPCcol(26), _
                                             CPCcol(26), CPCcol(26)
    Case 4
      'Amstrad CPC 27-color Fade-to-White (4th Phase)
      AFlibIII_ReplaceColor_Wildcard buffer, CPCcol(0), CPCcol(13), _
                                             CPCcol(1), CPCcol(24), _
                                             CPCcol(2), CPCcol(25), _
                                             CPCcol(3), CPCcol(25), _
                                             CPCcol(4), CPCcol(25), _
                                             CPCcol(5), CPCcol(25), _
                                             CPCcol(6), CPCcol(26), _
                                             CPCcol(7), CPCcol(26), _
                                             CPCcol(8), CPCcol(26), _
                                             CPCcol(9), CPCcol(25), _
                                             CPCcol(10), CPCcol(25), _
                                             CPCcol(11), CPCcol(26), _
                                             CPCcol(12), CPCcol(26), _
                                             CPCcol(13), CPCcol(26), _
                                             CPCcol(14), CPCcol(26), _
                                             CPCcol(15), CPCcol(26), _
                                             CPCcol(16), CPCcol(26), _
                                             CPCcol(17), CPCcol(26), _
                                             CPCcol(18), CPCcol(26), _
                                             CPCcol(19), CPCcol(26), _
                                             CPCcol(20), CPCcol(26), _
                                             CPCcol(21), CPCcol(26), _
                                             CPCcol(22), CPCcol(26), _
                                             CPCcol(23), CPCcol(26), _
                                             CPCcol(24), CPCcol(26), _
                                             CPCcol(25), CPCcol(26), _
                                             CPCcol(26), CPCcol(26)
    Case 3
      'Amstrad CPC 27-color Fade-to-White (3rd Phase)
      AFlibIII_ReplaceColor_Wildcard buffer, CPCcol(0), CPCcol(10), _
                                             CPCcol(1), CPCcol(23), _
                                             CPCcol(2), CPCcol(24), _
                                             CPCcol(3), CPCcol(24), _
                                             CPCcol(4), CPCcol(24), _
                                             CPCcol(5), CPCcol(24), _
                                             CPCcol(6), CPCcol(25), _
                                             CPCcol(7), CPCcol(25), _
                                             CPCcol(8), CPCcol(25), _
                                             CPCcol(9), CPCcol(24), _
                                             CPCcol(10), CPCcol(24), _
                                             CPCcol(11), CPCcol(25), _
                                             CPCcol(12), CPCcol(25), _
                                             CPCcol(13), CPCcol(25), _
                                             CPCcol(14), CPCcol(25), _
                                             CPCcol(15), CPCcol(26), _
                                             CPCcol(16), CPCcol(26), _
                                             CPCcol(17), CPCcol(26), _
                                             CPCcol(18), CPCcol(25), _
                                             CPCcol(19), CPCcol(25), _
                                             CPCcol(20), CPCcol(25), _
                                             CPCcol(21), CPCcol(26), _
                                             CPCcol(22), CPCcol(26), _
                                             CPCcol(23), CPCcol(26), _
                                             CPCcol(24), CPCcol(26), _
                                             CPCcol(25), CPCcol(26), _
                                             CPCcol(26), CPCcol(26)
    Case 2
      'Amstrad CPC 27-color Fade-to-White (2nd Phase)
      AFlibIII_ReplaceColor_Wildcard buffer, CPCcol(0), CPCcol(2), _
                                             CPCcol(1), CPCcol(11), _
                                             CPCcol(2), CPCcol(23), _
                                             CPCcol(3), CPCcol(15), _
                                             CPCcol(4), CPCcol(17), _
                                             CPCcol(5), CPCcol(17), _
                                             CPCcol(6), CPCcol(24), _
                                             CPCcol(7), CPCcol(24), _
                                             CPCcol(8), CPCcol(24), _
                                             CPCcol(9), CPCcol(21), _
                                             CPCcol(10), CPCcol(23), _
                                             CPCcol(11), CPCcol(24), _
                                             CPCcol(12), CPCcol(24), _
                                             CPCcol(13), CPCcol(24), _
                                             CPCcol(14), CPCcol(24), _
                                             CPCcol(15), CPCcol(25), _
                                             CPCcol(16), CPCcol(25), _
                                             CPCcol(17), CPCcol(25), _
                                             CPCcol(18), CPCcol(24), _
                                             CPCcol(19), CPCcol(24), _
                                             CPCcol(20), CPCcol(24), _
                                             CPCcol(21), CPCcol(25), _
                                             CPCcol(22), CPCcol(25), _
                                             CPCcol(23), CPCcol(25), _
                                             CPCcol(24), CPCcol(26), _
                                             CPCcol(25), CPCcol(26), _
                                             CPCcol(26), CPCcol(26)
    Case 1
      'Amstrad CPC 27-color Fade-to-White (1st Phase)
      AFlibIII_ReplaceColor_Wildcard buffer, CPCcol(0), CPCcol(1), _
                                             CPCcol(1), CPCcol(2), _
                                             CPCcol(2), CPCcol(11), _
                                             CPCcol(3), CPCcol(6), _
                                             CPCcol(4), CPCcol(8), _
                                             CPCcol(5), CPCcol(8), _
                                             CPCcol(6), CPCcol(15), _
                                             CPCcol(7), CPCcol(16), _
                                             CPCcol(8), CPCcol(17), _
                                             CPCcol(9), CPCcol(18), _
                                             CPCcol(10), CPCcol(19), _
                                             CPCcol(11), CPCcol(23), _
                                             CPCcol(12), CPCcol(16), _
                                             CPCcol(13), CPCcol(17), _
                                             CPCcol(14), CPCcol(17), _
                                             CPCcol(15), CPCcol(24), _
                                             CPCcol(16), CPCcol(24), _
                                             CPCcol(17), CPCcol(24), _
                                             CPCcol(18), CPCcol(21), _
                                             CPCcol(19), CPCcol(23), _
                                             CPCcol(20), CPCcol(23), _
                                             CPCcol(21), CPCcol(24), _
                                             CPCcol(22), CPCcol(24), _
                                             CPCcol(23), CPCcol(24), _
                                             CPCcol(24), CPCcol(25), _
                                             CPCcol(25), CPCcol(26), _
                                             CPCcol(26), CPCcol(26)
    Case 0
      Exit Sub  '<---- No change in fading; Neutral
    Case -1
      'Amstrad CPC 27-color Fade-to-Black (1st Phase)
      AFlibIII_ReplaceColor_Wildcard buffer, CPCcol(0), CPCcol(0), _
                                             CPCcol(1), CPCcol(0), _
                                             CPCcol(2), CPCcol(1), _
                                             CPCcol(3), CPCcol(1), _
                                             CPCcol(4), CPCcol(2), _
                                             CPCcol(5), CPCcol(2), _
                                             CPCcol(6), CPCcol(3), _
                                             CPCcol(7), CPCcol(4), _
                                             CPCcol(8), CPCcol(4), _
                                             CPCcol(9), CPCcol(1), _
                                             CPCcol(10), CPCcol(2), _
                                             CPCcol(11), CPCcol(2), _
                                             CPCcol(12), CPCcol(9), _
                                             CPCcol(13), CPCcol(10), _
                                             CPCcol(14), CPCcol(11), _
                                             CPCcol(15), CPCcol(6), _
                                             CPCcol(16), CPCcol(7), _
                                             CPCcol(17), CPCcol(8), _
                                             CPCcol(18), CPCcol(9), _
                                             CPCcol(19), CPCcol(10), _
                                             CPCcol(20), CPCcol(11), _
                                             CPCcol(21), CPCcol(9), _
                                             CPCcol(22), CPCcol(11), _
                                             CPCcol(23), CPCcol(19), _
                                             CPCcol(24), CPCcol(15), _
                                             CPCcol(25), CPCcol(24), _
                                             CPCcol(26), CPCcol(25)
    Case -2
      'Amstrad CPC 27-color Fade-to-Black (2nd Phase)
      AFlibIII_ReplaceColor_Wildcard buffer, CPCcol(0), CPCcol(0), _
                                             CPCcol(1), CPCcol(0), _
                                             CPCcol(2), CPCcol(0), _
                                             CPCcol(3), CPCcol(0), _
                                             CPCcol(4), CPCcol(1), _
                                             CPCcol(5), CPCcol(1), _
                                             CPCcol(6), CPCcol(1), _
                                             CPCcol(7), CPCcol(2), _
                                             CPCcol(8), CPCcol(2), _
                                             CPCcol(9), CPCcol(0), _
                                             CPCcol(10), CPCcol(1), _
                                             CPCcol(11), CPCcol(1), _
                                             CPCcol(12), CPCcol(2), _
                                             CPCcol(13), CPCcol(2), _
                                             CPCcol(14), CPCcol(2), _
                                             CPCcol(15), CPCcol(3), _
                                             CPCcol(16), CPCcol(4), _
                                             CPCcol(17), CPCcol(5), _
                                             CPCcol(18), CPCcol(2), _
                                             CPCcol(19), CPCcol(2), _
                                             CPCcol(20), CPCcol(2), _
                                             CPCcol(21), CPCcol(2), _
                                             CPCcol(22), CPCcol(2), _
                                             CPCcol(23), CPCcol(10), _
                                             CPCcol(24), CPCcol(6), _
                                             CPCcol(25), CPCcol(15), _
                                             CPCcol(26), CPCcol(24)
    Case -3
      'Amstrad CPC 27-color Fade-to-Black (3rd Phase)
      AFlibIII_ReplaceColor_Wildcard buffer, CPCcol(0), CPCcol(0), _
                                             CPCcol(1), CPCcol(0), _
                                             CPCcol(2), CPCcol(0), _
                                             CPCcol(3), CPCcol(0), _
                                             CPCcol(4), CPCcol(0), _
                                             CPCcol(5), CPCcol(0), _
                                             CPCcol(6), CPCcol(0), _
                                             CPCcol(7), CPCcol(1), _
                                             CPCcol(8), CPCcol(1), _
                                             CPCcol(9), CPCcol(0), _
                                             CPCcol(10), CPCcol(0), _
                                             CPCcol(11), CPCcol(0), _
                                             CPCcol(12), CPCcol(1), _
                                             CPCcol(13), CPCcol(1), _
                                             CPCcol(14), CPCcol(1), _
                                             CPCcol(15), CPCcol(1), _
                                             CPCcol(16), CPCcol(2), _
                                             CPCcol(17), CPCcol(2), _
                                             CPCcol(18), CPCcol(1), _
                                             CPCcol(19), CPCcol(1), _
                                             CPCcol(20), CPCcol(1), _
                                             CPCcol(21), CPCcol(1), _
                                             CPCcol(22), CPCcol(1), _
                                             CPCcol(23), CPCcol(2), _
                                             CPCcol(24), CPCcol(3), _
                                             CPCcol(25), CPCcol(6), _
                                             CPCcol(26), CPCcol(17)
    Case -4
      'Amstrad CPC 27-color Fade-to-Black (4th Phase)
      AFlibIII_ReplaceColor_Wildcard buffer, CPCcol(0), CPCcol(0), _
                                             CPCcol(1), CPCcol(0), _
                                             CPCcol(2), CPCcol(0), _
                                             CPCcol(3), CPCcol(0), _
                                             CPCcol(4), CPCcol(0), _
                                             CPCcol(5), CPCcol(0), _
                                             CPCcol(6), CPCcol(0), _
                                             CPCcol(7), CPCcol(0), _
                                             CPCcol(8), CPCcol(0), _
                                             CPCcol(9), CPCcol(0), _
                                             CPCcol(10), CPCcol(0), _
                                             CPCcol(11), CPCcol(0), _
                                             CPCcol(12), CPCcol(0), _
                                             CPCcol(13), CPCcol(0), _
                                             CPCcol(14), CPCcol(0), _
                                             CPCcol(15), CPCcol(0), _
                                             CPCcol(16), CPCcol(1), _
                                             CPCcol(17), CPCcol(1), _
                                             CPCcol(18), CPCcol(0), _
                                             CPCcol(19), CPCcol(0), _
                                             CPCcol(20), CPCcol(0), _
                                             CPCcol(21), CPCcol(0), _
                                             CPCcol(22), CPCcol(0), _
                                             CPCcol(23), CPCcol(1), _
                                             CPCcol(24), CPCcol(1), _
                                             CPCcol(25), CPCcol(3), _
                                             CPCcol(26), CPCcol(13)
    Case -5
      'Amstrad CPC 27-color Fade-to-Black (5th Phase)
      AFlibIII_ReplaceColor_Wildcard buffer, CPCcol(0), CPCcol(0), _
                                             CPCcol(1), CPCcol(0), _
                                             CPCcol(2), CPCcol(0), _
                                             CPCcol(3), CPCcol(0), _
                                             CPCcol(4), CPCcol(0), _
                                             CPCcol(5), CPCcol(0), _
                                             CPCcol(6), CPCcol(0), _
                                             CPCcol(7), CPCcol(0), _
                                             CPCcol(8), CPCcol(0), _
                                             CPCcol(9), CPCcol(0), _
                                             CPCcol(10), CPCcol(0), _
                                             CPCcol(11), CPCcol(0), _
                                             CPCcol(12), CPCcol(0), _
                                             CPCcol(13), CPCcol(0), _
                                             CPCcol(14), CPCcol(0), _
                                             CPCcol(15), CPCcol(0), _
                                             CPCcol(16), CPCcol(0), _
                                             CPCcol(17), CPCcol(0), _
                                             CPCcol(18), CPCcol(0), _
                                             CPCcol(19), CPCcol(0), _
                                             CPCcol(20), CPCcol(0), _
                                             CPCcol(21), CPCcol(0), _
                                             CPCcol(22), CPCcol(0), _
                                             CPCcol(23), CPCcol(0), _
                                             CPCcol(24), CPCcol(0), _
                                             CPCcol(25), CPCcol(1), _
                                             CPCcol(26), CPCcol(10)
    Case -6
      'Amstrad CPC 27-color Fade-to-Black (6th Phase)
      AFlibIII_ReplaceColor_Wildcard buffer, CPCcol(0), CPCcol(0), _
                                             CPCcol(1), CPCcol(0), _
                                             CPCcol(2), CPCcol(0), _
                                             CPCcol(3), CPCcol(0), _
                                             CPCcol(4), CPCcol(0), _
                                             CPCcol(5), CPCcol(0), _
                                             CPCcol(6), CPCcol(0), _
                                             CPCcol(7), CPCcol(0), _
                                             CPCcol(8), CPCcol(0), _
                                             CPCcol(9), CPCcol(0), _
                                             CPCcol(10), CPCcol(0), _
                                             CPCcol(11), CPCcol(0), _
                                             CPCcol(12), CPCcol(0), _
                                             CPCcol(13), CPCcol(0), _
                                             CPCcol(14), CPCcol(0), _
                                             CPCcol(15), CPCcol(0), _
                                             CPCcol(16), CPCcol(0), _
                                             CPCcol(17), CPCcol(0), _
                                             CPCcol(18), CPCcol(0), _
                                             CPCcol(19), CPCcol(0), _
                                             CPCcol(20), CPCcol(0), _
                                             CPCcol(21), CPCcol(0), _
                                             CPCcol(22), CPCcol(0), _
                                             CPCcol(23), CPCcol(0), _
                                             CPCcol(24), CPCcol(0), _
                                             CPCcol(25), CPCcol(0), _
                                             CPCcol(26), CPCcol(2)
    Case -7
      'Amstrad CPC 27-color Fade-to-Black (7th Phase)
      AFlibIII_ReplaceColor_Wildcard buffer, CPCcol(0), CPCcol(0), _
                                             CPCcol(1), CPCcol(0), _
                                             CPCcol(2), CPCcol(0), _
                                             CPCcol(3), CPCcol(0), _
                                             CPCcol(4), CPCcol(0), _
                                             CPCcol(5), CPCcol(0), _
                                             CPCcol(6), CPCcol(0), _
                                             CPCcol(7), CPCcol(0), _
                                             CPCcol(8), CPCcol(0), _
                                             CPCcol(9), CPCcol(0), _
                                             CPCcol(10), CPCcol(0), _
                                             CPCcol(11), CPCcol(0), _
                                             CPCcol(12), CPCcol(0), _
                                             CPCcol(13), CPCcol(0), _
                                             CPCcol(14), CPCcol(0), _
                                             CPCcol(15), CPCcol(0), _
                                             CPCcol(16), CPCcol(0), _
                                             CPCcol(17), CPCcol(0), _
                                             CPCcol(18), CPCcol(0), _
                                             CPCcol(19), CPCcol(0), _
                                             CPCcol(20), CPCcol(0), _
                                             CPCcol(21), CPCcol(0), _
                                             CPCcol(22), CPCcol(0), _
                                             CPCcol(23), CPCcol(0), _
                                             CPCcol(24), CPCcol(0), _
                                             CPCcol(25), CPCcol(0), _
                                             CPCcol(26), CPCcol(1)
    Case is < -7
      'Amstrad CPC 27-color Fade-to-Black (8th and Final Phase)
      AFlibIII_ReplaceColor_Wildcard buffer, CPCcol(0), CPCcol(0), _
                                             CPCcol(1), CPCcol(0), _
                                             CPCcol(2), CPCcol(0), _
                                             CPCcol(3), CPCcol(0), _
                                             CPCcol(4), CPCcol(0), _
                                             CPCcol(5), CPCcol(0), _
                                             CPCcol(6), CPCcol(0), _
                                             CPCcol(7), CPCcol(0), _
                                             CPCcol(8), CPCcol(0), _
                                             CPCcol(9), CPCcol(0), _
                                             CPCcol(10), CPCcol(0), _
                                             CPCcol(11), CPCcol(0), _
                                             CPCcol(12), CPCcol(0), _
                                             CPCcol(13), CPCcol(0), _
                                             CPCcol(14), CPCcol(0), _
                                             CPCcol(15), CPCcol(0), _
                                             CPCcol(16), CPCcol(0), _
                                             CPCcol(17), CPCcol(0), _
                                             CPCcol(18), CPCcol(0), _
                                             CPCcol(19), CPCcol(0), _
                                             CPCcol(20), CPCcol(0), _
                                             CPCcol(21), CPCcol(0), _
                                             CPCcol(22), CPCcol(0), _
                                             CPCcol(23), CPCcol(0), _
                                             CPCcol(24), CPCcol(0), _
                                             CPCcol(25), CPCcol(0), _
                                             CPCcol(26), CPCcol(0)
  End Select
End Sub













Private Function ENTERPRISEeasy ( Byval R_col as Integer, _
                                  Byval G_col as Integer, _
                                  Byval B_col as Integer ) as Integer
  
  Dim Color_Result as Integer
  Dim as Integer R_mix, G_mix, B_mix
  
  If R_col < 0 then R_col = 0
  If G_col < 0 then G_col = 0
  If B_col < 0 then B_col = 0
  If R_col > 7 then R_col = 7
  If G_col > 7 then G_col = 7
  If B_col > 7 then B_col = 7
  
  Select Case R_col
    Case 0: R_mix = 0
    Case 1: R_mix = 64
    Case 2: R_mix = 8
    Case 3: R_mix = 72
    Case 4: R_mix = 1
    Case 5: R_mix = 65
    Case 6: R_mix = 9
    Case 7: R_mix = 73
  End Select

  Select Case G_col
    Case 0: G_mix = 0
    Case 1: G_mix = 128
    Case 2: G_mix = 16
    Case 3: G_mix = 144
    Case 4: G_mix = 2
    Case 5: G_mix = 130
    Case 6: G_mix = 18
    Case 7: G_mix = 146
  End Select

  Select Case B_col
    Case 0: B_mix = 0
    Case 1: B_mix = 0
    Case 2: B_mix = 32
    Case 3: B_mix = 32
    Case 4: B_mix = 4
    Case 5: B_mix = 4
    Case 6: B_mix = 36
    Case 7: B_mix = 36
  End Select

  Color_Result = ENTERPRISEcol(R_mix + G_mix + B_mix)
  Return Color_Result

End Function



Private Function SAMCOUPEeasy ( Byval R_col as Integer, _
                                Byval G_col as Integer, _
                                Byval B_col as Integer, _
                                Byval Intensity as Integer = 0 ) as Integer
  
  Dim Color_Result as Integer
  Dim as Integer R_mix, G_mix, B_mix, I_mix
  
  If R_col < 0 then R_col = 0
  If G_col < 0 then G_col = 0
  If B_col < 0 then B_col = 0
  If R_col > 3 then R_col = 3
  If G_col > 3 then G_col = 3
  If B_col > 3 then B_col = 3
  
  If R_col >= 1 then R_mix += 2
  If R_col >= 2 then R_mix += 30
  If R_col >  2 then R_mix += 2

  If G_col >= 1 then G_mix += 4
  If G_col >= 2 then G_mix += 60
  If G_col >  2 then G_mix += 4

  If B_col >= 1 then B_mix += 1
  If B_col >= 2 then B_mix += 15
  If B_col >  2 then B_mix += 1
  
  If Intensity >= 1 then I_mix = 8

  Color_Result = SAMCOUPEcol(R_mix + G_mix + B_mix + I_mix)
  Return Color_Result

End Function



Private Function SMSeasy ( Byval R_col as Integer, _
                           Byval G_col as Integer, _
                           Byval B_col as Integer ) as Integer
  
  Dim Color_Result as Integer

  If R_col < 0 then R_col = 0
  If G_col < 0 then G_col = 0
  If B_col < 0 then B_col = 0
  If R_col > 3 then R_col = 3
  If G_col > 3 then G_col = 3
  If B_col > 3 then B_col = 3
  
  Color_Result = SMScol((R_col) + (G_col * 4) + (B_col * 16))
  Return Color_Result

End Function



Private Function RGB512easy ( Byval R_col as Integer, _
                              Byval G_col as Integer, _
                              Byval B_col as Integer ) as Integer
  
  Dim Color_Result as Integer

  If R_col < 0 then R_col = 0
  If G_col < 0 then G_col = 0
  If B_col < 0 then B_col = 0
  If R_col > 7 then R_col = 7
  If G_col > 7 then G_col = 7
  If B_col > 7 then B_col = 7
  
  Color_Result = RGB512col((R_col * 8) + (G_col * 64) + (B_col))
  Return Color_Result

End Function



Private Function RGB4096easy ( Byval R_col as Integer, _
                               Byval G_col as Integer, _
                               Byval B_col as Integer ) as Integer
  
  Dim Color_Result as Integer

  If R_col < 0 then R_col = 0
  If G_col < 0 then G_col = 0
  If B_col < 0 then B_col = 0
  If R_col > 15 then R_col = 15
  If G_col > 15 then G_col = 15
  If B_col > 15 then B_col = 15
  
  Select Case R_col
    Case is < 8: R_col *= 16
    Case is >= 8: R_col = (2032 + ((R_col - 7) * 16))
  End Select
  
  Color_Result = RGB4096col((R_col) + (G_col * 128) + (B_col))
  Return Color_Result

End Function



Private Sub PrivateCol_check_buffersize ( Byval buffer As Any Ptr, Byref x As Integer, _
                                          Byref y As Integer )

'----------------------------------------------------------------------
' BIG special thanks to cha0s on this *excellent* buffer detection
' routine!!!  d=^-^=b !!
'----------------------------------------------------------------------

x = 0: y = 0
If buffer = 0 Then Exit Sub

If isBufferNew_f( buffer ) Then
  x = cast( Uinteger Ptr, buffer )[2]
  y = cast( Uinteger Ptr, buffer )[3]
else
  x = cast( Ushort Ptr, buffer )[0] Shr 3
  y = cast( Ushort Ptr, buffer )[1]
end If
        
end sub



Public Sub PrivateCol_Print ( Byref text as string, _
                               Byval x AS integer, Byval y AS integer, _
                               Byval scale_x as single, Byval scale_y as single, _
                               Byval col_1 as integer, Byval col_2 as integer, _
                               Byval italic as integer, Byval style as integer, _
                               Byval fonttype as integer = 0, Byval buffer as Any Ptr = 0 )

'---------------------------------------------------------------------
' BIG Special Thanks to yetifoot for improving this routine to make
' this baby run even faster than ever!!!  d=^-^=b !!
'---------------------------------------------------------------------

Dim as Integer i, cf, vf, Row, Chara_Input, Chara_Scan, c, l, start_x

Dim As Integer f
start_x = (x + 1)
x = start_x
scale_x = ((scale_x * 2) - 1)
scale_y = ((scale_y * 2) - 1)
If scale_x < 0 then scale_x = 0
If scale_y < 0 then scale_y = 0

If fonttype = 0 then
  For i = 1 TO LEN(Text)
    Chara_Input = (ASC(Mid(Text, i, 1)))
    For Row = 0 TO 7
      For Chara_Scan = 0 TO 7
        If Bit(AF3_palFTarray(2, Chara_Input, row), 7 - Chara_Scan) Then
          If (buffer) THEN
            If style = 0 then Pset buffer, (((((x + Chara_Scan) * scale_x) - (Row * Italic)) + ((i - 1) * (scale_x * 8)) - 1), y + (Row * scale_y)), col_1
            If style = 1 then Line buffer, (((((x + Chara_Scan) * scale_x) - (Row * Italic)) + ((i - 1) * (scale_x * 8)) - 1), y + (Row * scale_y))-(((((x + Chara_Scan) * scale_x) - (Row * Italic)) + (scale_x - 1) + ((i - 1) * (scale_x * 8)) - 1), (y + (Row * scale_y)) + (scale_y - 1)), col_1, B
            If style = 2 then Line buffer, (((((x + Chara_Scan) * scale_x) - (Row * Italic)) + ((i - 1) * (scale_x * 8)) - 1), y + (Row * scale_y))-(((((X + Chara_Scan) * scale_x) - (Row * Italic)) + (scale_x - 1) + ((i - 1) * (scale_x * 8)) - 1), (y + (Row * scale_y)) + (scale_y - 1)), col_1, BF
          else
            If style = 0 then Pset (((((x + Chara_Scan) * scale_x) - (Row * Italic)) + ((i - 1) * (scale_x * 8)) - 1), y + (Row * scale_y)), col_1
            If style = 1 then Line (((((x + Chara_Scan) * scale_x) - (Row * Italic)) + ((i - 1) * (scale_x * 8)) - 1), y + (Row * scale_y))-(((((x + Chara_Scan) * scale_x) - (Row * Italic)) + (scale_x - 1) + ((i - 1) * (scale_x * 8)) - 1), (y + (Row * scale_y)) + (scale_y - 1)), col_1, B
            If style = 2 then Line (((((x + Chara_Scan) * scale_x) - (Row * Italic)) + ((i - 1) * (scale_x * 8)) - 1), y + (Row * scale_y))-(((((X + Chara_Scan) * scale_x) - (Row * Italic)) + (scale_x - 1) + ((i - 1) * (scale_x * 8)) - 1), (y + (Row * scale_y)) + (scale_y - 1)), col_1, BF
          End if
        End If
      Next
    Next
    x -= 4
  Next

  x = start_x
  For i = 1 TO LEN(Text)
    Chara_Input = (ASC(Mid(Text, i, 1)))
    For Row = 0 TO 7
      For Chara_Scan = 0 TO 7
        If Bit(AF3_palFTarray(1, Chara_Input, row), 7 - Chara_Scan) Then
          If (buffer) THEN
            If style = 0 then Pset buffer, (((((x + Chara_Scan) * scale_x) - (Row * Italic)) + ((i - 1) * (scale_x * 8)) - 1), y + (Row * scale_y)), col_2
            If style = 1 then Line buffer, (((((x + Chara_Scan) * scale_x) - (Row * Italic)) + ((i - 1) * (scale_x * 8)) - 1), y + (Row * scale_y))-(((((x + Chara_Scan) * scale_x) - (Row * Italic)) + (scale_x - 1) + ((i - 1) * (scale_x * 8)) - 1), (y + (Row * scale_y)) + (scale_y - 1)), col_2, B
            If style = 2 then Line buffer, (((((x + Chara_Scan) * scale_x) - (Row * Italic)) + ((i - 1) * (scale_x * 8)) - 1), y + (Row * scale_y))-(((((X + Chara_Scan) * scale_x) - (Row * Italic)) + (scale_x - 1) + ((i - 1) * (scale_x * 8)) - 1), (y + (Row * scale_y)) + (scale_y - 1)), col_2, BF
          else
            If style = 0 then Pset (((((x + Chara_Scan) * scale_x) - (Row * Italic)) + ((i - 1) * (scale_x * 8)) - 1), y + (Row * scale_y)), col_2
            If style = 1 then Line (((((x + Chara_Scan) * scale_x) - (Row * Italic)) + ((i - 1) * (scale_x * 8)) - 1), y + (Row * scale_y))-(((((x + Chara_Scan) * scale_x) - (Row * Italic)) + (scale_x - 1) + ((i - 1) * (scale_x * 8)) - 1), (y + (Row * scale_y)) + (scale_y - 1)), col_2, B
            If style = 2 then Line (((((x + Chara_Scan) * scale_x) - (Row * Italic)) + ((i - 1) * (scale_x * 8)) - 1), y + (Row * scale_y))-(((((X + Chara_Scan) * scale_x) - (Row * Italic)) + (scale_x - 1) + ((i - 1) * (scale_x * 8)) - 1), (y + (Row * scale_y)) + (scale_y - 1)), col_2, BF
          End if
        End If
      Next
    Next
    x -= 4
  Next
  
else
  
  For i = 1 TO LEN(Text)
    Chara_Input = (ASC(Mid(Text, i, 1))) + 96
    For Row = 0 TO 7
      For Chara_Scan = 0 TO 7
        If Bit(AF3_palFTarray(2, Chara_Input, row), 7 - Chara_Scan) Then
          If (buffer) THEN
            If style = 0 then Pset buffer, (((((x + Chara_Scan) * scale_x) - (Row * Italic)) + ((i - 1) * (scale_x * 8)) - 1), y + (Row * scale_y)), col_1
            If style = 1 then Line buffer, (((((x + Chara_Scan) * scale_x) - (Row * Italic)) + ((i - 1) * (scale_x * 8)) - 1), y + (Row * scale_y))-(((((x + Chara_Scan) * scale_x) - (Row * Italic)) + (scale_x - 1) + ((i - 1) * (scale_x * 8)) - 1), (y + (Row * scale_y)) + (scale_y - 1)), col_1, B
            If style = 2 then Line buffer, (((((x + Chara_Scan) * scale_x) - (Row * Italic)) + ((i - 1) * (scale_x * 8)) - 1), y + (Row * scale_y))-(((((X + Chara_Scan) * scale_x) - (Row * Italic)) + (scale_x - 1) + ((i - 1) * (scale_x * 8)) - 1), (y + (Row * scale_y)) + (scale_y - 1)), col_1, BF
          else
            If style = 0 then Pset (((((x + Chara_Scan) * scale_x) - (Row * Italic)) + ((i - 1) * (scale_x * 8)) - 1), y + (Row * scale_y)), col_1
            If style = 1 then Line (((((x + Chara_Scan) * scale_x) - (Row * Italic)) + ((i - 1) * (scale_x * 8)) - 1), y + (Row * scale_y))-(((((x + Chara_Scan) * scale_x) - (Row * Italic)) + (scale_x - 1) + ((i - 1) * (scale_x * 8)) - 1), (y + (Row * scale_y)) + (scale_y - 1)), col_1, B
            If style = 2 then Line (((((x + Chara_Scan) * scale_x) - (Row * Italic)) + ((i - 1) * (scale_x * 8)) - 1), y + (Row * scale_y))-(((((X + Chara_Scan) * scale_x) - (Row * Italic)) + (scale_x - 1) + ((i - 1) * (scale_x * 8)) - 1), (y + (Row * scale_y)) + (scale_y - 1)), col_1, BF
          End if
        End If
      Next
    Next
    x -= 2
  Next

  x = start_x
  For i = 1 TO LEN(Text)
    Chara_Input = (ASC(Mid(Text, i, 1))) + 96
    For Row = 0 TO 7
      For Chara_Scan = 0 TO 7
        If Bit(AF3_palFTarray(1, Chara_Input, row), 7 - Chara_Scan) Then
          If (buffer) THEN
            If style = 0 then Pset buffer, (((((x + Chara_Scan) * scale_x) - (Row * Italic)) + ((i - 1) * (scale_x * 8)) - 1), y + (Row * scale_y)), col_2
            If style = 1 then Line buffer, (((((x + Chara_Scan) * scale_x) - (Row * Italic)) + ((i - 1) * (scale_x * 8)) - 1), y + (Row * scale_y))-(((((x + Chara_Scan) * scale_x) - (Row * Italic)) + (scale_x - 1) + ((i - 1) * (scale_x * 8)) - 1), (y + (Row * scale_y)) + (scale_y - 1)), col_2, B
            If style = 2 then Line buffer, (((((x + Chara_Scan) * scale_x) - (Row * Italic)) + ((i - 1) * (scale_x * 8)) - 1), y + (Row * scale_y))-(((((X + Chara_Scan) * scale_x) - (Row * Italic)) + (scale_x - 1) + ((i - 1) * (scale_x * 8)) - 1), (y + (Row * scale_y)) + (scale_y - 1)), col_2, BF
          else
            If style = 0 then Pset (((((x + Chara_Scan) * scale_x) - (Row * Italic)) + ((i - 1) * (scale_x * 8)) - 1), y + (Row * scale_y)), col_2
            If style = 1 then Line (((((x + Chara_Scan) * scale_x) - (Row * Italic)) + ((i - 1) * (scale_x * 8)) - 1), y + (Row * scale_y))-(((((x + Chara_Scan) * scale_x) - (Row * Italic)) + (scale_x - 1) + ((i - 1) * (scale_x * 8)) - 1), (y + (Row * scale_y)) + (scale_y - 1)), col_2, B
            If style = 2 then Line (((((x + Chara_Scan) * scale_x) - (Row * Italic)) + ((i - 1) * (scale_x * 8)) - 1), y + (Row * scale_y))-(((((X + Chara_Scan) * scale_x) - (Row * Italic)) + (scale_x - 1) + ((i - 1) * (scale_x * 8)) - 1), (y + (Row * scale_y)) + (scale_y - 1)), col_2, BF
          End if
        End If
      Next
    Next
    x -= 2
  Next
  
End if

End Sub



Private Sub PrivateCol_Insignia ( Byval x AS integer, Byval y AS integer, _
                                  Byval scale_x as single, Byval scale_y as single, _
                                  Byval col_1 as integer, Byval col_2 as integer, _
                                  Byval italic as integer, Byval style as integer, _
                                  Byval buffer as Any Ptr = 0 )

PrivateCol_Print Chr(19), x + 16, y + 23, scale_x, scale_y, col_1, col_2, italic, style, 0, buffer
PrivateCol_Print Chr(1, 32, 2, 32, 3, 32, 4, 32, 5, 32, 6, 32, 7, 32, 8, 32, 9, 32, 10, 32) + _
                 Chr(11, 32, 12, 32, 13, 32, 14, 32, 15, 32, 16, 32, 17, 32, 18, 32), x, y + 7, scale_x, scale_y, col_1, col_2, italic, style, 0, buffer
PrivateCol_Print Chr(20, 32, 32, 32, 21), x + 56, y - 9, scale_x, scale_y, col_1, col_2, italic, style, 0, buffer

End Sub



Private Sub PrivateCol_Print_Shadow ( Byref text as string, _
                                      Byval x AS integer, Byval y AS integer, _
                                      Byval col_1 as integer, Byval col_2 as integer, _
                                      Byval shadcol as integer, Byval buffer as Any Ptr = 0 )

PrivateCol_Print text, x + 1, y + 1, 1, 1, shadcol, shadcol, 0, 2, 1, buffer
PrivateCol_Print text, x, y + 1, 1, 1, shadcol, shadcol, 0, 2, 1, buffer
PrivateCol_Print text, x + 1, y, 1, 1, shadcol, shadcol, 0, 2, 1, buffer
PrivateCol_Print text, x, y, 1, 1, col_1, col_2, 0, 1, 1, buffer

End Sub



'_________________________________________________________________________
Private Sub PrivateCol_FilledBox ( Byval sx1 as Integer, Byval sy1 as Integer, _
                                   Byval sx2 as Integer, Byval sy2 as Integer, _
                                   Byval col as Integer, Byval alpha_blend as Integer = 255, _
                                   Byval buffer as any Ptr = 0 )

dim as Integer x_difference, y_difference
If sx1 < sx2 then Swap sx1, sx2
If sy1 < sy2 then Swap sy1, sy2

x_difference = ((sx1 - sx2) + 1)
y_difference = ((sy1 - sy2) + 1)
If x_difference < 1 then x_difference = 1
If y_difference < 1 then y_difference = 1

dim tempbuffer as any Ptr = Imagecreate(x_difference, y_difference, col)
ScreenLock
  Put buffer, (sx2, sy2), tempbuffer, alpha, alpha_blend
ScreenUnlock

ImageDestroy tempbuffer

End sub



Private Sub PrivateCol_NESColor_LockON ( Byval Any16ColorColumn_from_0_to_3 As Integer, _
                                         Byval From_col_1 As Integer,     Byval To_col_1 As Integer, _
                                         Byval From_col_2 As Integer = 0, Byval To_col_2 As Integer = 0, _
                                         Byval From_col_3 As Integer = 0, Byval To_col_3 As Integer = 0, _
                                         Byval From_col_4 As Integer = 0, Byval To_col_4 As Integer = 0, _
                                         Byval From_col_5 As Integer = 0, Byval To_col_5 As Integer = 0, _
                                         Byval From_col_6 As Integer = 0, Byval To_col_6 As Integer = 0, _
                                         Byval From_col_7 As Integer = 0, Byval To_col_7 As Integer = 0, _
                                         Byval From_col_8 As Integer = 0, Byval To_col_8 As Integer = 0, _
                                         Byval From_col_9 As Integer = 0, Byval To_col_9 As Integer = 0, _
                                         Byval From_col_10 As Integer = 0, Byval To_col_10 As Integer = 0, _
                                         Byval From_col_11 As Integer = 0, Byval To_col_11 As Integer = 0, _
                                         Byval From_col_12 As Integer = 0, Byval To_col_12 As Integer = 0, _
                                         Byval From_col_13 As Integer = 0, Byval To_col_13 As Integer = 0, _
                                         Byval From_col_14 As Integer = 0, Byval To_col_14 As Integer = 0, _
                                         Byval From_col_15 As Integer = 0, Byval To_col_15 As Integer = 0, _
                                         Byval From_col_16 As Integer = 0, Byval To_col_16 As Integer = 0 )

  Dim Any16CC_Use as Integer
  If Any16ColorColumn_from_0_to_3 < 0 then Any16ColorColumn_from_0_to_3 = 0
  If Any16ColorColumn_from_0_to_3 > 3 then Any16ColorColumn_from_0_to_3 = 3
  
  Any16CC_Use = Any16ColorColumn_from_0_to_3
  
  StartNES_CUSTcol(0 + (Any16CC_Use * 16)) = From_col_1: EndNES_CUSTcol(0 + (Any16CC_Use * 16)) = To_col_1
  StartNES_CUSTcol(1 + (Any16CC_Use * 16)) = From_col_2: EndNES_CUSTcol(1 + (Any16CC_Use * 16)) = To_col_2
  StartNES_CUSTcol(2 + (Any16CC_Use * 16)) = From_col_3: EndNES_CUSTcol(2 + (Any16CC_Use * 16)) = To_col_3
  StartNES_CUSTcol(3 + (Any16CC_Use * 16)) = From_col_4: EndNES_CUSTcol(3 + (Any16CC_Use * 16)) = To_col_4
  StartNES_CUSTcol(4 + (Any16CC_Use * 16)) = From_col_5: EndNES_CUSTcol(4 + (Any16CC_Use * 16)) = To_col_5
  StartNES_CUSTcol(5 + (Any16CC_Use * 16)) = From_col_6: EndNES_CUSTcol(5 + (Any16CC_Use * 16)) = To_col_6
  StartNES_CUSTcol(6 + (Any16CC_Use * 16)) = From_col_7: EndNES_CUSTcol(6 + (Any16CC_Use * 16)) = To_col_7
  StartNES_CUSTcol(7 + (Any16CC_Use * 16)) = From_col_8: EndNES_CUSTcol(7 + (Any16CC_Use * 16)) = To_col_8
  StartNES_CUSTcol(8 + (Any16CC_Use * 16)) = From_col_9: EndNES_CUSTcol(8 + (Any16CC_Use * 16)) = To_col_9
  StartNES_CUSTcol(9 + (Any16CC_Use * 16)) = From_col_10: EndNES_CUSTcol(9 + (Any16CC_Use * 16)) = To_col_10
  StartNES_CUSTcol(10 + (Any16CC_Use * 16)) = From_col_11: EndNES_CUSTcol(10 + (Any16CC_Use * 16)) = To_col_11
  StartNES_CUSTcol(11 + (Any16CC_Use * 16)) = From_col_12: EndNES_CUSTcol(11 + (Any16CC_Use * 16)) = To_col_12
  StartNES_CUSTcol(12 + (Any16CC_Use * 16)) = From_col_13: EndNES_CUSTcol(12 + (Any16CC_Use * 16)) = To_col_13
  StartNES_CUSTcol(13 + (Any16CC_Use * 16)) = From_col_14: EndNES_CUSTcol(13 + (Any16CC_Use * 16)) = To_col_14
  StartNES_CUSTcol(14 + (Any16CC_Use * 16)) = From_col_15: EndNES_CUSTcol(14 + (Any16CC_Use * 16)) = To_col_15
  StartNES_CUSTcol(15 + (Any16CC_Use * 16)) = From_col_16: EndNES_CUSTcol(15 + (Any16CC_Use * 16)) = To_col_16
End Sub



Private Sub PrivateCol_SMSColor_LockON ( Byval Any16ColorColumn_from_0_to_3 As Integer, _
                                         Byval From_col_1 As Integer,     Byval To_col_1 As Integer, _
                                         Byval From_col_2 As Integer = 0, Byval To_col_2 As Integer = 0, _
                                         Byval From_col_3 As Integer = 0, Byval To_col_3 As Integer = 0, _
                                         Byval From_col_4 As Integer = 0, Byval To_col_4 As Integer = 0, _
                                         Byval From_col_5 As Integer = 0, Byval To_col_5 As Integer = 0, _
                                         Byval From_col_6 As Integer = 0, Byval To_col_6 As Integer = 0, _
                                         Byval From_col_7 As Integer = 0, Byval To_col_7 As Integer = 0, _
                                         Byval From_col_8 As Integer = 0, Byval To_col_8 As Integer = 0, _
                                         Byval From_col_9 As Integer = 0, Byval To_col_9 As Integer = 0, _
                                         Byval From_col_10 As Integer = 0, Byval To_col_10 As Integer = 0, _
                                         Byval From_col_11 As Integer = 0, Byval To_col_11 As Integer = 0, _
                                         Byval From_col_12 As Integer = 0, Byval To_col_12 As Integer = 0, _
                                         Byval From_col_13 As Integer = 0, Byval To_col_13 As Integer = 0, _
                                         Byval From_col_14 As Integer = 0, Byval To_col_14 As Integer = 0, _
                                         Byval From_col_15 As Integer = 0, Byval To_col_15 As Integer = 0, _
                                         Byval From_col_16 As Integer = 0, Byval To_col_16 As Integer = 0 )

  Dim Any16CC_Use as Integer
  If Any16ColorColumn_from_0_to_3 < 0 then Any16ColorColumn_from_0_to_3 = 0
  If Any16ColorColumn_from_0_to_3 > 3 then Any16ColorColumn_from_0_to_3 = 3
  
  Any16CC_Use = Any16ColorColumn_from_0_to_3
  
  StartSMS_CUSTcol(0 + (Any16CC_Use * 16)) = From_col_1: EndSMS_CUSTcol(0 + (Any16CC_Use * 16)) = To_col_1
  StartSMS_CUSTcol(1 + (Any16CC_Use * 16)) = From_col_2: EndSMS_CUSTcol(1 + (Any16CC_Use * 16)) = To_col_2
  StartSMS_CUSTcol(2 + (Any16CC_Use * 16)) = From_col_3: EndSMS_CUSTcol(2 + (Any16CC_Use * 16)) = To_col_3
  StartSMS_CUSTcol(3 + (Any16CC_Use * 16)) = From_col_4: EndSMS_CUSTcol(3 + (Any16CC_Use * 16)) = To_col_4
  StartSMS_CUSTcol(4 + (Any16CC_Use * 16)) = From_col_5: EndSMS_CUSTcol(4 + (Any16CC_Use * 16)) = To_col_5
  StartSMS_CUSTcol(5 + (Any16CC_Use * 16)) = From_col_6: EndSMS_CUSTcol(5 + (Any16CC_Use * 16)) = To_col_6
  StartSMS_CUSTcol(6 + (Any16CC_Use * 16)) = From_col_7: EndSMS_CUSTcol(6 + (Any16CC_Use * 16)) = To_col_7
  StartSMS_CUSTcol(7 + (Any16CC_Use * 16)) = From_col_8: EndSMS_CUSTcol(7 + (Any16CC_Use * 16)) = To_col_8
  StartSMS_CUSTcol(8 + (Any16CC_Use * 16)) = From_col_9: EndSMS_CUSTcol(8 + (Any16CC_Use * 16)) = To_col_9
  StartSMS_CUSTcol(9 + (Any16CC_Use * 16)) = From_col_10: EndSMS_CUSTcol(9 + (Any16CC_Use * 16)) = To_col_10
  StartSMS_CUSTcol(10 + (Any16CC_Use * 16)) = From_col_11: EndSMS_CUSTcol(10 + (Any16CC_Use * 16)) = To_col_11
  StartSMS_CUSTcol(11 + (Any16CC_Use * 16)) = From_col_12: EndSMS_CUSTcol(11 + (Any16CC_Use * 16)) = To_col_12
  StartSMS_CUSTcol(12 + (Any16CC_Use * 16)) = From_col_13: EndSMS_CUSTcol(12 + (Any16CC_Use * 16)) = To_col_13
  StartSMS_CUSTcol(13 + (Any16CC_Use * 16)) = From_col_14: EndSMS_CUSTcol(13 + (Any16CC_Use * 16)) = To_col_14
  StartSMS_CUSTcol(14 + (Any16CC_Use * 16)) = From_col_15: EndSMS_CUSTcol(14 + (Any16CC_Use * 16)) = To_col_15
  StartSMS_CUSTcol(15 + (Any16CC_Use * 16)) = From_col_16: EndSMS_CUSTcol(15 + (Any16CC_Use * 16)) = To_col_16
End Sub



Private Function PrivateColRep( Byval Image As Uinteger ptr, _
                                Byval ReplaceThis As Uinteger, _
                                Byval WithThis As Uinteger ) As Uinteger ptr
                               
  #macro pixelpoint(_x,_y,colour)
  pixel=row+pitch*(_y)+(_x) Shl 2
  (colour)=*pixel
  #endmacro
  #macro ppset(_x,_y,colour)
  pixel2=row2+pitch2*(_y)+(_x) Shl 2
  *pixel2=(colour)
  #endmacro
  Dim As Integer _x,_y
  Dim As Integer pitch,pitch2
  Dim  As Any ptr row,row2
  Dim As Uinteger ptr pixel,pixel2
  Dim As Uinteger col
  Dim as Integer Rc, Gc, Bc
  Imageinfo Image,_x,_y,,pitch,row
  Dim  As Uinteger ptr im=Imagecreate(_x,_y)
  Imageinfo im,,,,pitch2,row2
  For y As Integer=0 To _y-1
    For x As Integer=0 To _x-1
      pixelpoint((x),(y),col)
      Rc = ((col shr 16) and &hFF) 
      Gc = ((col shr 8) and &hFF)
      Bc = (col and &hFF)
      col = RGB(Rc, Gc, Bc)
      If col=ReplaceThis Then col=WithThis
      ppset((x),(y),col)
    Next x
  Next y
  Function= im
  im = 0: ImageDestroy im
End Function



Private Function PrivateColRep_2colors( Byval Image As Uinteger ptr, _
                                        Byval ReplaceThis_1 As Uinteger, Byval WithThis_1 As Uinteger, _
                                        Byval ReplaceThis_2 As Uinteger, Byval WithThis_2 As Uinteger ) As Uinteger ptr
                               
  #macro pixelpoint(_x,_y,colour)
  pixel=row+pitch*(_y)+(_x) Shl 2
  (colour)=*pixel
  #endmacro
  #macro ppset(_x,_y,colour)
  pixel2=row2+pitch2*(_y)+(_x) Shl 2
  *pixel2=(colour)
  #endmacro
  Dim As Integer _x,_y
  Dim As Integer pitch,pitch2
  Dim  As Any ptr row,row2
  Dim As Uinteger ptr pixel,pixel2
  Dim As Uinteger col
  Dim as Integer Rc, Gc, Bc
  Imageinfo Image,_x,_y,,pitch,row
  Dim  As Uinteger ptr im=Imagecreate(_x,_y)
  Imageinfo im,,,,pitch2,row2
  For y As Integer=0 To _y-1
    For x As Integer=0 To _x-1
      pixelpoint((x),(y),col)
      Rc = ((col shr 16) and &hFF) 
      Gc = ((col shr 8) and &hFF)
      Bc = (col and &hFF)
      col = RGB(Rc, Gc, Bc)
      Select Case col
        Case ReplaceThis_1: col = WithThis_1
        Case ReplaceThis_2: col = WithThis_2
      End Select
      ppset((x),(y),col)
    Next x
  Next y
  Function= im
  im = 0: ImageDestroy im
End Function



Private Function PrivateColRep_4colors( Byval Image As Uinteger ptr, _
                                        Byval ReplaceThis_1 As Uinteger, Byval WithThis_1 As Uinteger, _
                                        Byval ReplaceThis_2 As Uinteger, Byval WithThis_2 As Uinteger, _
                                        Byval ReplaceThis_3 As Uinteger, Byval WithThis_3 As Uinteger, _
                                        Byval ReplaceThis_4 As Uinteger, Byval WithThis_4 As Uinteger ) As Uinteger ptr
                               
  #macro pixelpoint(_x,_y,colour)
  pixel=row+pitch*(_y)+(_x) Shl 2
  (colour)=*pixel
  #endmacro
  #macro ppset(_x,_y,colour)
  pixel2=row2+pitch2*(_y)+(_x) Shl 2
  *pixel2=(colour)
  #endmacro
  Dim As Integer _x,_y
  Dim As Integer pitch,pitch2
  Dim  As Any ptr row,row2
  Dim As Uinteger ptr pixel,pixel2
  Dim As Uinteger col
  Dim as Integer Rc, Gc, Bc
  Imageinfo Image,_x,_y,,pitch,row
  Dim  As Uinteger ptr im=Imagecreate(_x,_y)
  Imageinfo im,,,,pitch2,row2
  For y As Integer=0 To _y-1
    For x As Integer=0 To _x-1
      pixelpoint((x),(y),col)
      Rc = ((col shr 16) and &hFF) 
      Gc = ((col shr 8) and &hFF)
      Bc = (col and &hFF)
      col = RGB(Rc, Gc, Bc)
      Select Case col
        Case ReplaceThis_1: col = WithThis_1
        Case ReplaceThis_2: col = WithThis_2
        Case ReplaceThis_3: col = WithThis_3
        Case ReplaceThis_4: col = WithThis_4
      End Select
      ppset((x),(y),col)
    Next x
  Next y
  Function= im
  im = 0: ImageDestroy im
End Function



Private Function PrivateColRep_8colors( Byval Image As Uinteger ptr, _
                                        Byval ReplaceThis_1 As Uinteger, Byval WithThis_1 As Uinteger, _
                                        Byval ReplaceThis_2 As Uinteger, Byval WithThis_2 As Uinteger, _
                                        Byval ReplaceThis_3 As Uinteger, Byval WithThis_3 As Uinteger, _
                                        Byval ReplaceThis_4 As Uinteger, Byval WithThis_4 As Uinteger, _
                                        Byval ReplaceThis_5 As Uinteger, Byval WithThis_5 As Uinteger, _
                                        Byval ReplaceThis_6 As Uinteger, Byval WithThis_6 As Uinteger, _
                                        Byval ReplaceThis_7 As Uinteger, Byval WithThis_7 As Uinteger, _
                                        Byval ReplaceThis_8 As Uinteger, Byval WithThis_8 As Uinteger ) As Uinteger ptr
                               
  #macro pixelpoint(_x,_y,colour)
  pixel=row+pitch*(_y)+(_x) Shl 2
  (colour)=*pixel
  #endmacro
  #macro ppset(_x,_y,colour)
  pixel2=row2+pitch2*(_y)+(_x) Shl 2
  *pixel2=(colour)
  #endmacro
  Dim As Integer _x,_y
  Dim As Integer pitch,pitch2
  Dim  As Any ptr row,row2
  Dim As Uinteger ptr pixel,pixel2
  Dim As Uinteger col
  Dim as Integer Rc, Gc, Bc
  Imageinfo Image,_x,_y,,pitch,row
  Dim  As Uinteger ptr im=Imagecreate(_x,_y)
  Imageinfo im,,,,pitch2,row2
  For y As Integer=0 To _y-1
    For x As Integer=0 To _x-1
      pixelpoint((x),(y),col)
      Rc = ((col shr 16) and &hFF) 
      Gc = ((col shr 8) and &hFF)
      Bc = (col and &hFF)
      col = RGB(Rc, Gc, Bc)
      Select Case col
        Case ReplaceThis_1: col = WithThis_1
        Case ReplaceThis_2: col = WithThis_2
        Case ReplaceThis_3: col = WithThis_3
        Case ReplaceThis_4: col = WithThis_4
        Case ReplaceThis_5: col = WithThis_5
        Case ReplaceThis_6: col = WithThis_6
        Case ReplaceThis_7: col = WithThis_7
        Case ReplaceThis_8: col = WithThis_8
      End Select
      ppset((x),(y),col)
    Next x
  Next y
  Function= im
  im = 0: ImageDestroy im
End Function



Private Function PrivateColRep_16colors( Byval Image As Uinteger ptr, _
                                         Byval ReplaceThis_1 As Uinteger, Byval WithThis_1 As Uinteger, _
                                         Byval ReplaceThis_2 As Uinteger, Byval WithThis_2 As Uinteger, _
                                         Byval ReplaceThis_3 As Uinteger, Byval WithThis_3 As Uinteger, _
                                         Byval ReplaceThis_4 As Uinteger, Byval WithThis_4 As Uinteger, _
                                         Byval ReplaceThis_5 As Uinteger, Byval WithThis_5 As Uinteger, _
                                         Byval ReplaceThis_6 As Uinteger, Byval WithThis_6 As Uinteger, _
                                         Byval ReplaceThis_7 As Uinteger, Byval WithThis_7 As Uinteger, _
                                         Byval ReplaceThis_8 As Uinteger, Byval WithThis_8 As Uinteger, _
                                         Byval ReplaceThis_9 As Uinteger, Byval WithThis_9 As Uinteger, _
                                         Byval ReplaceThis_10 As Uinteger, Byval WithThis_10 As Uinteger, _
                                         Byval ReplaceThis_11 As Uinteger, Byval WithThis_11 As Uinteger, _
                                         Byval ReplaceThis_12 As Uinteger, Byval WithThis_12 As Uinteger, _
                                         Byval ReplaceThis_13 As Uinteger, Byval WithThis_13 As Uinteger, _
                                         Byval ReplaceThis_14 As Uinteger, Byval WithThis_14 As Uinteger, _
                                         Byval ReplaceThis_15 As Uinteger, Byval WithThis_15 As Uinteger, _
                                         Byval ReplaceThis_16 As Uinteger, Byval WithThis_16 As Uinteger ) As Uinteger ptr
                               
  #macro pixelpoint(_x,_y,colour)
  pixel=row+pitch*(_y)+(_x) Shl 2
  (colour)=*pixel
  #endmacro
  #macro ppset(_x,_y,colour)
  pixel2=row2+pitch2*(_y)+(_x) Shl 2
  *pixel2=(colour)
  #endmacro
  Dim As Integer _x,_y
  Dim As Integer pitch,pitch2
  Dim  As Any ptr row,row2
  Dim As Uinteger ptr pixel,pixel2
  Dim As Uinteger col
  Dim as Integer Rc, Gc, Bc
  Imageinfo Image,_x,_y,,pitch,row
  Dim  As Uinteger ptr im=Imagecreate(_x,_y)
  Imageinfo im,,,,pitch2,row2
  For y As Integer=0 To _y-1
    For x As Integer=0 To _x-1
      pixelpoint((x),(y),col)
      Rc = ((col shr 16) and &hFF) 
      Gc = ((col shr 8) and &hFF)
      Bc = (col and &hFF)
      col = RGB(Rc, Gc, Bc)
      Select Case col
        Case ReplaceThis_1: col = WithThis_1
        Case ReplaceThis_2: col = WithThis_2
        Case ReplaceThis_3: col = WithThis_3
        Case ReplaceThis_4: col = WithThis_4
        Case ReplaceThis_5: col = WithThis_5
        Case ReplaceThis_6: col = WithThis_6
        Case ReplaceThis_7: col = WithThis_7
        Case ReplaceThis_8: col = WithThis_8
        Case ReplaceThis_9: col = WithThis_9
        Case ReplaceThis_10: col = WithThis_10
        Case ReplaceThis_11: col = WithThis_11
        Case ReplaceThis_12: col = WithThis_12
        Case ReplaceThis_13: col = WithThis_13
        Case ReplaceThis_14: col = WithThis_14
        Case ReplaceThis_15: col = WithThis_15
        Case ReplaceThis_16: col = WithThis_16
      End Select
      ppset((x),(y),col)
    Next x
  Next y
  Function= im
  im = 0: ImageDestroy im
End Function



Private Function PrivateColRep_30colors( Byval Image As Uinteger ptr, _
                                         Byval ReplaceThis_1 As Uinteger, Byval WithThis_1 As Uinteger, _
                                         Byval ReplaceThis_2 As Uinteger, Byval WithThis_2 As Uinteger, _
                                         Byval ReplaceThis_3 As Uinteger, Byval WithThis_3 As Uinteger, _
                                         Byval ReplaceThis_4 As Uinteger, Byval WithThis_4 As Uinteger, _
                                         Byval ReplaceThis_5 As Uinteger, Byval WithThis_5 As Uinteger, _
                                         Byval ReplaceThis_6 As Uinteger, Byval WithThis_6 As Uinteger, _
                                         Byval ReplaceThis_7 As Uinteger, Byval WithThis_7 As Uinteger, _
                                         Byval ReplaceThis_8 As Uinteger, Byval WithThis_8 As Uinteger, _
                                         Byval ReplaceThis_9 As Uinteger, Byval WithThis_9 As Uinteger, _
                                         Byval ReplaceThis_10 As Uinteger, Byval WithThis_10 As Uinteger, _
                                         Byval ReplaceThis_11 As Uinteger, Byval WithThis_11 As Uinteger, _
                                         Byval ReplaceThis_12 As Uinteger, Byval WithThis_12 As Uinteger, _
                                         Byval ReplaceThis_13 As Uinteger, Byval WithThis_13 As Uinteger, _
                                         Byval ReplaceThis_14 As Uinteger, Byval WithThis_14 As Uinteger, _
                                         Byval ReplaceThis_15 As Uinteger, Byval WithThis_15 As Uinteger, _
                                         Byval ReplaceThis_16 As Uinteger, Byval WithThis_16 As Uinteger, _
                                         Byval ReplaceThis_17 As Uinteger, Byval WithThis_17 As Uinteger, _
                                         Byval ReplaceThis_18 As Uinteger, Byval WithThis_18 As Uinteger, _
                                         Byval ReplaceThis_19 As Uinteger, Byval WithThis_19 As Uinteger, _
                                         Byval ReplaceThis_20 As Uinteger, Byval WithThis_20 As Uinteger, _
                                         Byval ReplaceThis_21 As Uinteger, Byval WithThis_21 As Uinteger, _
                                         Byval ReplaceThis_22 As Uinteger, Byval WithThis_22 As Uinteger, _
                                         Byval ReplaceThis_23 As Uinteger, Byval WithThis_23 As Uinteger, _
                                         Byval ReplaceThis_24 As Uinteger, Byval WithThis_24 As Uinteger, _
                                         Byval ReplaceThis_25 As Uinteger, Byval WithThis_25 As Uinteger, _
                                         Byval ReplaceThis_26 As Uinteger, Byval WithThis_26 As Uinteger, _
                                         Byval ReplaceThis_27 As Uinteger, Byval WithThis_27 As Uinteger, _
                                         Byval ReplaceThis_28 As Uinteger, Byval WithThis_28 As Uinteger, _
                                         Byval ReplaceThis_29 As Uinteger, Byval WithThis_29 As Uinteger, _
                                         Byval ReplaceThis_30 As Uinteger, Byval WithThis_30 As Uinteger ) As Uinteger ptr
                          
  #macro pixelpoint(_x,_y,colour)
  pixel=row+pitch*(_y)+(_x) Shl 2
  (colour)=*pixel
  #endmacro
  #macro ppset(_x,_y,colour)
  pixel2=row2+pitch2*(_y)+(_x) Shl 2
  *pixel2=(colour)
  #endmacro
  Dim As Integer _x,_y
  Dim As Integer pitch,pitch2
  Dim  As Any ptr row,row2
  Dim As Uinteger ptr pixel,pixel2
  Dim As Uinteger col
  Dim as Integer Rc, Gc, Bc
  Imageinfo Image,_x,_y,,pitch,row
  Dim  As Uinteger ptr im=Imagecreate(_x,_y)
  Imageinfo im,,,,pitch2,row2
  For y As Integer=0 To _y-1
    For x As Integer=0 To _x-1
      pixelpoint((x),(y),col)
      Rc = ((col shr 16) and &hFF) 
      Gc = ((col shr 8) and &hFF)
      Bc = (col and &hFF)
      col = RGB(Rc, Gc, Bc)
      Select Case col
        Case ReplaceThis_1: col = WithThis_1
        Case ReplaceThis_2: col = WithThis_2
        Case ReplaceThis_3: col = WithThis_3
        Case ReplaceThis_4: col = WithThis_4
        Case ReplaceThis_5: col = WithThis_5
        Case ReplaceThis_6: col = WithThis_6
        Case ReplaceThis_7: col = WithThis_7
        Case ReplaceThis_8: col = WithThis_8
        Case ReplaceThis_9: col = WithThis_9
        Case ReplaceThis_10: col = WithThis_10
        Case ReplaceThis_11: col = WithThis_11
        Case ReplaceThis_12: col = WithThis_12
        Case ReplaceThis_13: col = WithThis_13
        Case ReplaceThis_14: col = WithThis_14
        Case ReplaceThis_15: col = WithThis_15
        Case ReplaceThis_16: col = WithThis_16
        Case ReplaceThis_17: col = WithThis_17
        Case ReplaceThis_18: col = WithThis_18
        Case ReplaceThis_19: col = WithThis_19
        Case ReplaceThis_20: col = WithThis_20
        Case ReplaceThis_21: col = WithThis_21
        Case ReplaceThis_22: col = WithThis_22
        Case ReplaceThis_23: col = WithThis_23
        Case ReplaceThis_24: col = WithThis_24
        Case ReplaceThis_25: col = WithThis_25
        Case ReplaceThis_26: col = WithThis_26
        Case ReplaceThis_27: col = WithThis_27
        Case ReplaceThis_28: col = WithThis_28
        Case ReplaceThis_29: col = WithThis_29
        Case ReplaceThis_30: col = WithThis_30
      End Select
      ppset((x),(y),col)
    Next x
  Next y
  Function= im
  im = 0: ImageDestroy im
End Function



Private Function PrivateColRep_64colors( Byval Image As Uinteger ptr ) As Uinteger ptr
                          
  #macro pixelpoint(_x,_y,colour)
  pixel=row+pitch*(_y)+(_x) Shl 2
  (colour)=*pixel
  #endmacro
  #macro ppset(_x,_y,colour)
  pixel2=row2+pitch2*(_y)+(_x) Shl 2
  *pixel2=(colour)
  #endmacro
  Dim As Integer _x,_y
  Dim As Integer pitch,pitch2
  Dim  As Any ptr row,row2
  Dim As Uinteger ptr pixel,pixel2
  Dim As Uinteger col
  Dim as Integer Rc, Gc, Bc
  Imageinfo Image,_x,_y,,pitch,row
  Dim  As Uinteger ptr im=Imagecreate(_x,_y)
  Imageinfo im,,,,pitch2,row2
  For y As Integer=0 To _y-1
    For x As Integer=0 To _x-1
      pixelpoint((x),(y),col)
      Rc = ((col shr 16) and &hFF) 
      Gc = ((col shr 8) and &hFF)
      Bc = (col and &hFF)
      col = RGB(Rc, Gc, Bc)
      For colchange as Integer = 0 to 63
        Select Case col
          Case Start64_CUSTcol(colchange): col = End64_CUSTcol(colchange)
        End Select
      Next
      ppset((x),(y),col)
    Next x
  Next y
  Function= im
  im = 0: ImageDestroy im
End Function



Private Function PrivateColRep_64colors_FC( Byval Image As Uinteger ptr, _
                                            Byval Normal_or_Reverse as Integer = 0 ) As Uinteger ptr
                          
  #macro pixelpoint(_x,_y,colour)
  pixel=row+pitch*(_y)+(_x) Shl 2
  (colour)=*pixel
  #endmacro
  #macro ppset(_x,_y,colour)
  pixel2=row2+pitch2*(_y)+(_x) Shl 2
  *pixel2=(colour)
  #endmacro
  Dim As Integer _x,_y
  Dim As Integer pitch,pitch2
  Dim  As Any ptr row,row2
  Dim As Uinteger ptr pixel,pixel2
  Dim As Uinteger col
  Dim as Integer Rc, Gc, Bc
  Imageinfo Image,_x,_y,,pitch,row
  Dim  As Uinteger ptr im=Imagecreate(_x,_y)
  Imageinfo im,,,,pitch2,row2
  For y As Integer=0 To _y-1
    For x As Integer=0 To _x-1
      pixelpoint((x),(y),col)
      Rc = ((col shr 16) and &hFF) 
      Gc = ((col shr 8) and &hFF)
      Bc = (col and &hFF)
      col = RGB(Rc, Gc, Bc)
      If Normal_or_Reverse = 0 then
        For colchange as Integer = 0 to 63 step 1  'Normal Order from 0 to 63
          Select Case col
            Case StartNES_CUSTcol(colchange): col = EndNES_CUSTcol(colchange)
          End Select
        Next
      else
        For colchange as Integer = 63 to 0 step -1 'Reverse Order from 63 to 0
          Select Case col
            Case StartNES_CUSTcol(colchange): col = EndNES_CUSTcol(colchange)
          End Select
        Next
      End if
      ppset((x),(y),col)
    Next x
  Next y
  Function= im
  im = 0: ImageDestroy im
End Function



Private Function PrivateColRep_64colors_SMS( Byval Image As Uinteger ptr, _
                                             Byval Normal_or_Reverse as Integer = 0 ) As Uinteger ptr
                          
  #macro pixelpoint(_x,_y,colour)
  pixel=row+pitch*(_y)+(_x) Shl 2
  (colour)=*pixel
  #endmacro
  #macro ppset(_x,_y,colour)
  pixel2=row2+pitch2*(_y)+(_x) Shl 2
  *pixel2=(colour)
  #endmacro
  Dim As Integer _x,_y
  Dim As Integer pitch,pitch2
  Dim  As Any ptr row,row2
  Dim As Uinteger ptr pixel,pixel2
  Dim As Uinteger col
  Dim as Integer Rc, Gc, Bc
  Imageinfo Image,_x,_y,,pitch,row
  Dim  As Uinteger ptr im=Imagecreate(_x,_y)
  Imageinfo im,,,,pitch2,row2
  For y As Integer=0 To _y-1
    For x As Integer=0 To _x-1
      pixelpoint((x),(y),col)
      Rc = ((col shr 16) and &hFF) 
      Gc = ((col shr 8) and &hFF)
      Bc = (col and &hFF)
      col = RGB(Rc, Gc, Bc)
      If Normal_or_Reverse = 0 then
        For colchange as Integer = 0 to 63 step 1  'Normal Order from 0 to 63
          Select Case col
            Case StartSMS_CUSTcol(colchange): col = EndSMS_CUSTcol(colchange)
          End Select
        Next
      else
        For colchange as Integer = 63 to 0 step -1 'Reverse Order from 63 to 0
          Select Case col
            Case StartSMS_CUSTcol(colchange): col = EndSMS_CUSTcol(colchange)
          End Select
        Next
      End if
      ppset((x),(y),col)
    Next x
  Next y
  Function= im
  im = 0: ImageDestroy im
End Function



Private Function PrivateColRep_256colors( Byval Image As Uinteger ptr ) As Uinteger ptr
                          
  #macro pixelpoint(_x,_y,colour)
  pixel=row+pitch*(_y)+(_x) Shl 2
  (colour)=*pixel
  #endmacro
  #macro ppset(_x,_y,colour)
  pixel2=row2+pitch2*(_y)+(_x) Shl 2
  *pixel2=(colour)
  #endmacro
  Dim As Integer _x,_y
  Dim As Integer pitch,pitch2
  Dim  As Any ptr row,row2
  Dim As Uinteger ptr pixel,pixel2
  Dim As Uinteger col
  Dim as Integer Rc, Gc, Bc
  Imageinfo Image,_x,_y,,pitch,row
  Dim  As Uinteger ptr im=Imagecreate(_x,_y)
  Imageinfo im,,,,pitch2,row2
  For y As Integer=0 To _y-1
    For x As Integer=0 To _x-1
      pixelpoint((x),(y),col)
      Rc = ((col shr 16) and &hFF) 
      Gc = ((col shr 8) and &hFF)
      Bc = (col and &hFF)
      col = RGB(Rc, Gc, Bc)
      For colchange as Integer = 0 to 255
        Select Case col
          Case Start256_CUSTcol(colchange): col = End256_CUSTcol(colchange)
        End Select
      Next
      ppset((x),(y),col)
    Next x
  Next y
  Function= im
  im = 0: ImageDestroy im
End Function


